/*
 *
 *    ENUMERATED.c
 *
 *    $Source: /usr/local/CVS/a2c/runtime/src/ENUMERATED.c,v 
 *    $Revision: 1.12 
 *    $Date: 1997/06/06 00:30:32 
 *    $Name: SETREF_1_0_Release 
 *    $Disclaimer: 
 *    ----------------------------------------------------------------------
 *    SET Draft Reference Implementation Disclaimer/License
 *    June 30, 1997
 *    
 *    This is a beta version of the SET Draft Reference Implementation
 *    ("DRI").  It is a work in progress and is being provided at this
 *    stage and in this form to help developers and other interested
 *    parties to understand the SET protocol.  This version of the DRI
 *    provides the core functionality required to process a simple
 *    transaction.  This release does not support certificate authority
 *    messages. Nor does it support the SET option to perform
 *    transactions without cardholder certificates.  For more details
 *    on the functionality in this beta version, please refer to the
 *    attached documentation.  
 *    
 *    Later versions of the DRI will include additional functionality
 *    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
 *    DEVELOPMENT.  If you discover a bug, please let us know by posting
 *    a message to the SET-DEV mailing list.  Our lawyers made us include
 *    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
 *    describes what you can do with the DRI.
 *     
 *    Copyright (C) 1996, 1997, Visa International Service Association and
 *    MasterCard International Incorporated.  All rights reserved.  
 *    Permission to copy and implement the material contained herein is
 *    granted subject to the conditions that (i) any copy or re-publication
 *    must bear this legend in full; (ii) any derivative work must bear
 *    a notice that it is not the Draft Reference Implementation ("DRI")
 *    for SET and (iii) that none of the copyright holders shall have any
 *    responsibility or liability whatsoever to any other party arising
 *    from the use or publication of the material contained herein.
 *    
 *    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
 *    limited license to (i) make, use, copy and modify the DRI for the
 *    purpose of developing software that complies with the SET
 *    Specification ("SET Products") and for the purpose of achieving a
 *    better understanding of the SET Protocol; and (ii) distribute SET
 *    Products that incorporate all or a portion of the DRI and other
 *    software, which together are provided under a defined interface
 *    different from that provided by the DRI's API.  Licensee shall not
 *    redistribute or sell a license to the DRI nor shall Licensee
 *    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
 *    means a product that provides comprehensive facilities to enable
 *    other parties to create software products for distribution. 
 *    Bolt-on applications and payment modules shall not be considered
 *    Toolkits for the purpose of this license.  The DRI is not intended
 *    to be used as a Toolkit.
 *    
 *    Licensors make no representation or warranty of any kind, express
 *    or implied, relating to the DRI.  Licensors are making the DRI
 *    publicly available as an aid to understanding, creating, and
 *    testing SET Products.  Licensees are solely responsible for any
 *    use of the DRI and agree to hold Licensors harmless for any claim
 *    that may arise out of any product created with the DRI.  
 *    
 *    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
 *    Corporation with offices at 4984 El Camino Real, Los Altos,
 *    California, as a third party beneficiary of this license.
 *    
 *    This software is controlled material under U.S. law and the laws
 *    of other jurisdictions and you hereby acknowledge and agree that
 *    you must fully comply with all the current laws of the United States
 *    including, without limitation, rules and regulations of the United
 *    States Office of Export Administration and other applicable U.S.
 *    governmental agencies.  
 *    ----------------------------------------------------------------------
 *     $
 *
 *    Copyright (C) 1996, 1997, Visa International Service Association and MasterCard International Incorporated
 *    All Rights Reserved.
 *
 *    briank@terisa.com
 *
 */

#include <define.h>
#include <io_ctx.h>

#include "asn.h"
#include "asn_types.h"
#include "asn_error.h"

#include "ENUMERATED.h"


#ifndef LINT
static char rcsid[] = "$Id: ENUMERATED.c,v 1.12 1997/06/06 00:30:32 briank Exp ";
#endif



static char type_name[] = "ENUMERATED";

PRIVATE A2C_DECODE_FUNCTION_PROTOTYPE(decode_INTEGER);
PRIVATE A2C_ENCODE_FUNCTION_PROTOTYPE(encode_INTEGER);
static A2C_VERIFY_FUNCTION_PROTOTYPE(verify_ENUMERATED);



static int
verify_ENUMERATED(null, ctx, module, selector, index, data, error)
    io_ctx                    null;
    struct asn_verify_ctx_   *ctx;
    struct a2c_module_       *module;
    UINT4                     selector;
    UINT4                    *index;
    VOID                     *data;
    char                      error[ERROR_MESSAGE_LENGTH];
{
    ENUMERATION              *enumeration  = 0;
    asn__enumerated           value        = 0;
    int                       i;
UNUSED_ARG(null);
UNUSED_ARG(ctx);
UNUSED_ARG(error);


    enumeration = module->types[selector].template[*index].enumeration;

    if (enumeration != 0 && enumeration->elipsis == NO_ELIPSIS) {
        value = *(asn__enumerated*)data;
        for (i = 0; i < enumeration->length; ++i) {
            if (value == enumeration->value[i]) {
                return NO_ERROR;   /* RETURN */
            }
        }
        /* if this point is reached, then no match was found */
        ERETURN(A2C_ERR_WRONG_ENUMERATION);
    }

    return NO_ERROR;
}


PRIVATE_DEF struct vtbl_ a2c_vtbl__ENUMERATED =
    { type_name, decode_INTEGER, encode_INTEGER, verify_ENUMERATED };



