/*
 *
 *    asn_error.c
 *
 *    $Source: /usr/local/CVS/a2c/runtime/src/asn_error.c,v 
 *    $Revision: 1.11 
 *    $Date: 1997/06/06 00:31:05 
 *    $Name: SETREF_1_0_Release 
 *    $Disclaimer: 
 *    ----------------------------------------------------------------------
 *    SET Draft Reference Implementation Disclaimer/License
 *    June 30, 1997
 *    
 *    This is a beta version of the SET Draft Reference Implementation
 *    ("DRI").  It is a work in progress and is being provided at this
 *    stage and in this form to help developers and other interested
 *    parties to understand the SET protocol.  This version of the DRI
 *    provides the core functionality required to process a simple
 *    transaction.  This release does not support certificate authority
 *    messages. Nor does it support the SET option to perform
 *    transactions without cardholder certificates.  For more details
 *    on the functionality in this beta version, please refer to the
 *    attached documentation.  
 *    
 *    Later versions of the DRI will include additional functionality
 *    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
 *    DEVELOPMENT.  If you discover a bug, please let us know by posting
 *    a message to the SET-DEV mailing list.  Our lawyers made us include
 *    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
 *    describes what you can do with the DRI.
 *     
 *    Copyright (C) 1996, 1997, Visa International Service Association and
 *    MasterCard International Incorporated.  All rights reserved.  
 *    Permission to copy and implement the material contained herein is
 *    granted subject to the conditions that (i) any copy or re-publication
 *    must bear this legend in full; (ii) any derivative work must bear
 *    a notice that it is not the Draft Reference Implementation ("DRI")
 *    for SET and (iii) that none of the copyright holders shall have any
 *    responsibility or liability whatsoever to any other party arising
 *    from the use or publication of the material contained herein.
 *    
 *    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
 *    limited license to (i) make, use, copy and modify the DRI for the
 *    purpose of developing software that complies with the SET
 *    Specification ("SET Products") and for the purpose of achieving a
 *    better understanding of the SET Protocol; and (ii) distribute SET
 *    Products that incorporate all or a portion of the DRI and other
 *    software, which together are provided under a defined interface
 *    different from that provided by the DRI's API.  Licensee shall not
 *    redistribute or sell a license to the DRI nor shall Licensee
 *    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
 *    means a product that provides comprehensive facilities to enable
 *    other parties to create software products for distribution. 
 *    Bolt-on applications and payment modules shall not be considered
 *    Toolkits for the purpose of this license.  The DRI is not intended
 *    to be used as a Toolkit.
 *    
 *    Licensors make no representation or warranty of any kind, express
 *    or implied, relating to the DRI.  Licensors are making the DRI
 *    publicly available as an aid to understanding, creating, and
 *    testing SET Products.  Licensees are solely responsible for any
 *    use of the DRI and agree to hold Licensors harmless for any claim
 *    that may arise out of any product created with the DRI.  
 *    
 *    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
 *    Corporation with offices at 4984 El Camino Real, Los Altos,
 *    California, as a third party beneficiary of this license.
 *    
 *    This software is controlled material under U.S. law and the laws
 *    of other jurisdictions and you hereby acknowledge and agree that
 *    you must fully comply with all the current laws of the United States
 *    including, without limitation, rules and regulations of the United
 *    States Office of Export Administration and other applicable U.S.
 *    governmental agencies.  
 *    ----------------------------------------------------------------------
 *     $
 *
 *    Copyright (C) 1996, 1997, Visa International Service Association and MasterCard International Incorporated
 *    All Rights Reserved.
 *
 *    briank@terisa.com
 *
 */



#include <define.h>
#include <error_module.h>

#include "a2c.h"
#include "asn_error.h"


#ifndef LINT
static char rcsid[] = "$Id: asn_error.c,v 1.11 1997/06/06 00:31:05 briank Exp ";
#endif



/*
 *    ERROR MODULE
 */
static error_msg a2c_error_messages__[] = {
  A2C_ERROR_MESSAGES
  { 0, 0 } };

PRIVATE_DEF struct error_module_ error_module_2_a2c__[] =
   {{ A2C_MODULE_NO_, "a2c", a2c_error_messages__, 0,
      ERROR_MODULE_VTBL_DEFAULT }};
    /* the name 'error_module_2_a2c__' assumes that A2C_MODULE_NO_==2 */


PRIVATE int
a2c_extern_error(status)
    int    status;
{
    /* pass through non-a2c errors */
    if (ERROR_MODULE(status) != ERROR_MODULE(A2C_ERR_ENCODING)) {
        return(status);
    }

    if (ERROR_NUMBER(status) >= ERROR_NUMBER(A2C_ERR_ENCODING)) {
        return(A2C_ERR_ENCODING);
    }
    else if (ERROR_NUMBER(status) >= ERROR_NUMBER(A2C_ERR_INTERNAL)) {
        return(A2C_ERR_INTERNAL);
    }
    else if (ERROR_NUMBER(status) >= ERROR_NUMBER(A2C_ERR_IO)) {
        return(A2C_ERR_IO);
    }
    else if (ERROR_NUMBER(status) >= ERROR_NUMBER(A2C_ERR_USER_DATA)) {
        return(status);   /* return "user data" errors as is */
    }
    else if (ERROR_NUMBER(status) >= ERROR_NUMBER(A2C_ERR_NO_MEMORY)) {
        return(A2C_ERR_NO_MEMORY);
    }

    /* should never reach this point */
    return(A2C_ERR_INTERNAL);
}


