/*
 *
 *    asn_error.h
 *
 *    $Source: /usr/local/CVS/a2c/runtime/src/asn_error.h,v 
 *    $Revision: 1.15 
 *    $Date: 1997/06/06 00:31:06 
 *    $Name: SETREF_1_0_Release 
 *    $Disclaimer: 
 *    ----------------------------------------------------------------------
 *    SET Draft Reference Implementation Disclaimer/License
 *    June 30, 1997
 *    
 *    This is a beta version of the SET Draft Reference Implementation
 *    ("DRI").  It is a work in progress and is being provided at this
 *    stage and in this form to help developers and other interested
 *    parties to understand the SET protocol.  This version of the DRI
 *    provides the core functionality required to process a simple
 *    transaction.  This release does not support certificate authority
 *    messages. Nor does it support the SET option to perform
 *    transactions without cardholder certificates.  For more details
 *    on the functionality in this beta version, please refer to the
 *    attached documentation.  
 *    
 *    Later versions of the DRI will include additional functionality
 *    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
 *    DEVELOPMENT.  If you discover a bug, please let us know by posting
 *    a message to the SET-DEV mailing list.  Our lawyers made us include
 *    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
 *    describes what you can do with the DRI.
 *     
 *    Copyright (C) 1996, 1997, Visa International Service Association and
 *    MasterCard International Incorporated.  All rights reserved.  
 *    Permission to copy and implement the material contained herein is
 *    granted subject to the conditions that (i) any copy or re-publication
 *    must bear this legend in full; (ii) any derivative work must bear
 *    a notice that it is not the Draft Reference Implementation ("DRI")
 *    for SET and (iii) that none of the copyright holders shall have any
 *    responsibility or liability whatsoever to any other party arising
 *    from the use or publication of the material contained herein.
 *    
 *    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
 *    limited license to (i) make, use, copy and modify the DRI for the
 *    purpose of developing software that complies with the SET
 *    Specification ("SET Products") and for the purpose of achieving a
 *    better understanding of the SET Protocol; and (ii) distribute SET
 *    Products that incorporate all or a portion of the DRI and other
 *    software, which together are provided under a defined interface
 *    different from that provided by the DRI's API.  Licensee shall not
 *    redistribute or sell a license to the DRI nor shall Licensee
 *    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
 *    means a product that provides comprehensive facilities to enable
 *    other parties to create software products for distribution. 
 *    Bolt-on applications and payment modules shall not be considered
 *    Toolkits for the purpose of this license.  The DRI is not intended
 *    to be used as a Toolkit.
 *    
 *    Licensors make no representation or warranty of any kind, express
 *    or implied, relating to the DRI.  Licensors are making the DRI
 *    publicly available as an aid to understanding, creating, and
 *    testing SET Products.  Licensees are solely responsible for any
 *    use of the DRI and agree to hold Licensors harmless for any claim
 *    that may arise out of any product created with the DRI.  
 *    
 *    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
 *    Corporation with offices at 4984 El Camino Real, Los Altos,
 *    California, as a third party beneficiary of this license.
 *    
 *    This software is controlled material under U.S. law and the laws
 *    of other jurisdictions and you hereby acknowledge and agree that
 *    you must fully comply with all the current laws of the United States
 *    including, without limitation, rules and regulations of the United
 *    States Office of Export Administration and other applicable U.S.
 *    governmental agencies.  
 *    ----------------------------------------------------------------------
 *     $
 *
 *    Copyright (C) 1996, 1997, Visa International Service Association and MasterCard International Incorporated
 *    All Rights Reserved.
 *
 *    briank@terisa.com
 *
 */

#ifndef __ASN_ERROR_H__
#define __ASN_ERROR_H__


#include <error_module.h>

#include "a2c.h"



#ifdef __cplusplus
extern "C" {      
#endif            


PRIVATE int    a2c_extern_error
  PROTO_LIST((
    int    status
  ));




/*
 *    THIS_MODULE_NUMBER
 */
#define THIS_MODULE_NUMBER               A2C_MODULE_NO_




/*
 *    ERRORS
 *
 */
/* internal errors */
#define A2C_ERR_BUFFER                   ERROR_MAKE(A2C_MODULE_NO_, 55)
#define A2C_ERR_FINALIZE                 ERROR_MAKE(A2C_MODULE_NO_, 59)

/* decoding I/O errors */
#define A2C_ERR_EOF                      ERROR_MAKE(A2C_MODULE_NO_, 21)
#define A2C_ERR_BAD_FTELL                ERROR_MAKE(A2C_MODULE_NO_, 22)

/* encoding I/O errors */
#define A2C_ERR_OUTSTREAM_LEN            ERROR_MAKE(A2C_MODULE_NO_, 31)

/* decoding errors */
#define A2C_ERR_TAG_LEN                  ERROR_MAKE(A2C_MODULE_NO_, 51)
#define A2C_ERR_CLASS_NUMBER             ERROR_MAKE(A2C_MODULE_NO_, 52)
#define A2C_ERR_LEN_LEN                  ERROR_MAKE(A2C_MODULE_NO_, 53)
#define A2C_ERR_ZERO_LEN                 ERROR_MAKE(A2C_MODULE_NO_, 54)
#define A2C_ERR_OBJECT_SIZE              ERROR_MAKE(A2C_MODULE_NO_, 55)

#define A2C_WARN_WRONG_TAG               ERROR_MAKE(A2C_MODULE_NO_, 101)
#define A2C_WARN_DEFAULT                 ERROR_MAKE(A2C_MODULE_NO_, 102)

/* encoding errors */




#define A2C_ERR_DEFINITE_EOC             ERROR_MAKE(A2C_MODULE_NO_, 103)
#define A2C_ERR_UTC_BAD_CHAR             ERROR_MAKE(A2C_MODULE_NO_, 104)
#define A2C_ERR_BAD_TAG                  ERROR_MAKE(A2C_MODULE_NO_, 105)
#define A2C_ERR_BAD_LEN                  ERROR_MAKE(A2C_MODULE_NO_, 106)
#define A2C_ERR_WRONG_TAG                ERROR_MAKE(A2C_MODULE_NO_, 107)
#define A2C_ERR_WRONG_LENGTH             ERROR_MAKE(A2C_MODULE_NO_, 108)
#define A2C_ERR_WRONG_VALUE              ERROR_MAKE(A2C_MODULE_NO_, 109)
#define A2C_ERR_EOC_CONSTRUCTED          ERROR_MAKE(A2C_MODULE_NO_, 110)
#define A2C_ERR_EOC_LENGTH               ERROR_MAKE(A2C_MODULE_NO_, 111)
#define A2C_ERR_STRUCT                   ERROR_MAKE(A2C_MODULE_NO_, 112)
#define A2C_ERR_CONSTRUCTED              ERROR_MAKE(A2C_MODULE_NO_, 113)
#define A2C_ERR_PRIMITIVE                ERROR_MAKE(A2C_MODULE_NO_, 114)
#define A2C_ERR_BAD_VALUE                ERROR_MAKE(A2C_MODULE_NO_, 115)
#define A2C_ERR_MISSING_CHOICE           ERROR_MAKE(A2C_MODULE_NO_, 116)
#define A2C_ERR_ENCODING_WRONG           ERROR_MAKE(A2C_MODULE_NO_, 117)
#define A2C_ERR_BAD_CHAR                 ERROR_MAKE(A2C_MODULE_NO_, 118)
#define A2C_ERR_MIN_SIZE_SEQUENCE_OF     ERROR_MAKE(A2C_MODULE_NO_, 119)
#define A2C_ERR_MAX_SIZE_SEQUENCE_OF     ERROR_MAKE(A2C_MODULE_NO_, 120)
#define A2C_ERR_MIN_SIZE_SET_OF          ERROR_MAKE(A2C_MODULE_NO_, 121)
#define A2C_ERR_MAX_SIZE_SET_OF          ERROR_MAKE(A2C_MODULE_NO_, 122)
#define A2C_ERR_MIN_SIZE_STRING          ERROR_MAKE(A2C_MODULE_NO_, 123)
#define A2C_ERR_MAX_SIZE_STRING          ERROR_MAKE(A2C_MODULE_NO_, 124)
#define A2C_ERR_MIN_VALUE                ERROR_MAKE(A2C_MODULE_NO_, 125)
#define A2C_ERR_MAX_VALUE                ERROR_MAKE(A2C_MODULE_NO_, 126)
#define A2C_ERR_WRONG_ENUMERATION        ERROR_MAKE(A2C_MODULE_NO_, 127)



#define A2C_ERROR_MESSAGES \
{ A2C_ERR_EOF                ,"end-of-file encountered, possibly unexpected" },\
{ A2C_ERR_TAG_LEN            ,"size of tag exceeded size of built-in type" },\
{ A2C_ERR_CLASS_NUMBER       ,"invalid class number" },\
{ A2C_ERR_LEN_LEN            ,"size of length exceeded size of built-in type" },\
{ A2C_ERR_DEFINITE_EOC       ,"EOC in definite-length type" },\
{ A2C_ERR_OBJECT_SIZE        ,"object size greater the specified size" },\
{ A2C_ERR_ZERO_LEN           ,"object must have more than zero length" },\
{ A2C_ERR_UTC_BAD_CHAR       ,"non-numeric character in UTCTime encoding" },\
{ A2C_ERR_STRUCT             ,"ber-encoding has invalid recursive structure" },\
{ A2C_ERR_NO_MEMORY          ,"out of memory" },\
{ A2C_ERR_BAD_FTELL          ,"invalid ftell, stream index unavailable" },\
{ A2C_ERR_BUFFER             ,"unable to re-assign buffer with setvbuf" },\
{ A2C_ERR_OUTSTREAM_LEN      ,"object size exceeded size of destination" },\
{ A2C_ERR_WRONG_TAG          ,"wrong tag, a different one expected" },\
{ A2C_ERR_WRONG_LENGTH       ,"wrong length, a different one expected" },\
{ A2C_ERR_WRONG_VALUE        ,"wrong value, a different one expected" },\
{ A2C_ERR_FINALIZE           ,"finalize called prematurely" },\
{ A2C_ERR_BAD_PARAMETER      ,"bad parameter passed to function" },\
{ A2C_ERR_VALUE_MISSING      ,"value missing but not optional" },\
{ A2C_ERR_EOC_CONSTRUCTED    ,"illegal eoc, primitive expected" },\
{ A2C_ERR_EOC_LENGTH         ,"illegal eoc, zero length expected" },\
{ A2C_WARN_WRONG_TAG         ,"note, optional field not supplied" },\
{ A2C_ERR_BAD_CHOSEN         ,"bad chosen value" },\
{ A2C_ERR_BAD_CHAR           ,"illegal character contained in string type" },\
{ A2C_ERR_NOTHING_CHOSEN     ,"nothing chosen" },\
{ A2C_ERR_ENCODING           ,"encoding error" },\
{ A2C_ERR_ENCODING_WRONG     ,"decoding error due to incorrect encoding" },\
{ A2C_ERR_MIN_SIZE_STRING    ,"minimum string size" },\
{ A2C_ERR_MAX_SIZE_STRING    ,"maximum string size exceeded" },\
{ A2C_ERR_MIN_SIZE_SET_OF    ,"minimum SET OF size" },\
{ A2C_ERR_MAX_SIZE_SET_OF    ,"maximum SET OF size exceeded" },\
{ A2C_ERR_MIN_SIZE_SEQUENCE_OF    ,"minimum SEQUENCE OF size" },\
{ A2C_ERR_MAX_SIZE_SEQUENCE_OF    ,"maximum SEQUENCE OF size exceeded" },\
{ A2C_ERR_MIN_VALUE          ,"minimum permitted value" },\
{ A2C_ERR_MAX_VALUE          ,"maximum permitted value exceeded" },\
{ A2C_ERR_WRONG_ENUMERATION  ,"wrong enumeration in encoding" },\
{ A2C_ERR_BAD_TAG            ,"illegal encoding of tag" },\
{ A2C_ERR_BAD_VALUE          ,"illegal encoding of value" },\
{ A2C_ERR_PRIMITIVE          ,"illegal primitive type, constructed expected" },\
{ A2C_ERR_CONSTRUCTED        ,"illegal constructed type, primitive expected" },\
{ A2C_WARN_DEFAULT           ,"default value used" },\


#ifdef __cplusplus
}
#endif
#endif

