#
#    targets.mk
#
#    $Source: /usr/local/CVS/a2c/runtime/src/targets.mk,v 
#    $Revision: 1.14 
#    $Date: 1997/06/25 03:00:48 
#    $Name: SETREF_1_0_Release 
#    $Disclaimer: 
#    ----------------------------------------------------------------------
#    SET Draft Reference Implementation Disclaimer/License
#    June 30, 1997
#    
#    This is a beta version of the SET Draft Reference Implementation
#    ("DRI").  It is a work in progress and is being provided at this
#    stage and in this form to help developers and other interested
#    parties to understand the SET protocol.  This version of the DRI
#    provides the core functionality required to process a simple
#    transaction.  This release does not support certificate authority
#    messages. Nor does it support the SET option to perform
#    transactions without cardholder certificates.  For more details
#    on the functionality in this beta version, please refer to the
#    attached documentation.  
#    
#    Later versions of the DRI will include additional functionality
#    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
#    DEVELOPMENT.  If you discover a bug, please let us know by posting
#    a message to the SET-DEV mailing list.  Our lawyers made us include
#    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
#    describes what you can do with the DRI.
#     
#    Copyright (C) 1996, 1997, Visa International Service Association and
#    MasterCard International Incorporated.  All rights reserved.  
#    Permission to copy and implement the material contained herein is
#    granted subject to the conditions that (i) any copy or re-publication
#    must bear this legend in full; (ii) any derivative work must bear
#    a notice that it is not the Draft Reference Implementation ("DRI")
#    for SET and (iii) that none of the copyright holders shall have any
#    responsibility or liability whatsoever to any other party arising
#    from the use or publication of the material contained herein.
#    
#    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
#    limited license to (i) make, use, copy and modify the DRI for the
#    purpose of developing software that complies with the SET
#    Specification ("SET Products") and for the purpose of achieving a
#    better understanding of the SET Protocol; and (ii) distribute SET
#    Products that incorporate all or a portion of the DRI and other
#    software, which together are provided under a defined interface
#    different from that provided by the DRI's API.  Licensee shall not
#    redistribute or sell a license to the DRI nor shall Licensee
#    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
#    means a product that provides comprehensive facilities to enable
#    other parties to create software products for distribution. 
#    Bolt-on applications and payment modules shall not be considered
#    Toolkits for the purpose of this license.  The DRI is not intended
#    to be used as a Toolkit.
#    
#    Licensors make no representation or warranty of any kind, express
#    or implied, relating to the DRI.  Licensors are making the DRI
#    publicly available as an aid to understanding, creating, and
#    testing SET Products.  Licensees are solely responsible for any
#    use of the DRI and agree to hold Licensors harmless for any claim
#    that may arise out of any product created with the DRI.  
#    
#    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
#    Corporation with offices at 4984 El Camino Real, Los Altos,
#    California, as a third party beneficiary of this license.
#    
#    This software is controlled material under U.S. law and the laws
#    of other jurisdictions and you hereby acknowledge and agree that
#    you must fully comply with all the current laws of the United States
#    including, without limitation, rules and regulations of the United
#    States Office of Export Administration and other applicable U.S.
#    governmental agencies.  
#    ----------------------------------------------------------------------
#     $
#
#    Copyright (C) 1997, Visa International Service Association and MasterCard International Incorporated
#    All Rights Reserved.
#
#    briank@terisa.com
#



#
#    CONFIGURE USER-DEFINED LOCAL ENVIRONMENT
#
#    These fields are specified by the user.  The remainder of
#    this file is generated from this user-specified information.
#
# A2C_DEFINES:
#    cpp defines, with the -D flag preceeding each
#
# A2C_INCLUDES:
#    cpp include directories, with the -I flag preceeding each
#
# A2C_INTERNAL:
#    headers files which are local to a specific module directory,
#    and should not be used by other parts of the toolkit or by
#    the user
#
# A2C_LIBNAME:
#    the library associated with this module directory, used in
#    most cases for debugging purposes
#
# A2C_MAKEFILES:
#    the makefiles
#
# A2C_PREFIX:
#    defines the module name, which also serves as the
#    prefix for all the variable names defined in this file
#
# A2C_PRIVATE:
#    the private, for-toolkit-use-only API header files
#
# A2C_PROGRAMS:
#    programs to build
#
# A2C_PUBLIC:
#    the header files that define the public API for the toolkit
#
# A2C_SOURCES:
#    the source files to compile to object
#
A2C_DEFINES               =
A2C_INCLUDES              = -I$(ALLOC_CTX_SRCDIR) -I$(ERROR_CTX_SRCDIR) \
                            -I$(INCLUDE_SRCDIR) -I$(IO_CTX_SRCDIR)
A2C_INTERNAL              = ANY.h BIT_STRING.h BMPString.h BOOLEAN.h CHOICE.h \
                            ENUMERATED.h EOC.h EXPLICIT_TAG.h \
                            GeneralizedTime.h IA5String.h IMPLICIT_TAG.h \
                            INTEGER.h NULL.h NumericString.h \
                            OBJECT_IDENTIFIER.h OCTET_STRING.h \
                            PrintableString.h REAL.h SEQUENCE.h SEQUENCE_OF.h \
                            SET_OF.h UTCTime.h VisibleString.h a2c_ctx.h \
                            a2c_decode.h a2c_encode.h a2c_print.h a2c_vtbl.h \
                            anystring.h asciichar.h asn.h asn_decode_ctx.h \
                            asn_encode_ctx.h asn_error.h asn_tlv.h \
                            ber_length.h ber_tag.h berencode.h params.h \
                            runtime.h using_any.h utcfunc.h
A2C_LIBNAME               = liba2c.$(LIBSUFFIX)
A2C_MAKEFILES             = Makefile global.mk override.mk targets.mk
A2C_PREFIX                = A2C
A2C_PRIVATE               = a2c.h a2c_dot_c_file.h
A2C_PROGRAMS              =
A2C_PUBLIC                = asn_types.h
A2C_SOURCES               = ANY.c BIT_STRING.c BMPString.c BOOLEAN.c CHOICE.c \
                            ENUMERATED.c EOC.c EXPLICIT_TAG.c \
                            GeneralizedTime.c IA5String.c IMPLICIT_TAG.c \
                            INTEGER.c NULL.c NumericString.c \
                            OBJECT_IDENTIFIER.c OCTET_STRING.c \
                            PrintableString.c REAL.c SEQUENCE.c SEQUENCE_OF.c \
                            SET_OF.c UTCTime.c VisibleString.c a2c_ctx.c \
                            a2c_decode.c a2c_encode.c a2c_print.c a2c_util.c \
                            anystring.c asn_decode_ctx.c asn_encode_ctx.c \
                            asn_error.c asn_tlv.c ber_length.c ber_tag.c \
                            berencode.c params.c runtime.c using_any.c \
                            utcfunc.c



#
#    CONFIGURE AUTOMATICALLY-GENERATED LOCAL ENVIRONMENT
#
# A2C_OBJECTS:
#    object files to build
#
# A2C_UNUSED:
#    obsolete files in the module directory that are not
#    used during the build process
#
# A2C_USED:
#    all files in the module directory that are used
#    during the build process
#
A2C_OBJECTS               = ANY.$(OBJSUFFIX) BIT_STRING.$(OBJSUFFIX) \
                            BMPString.$(OBJSUFFIX) BOOLEAN.$(OBJSUFFIX) \
                            CHOICE.$(OBJSUFFIX) ENUMERATED.$(OBJSUFFIX) \
                            EOC.$(OBJSUFFIX) EXPLICIT_TAG.$(OBJSUFFIX) \
                            GeneralizedTime.$(OBJSUFFIX) \
                            IA5String.$(OBJSUFFIX) IMPLICIT_TAG.$(OBJSUFFIX) \
                            INTEGER.$(OBJSUFFIX) NULL.$(OBJSUFFIX) \
                            NumericString.$(OBJSUFFIX) \
                            OBJECT_IDENTIFIER.$(OBJSUFFIX) \
                            OCTET_STRING.$(OBJSUFFIX) \
                            PrintableString.$(OBJSUFFIX) REAL.$(OBJSUFFIX) \
                            SEQUENCE.$(OBJSUFFIX) SEQUENCE_OF.$(OBJSUFFIX) \
                            SET_OF.$(OBJSUFFIX) UTCTime.$(OBJSUFFIX) \
                            VisibleString.$(OBJSUFFIX) a2c_ctx.$(OBJSUFFIX) \
                            a2c_decode.$(OBJSUFFIX) a2c_encode.$(OBJSUFFIX) \
                            a2c_print.$(OBJSUFFIX) a2c_util.$(OBJSUFFIX) \
                            anystring.$(OBJSUFFIX) asn_decode_ctx.$(OBJSUFFIX) \
                            asn_encode_ctx.$(OBJSUFFIX) asn_error.$(OBJSUFFIX) \
                            asn_tlv.$(OBJSUFFIX) ber_length.$(OBJSUFFIX) \
                            ber_tag.$(OBJSUFFIX) berencode.$(OBJSUFFIX) \
                            params.$(OBJSUFFIX) runtime.$(OBJSUFFIX) \
                            using_any.$(OBJSUFFIX) utcfunc.$(OBJSUFFIX)
A2C_UNUSED                =
A2C_USED                  = $(A2C_INTERNAL:%=$(A2C_SRCDIR)%) \
                            $(A2C_MAKEFILES:%=$(A2C_SRCDIR)%) \
                            $(A2C_PRIVATE:%=$(A2C_SRCDIR)%) \
                            $(A2C_PUBLIC:%=$(A2C_SRCDIR)%) \
                            $(A2C_SOURCES:%=$(A2C_SRCDIR)%)



#
#    NOTES
#
#    The following variables may be used during the build process,
#    but are not defined in this file.  If they are to be set
#    to something other than the default blank, then they must
#    be set by the calling make system.
#
# A2C_SRCDIR:
#    if the build target directory is different from the
#    module directory (the source directory), then this
#    variable contains the relative or full path of
#    the module directory
#
# LIBARS:
#    the library archive files (with fully-specified paths) that
#    executables built from this module directory depend upon
#
# LIBPATHS:
#    the paths to search for library archives (specified with
#    the -L)
#
# LIBS:
#    the libraries to use while building executables from
#    this module directory (specified with the -l)
#



#
#    GENERIC ENVIRONMENT
#
DEFINES                  += $(A2C_DEFINES)
OBJECTS                  += $(A2C_OBJECTS)
PUBLIC                   += $(A2C_PUBLIC)



#
#    GENERIC DEPENDENCIES
#
# default:
#    default dependency, must be the first dependency in this makefile
#
# all:
#    build everything in this module directory
#
# build:
#    make only the toolkit build files of this module directory
#
# ci:
#    perform an RCS check-in of this module directory
#
# clean:
#    remove the compiled files
#
# clean_public:
#    remove the public header files that have been copied
#    to a public build directory
#
# objects:
#    build the object files (this dependency is used for
#    building the toolkit library)
#
# private:
#    build only the private API header files
#
# public:
#    build only the public API header files
#
default:                    $(A2C_LIBNAME)
default:                    $(A2C_PROGRAMS)

all:                        $(A2C_PUBLIC)
all:                        $(A2C_OBJECTS)
all:                        $(A2C_LIBNAME)
all:                        $(A2C_PROGRAMS)
build:                      $(A2C_PUBLIC)
build:                      $(A2C_OBJECTS)
ci:                         a2c_ci
clean:                      a2c_clean
clean_public:               a2c_clean_public
objects:                    $(A2C_OBJECTS)
private:                    $(A2C_PRIVATE)
public:                     $(A2C_PUBLIC)



#
#    LOCAL UTILITY DEPENDENCIES
#
#    utility dependencies are necessary because of some
#    make-isms having to do with dependencies
#

a2c_ci:
	$(CI) $(CIFLAGS) $(A2C_USED)

a2c_clean:
	$(RM) $(RMFLAGS) $(A2C_OBJECTS) $(A2C_LIBNAME) $(A2C_PROGRAMS)

a2c_clean_public:
	$(RM) $(RMFLAGS) $(A2C_PUBLIC)

a2c_objects: $(A2C_OBJECTS)

a2c_programs: $(A2C_PROGRAMS)

a2c_public: $(A2C_PUBLIC)



#
#    BUILD DEPENDENCIES
#
#    build dependencies invoke the rule used to build each
#    class of file
#

$(A2C_LIBNAME):
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@

$(A2C_OBJECTS):
	$(COMPILE.c) $(A2C_SRCDIR)$(@:%.$(OBJSUFFIX)=%.c) $(DEFINES) $(INCLUDES)
 
$(A2C_PUBLIC):
	$(CP) $(CPFLAGS) $(A2C_SRCDIR)$@ $@

$(A2C_PROGRAMS):
	$(LINK.c) $@.$(OBJSUFFIX) $(LDLIBS) $(LIBS) $(LIBPATHS)



#
#    FILE DEPENDENCIES
#
#    file dependencies state, for each file that is built,
#    which file(s) it depends upon
#

asn_types.h: $(A2C_SRCDIR)asn_types.h

ANY.$(OBJSUFFIX): $(A2C_SRCDIR)ANY.h
ANY.$(OBJSUFFIX): $(A2C_SRCDIR)ANY.c

BIT_STRING.$(OBJSUFFIX): $(A2C_SRCDIR)BIT_STRING.h
BIT_STRING.$(OBJSUFFIX): $(A2C_SRCDIR)BIT_STRING.c

BMPString.$(OBJSUFFIX): $(A2C_SRCDIR)BMPString.h
BMPString.$(OBJSUFFIX): $(A2C_SRCDIR)BMPString.c

BOOLEAN.$(OBJSUFFIX): $(A2C_SRCDIR)BOOLEAN.h
BOOLEAN.$(OBJSUFFIX): $(A2C_SRCDIR)BOOLEAN.c

CHOICE.$(OBJSUFFIX): $(A2C_SRCDIR)CHOICE.h
CHOICE.$(OBJSUFFIX): $(A2C_SRCDIR)CHOICE.c

ENUMERATED.$(OBJSUFFIX): $(A2C_SRCDIR)ENUMERATED.h
ENUMERATED.$(OBJSUFFIX): $(A2C_SRCDIR)ENUMERATED.c

EOC.$(OBJSUFFIX): $(A2C_SRCDIR)EOC.h
EOC.$(OBJSUFFIX): $(A2C_SRCDIR)EOC.c

EXPLICIT_TAG.$(OBJSUFFIX): $(A2C_SRCDIR)EXPLICIT_TAG.h
EXPLICIT_TAG.$(OBJSUFFIX): $(A2C_SRCDIR)EXPLICIT_TAG.c

GeneralizedTime.$(OBJSUFFIX): $(A2C_SRCDIR)GeneralizedTime.h
GeneralizedTime.$(OBJSUFFIX): $(A2C_SRCDIR)GeneralizedTime.c

IA5String.$(OBJSUFFIX): $(A2C_SRCDIR)IA5String.h
IA5String.$(OBJSUFFIX): $(A2C_SRCDIR)IA5String.c

IMPLICIT_TAG.$(OBJSUFFIX): $(A2C_SRCDIR)IMPLICIT_TAG.h
IMPLICIT_TAG.$(OBJSUFFIX): $(A2C_SRCDIR)IMPLICIT_TAG.c

INTEGER.$(OBJSUFFIX): $(A2C_SRCDIR)INTEGER.h
INTEGER.$(OBJSUFFIX): $(A2C_SRCDIR)INTEGER.c

NULL.$(OBJSUFFIX): $(A2C_SRCDIR)NULL.h
NULL.$(OBJSUFFIX): $(A2C_SRCDIR)NULL.c

NumericString.$(OBJSUFFIX): $(A2C_SRCDIR)NumericString.h
NumericString.$(OBJSUFFIX): $(A2C_SRCDIR)NumericString.c

OBJECT_IDENTIFIER.$(OBJSUFFIX): $(A2C_SRCDIR)OBJECT_IDENTIFIER.h
OBJECT_IDENTIFIER.$(OBJSUFFIX): $(A2C_SRCDIR)OBJECT_IDENTIFIER.c

OCTET_STRING.$(OBJSUFFIX): $(A2C_SRCDIR)OCTET_STRING.h
OCTET_STRING.$(OBJSUFFIX): $(A2C_SRCDIR)OCTET_STRING.c

PrintableString.$(OBJSUFFIX): $(A2C_SRCDIR)PrintableString.h
PrintableString.$(OBJSUFFIX): $(A2C_SRCDIR)PrintableString.c

REAL.$(OBJSUFFIX): $(A2C_SRCDIR)REAL.h
REAL.$(OBJSUFFIX): $(A2C_SRCDIR)REAL.c

SEQUENCE.$(OBJSUFFIX): $(A2C_SRCDIR)SEQUENCE.h
SEQUENCE.$(OBJSUFFIX): $(A2C_SRCDIR)SEQUENCE.c

SEQUENCE_OF.$(OBJSUFFIX): $(A2C_SRCDIR)SEQUENCE_OF.h
SEQUENCE_OF.$(OBJSUFFIX): $(A2C_SRCDIR)SEQUENCE_OF.c

SET_OF.$(OBJSUFFIX): $(A2C_SRCDIR)SET_OF.h
SET_OF.$(OBJSUFFIX): $(A2C_SRCDIR)SET_OF.c

UTCTime.$(OBJSUFFIX): $(A2C_SRCDIR)UTCTime.h
UTCTime.$(OBJSUFFIX): $(A2C_SRCDIR)UTCTime.c

VisibleString.$(OBJSUFFIX): $(A2C_SRCDIR)VisibleString.h
VisibleString.$(OBJSUFFIX): $(A2C_SRCDIR)VisibleString.c

a2c_ctx.$(OBJSUFFIX): $(A2C_SRCDIR)a2c_ctx.h
a2c_ctx.$(OBJSUFFIX): $(A2C_SRCDIR)a2c_ctx.c

a2c_decode.$(OBJSUFFIX): $(A2C_SRCDIR)a2c_decode.h
a2c_decode.$(OBJSUFFIX): $(A2C_SRCDIR)a2c_decode.c

a2c_encode.$(OBJSUFFIX): $(A2C_SRCDIR)a2c_encode.h
a2c_encode.$(OBJSUFFIX): $(A2C_SRCDIR)a2c_encode.c

a2c_print.$(OBJSUFFIX): $(A2C_SRCDIR)a2c_print.h
a2c_print.$(OBJSUFFIX): $(A2C_SRCDIR)a2c_print.c

a2c_util.$(OBJSUFFIX): $(A2C_SRCDIR)a2c_util.c

anystring.$(OBJSUFFIX): $(A2C_SRCDIR)anystring.h
anystring.$(OBJSUFFIX): $(A2C_SRCDIR)anystring.c

asn_decode_ctx.$(OBJSUFFIX): $(A2C_SRCDIR)asn_decode_ctx.h
asn_decode_ctx.$(OBJSUFFIX): $(A2C_SRCDIR)asn_decode_ctx.c

asn_encode_ctx.$(OBJSUFFIX): $(A2C_SRCDIR)asn_encode_ctx.h
asn_encode_ctx.$(OBJSUFFIX): $(A2C_SRCDIR)asn_encode_ctx.c

asn_error.$(OBJSUFFIX): $(A2C_SRCDIR)asn_error.h
asn_error.$(OBJSUFFIX): $(A2C_SRCDIR)asn_error.c

asn_tlv.$(OBJSUFFIX): $(A2C_SRCDIR)asn_tlv.h
asn_tlv.$(OBJSUFFIX): $(A2C_SRCDIR)asn_tlv.c

ber_length.$(OBJSUFFIX): $(A2C_SRCDIR)ber_length.h
ber_length.$(OBJSUFFIX): $(A2C_SRCDIR)ber_length.c

ber_tag.$(OBJSUFFIX): $(A2C_SRCDIR)ber_tag.h
ber_tag.$(OBJSUFFIX): $(A2C_SRCDIR)ber_tag.c

berencode.$(OBJSUFFIX): $(A2C_SRCDIR)berencode.h
berencode.$(OBJSUFFIX): $(A2C_SRCDIR)berencode.c

params.$(OBJSUFFIX): $(A2C_SRCDIR)params.h
params.$(OBJSUFFIX): $(A2C_SRCDIR)params.c

runtime.$(OBJSUFFIX): $(A2C_SRCDIR)runtime.h
runtime.$(OBJSUFFIX): $(A2C_SRCDIR)runtime.c

using_any.$(OBJSUFFIX): $(A2C_SRCDIR)using_any.h
using_any.$(OBJSUFFIX): $(A2C_SRCDIR)using_any.c

utcfunc.$(OBJSUFFIX): $(A2C_SRCDIR)utcfunc.h
utcfunc.$(OBJSUFFIX): $(A2C_SRCDIR)utcfunc.c

$(A2C_LIBNAME): $(A2C_OBJECTS)
