
/*
 *
 *    pkcs8.c
 *
 *    Note, this file consists of machine-generated code that
 *    is processed by an interpreter in the ASN.1/DER runtime.
 *    The contents of this file are not intended to be human-
 *    readable.  Do not edit these contents.
 *
 *
 *    $Source: /usr/local/CVS/SETREF_1_0_Release/asn1/src/pkcs8.c,v 
 *    $Revision: 1.8 
 *    $Date: 1997/07/01 01:08:43 
 *    $Name: SETREF_1_0_Release 
 *    $Disclaimer: 
 *    ----------------------------------------------------------------------
 *    SET Draft Reference Implementation Disclaimer/License
 *    June 30, 1997
 *    
 *    This is a beta version of the SET Draft Reference Implementation
 *    ("DRI").  It is a work in progress and is being provided at this
 *    stage and in this form to help developers and other interested
 *    parties to understand the SET protocol.  This version of the DRI
 *    provides the core functionality required to process a simple
 *    transaction.  This release does not support certificate authority
 *    messages. Nor does it support the SET option to perform
 *    transactions without cardholder certificates.  For more details
 *    on the functionality in this beta version, please refer to the
 *    attached documentation.  
 *    
 *    Later versions of the DRI will include additional functionality
 *    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
 *    DEVELOPMENT.  If you discover a bug, please let us know by posting
 *    a message to the SET-DEV mailing list.  Our lawyers made us include
 *    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
 *    describes what you can do with the DRI.
 *     
 *    Copyright (C) 1996, 1997, Visa International Service Association and
 *    MasterCard International Incorporated.  All rights reserved.  
 *    Permission to copy and implement the material contained herein is
 *    granted subject to the conditions that (i) any copy or re-publication
 *    must bear this legend in full; (ii) any derivative work must bear
 *    a notice that it is not the Draft Reference Implementation ("DRI")
 *    for SET and (iii) that none of the copyright holders shall have any
 *    responsibility or liability whatsoever to any other party arising
 *    from the use or publication of the material contained herein.
 *    
 *    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
 *    limited license to (i) make, use, copy and modify the DRI for the
 *    purpose of developing software that complies with the SET
 *    Specification ("SET Products") and for the purpose of achieving a
 *    better understanding of the SET Protocol; and (ii) distribute SET
 *    Products that incorporate all or a portion of the DRI and other
 *    software, which together are provided under a defined interface
 *    different from that provided by the DRI's API.  Licensee shall not
 *    redistribute or sell a license to the DRI nor shall Licensee
 *    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
 *    means a product that provides comprehensive facilities to enable
 *    other parties to create software products for distribution. 
 *    Bolt-on applications and payment modules shall not be considered
 *    Toolkits for the purpose of this license.  The DRI is not intended
 *    to be used as a Toolkit.
 *    
 *    Licensors make no representation or warranty of any kind, express
 *    or implied, relating to the DRI.  Licensors are making the DRI
 *    publicly available as an aid to understanding, creating, and
 *    testing SET Products.  Licensees are solely responsible for any
 *    use of the DRI and agree to hold Licensors harmless for any claim
 *    that may arise out of any product created with the DRI.  
 *    
 *    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
 *    Corporation with offices at 4984 El Camino Real, Los Altos,
 *    California, as a third party beneficiary of this license.
 *    
 *    This software is controlled material under U.S. law and the laws
 *    of other jurisdictions and you hereby acknowledge and agree that
 *    you must fully comply with all the current laws of the United States
 *    including, without limitation, rules and regulations of the United
 *    States Office of Export Administration and other applicable U.S.
 *    governmental agencies.  
 *    ----------------------------------------------------------------------
 *     $
 *
 *    Copyright (C) 1996, 1997, Visa International Service Association and MasterCard International Incorporated
 *    All Rights Reserved.
 *
 *    briank@terisa.com
 *
 */

#include <a2c_dot_c_file.h>
#include "pkcs8.h"

#ifndef LINT
static char rcsid[] = "$Id: pkcs8.c,v 1.8 1997/07/01 01:08:43 briank Exp ";
#endif



















static struct asn_template_ AlgorithmIdentifier[] = {
    { 0, 0x0, 0xb0, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, 0, 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
    { 0, 0x0, 0xb0, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(pkcs8__AlgorithmIdentifier), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
};

static struct asn_template_ PrivateKeyInfo[] = {
    { 0, 0x0, 0xb1, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, 0, 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
    { 0, 0x0, 0xb1, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(pkcs8__PrivateKeyInfo), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
};

static struct asn_template_ UnencodedPrivateKeyInfo[] = {
    { 0, 0x0, 0xb6, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(pkcs8__UnencodedPrivateKeyInfo), 0, 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
        { 1, 0xb6, 0xb2, 0, 0, CLASS_UNIVERSAL, TAG_INTEGER, TAGGING_BASE, sizeof(pkcs8__Version), OFFSET(pkcs8__UnencodedPrivateKeyInfo,version), 0, 0, 0, 0, VTBL_INTEGER, 0, -1 },
        { 1, 0xb6, 0xb3, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, OFFSET(pkcs8__UnencodedPrivateKeyInfo,privateKeyAlgorithm), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
        { 1, 0xb6, 0xb3, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(pkcs8__AlgorithmIdentifier), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
        { 1, 0xb6, 0xb4, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(pkcs8__PrivateKey), OFFSET(pkcs8__UnencodedPrivateKeyInfo,privateKey), 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
        { 1, 0xb6, 0xb5, 0, 0, CLASS_CONTEXT, 0, TAGGING_IMPLICIT, 0, OFFSET(pkcs8__UnencodedPrivateKeyInfo,attributes), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, FLAG_OPTIONAL, 0 },
        { 1, 0xb6, 0xb5, 0, 0, CLASS_UNIVERSAL, TAG_SET_OF, TAGGING_BASE, sizeof(pkcs8__PrivateKeyAttributes), 0, 0, 0, 0, 0, VTBL_SET_OF, 0, 0 },
            { 2, 0xbb, 0xba, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__Attribute), AOFFSET(pkcs8__PrivateKeyAttributes,attribute), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                { 3, 0x27, 0x25, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__Attribute,type), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
                { 3, 0x27, 0x26, 0, 0, CLASS_UNIVERSAL, TAG_SET_OF, TAGGING_BASE, sizeof(x509__AttributeValues), OFFSET(x509__Attribute,values), 1, INT_MAX, 0, 0, VTBL_SET_OF, FLAG_BOUNDED, -1 },
                    { 4, 0x29, 0x28, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(asn__any), AOFFSET(x509__AttributeValues,any), 0, 0, 0, 0, VTBL_ANY, 0, -1 },
                { 3, 0x27, 0x26, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
            { 2, 0xbb, 0xba, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
        { 1, 0xb6, 0xb5, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
    { 0, 0x0, 0xb6, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
};

static struct asn_template_ Version[] = {
    { 0, 0x0, 0xb7, 0, 0, CLASS_UNIVERSAL, TAG_INTEGER, TAGGING_BASE, sizeof(pkcs8__Version), 0, 0, 0, 0, 0, VTBL_INTEGER, 0, -1 },
};

static struct asn_template_ PrivateKeyAlgorithmIdentifier[] = {
    { 0, 0x0, 0xb8, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, 0, 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
    { 0, 0x0, 0xb8, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(pkcs8__AlgorithmIdentifier), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
};

static struct asn_template_ PrivateKey[] = {
    { 0, 0x0, 0xb9, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(pkcs8__PrivateKey), 0, 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
};

static struct asn_template_ PrivateKeyAttributes[] = {
    { 0, 0x0, 0xbb, 0, 0, CLASS_UNIVERSAL, TAG_SET_OF, TAGGING_BASE, sizeof(pkcs8__PrivateKeyAttributes), 0, 0, 0, 0, 0, VTBL_SET_OF, 0, -1 },
        { 1, 0xbb, 0xba, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__Attribute), AOFFSET(pkcs8__PrivateKeyAttributes,attribute), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
            { 2, 0x27, 0x25, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__Attribute,type), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
            { 2, 0x27, 0x26, 0, 0, CLASS_UNIVERSAL, TAG_SET_OF, TAGGING_BASE, sizeof(x509__AttributeValues), OFFSET(x509__Attribute,values), 1, INT_MAX, 0, 0, VTBL_SET_OF, FLAG_BOUNDED, -1 },
                { 3, 0x29, 0x28, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(asn__any), AOFFSET(x509__AttributeValues,any), 0, 0, 0, 0, VTBL_ANY, 0, -1 },
            { 2, 0x27, 0x26, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
        { 1, 0xbb, 0xba, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
    { 0, 0x0, 0xbb, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
};

static struct asn_template_ EncryptedPrivateKeyInfo[] = {
    { 0, 0x0, 0xbe, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(pkcs8__EncryptedPrivateKeyInfo), 0, 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
        { 1, 0xbe, 0xbc, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, OFFSET(pkcs8__EncryptedPrivateKeyInfo,encryptionAlgorithm), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
        { 1, 0xbe, 0xbc, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(pkcs8__AlgorithmIdentifier), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
        { 1, 0xbe, 0xbd, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(pkcs8__EncryptedData), OFFSET(pkcs8__EncryptedPrivateKeyInfo,encryptedData), 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
    { 0, 0x0, 0xbe, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
};

static struct asn_template_ EncryptionAlgorithmIdentifier[] = {
    { 0, 0x0, 0xbf, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, 0, 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
    { 0, 0x0, 0xbf, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(pkcs8__AlgorithmIdentifier), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
};

static struct asn_template_ EncryptedData[] = {
    { 0, 0x0, 0xc0, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(pkcs8__EncryptedData), 0, 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
};



static struct asn_type_info_ pkcs8_types[] = {
    { AlgorithmIdentifier, 0, TEMPLATE_SIZE(AlgorithmIdentifier) },
    { PrivateKeyInfo, 0, TEMPLATE_SIZE(PrivateKeyInfo) },
    { UnencodedPrivateKeyInfo, 0, TEMPLATE_SIZE(UnencodedPrivateKeyInfo) },
    { Version, 0, TEMPLATE_SIZE(Version) },
    { PrivateKeyAlgorithmIdentifier, 0, TEMPLATE_SIZE(PrivateKeyAlgorithmIdentifier) },
    { PrivateKey, 0, TEMPLATE_SIZE(PrivateKey) },
    { PrivateKeyAttributes, 0, TEMPLATE_SIZE(PrivateKeyAttributes) },
    { EncryptedPrivateKeyInfo, 0, TEMPLATE_SIZE(EncryptedPrivateKeyInfo) },
    { EncryptionAlgorithmIdentifier, 0, TEMPLATE_SIZE(EncryptionAlgorithmIdentifier) },
    { EncryptedData, 0, TEMPLATE_SIZE(EncryptedData) },
};

static struct a2c_module_ pkcs8__module__ = { 10, pkcs8_types, "pkcs8" };

PRIVATE_DEF a2c_module pkcs8 = (a2c_module)&pkcs8__module__;

