/*
 *
 *    pkcs8.h
 *
 *    Note, this file consists of machine-generated data structures.
 *    Do not edit these contents.
 *
 *
 *    $Source: /usr/local/CVS/SETREF_1_0_Release/asn1/src/pkcs8.h,v 
 *    $Revision: 1.8 
 *    $Date: 1997/07/01 01:08:45 
 *    $Name: SETREF_1_0_Release 
 *    $Disclaimer: 
 *    ----------------------------------------------------------------------
 *    SET Draft Reference Implementation Disclaimer/License
 *    June 30, 1997
 *    
 *    This is a beta version of the SET Draft Reference Implementation
 *    ("DRI").  It is a work in progress and is being provided at this
 *    stage and in this form to help developers and other interested
 *    parties to understand the SET protocol.  This version of the DRI
 *    provides the core functionality required to process a simple
 *    transaction.  This release does not support certificate authority
 *    messages. Nor does it support the SET option to perform
 *    transactions without cardholder certificates.  For more details
 *    on the functionality in this beta version, please refer to the
 *    attached documentation.  
 *    
 *    Later versions of the DRI will include additional functionality
 *    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
 *    DEVELOPMENT.  If you discover a bug, please let us know by posting
 *    a message to the SET-DEV mailing list.  Our lawyers made us include
 *    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
 *    describes what you can do with the DRI.
 *     
 *    Copyright (C) 1996, 1997, Visa International Service Association and
 *    MasterCard International Incorporated.  All rights reserved.  
 *    Permission to copy and implement the material contained herein is
 *    granted subject to the conditions that (i) any copy or re-publication
 *    must bear this legend in full; (ii) any derivative work must bear
 *    a notice that it is not the Draft Reference Implementation ("DRI")
 *    for SET and (iii) that none of the copyright holders shall have any
 *    responsibility or liability whatsoever to any other party arising
 *    from the use or publication of the material contained herein.
 *    
 *    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
 *    limited license to (i) make, use, copy and modify the DRI for the
 *    purpose of developing software that complies with the SET
 *    Specification ("SET Products") and for the purpose of achieving a
 *    better understanding of the SET Protocol; and (ii) distribute SET
 *    Products that incorporate all or a portion of the DRI and other
 *    software, which together are provided under a defined interface
 *    different from that provided by the DRI's API.  Licensee shall not
 *    redistribute or sell a license to the DRI nor shall Licensee
 *    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
 *    means a product that provides comprehensive facilities to enable
 *    other parties to create software products for distribution. 
 *    Bolt-on applications and payment modules shall not be considered
 *    Toolkits for the purpose of this license.  The DRI is not intended
 *    to be used as a Toolkit.
 *    
 *    Licensors make no representation or warranty of any kind, express
 *    or implied, relating to the DRI.  Licensors are making the DRI
 *    publicly available as an aid to understanding, creating, and
 *    testing SET Products.  Licensees are solely responsible for any
 *    use of the DRI and agree to hold Licensors harmless for any claim
 *    that may arise out of any product created with the DRI.  
 *    
 *    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
 *    Corporation with offices at 4984 El Camino Real, Los Altos,
 *    California, as a third party beneficiary of this license.
 *    
 *    This software is controlled material under U.S. law and the laws
 *    of other jurisdictions and you hereby acknowledge and agree that
 *    you must fully comply with all the current laws of the United States
 *    including, without limitation, rules and regulations of the United
 *    States Office of Export Administration and other applicable U.S.
 *    governmental agencies.  
 *    ----------------------------------------------------------------------
 *     $
 *
 *    Copyright (C) 1996, 1997, Visa International Service Association and MasterCard International Incorporated
 *    All Rights Reserved.
 *
 *    briank@terisa.com
 *
 */

#ifndef __pkcs8__h__
#define __pkcs8__h__

#include <define.h>

#include <asn_types.h>

#ifdef __cplusplus
extern "C" {
#endif


#include "x509.h"

typedef
    asn__any                       pkcs8__AlgorithmIdentifier       ; 

typedef
    asn__any                       pkcs8__PrivateKeyInfo            ; 

typedef
    asn__integer                   pkcs8__Version                   ; 

typedef
    pkcs8__AlgorithmIdentifier     pkcs8__PrivateKeyAlgorithmIdentifier   ; 

typedef
    asn__octet_string              pkcs8__PrivateKey                ; 

typedef
    struct                         pkcs8__PrivateKeyAttributes_       
    {                                                                 
        struct pkcs8__PrivateKeyAttributes_ *next                            ; 
        x509__Attribute                attribute                        ; 
    }                              pkcs8__PrivateKeyAttributes      ; 

typedef
    struct                         pkcs8__UnencodedPrivateKeyInfo_     
    {                                                                 
# define                               pkcs8__UnencodedPrivateKeyInfo__attributes   0 
        UCHAR                          _present[1]                      ; 
        pkcs8__Version                 version                          ; 
        pkcs8__PrivateKeyAlgorithmIdentifier privateKeyAlgorithm              ; 
        pkcs8__PrivateKey              privateKey                       ; 
        pkcs8__PrivateKeyAttributes    *attributes                      ; 
    }                              pkcs8__UnencodedPrivateKeyInfo   ; 

typedef
    pkcs8__AlgorithmIdentifier     pkcs8__EncryptionAlgorithmIdentifier   ; 

typedef
    asn__octet_string              pkcs8__EncryptedData             ; 

typedef
    struct                         pkcs8__EncryptedPrivateKeyInfo_     
    {                                                                 
        pkcs8__EncryptionAlgorithmIdentifier encryptionAlgorithm              ; 
        pkcs8__EncryptedData           encryptedData                    ; 
    }                              pkcs8__EncryptedPrivateKeyInfo   ; 








# define                           PKCS8__ALGORITHMIDENTIFIER       0 /* pkcs8__AlgorithmIdentifier */
# define                           PKCS8__PRIVATEKEYINFO            1 /* pkcs8__PrivateKeyInfo */
# define                           PKCS8__UNENCODEDPRIVATEKEYINFO   2 /* pkcs8__UnencodedPrivateKeyInfo */
# define                           PKCS8__VERSION                   3 /* pkcs8__Version */
# define                           PKCS8__PRIVATEKEYALGORITHMIDENTIFIER   4 /* pkcs8__PrivateKeyAlgorithmIdentifier */
# define                           PKCS8__PRIVATEKEY                5 /* pkcs8__PrivateKey */
# define                           PKCS8__PRIVATEKEYATTRIBUTES      6 /* pkcs8__PrivateKeyAttributes */
# define                           PKCS8__ENCRYPTEDPRIVATEKEYINFO   7 /* pkcs8__EncryptedPrivateKeyInfo */
# define                           PKCS8__ENCRYPTIONALGORITHMIDENTIFIER   8 /* pkcs8__EncryptionAlgorithmIdentifier */
# define                           PKCS8__ENCRYPTEDDATA             9 /* pkcs8__EncryptedData */



PRIVATE      a2c_module                     pkcs8                            ; 


#ifdef __cplusplus
}
#endif
#endif

