/*
 *
 *    setpkcs7.h
 *
 *    Note, this file consists of machine-generated data structures.
 *    Do not edit these contents.
 *
 *
 *    $Source: /usr/local/CVS/SETREF_1_0_Release/asn1/src/setpkcs7.h,v 
 *    $Revision: 1.8 
 *    $Date: 1997/07/01 01:08:50 
 *    $Name: SETREF_1_0_Release 
 *    $Disclaimer: 
 *    ----------------------------------------------------------------------
 *    SET Draft Reference Implementation Disclaimer/License
 *    June 30, 1997
 *    
 *    This is a beta version of the SET Draft Reference Implementation
 *    ("DRI").  It is a work in progress and is being provided at this
 *    stage and in this form to help developers and other interested
 *    parties to understand the SET protocol.  This version of the DRI
 *    provides the core functionality required to process a simple
 *    transaction.  This release does not support certificate authority
 *    messages. Nor does it support the SET option to perform
 *    transactions without cardholder certificates.  For more details
 *    on the functionality in this beta version, please refer to the
 *    attached documentation.  
 *    
 *    Later versions of the DRI will include additional functionality
 *    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
 *    DEVELOPMENT.  If you discover a bug, please let us know by posting
 *    a message to the SET-DEV mailing list.  Our lawyers made us include
 *    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
 *    describes what you can do with the DRI.
 *     
 *    Copyright (C) 1996, 1997, Visa International Service Association and
 *    MasterCard International Incorporated.  All rights reserved.  
 *    Permission to copy and implement the material contained herein is
 *    granted subject to the conditions that (i) any copy or re-publication
 *    must bear this legend in full; (ii) any derivative work must bear
 *    a notice that it is not the Draft Reference Implementation ("DRI")
 *    for SET and (iii) that none of the copyright holders shall have any
 *    responsibility or liability whatsoever to any other party arising
 *    from the use or publication of the material contained herein.
 *    
 *    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
 *    limited license to (i) make, use, copy and modify the DRI for the
 *    purpose of developing software that complies with the SET
 *    Specification ("SET Products") and for the purpose of achieving a
 *    better understanding of the SET Protocol; and (ii) distribute SET
 *    Products that incorporate all or a portion of the DRI and other
 *    software, which together are provided under a defined interface
 *    different from that provided by the DRI's API.  Licensee shall not
 *    redistribute or sell a license to the DRI nor shall Licensee
 *    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
 *    means a product that provides comprehensive facilities to enable
 *    other parties to create software products for distribution. 
 *    Bolt-on applications and payment modules shall not be considered
 *    Toolkits for the purpose of this license.  The DRI is not intended
 *    to be used as a Toolkit.
 *    
 *    Licensors make no representation or warranty of any kind, express
 *    or implied, relating to the DRI.  Licensors are making the DRI
 *    publicly available as an aid to understanding, creating, and
 *    testing SET Products.  Licensees are solely responsible for any
 *    use of the DRI and agree to hold Licensors harmless for any claim
 *    that may arise out of any product created with the DRI.  
 *    
 *    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
 *    Corporation with offices at 4984 El Camino Real, Los Altos,
 *    California, as a third party beneficiary of this license.
 *    
 *    This software is controlled material under U.S. law and the laws
 *    of other jurisdictions and you hereby acknowledge and agree that
 *    you must fully comply with all the current laws of the United States
 *    including, without limitation, rules and regulations of the United
 *    States Office of Export Administration and other applicable U.S.
 *    governmental agencies.  
 *    ----------------------------------------------------------------------
 *     $
 *
 *    Copyright (C) 1996, 1997, Visa International Service Association and MasterCard International Incorporated
 *    All Rights Reserved.
 *
 *    briank@terisa.com
 *
 */

#ifndef __setpkcs7__h__
#define __setpkcs7__h__

#include <define.h>

#include <asn_types.h>

#ifdef __cplusplus
extern "C" {
#endif


#include "x509.h"

typedef
    asn__any                       setpkcs7__Certificate            ; 

typedef
    asn__any                       setpkcs7__CertificateRevocationList   ; 

typedef
    asn__any                       setpkcs7__Name                   ; 

typedef
    struct                         setpkcs7__Attributes_              
    {                                                                 
        struct setpkcs7__Attributes_   *next                            ; 
        x509__Attribute                attribute                        ; 
    }                              setpkcs7__Attributes             ; 

typedef
    asn__octet_string              setpkcs7__Data                   ; 

typedef
    struct                         setpkcs7__CertificateRevocationLists_     
    {                                                                 
        struct setpkcs7__CertificateRevocationLists_ *next                            ; 
        setpkcs7__CertificateRevocationList certificateRevocationList        ; 
    }                              setpkcs7__CertificateRevocationLists   ; 

typedef
    struct                         setpkcs7__Certificates_            
    {                                                                 
        struct setpkcs7__Certificates_ *next                            ; 
        setpkcs7__Certificate          certificate                      ; 
    }                              setpkcs7__Certificates           ; 

typedef
    x509__AlgorithmIdentifier      setpkcs7__ContentEncryptionAlgorithmIdentifier   ; 

typedef
    x509__AlgorithmIdentifier      setpkcs7__DigestAlgorithmIdentifier   ; 

typedef
    x509__AlgorithmIdentifier      setpkcs7__DigestEncryptionAlgorithmIdentifier   ; 

typedef
    struct                         setpkcs7__IssuerAndSerialNumber_     
    {                                                                 
        setpkcs7__Name                 issuer                           ; 
        x509__CertificateSerialNumber  serialNumber                     ; 
    }                              setpkcs7__IssuerAndSerialNumber   ; 

typedef
    x509__AlgorithmIdentifier      setpkcs7__KeyEncryptionAlgorithmIdentifier   ; 

typedef
    asn__integer                   setpkcs7__Version                ; 

typedef
    asn__object_identifier         setpkcs7__ContentType            ; 

typedef
    struct                         setpkcs7__ContentInfo_             
    {                                                                 
# define                               setpkcs7__ContentInfo__content   0 
        UCHAR                          _present[1]                      ; 
        setpkcs7__ContentType          contentType                      ; 
        asn__any                       content                          ; 
    }                              setpkcs7__ContentInfo            ; 

typedef
    struct                         setpkcs7__DigestAlgorithmIdentifiers_     
    {                                                                 
        struct setpkcs7__DigestAlgorithmIdentifiers_ *next                            ; 
        setpkcs7__DigestAlgorithmIdentifier digestAlgorithmIdentifier        ; 
    }                              setpkcs7__DigestAlgorithmIdentifiers   ; 

typedef
    asn__octet_string              setpkcs7__EncryptedDigest        ; 

typedef
    struct                         setpkcs7__SignerInfo_              
    {                                                                 
# define                               setpkcs7__SignerInfo__authenticatedAttributes   0 
# define                               setpkcs7__SignerInfo__unauthenticatedAttributes   1 
        UCHAR                          _present[1]                      ; 
        setpkcs7__Version              version                          ; 
        setpkcs7__IssuerAndSerialNumber issuerAndSerialNumber            ; 
        setpkcs7__DigestAlgorithmIdentifier digestAlgorithm                  ; 
        setpkcs7__Attributes           *authenticatedAttributes         ; 
        setpkcs7__DigestEncryptionAlgorithmIdentifier digestEncryptionAlgorithm        ; 
        setpkcs7__EncryptedDigest      encryptedDigest                  ; 
        setpkcs7__Attributes           *unauthenticatedAttributes       ; 
    }                              setpkcs7__SignerInfo             ; 

typedef
    struct                         setpkcs7__SignerInfos_             
    {                                                                 
        struct setpkcs7__SignerInfos_  *next                            ; 
        setpkcs7__SignerInfo           signerInfo                       ; 
    }                              setpkcs7__SignerInfos            ; 

typedef
    struct                         setpkcs7__SignedData_              
    {                                                                 
# define                               setpkcs7__SignedData__certificates   0 
# define                               setpkcs7__SignedData__crls       1 
        UCHAR                          _present[1]                      ; 
        setpkcs7__Version              version                          ; 
        setpkcs7__DigestAlgorithmIdentifiers *digestAlgorithms                ; 
        setpkcs7__ContentInfo          contentInfo                      ; 
        setpkcs7__Certificates         *certificates                    ; 
        setpkcs7__CertificateRevocationLists *crls                            ; 
        setpkcs7__SignerInfos          *signerInfos                     ; 
    }                              setpkcs7__SignedData             ; 

typedef
    asn__octet_string              setpkcs7__Digest                 ; 

typedef
    struct                         setpkcs7__DigestInfo_              
    {                                                                 
        setpkcs7__DigestAlgorithmIdentifier digestAlgorithm                  ; 
        setpkcs7__Digest               digest                           ; 
    }                              setpkcs7__DigestInfo             ; 

typedef
    asn__octet_string              setpkcs7__EncryptedKey           ; 

typedef
    struct                         setpkcs7__RecipientInfo_           
    {                                                                 
        setpkcs7__Version              version                          ; 
        setpkcs7__IssuerAndSerialNumber issuerAndSerialNumber            ; 
        setpkcs7__KeyEncryptionAlgorithmIdentifier keyEncryptionAlgorithm           ; 
        setpkcs7__EncryptedKey         encryptedKey                     ; 
    }                              setpkcs7__RecipientInfo          ; 

typedef
    struct                         setpkcs7__RecipientInfos_          
    {                                                                 
        struct setpkcs7__RecipientInfos_ *next                            ; 
        setpkcs7__RecipientInfo        recipientInfo                    ; 
    }                              setpkcs7__RecipientInfos         ; 

typedef
    asn__octet_string              setpkcs7__EncryptedContent       ; 

typedef
    struct                         setpkcs7__EncryptedContentInfo_     
    {                                                                 
# define                               setpkcs7__EncryptedContentInfo__encryptedContent   0 
        UCHAR                          _present[1]                      ; 
        setpkcs7__ContentType          contentType                      ; 
        setpkcs7__ContentEncryptionAlgorithmIdentifier contentEncryptionAlgorithm       ; 
        setpkcs7__EncryptedContent     encryptedContent                 ; 
    }                              setpkcs7__EncryptedContentInfo   ; 

typedef
    struct                         setpkcs7__EnvelopedData_           
    {                                                                 
        setpkcs7__Version              version                          ; 
        setpkcs7__RecipientInfos       *recipientInfos                  ; 
        setpkcs7__EncryptedContentInfo encryptedContentInfo             ; 
    }                              setpkcs7__EnvelopedData          ; 

typedef
    struct                         setpkcs7__DigestedData_            
    {                                                                 
        setpkcs7__Version              version                          ; 
        setpkcs7__DigestAlgorithmIdentifier digestAlgorithm                  ; 
        setpkcs7__ContentInfo          contentInfo                      ; 
        setpkcs7__Digest               digest                           ; 
    }                              setpkcs7__DigestedData           ; 



extern      asn__object_identifier         setpkcs7__pkcs_7                 ; 
extern      asn__object_identifier         setpkcs7__data                   ; 
extern      asn__object_identifier         setpkcs7__signedData             ; 
extern      asn__object_identifier         setpkcs7__envelopedData          ; 
extern      asn__object_identifier         setpkcs7__digestedData           ; 





# define                           SETPKCS7__CERTIFICATE            0 /* setpkcs7__Certificate */
# define                           SETPKCS7__CERTIFICATEREVOCATIONLIST   1 /* setpkcs7__CertificateRevocationList */
# define                           SETPKCS7__NAME                   2 /* setpkcs7__Name */
# define                           SETPKCS7__ATTRIBUTES             3 /* setpkcs7__Attributes */
# define                           SETPKCS7__DATA                   4 /* setpkcs7__Data */
# define                           SETPKCS7__CERTIFICATEREVOCATIONLISTS   5 /* setpkcs7__CertificateRevocationLists */
# define                           SETPKCS7__CERTIFICATES           6 /* setpkcs7__Certificates */
# define                           SETPKCS7__CONTENTENCRYPTIONALGORITHMIDENTIFIER   7 /* setpkcs7__ContentEncryptionAlgorithmIdentifier */
# define                           SETPKCS7__DIGESTALGORITHMIDENTIFIER   8 /* setpkcs7__DigestAlgorithmIdentifier */
# define                           SETPKCS7__DIGESTENCRYPTIONALGORITHMIDENTIFIER   9 /* setpkcs7__DigestEncryptionAlgorithmIdentifier */
# define                           SETPKCS7__ISSUERANDSERIALNUMBER  10 /* setpkcs7__IssuerAndSerialNumber */
# define                           SETPKCS7__KEYENCRYPTIONALGORITHMIDENTIFIER  11 /* setpkcs7__KeyEncryptionAlgorithmIdentifier */
# define                           SETPKCS7__VERSION               12 /* setpkcs7__Version */
# define                           SETPKCS7__CONTENTINFO           13 /* setpkcs7__ContentInfo */
# define                           SETPKCS7__CONTENTTYPE           14 /* setpkcs7__ContentType */
# define                           SETPKCS7__SIGNEDDATA            15 /* setpkcs7__SignedData */
# define                           SETPKCS7__DIGESTALGORITHMIDENTIFIERS  16 /* setpkcs7__DigestAlgorithmIdentifiers */
# define                           SETPKCS7__SIGNERINFOS           17 /* setpkcs7__SignerInfos */
# define                           SETPKCS7__SIGNERINFO            18 /* setpkcs7__SignerInfo */
# define                           SETPKCS7__ENCRYPTEDDIGEST       19 /* setpkcs7__EncryptedDigest */
# define                           SETPKCS7__DIGESTINFO            20 /* setpkcs7__DigestInfo */
# define                           SETPKCS7__DIGEST                21 /* setpkcs7__Digest */
# define                           SETPKCS7__ENVELOPEDDATA         22 /* setpkcs7__EnvelopedData */
# define                           SETPKCS7__RECIPIENTINFOS        23 /* setpkcs7__RecipientInfos */
# define                           SETPKCS7__ENCRYPTEDCONTENTINFO  24 /* setpkcs7__EncryptedContentInfo */
# define                           SETPKCS7__ENCRYPTEDCONTENT      25 /* setpkcs7__EncryptedContent */
# define                           SETPKCS7__RECIPIENTINFO         26 /* setpkcs7__RecipientInfo */
# define                           SETPKCS7__ENCRYPTEDKEY          27 /* setpkcs7__EncryptedKey */
# define                           SETPKCS7__DIGESTEDDATA          28 /* setpkcs7__DigestedData */



PRIVATE      a2c_module                     setpkcs7                         ; 


#ifdef __cplusplus
}
#endif
#endif

