/*
 *
 *    setpkcs7_useful.h
 *
 *    Note, this file consists of machine-generated data structures.
 *    Do not edit these contents.
 *
 *
 *    $Source: /usr/local/CVS/SETREF_1_0_Release/asn1/src/setpkcs7_useful.h,v 
 *    $Revision: 1.6 
 *    $Date: 1997/07/01 01:08:53 
 *    $Name: SETREF_1_0_Release 
 *    $Disclaimer: 
 *    ----------------------------------------------------------------------
 *    SET Draft Reference Implementation Disclaimer/License
 *    June 30, 1997
 *    
 *    This is a beta version of the SET Draft Reference Implementation
 *    ("DRI").  It is a work in progress and is being provided at this
 *    stage and in this form to help developers and other interested
 *    parties to understand the SET protocol.  This version of the DRI
 *    provides the core functionality required to process a simple
 *    transaction.  This release does not support certificate authority
 *    messages. Nor does it support the SET option to perform
 *    transactions without cardholder certificates.  For more details
 *    on the functionality in this beta version, please refer to the
 *    attached documentation.  
 *    
 *    Later versions of the DRI will include additional functionality
 *    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
 *    DEVELOPMENT.  If you discover a bug, please let us know by posting
 *    a message to the SET-DEV mailing list.  Our lawyers made us include
 *    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
 *    describes what you can do with the DRI.
 *     
 *    Copyright (C) 1996, 1997, Visa International Service Association and
 *    MasterCard International Incorporated.  All rights reserved.  
 *    Permission to copy and implement the material contained herein is
 *    granted subject to the conditions that (i) any copy or re-publication
 *    must bear this legend in full; (ii) any derivative work must bear
 *    a notice that it is not the Draft Reference Implementation ("DRI")
 *    for SET and (iii) that none of the copyright holders shall have any
 *    responsibility or liability whatsoever to any other party arising
 *    from the use or publication of the material contained herein.
 *    
 *    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
 *    limited license to (i) make, use, copy and modify the DRI for the
 *    purpose of developing software that complies with the SET
 *    Specification ("SET Products") and for the purpose of achieving a
 *    better understanding of the SET Protocol; and (ii) distribute SET
 *    Products that incorporate all or a portion of the DRI and other
 *    software, which together are provided under a defined interface
 *    different from that provided by the DRI's API.  Licensee shall not
 *    redistribute or sell a license to the DRI nor shall Licensee
 *    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
 *    means a product that provides comprehensive facilities to enable
 *    other parties to create software products for distribution. 
 *    Bolt-on applications and payment modules shall not be considered
 *    Toolkits for the purpose of this license.  The DRI is not intended
 *    to be used as a Toolkit.
 *    
 *    Licensors make no representation or warranty of any kind, express
 *    or implied, relating to the DRI.  Licensors are making the DRI
 *    publicly available as an aid to understanding, creating, and
 *    testing SET Products.  Licensees are solely responsible for any
 *    use of the DRI and agree to hold Licensors harmless for any claim
 *    that may arise out of any product created with the DRI.  
 *    
 *    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
 *    Corporation with offices at 4984 El Camino Real, Los Altos,
 *    California, as a third party beneficiary of this license.
 *    
 *    This software is controlled material under U.S. law and the laws
 *    of other jurisdictions and you hereby acknowledge and agree that
 *    you must fully comply with all the current laws of the United States
 *    including, without limitation, rules and regulations of the United
 *    States Office of Export Administration and other applicable U.S.
 *    governmental agencies.  
 *    ----------------------------------------------------------------------
 *     $
 *
 *    Copyright (C) 1996, 1997, Visa International Service Association and MasterCard International Incorporated
 *    All Rights Reserved.
 *
 *    briank@terisa.com
 *
 */

#ifndef __setpkcs7_useful__h__
#define __setpkcs7_useful__h__

#include <define.h>

#include <asn_types.h>

#ifdef __cplusplus
extern "C" {
#endif


#include "setpkcs7.h"
#include "x509.h"

typedef
    asn__any                       setpkcs7_useful__AlgorithmIdentifier   ; 

typedef
    setpkcs7_useful__AlgorithmIdentifier setpkcs7_useful__DigestAlgorithmIdentifier   ; 

typedef
    struct                         setpkcs7_useful__DigestAlgorithmIdentifiers_     
    {                                                                 
        struct setpkcs7_useful__DigestAlgorithmIdentifiers_ *next                            ; 
        setpkcs7_useful__DigestAlgorithmIdentifier digestAlgorithmIdentifier        ; 
    }                              setpkcs7_useful__DigestAlgorithmIdentifiers   ; 

typedef
    asn__any                       setpkcs7_useful__AnyIssuerAndSerialNumber   ; 

typedef
    struct                         setpkcs7_useful__Attributes_       
    {                                                                 
        struct setpkcs7_useful__Attributes_ *next                            ; 
        x509__Attribute                attribute                        ; 
    }                              setpkcs7_useful__Attributes      ; 

typedef
    setpkcs7_useful__AlgorithmIdentifier setpkcs7_useful__DigestEncryptionAlgorithmIdentifier   ; 

typedef
    asn__octet_string              setpkcs7_useful__EncryptedDigest   ; 

typedef
    struct                         setpkcs7_useful__SignerInfo_       
    {                                                                 
# define                               setpkcs7_useful__SignerInfo__authenticatedAttributes   0 
# define                               setpkcs7_useful__SignerInfo__unauthenticatedAttributes   1 
        UCHAR                          _present[1]                      ; 
        setpkcs7__Version              version                          ; 
        setpkcs7_useful__AnyIssuerAndSerialNumber issuerAndSerialNumber            ; 
        setpkcs7_useful__DigestAlgorithmIdentifier digestAlgorithm                  ; 
        setpkcs7_useful__Attributes    *authenticatedAttributes         ; 
        setpkcs7_useful__DigestEncryptionAlgorithmIdentifier digestEncryptionAlgorithm        ; 
        setpkcs7_useful__EncryptedDigest encryptedDigest                  ; 
        setpkcs7_useful__Attributes    *unauthenticatedAttributes       ; 
    }                              setpkcs7_useful__SignerInfo      ; 

typedef
    struct                         setpkcs7_useful__SignerInfos_      
    {                                                                 
        struct setpkcs7_useful__SignerInfos_ *next                            ; 
        setpkcs7_useful__SignerInfo    signerInfo                       ; 
    }                              setpkcs7_useful__SignerInfos     ; 

typedef
    struct                         setpkcs7_useful__SignedData_       
    {                                                                 
# define                               setpkcs7_useful__SignedData__certificates   0 
# define                               setpkcs7_useful__SignedData__crls   1 
        UCHAR                          _present[1]                      ; 
        setpkcs7__Version              version                          ; 
        setpkcs7_useful__DigestAlgorithmIdentifiers *digestAlgorithms                ; 
        setpkcs7__ContentInfo          contentInfo                      ; 
        setpkcs7__Certificates         *certificates                    ; 
        setpkcs7__CertificateRevocationLists *crls                            ; 
        setpkcs7_useful__SignerInfos   *signerInfos                     ; 
    }                              setpkcs7_useful__SignedData      ; 

typedef
    setpkcs7_useful__AlgorithmIdentifier setpkcs7_useful__ContentEncryptionAlgorithmIdentifier   ; 

typedef
    setpkcs7_useful__AlgorithmIdentifier setpkcs7_useful__KeyEncryptionAlgorithmIdentifier   ; 

typedef
    asn__octet_string              setpkcs7_useful__EncryptedContent   ; 

typedef
    asn__octet_string              setpkcs7_useful__EncryptedKey    ; 

typedef
    struct                         setpkcs7_useful__RecipientInfo_     
    {                                                                 
        setpkcs7__Version              version                          ; 
        setpkcs7_useful__AnyIssuerAndSerialNumber issuerAndSerialNumber            ; 
        setpkcs7_useful__KeyEncryptionAlgorithmIdentifier keyEncryptionAlgorithm           ; 
        setpkcs7_useful__EncryptedKey  encryptedKey                     ; 
    }                              setpkcs7_useful__RecipientInfo   ; 

typedef
    struct                         setpkcs7_useful__RecipientInfos_     
    {                                                                 
        struct setpkcs7_useful__RecipientInfos_ *next                            ; 
        setpkcs7_useful__RecipientInfo recipientInfo                    ; 
    }                              setpkcs7_useful__RecipientInfos   ; 

typedef
    struct                         setpkcs7_useful__EncryptedContentInfo_     
    {                                                                 
# define                               setpkcs7_useful__EncryptedContentInfo__encryptedContent   0 
        UCHAR                          _present[1]                      ; 
        setpkcs7__ContentType          contentType                      ; 
        setpkcs7_useful__ContentEncryptionAlgorithmIdentifier contentEncryptionAlgorithm       ; 
        setpkcs7_useful__EncryptedContent encryptedContent                 ; 
    }                              setpkcs7_useful__EncryptedContentInfo   ; 

typedef
    struct                         setpkcs7_useful__EnvelopedData_     
    {                                                                 
        setpkcs7__Version              version                          ; 
        setpkcs7_useful__RecipientInfos *recipientInfos                  ; 
        setpkcs7_useful__EncryptedContentInfo encryptedContentInfo             ; 
    }                              setpkcs7_useful__EnvelopedData   ; 








# define                           SETPKCS7_USEFUL__SIGNEDDATA      0 /* setpkcs7_useful__SignedData */
# define                           SETPKCS7_USEFUL__ALGORITHMIDENTIFIER   1 /* setpkcs7_useful__AlgorithmIdentifier */
# define                           SETPKCS7_USEFUL__DIGESTENCRYPTIONALGORITHMIDENTIFIER   2 /* setpkcs7_useful__DigestEncryptionAlgorithmIdentifier */
# define                           SETPKCS7_USEFUL__DIGESTALGORITHMIDENTIFIER   3 /* setpkcs7_useful__DigestAlgorithmIdentifier */
# define                           SETPKCS7_USEFUL__CONTENTENCRYPTIONALGORITHMIDENTIFIER   4 /* setpkcs7_useful__ContentEncryptionAlgorithmIdentifier */
# define                           SETPKCS7_USEFUL__KEYENCRYPTIONALGORITHMIDENTIFIER   5 /* setpkcs7_useful__KeyEncryptionAlgorithmIdentifier */
# define                           SETPKCS7_USEFUL__DIGESTALGORITHMIDENTIFIERS   6 /* setpkcs7_useful__DigestAlgorithmIdentifiers */
# define                           SETPKCS7_USEFUL__SIGNERINFOS     7 /* setpkcs7_useful__SignerInfos */
# define                           SETPKCS7_USEFUL__ANYISSUERANDSERIALNUMBER   8 /* setpkcs7_useful__AnyIssuerAndSerialNumber */
# define                           SETPKCS7_USEFUL__ATTRIBUTES      9 /* setpkcs7_useful__Attributes */
# define                           SETPKCS7_USEFUL__ENCRYPTEDDIGEST  10 /* setpkcs7_useful__EncryptedDigest */
# define                           SETPKCS7_USEFUL__SIGNERINFO     11 /* setpkcs7_useful__SignerInfo */
# define                           SETPKCS7_USEFUL__ENCRYPTEDCONTENT  12 /* setpkcs7_useful__EncryptedContent */
# define                           SETPKCS7_USEFUL__RECIPIENTINFOS  13 /* setpkcs7_useful__RecipientInfos */
# define                           SETPKCS7_USEFUL__RECIPIENTINFO  14 /* setpkcs7_useful__RecipientInfo */
# define                           SETPKCS7_USEFUL__ENCRYPTEDKEY   15 /* setpkcs7_useful__EncryptedKey */
# define                           SETPKCS7_USEFUL__ENCRYPTEDCONTENTINFO  16 /* setpkcs7_useful__EncryptedContentInfo */
# define                           SETPKCS7_USEFUL__ENVELOPEDDATA  17 /* setpkcs7_useful__EnvelopedData */



PRIVATE      a2c_module                     setpkcs7_useful                  ; 


#ifdef __cplusplus
}
#endif
#endif

