#
#    targets.mk
#
#    $Source: /usr/local/CVS/SETREF_1_0_Release/asn1/src/targets.mk,v 
#    $Revision: 1.7 
#    $Date: 1997/06/25 16:45:49 
#    $Name: SETREF_1_0_Release 
#    $Disclaimer: 
#    ----------------------------------------------------------------------
#    SET Draft Reference Implementation Disclaimer/License
#    June 30, 1997
#    
#    This is a beta version of the SET Draft Reference Implementation
#    ("DRI").  It is a work in progress and is being provided at this
#    stage and in this form to help developers and other interested
#    parties to understand the SET protocol.  This version of the DRI
#    provides the core functionality required to process a simple
#    transaction.  This release does not support certificate authority
#    messages. Nor does it support the SET option to perform
#    transactions without cardholder certificates.  For more details
#    on the functionality in this beta version, please refer to the
#    attached documentation.  
#    
#    Later versions of the DRI will include additional functionality
#    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
#    DEVELOPMENT.  If you discover a bug, please let us know by posting
#    a message to the SET-DEV mailing list.  Our lawyers made us include
#    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
#    describes what you can do with the DRI.
#     
#    Copyright (C) 1996, 1997, Visa International Service Association and
#    MasterCard International Incorporated.  All rights reserved.  
#    Permission to copy and implement the material contained herein is
#    granted subject to the conditions that (i) any copy or re-publication
#    must bear this legend in full; (ii) any derivative work must bear
#    a notice that it is not the Draft Reference Implementation ("DRI")
#    for SET and (iii) that none of the copyright holders shall have any
#    responsibility or liability whatsoever to any other party arising
#    from the use or publication of the material contained herein.
#    
#    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
#    limited license to (i) make, use, copy and modify the DRI for the
#    purpose of developing software that complies with the SET
#    Specification ("SET Products") and for the purpose of achieving a
#    better understanding of the SET Protocol; and (ii) distribute SET
#    Products that incorporate all or a portion of the DRI and other
#    software, which together are provided under a defined interface
#    different from that provided by the DRI's API.  Licensee shall not
#    redistribute or sell a license to the DRI nor shall Licensee
#    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
#    means a product that provides comprehensive facilities to enable
#    other parties to create software products for distribution. 
#    Bolt-on applications and payment modules shall not be considered
#    Toolkits for the purpose of this license.  The DRI is not intended
#    to be used as a Toolkit.
#    
#    Licensors make no representation or warranty of any kind, express
#    or implied, relating to the DRI.  Licensors are making the DRI
#    publicly available as an aid to understanding, creating, and
#    testing SET Products.  Licensees are solely responsible for any
#    use of the DRI and agree to hold Licensors harmless for any claim
#    that may arise out of any product created with the DRI.  
#    
#    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
#    Corporation with offices at 4984 El Camino Real, Los Altos,
#    California, as a third party beneficiary of this license.
#    
#    This software is controlled material under U.S. law and the laws
#    of other jurisdictions and you hereby acknowledge and agree that
#    you must fully comply with all the current laws of the United States
#    including, without limitation, rules and regulations of the United
#    States Office of Export Administration and other applicable U.S.
#    governmental agencies.  
#    ----------------------------------------------------------------------
#     $
#
#    Copyright (C) 1997, Visa International Service Association and MasterCard International Incorporated
#    All Rights Reserved.
#
#    briank@terisa.com
#



#
#    CONFIGURE USER-DEFINED LOCAL ENVIRONMENT
#
#    These fields are specified by the user.  The remainder of
#    this file is generated from this user-specified information.
#
# ASN1_DEFINES:
#    cpp defines, with the -D flag preceeding each
#
# ASN1_INCLUDES:
#    cpp include directories, with the -I flag preceeding each
#
# ASN1_INTERNAL:
#    headers files which are local to a specific module directory,
#    and should not be used by other parts of the toolkit or by
#    the user
#
# ASN1_LIBNAME:
#    the library associated with this module directory, used in
#    most cases for debugging purposes
#
# ASN1_MAKEFILES:
#    the makefiles
#
# ASN1_PREFIX:
#    defines the module name, which also serves as the
#    prefix for all the variable names defined in this file
#
# ASN1_PRIVATE:
#    the private, for-toolkit-use-only API header files
#
# ASN1_PROGRAMS:
#    programs to build
#
# ASN1_PUBLIC:
#    the header files that define the public API for the toolkit
#
# ASN1_SOURCES:
#    the source files to compile to object
#
ASN1_DEFINES              =
ASN1_INCLUDES             = -I$(A2C_SRCDIR) -I$(ALLOC_CTX_SRCDIR) \
                            -I$(ALLOC_CTX_SRCDIR) -I$(INCLUDE_SRCDIR) \
                            -I$(ERROR_CTX_SRCDIR) -I$(IO_CTX_SRCDIR)
ASN1_INTERNAL             =
ASN1_LIBNAME              = libasn1.$(LIBSUFFIX)
ASN1_MAKEFILES            = Makefile global.mk override.mk targets.mk
ASN1_PREFIX               = ASN1
ASN1_PRIVATE              =
ASN1_PROGRAMS             =
ASN1_PUBLIC               = asn1set.h pkcs8.h pkcs9.h setpkcs7.h \
                            setpkcs7_useful.h x509.h x509_useful.h
ASN1_SOURCES              = asn1set.c pkcs8.c pkcs9.c setpkcs7.c \
                            setpkcs7_useful.c x509.c x509_useful.c



#
#    CONFIGURE AUTOMATICALLY-GENERATED LOCAL ENVIRONMENT
#
# ASN1_OBJECTS:
#    object files to build
#
# ASN1_UNUSED:
#    obsolete files in the module directory that are not
#    used during the build process
#
# ASN1_USED:
#    all files in the module directory that are used
#    during the build process
#
ASN1_OBJECTS              = asn1set.$(OBJSUFFIX) pkcs8.$(OBJSUFFIX) \
                            pkcs9.$(OBJSUFFIX) setpkcs7.$(OBJSUFFIX) \
                            setpkcs7_useful.$(OBJSUFFIX) x509.$(OBJSUFFIX) \
                            x509_useful.$(OBJSUFFIX)
ASN1_UNUSED               =
ASN1_USED                 = $(ASN1_INTERNAL:%=$(ASN1_SRCDIR)%) \
                            $(ASN1_MAKEFILES:%=$(ASN1_SRCDIR)%) \
                            $(ASN1_PRIVATE:%=$(ASN1_SRCDIR)%) \
                            $(ASN1_PUBLIC:%=$(ASN1_SRCDIR)%) \
                            $(ASN1_SOURCES:%=$(ASN1_SRCDIR)%)



#
#    NOTES
#
#    The following variables may be used during the build process,
#    but are not defined in this file.  If they are to be set
#    to something other than the default blank, then they must
#    be set by the calling make system.
#
# ASN1_SRCDIR:
#    if the build target directory is different from the
#    module directory (the source directory), then this
#    variable contains the relative or full path of
#    the module directory
#
# LIBARS:
#    the library archive files (with fully-specified paths) that
#    executables built from this module directory depend upon
#
# LIBPATHS:
#    the paths to search for library archives (specified with
#    the -L)
#
# LIBS:
#    the libraries to use while building executables from
#    this module directory (specified with the -l)
#



#
#    GENERIC ENVIRONMENT
#
DEFINES                  += $(ASN1_DEFINES)
OBJECTS                  += $(ASN1_OBJECTS)
PUBLIC                   += $(ASN1_PUBLIC)



#
#    GENERIC DEPENDENCIES
#
# default:
#    default dependency, must be the first dependency in this makefile
#
# all:
#    build everything in this module directory
#
# build:
#    make only the toolkit build files of this module directory
#
# ci:
#    perform an RCS check-in of this module directory
#
# clean:
#    remove the compiled files
#
# clean_public:
#    remove the public header files that have been copied
#    to a public build directory
#
# objects:
#    build the object files (this dependency is used for
#    building the toolkit library)
#
# private:
#    build only the private API header files
#
# public:
#    build only the public API header files
#
default:                    $(ASN1_LIBNAME)
default:                    $(ASN1_PROGRAMS)

all:                        $(ASN1_PUBLIC)
all:                        $(ASN1_OBJECTS)
all:                        $(ASN1_LIBNAME)
all:                        $(ASN1_PROGRAMS)
build:                      $(ASN1_PUBLIC)
build:                      $(ASN1_OBJECTS)
ci:                         asn1_ci
clean:                      asn1_clean
clean_public:               asn1_clean_public
objects:                    $(ASN1_OBJECTS)
private:                    $(ASN1_PRIVATE)
public:                     $(ASN1_PUBLIC)



#
#    LOCAL UTILITY DEPENDENCIES
#
#    utility dependencies are necessary because of some
#    make-isms having to do with dependencies
#

asn1_ci:
	$(CI) $(CIFLAGS) $(ASN1_USED)

asn1_clean:
	$(RM) $(RMFLAGS) $(ASN1_OBJECTS) $(ASN1_LIBNAME) $(ASN1_PROGRAMS)

asn1_clean_public:
	$(RM) $(RMFLAGS) $(ASN1_PUBLIC)

asn1_objects: $(ASN1_OBJECTS)

asn1_programs: $(ASN1_PROGRAMS)

asn1_public: $(ASN1_PUBLIC)



#
#    BUILD DEPENDENCIES
#
#    build dependencies invoke the rule used to build each
#    class of file
#

$(ASN1_LIBNAME):
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@

$(ASN1_OBJECTS):
	$(COMPILE.c) $(ASN1_SRCDIR)$(@:%.$(OBJSUFFIX)=%.c) $(DEFINES) $(INCLUDES)
 
$(ASN1_PUBLIC):
	$(CP) $(CPFLAGS) $(ASN1_SRCDIR)$@ $@

$(ASN1_PROGRAMS):
	$(LINK.c) $@.$(OBJSUFFIX) $(LDLIBS) $(LIBS) $(LIBPATHS)



#
#    FILE DEPENDENCIES
#
#    file dependencies state, for each file that is built,
#    which file(s) it depends upon
#

asn1set.h: $(ASN1_SRCDIR)asn1set.h

pkcs8.h: $(ASN1_SRCDIR)pkcs8.h

pkcs9.h: $(ASN1_SRCDIR)pkcs9.h

setpkcs7.h: $(ASN1_SRCDIR)setpkcs7.h

setpkcs7_useful.h: $(ASN1_SRCDIR)setpkcs7_useful.h

x509.h: $(ASN1_SRCDIR)x509.h

x509_useful.h: $(ASN1_SRCDIR)x509_useful.h

asn1set.$(OBJSUFFIX): $(ASN1_SRCDIR)asn1set.h
asn1set.$(OBJSUFFIX): $(ASN1_SRCDIR)asn1set.c

pkcs8.$(OBJSUFFIX): $(ASN1_SRCDIR)pkcs8.h
pkcs8.$(OBJSUFFIX): $(ASN1_SRCDIR)pkcs8.c

pkcs9.$(OBJSUFFIX): $(ASN1_SRCDIR)pkcs9.h
pkcs9.$(OBJSUFFIX): $(ASN1_SRCDIR)pkcs9.c

setpkcs7.$(OBJSUFFIX): $(ASN1_SRCDIR)setpkcs7.h
setpkcs7.$(OBJSUFFIX): $(ASN1_SRCDIR)setpkcs7.c

setpkcs7_useful.$(OBJSUFFIX): $(ASN1_SRCDIR)setpkcs7_useful.h
setpkcs7_useful.$(OBJSUFFIX): $(ASN1_SRCDIR)setpkcs7_useful.c

x509.$(OBJSUFFIX): $(ASN1_SRCDIR)x509.h
x509.$(OBJSUFFIX): $(ASN1_SRCDIR)x509.c

x509_useful.$(OBJSUFFIX): $(ASN1_SRCDIR)x509_useful.h
x509_useful.$(OBJSUFFIX): $(ASN1_SRCDIR)x509_useful.c

$(ASN1_LIBNAME): $(ASN1_OBJECTS)
