/*
 *
 *    x509_useful.c
 *
 *    Note, this file consists of machine-generated code that
 *    is processed by an interpreter in the ASN.1/DER runtime.
 *    The contents of this file are not intended to be human-
 *    readable.  Do not edit these contents.
 *
 *
 *    $Source: /usr/local/CVS/SETREF_1_0_Release/asn1/src/x509_useful.c,v 
 *    $Revision: 1.6 
 *    $Date: 1997/07/01 01:08:58 
 *    $Name: SETREF_1_0_Release 
 *    $Disclaimer: 
 *    ----------------------------------------------------------------------
 *    SET Draft Reference Implementation Disclaimer/License
 *    June 30, 1997
 *    
 *    This is a beta version of the SET Draft Reference Implementation
 *    ("DRI").  It is a work in progress and is being provided at this
 *    stage and in this form to help developers and other interested
 *    parties to understand the SET protocol.  This version of the DRI
 *    provides the core functionality required to process a simple
 *    transaction.  This release does not support certificate authority
 *    messages. Nor does it support the SET option to perform
 *    transactions without cardholder certificates.  For more details
 *    on the functionality in this beta version, please refer to the
 *    attached documentation.  
 *    
 *    Later versions of the DRI will include additional functionality
 *    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
 *    DEVELOPMENT.  If you discover a bug, please let us know by posting
 *    a message to the SET-DEV mailing list.  Our lawyers made us include
 *    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
 *    describes what you can do with the DRI.
 *     
 *    Copyright (C) 1996, 1997, Visa International Service Association and
 *    MasterCard International Incorporated.  All rights reserved.  
 *    Permission to copy and implement the material contained herein is
 *    granted subject to the conditions that (i) any copy or re-publication
 *    must bear this legend in full; (ii) any derivative work must bear
 *    a notice that it is not the Draft Reference Implementation ("DRI")
 *    for SET and (iii) that none of the copyright holders shall have any
 *    responsibility or liability whatsoever to any other party arising
 *    from the use or publication of the material contained herein.
 *    
 *    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
 *    limited license to (i) make, use, copy and modify the DRI for the
 *    purpose of developing software that complies with the SET
 *    Specification ("SET Products") and for the purpose of achieving a
 *    better understanding of the SET Protocol; and (ii) distribute SET
 *    Products that incorporate all or a portion of the DRI and other
 *    software, which together are provided under a defined interface
 *    different from that provided by the DRI's API.  Licensee shall not
 *    redistribute or sell a license to the DRI nor shall Licensee
 *    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
 *    means a product that provides comprehensive facilities to enable
 *    other parties to create software products for distribution. 
 *    Bolt-on applications and payment modules shall not be considered
 *    Toolkits for the purpose of this license.  The DRI is not intended
 *    to be used as a Toolkit.
 *    
 *    Licensors make no representation or warranty of any kind, express
 *    or implied, relating to the DRI.  Licensors are making the DRI
 *    publicly available as an aid to understanding, creating, and
 *    testing SET Products.  Licensees are solely responsible for any
 *    use of the DRI and agree to hold Licensors harmless for any claim
 *    that may arise out of any product created with the DRI.  
 *    
 *    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
 *    Corporation with offices at 4984 El Camino Real, Los Altos,
 *    California, as a third party beneficiary of this license.
 *    
 *    This software is controlled material under U.S. law and the laws
 *    of other jurisdictions and you hereby acknowledge and agree that
 *    you must fully comply with all the current laws of the United States
 *    including, without limitation, rules and regulations of the United
 *    States Office of Export Administration and other applicable U.S.
 *    governmental agencies.  
 *    ----------------------------------------------------------------------
 *     $
 *
 *    Copyright (C) 1996, 1997, Visa International Service Association and MasterCard International Incorporated
 *    All Rights Reserved.
 *
 *    briank@terisa.com
 *
 */

#include <a2c_dot_c_file.h>
#include "x509_useful.h"

#ifndef LINT
static char rcsid[] = "$Id: x509_useful.c,v 1.6 1997/07/01 01:08:58 briank Exp ";
#endif



















static
asn__boolean                  default__asn__boolean__FALSE = 0;


static struct asn_template_ Name[] = {
    { 0, 0x0, 0x89, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, 0, 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
    { 0, 0x0, 0x89, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(x509_useful__Name), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
};

static struct asn_template_ SubjectPublicKeyInfo[] = {
    { 0, 0x0, 0x8a, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, 0, 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
    { 0, 0x0, 0x8a, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(x509_useful__SubjectPublicKeyInfo), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
};

static struct asn_template_ SIGNED[] = {
    { 0, 0x0, 0x8e, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509_useful__SIGNED), 0, 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
        { 1, 0x8e, 0x8b, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(asn__any), OFFSET(x509_useful__SIGNED,toBeSigned), 0, 0, 0, 0, VTBL_ANY, 0, -1 },
        { 1, 0x8e, 0x8c, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__SIGNED,algorithm), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
        { 1, 0x8e, 0x8c, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(asn__any), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
        { 1, 0x8e, 0x8d, 0, 0, CLASS_UNIVERSAL, 3, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__SIGNED,signature), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
        { 1, 0x8e, 0x8d, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(asn__octet_string), 0, 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
    { 0, 0x0, 0x8e, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
};

static struct asn_template_ Certificate[] = {
    { 0, 0x0, 0x92, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509_useful__Certificate), 0, 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
        { 1, 0x92, 0x8f, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509_useful__UnsignedCertificate), OFFSET(x509_useful__Certificate,toBeSigned), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
            { 2, 0x9d, 0x93, 0, 0, CLASS_CONTEXT, 0, TAGGING_EXPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,version), 0, 0, 0, 0, VTBL_EXPLICIT_TAG, FLAG_DEFAULT, -1 },
                { 3, 0x9d, 0x93, 0, 0, CLASS_UNIVERSAL, TAG_INTEGER, TAGGING_BASE, sizeof(x509__Version), 0, 0, 0, &x509__v1, 0, VTBL_INTEGER, FLAG_DEFAULT, -1 },
            { 2, 0x9d, 0x93, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
            { 2, 0x9d, 0x94, 0, 0, CLASS_UNIVERSAL, 2, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,serialNumber), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
            { 2, 0x9d, 0x94, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(x509__SerialNumber), 0, 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
            { 2, 0x9d, 0x95, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__AlgorithmIdentifier), OFFSET(x509_useful__UnsignedCertificate,signature), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                { 3, 0x35, 0x33, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__AlgorithmIdentifier,algorithm), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
                { 3, 0x35, 0x34, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(asn__any), OFFSET(x509__AlgorithmIdentifier,parameters), 0, 0, 0, 0, VTBL_ANY, FLAG_OPTIONAL, 0 },
            { 2, 0x9d, 0x95, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
            { 2, 0x9d, 0x96, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,issuer), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
            { 2, 0x9d, 0x96, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(x509_useful__Name), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
            { 2, 0x9d, 0x97, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__Validity), OFFSET(x509_useful__UnsignedCertificate,validity), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                { 3, 0x2f, 0x2d, 0, 0, CLASS_UNIVERSAL, TAG_UTCTime, TAGGING_BASE, sizeof(asn__utc_time), OFFSET(x509__Validity,notBefore), 0, 0, 0, 0, VTBL_UTCTime, 0, -1 },
                { 3, 0x2f, 0x2e, 0, 0, CLASS_UNIVERSAL, TAG_UTCTime, TAGGING_BASE, sizeof(asn__utc_time), OFFSET(x509__Validity,notAfter), 0, 0, 0, 0, VTBL_UTCTime, 0, -1 },
            { 2, 0x9d, 0x97, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
            { 2, 0x9d, 0x98, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,subject), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
            { 2, 0x9d, 0x98, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(x509_useful__Name), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
            { 2, 0x9d, 0x99, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,subjectPublicKeyInfo), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
            { 2, 0x9d, 0x99, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(x509_useful__SubjectPublicKeyInfo), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
            { 2, 0x9d, 0x9a, 0, 0, CLASS_CONTEXT, 1, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,issuerUniqueIdentifier), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, FLAG_OPTIONAL, 0 },
            { 2, 0x9d, 0x9a, 0, 0, CLASS_UNIVERSAL, TAG_BIT_STRING, TAGGING_BASE, sizeof(x509__UniqueIdentifier), 0, 0, 0, 0, 0, VTBL_BIT_STRING, 0, 0 },
            { 2, 0x9d, 0x9b, 0, 0, CLASS_CONTEXT, 2, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,subjectUniqueIdentifier), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, FLAG_OPTIONAL, 1 },
            { 2, 0x9d, 0x9b, 0, 0, CLASS_UNIVERSAL, TAG_BIT_STRING, TAGGING_BASE, sizeof(x509__UniqueIdentifier), 0, 0, 0, 0, 0, VTBL_BIT_STRING, 0, 1 },
            { 2, 0x9d, 0x9c, 0, 0, CLASS_CONTEXT, 3, TAGGING_EXPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,extensions), 0, 0, 0, 0, VTBL_EXPLICIT_TAG, FLAG_OPTIONAL, 2 },
                { 3, 0x9d, 0x9c, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE_OF, TAGGING_BASE, sizeof(x509__Extensions), 0, 0, 0, 0, 0, VTBL_SEQUENCE_OF, 0, 2 },
                    { 4, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__Extension), AOFFSET(x509__Extensions,extension), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                        { 5, 0x4c, 0x49, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__Extension,extnID), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
                        { 5, 0x4c, 0x4a, 0, 0, CLASS_UNIVERSAL, TAG_BOOLEAN, TAGGING_BASE, sizeof(asn__boolean), OFFSET(x509__Extension,critical), 0, 0, &default__asn__boolean__FALSE, 0, VTBL_BOOLEAN, FLAG_DEFAULT | FLAG_DEFAULT, -1 },
                        { 5, 0x4c, 0x4b, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(asn__octet_string), OFFSET(x509__Extension,extnValue), 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
                    { 4, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
                { 3, 0x9d, 0x9c, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
            { 2, 0x9d, 0x9c, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
        { 1, 0x92, 0x8f, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
        { 1, 0x92, 0x90, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__AlgorithmIdentifier), OFFSET(x509_useful__Certificate,algorithm), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
            { 2, 0x35, 0x33, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__AlgorithmIdentifier,algorithm), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
            { 2, 0x35, 0x34, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(asn__any), OFFSET(x509__AlgorithmIdentifier,parameters), 0, 0, 0, 0, VTBL_ANY, FLAG_OPTIONAL, 0 },
        { 1, 0x92, 0x90, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
        { 1, 0x92, 0x91, 0, 0, CLASS_UNIVERSAL, TAG_BIT_STRING, TAGGING_BASE, sizeof(asn__bit_string), OFFSET(x509_useful__Certificate,signature), 0, 0, 0, 0, VTBL_BIT_STRING, 0, -1 },
    { 0, 0x0, 0x92, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
};

static struct asn_template_ UnsignedCertificate[] = {
    { 0, 0x0, 0x9d, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509_useful__UnsignedCertificate), 0, 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
        { 1, 0x9d, 0x93, 0, 0, CLASS_CONTEXT, 0, TAGGING_EXPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,version), 0, 0, 0, 0, VTBL_EXPLICIT_TAG, FLAG_DEFAULT, -1 },
            { 2, 0x9d, 0x93, 0, 0, CLASS_UNIVERSAL, TAG_INTEGER, TAGGING_BASE, sizeof(x509__Version), 0, 0, 0, &x509__v1, 0, VTBL_INTEGER, FLAG_DEFAULT, -1 },
        { 1, 0x9d, 0x93, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
        { 1, 0x9d, 0x94, 0, 0, CLASS_UNIVERSAL, 2, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,serialNumber), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
        { 1, 0x9d, 0x94, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(x509__SerialNumber), 0, 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
        { 1, 0x9d, 0x95, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__AlgorithmIdentifier), OFFSET(x509_useful__UnsignedCertificate,signature), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
            { 2, 0x35, 0x33, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__AlgorithmIdentifier,algorithm), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
            { 2, 0x35, 0x34, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(asn__any), OFFSET(x509__AlgorithmIdentifier,parameters), 0, 0, 0, 0, VTBL_ANY, FLAG_OPTIONAL, 0 },
        { 1, 0x9d, 0x95, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
        { 1, 0x9d, 0x96, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,issuer), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
        { 1, 0x9d, 0x96, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(x509_useful__Name), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
        { 1, 0x9d, 0x97, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__Validity), OFFSET(x509_useful__UnsignedCertificate,validity), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
            { 2, 0x2f, 0x2d, 0, 0, CLASS_UNIVERSAL, TAG_UTCTime, TAGGING_BASE, sizeof(asn__utc_time), OFFSET(x509__Validity,notBefore), 0, 0, 0, 0, VTBL_UTCTime, 0, -1 },
            { 2, 0x2f, 0x2e, 0, 0, CLASS_UNIVERSAL, TAG_UTCTime, TAGGING_BASE, sizeof(asn__utc_time), OFFSET(x509__Validity,notAfter), 0, 0, 0, 0, VTBL_UTCTime, 0, -1 },
        { 1, 0x9d, 0x97, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
        { 1, 0x9d, 0x98, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,subject), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
        { 1, 0x9d, 0x98, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(x509_useful__Name), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
        { 1, 0x9d, 0x99, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,subjectPublicKeyInfo), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
        { 1, 0x9d, 0x99, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(x509_useful__SubjectPublicKeyInfo), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
        { 1, 0x9d, 0x9a, 0, 0, CLASS_CONTEXT, 1, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,issuerUniqueIdentifier), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, FLAG_OPTIONAL, 0 },
        { 1, 0x9d, 0x9a, 0, 0, CLASS_UNIVERSAL, TAG_BIT_STRING, TAGGING_BASE, sizeof(x509__UniqueIdentifier), 0, 0, 0, 0, 0, VTBL_BIT_STRING, 0, 0 },
        { 1, 0x9d, 0x9b, 0, 0, CLASS_CONTEXT, 2, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,subjectUniqueIdentifier), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, FLAG_OPTIONAL, 1 },
        { 1, 0x9d, 0x9b, 0, 0, CLASS_UNIVERSAL, TAG_BIT_STRING, TAGGING_BASE, sizeof(x509__UniqueIdentifier), 0, 0, 0, 0, 0, VTBL_BIT_STRING, 0, 1 },
        { 1, 0x9d, 0x9c, 0, 0, CLASS_CONTEXT, 3, TAGGING_EXPLICIT, 0, OFFSET(x509_useful__UnsignedCertificate,extensions), 0, 0, 0, 0, VTBL_EXPLICIT_TAG, FLAG_OPTIONAL, 2 },
            { 2, 0x9d, 0x9c, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE_OF, TAGGING_BASE, sizeof(x509__Extensions), 0, 0, 0, 0, 0, VTBL_SEQUENCE_OF, 0, 2 },
                { 3, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__Extension), AOFFSET(x509__Extensions,extension), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                    { 4, 0x4c, 0x49, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__Extension,extnID), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
                    { 4, 0x4c, 0x4a, 0, 0, CLASS_UNIVERSAL, TAG_BOOLEAN, TAGGING_BASE, sizeof(asn__boolean), OFFSET(x509__Extension,critical), 0, 0, &default__asn__boolean__FALSE, 0, VTBL_BOOLEAN, FLAG_DEFAULT | FLAG_DEFAULT, -1 },
                    { 4, 0x4c, 0x4b, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(asn__octet_string), OFFSET(x509__Extension,extnValue), 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
                { 3, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
            { 2, 0x9d, 0x9c, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
        { 1, 0x9d, 0x9c, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
    { 0, 0x0, 0x9d, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
};

static struct asn_template_ DirectoryString[] = {
    { 0, 0x0, 0xa2, 0, 0, CLASS_SPECIAL, TAG_CHOICE, TAGGING_BASE, sizeof(x509_useful__DirectoryString), 0, 0, 0, 0, 0, VTBL_CHOICE, 0, -1 },
        { 1, 0xa2, 0x9e, 0, 0, CLASS_UNIVERSAL, TAG_PrintableString, TAGGING_BASE, sizeof(asn__printable_string), COFFSET(x509_useful__DirectoryString,printable), 1, INT_MAX, 0, 0, VTBL_PrintableString, FLAG_BOUNDED, -1 },
        { 1, 0xa2, 0x9f, 0, 0, CLASS_UNIVERSAL, 20, TAGGING_IMPLICIT, 0, COFFSET(x509_useful__DirectoryString,t61), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
        { 1, 0xa2, 0x9f, 0, 0, CLASS_UNIVERSAL, TAG_IA5String, TAGGING_BASE, sizeof(asn__ia5_string), 0, 1, INT_MAX, 0, 0, VTBL_IA5String, FLAG_BOUNDED, -1 },
        { 1, 0xa2, 0xa0, 0, 0, CLASS_UNIVERSAL, TAG_IA5String, TAGGING_BASE, sizeof(asn__ia5_string), COFFSET(x509_useful__DirectoryString,ia5), 1, INT_MAX, 0, 0, VTBL_IA5String, FLAG_BOUNDED, -1 },
        { 1, 0xa2, 0xa1, 0, 0, CLASS_UNIVERSAL, TAG_BMPString, TAGGING_BASE, sizeof(asn__bmp_string), COFFSET(x509_useful__DirectoryString,bmp), 1, INT_MAX, 0, 0, VTBL_BMPString, FLAG_BOUNDED, -1 },
    { 0, 0x0, 0xa2, 0, 0, CLASS_SPECIAL, TAG_CHOICE_END, TAGGING_BASE, 0, 0, 0, 0, 0, 0, 0, 0, -1 },
};

static struct asn_template_ CertificateRevocationList[] = {
    { 0, 0x0, 0xa3, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509_useful__CRL), 0, 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
        { 1, 0xa7, 0xa4, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509_useful__UnsignedCertificateRevocationList), OFFSET(x509_useful__CRL,toBeSigned), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
            { 2, 0xaf, 0xa8, 0, 0, CLASS_UNIVERSAL, TAG_INTEGER, TAGGING_BASE, sizeof(x509__Version), OFFSET(x509_useful__UnsignedCertificateRevocationList,version), 0, 0, 0, 0, VTBL_INTEGER, FLAG_OPTIONAL, 0 },
            { 2, 0xaf, 0xa9, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__AlgorithmIdentifier), OFFSET(x509_useful__UnsignedCertificateRevocationList,signature), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                { 3, 0x35, 0x33, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__AlgorithmIdentifier,algorithm), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
                { 3, 0x35, 0x34, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(asn__any), OFFSET(x509__AlgorithmIdentifier,parameters), 0, 0, 0, 0, VTBL_ANY, FLAG_OPTIONAL, 0 },
            { 2, 0xaf, 0xa9, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
            { 2, 0xaf, 0xaa, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificateRevocationList,issuer), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
            { 2, 0xaf, 0xaa, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(x509_useful__Name), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
            { 2, 0xaf, 0xab, 0, 0, CLASS_UNIVERSAL, TAG_UTCTime, TAGGING_BASE, sizeof(asn__utc_time), OFFSET(x509_useful__UnsignedCertificateRevocationList,thisUpdate), 0, 0, 0, 0, VTBL_UTCTime, 0, -1 },
            { 2, 0xaf, 0xac, 0, 0, CLASS_UNIVERSAL, TAG_UTCTime, TAGGING_BASE, sizeof(asn__utc_time), OFFSET(x509_useful__UnsignedCertificateRevocationList,nextUpdate), 0, 0, 0, 0, VTBL_UTCTime, FLAG_OPTIONAL, 1 },
            { 2, 0xaf, 0xad, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE_OF, TAGGING_BASE, sizeof(x509__CRLEntries), OFFSET(x509_useful__UnsignedCertificateRevocationList,revokedCertificates), 0, 0, 0, 0, VTBL_SEQUENCE_OF, FLAG_OPTIONAL, 2 },
                { 3, 0x5b, 0x5a, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__CRLEntry), AOFFSET(x509__CRLEntries,cRLEntry), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                    { 4, 0x5f, 0x5c, 0, 0, CLASS_UNIVERSAL, 2, TAGGING_IMPLICIT, 0, OFFSET(x509__CRLEntry,userCertificate), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
                    { 4, 0x5f, 0x5c, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(x509__SerialNumber), 0, 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
                    { 4, 0x5f, 0x5d, 0, 0, CLASS_UNIVERSAL, TAG_UTCTime, TAGGING_BASE, sizeof(asn__utc_time), OFFSET(x509__CRLEntry,revocationDate), 0, 0, 0, 0, VTBL_UTCTime, 0, -1 },
                    { 4, 0x5f, 0x5e, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE_OF, TAGGING_BASE, sizeof(x509__Extensions), OFFSET(x509__CRLEntry,crlEntryExtensions), 0, 0, 0, 0, VTBL_SEQUENCE_OF, FLAG_OPTIONAL, 0 },
                        { 5, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__Extension), AOFFSET(x509__Extensions,extension), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                            { 6, 0x4c, 0x49, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__Extension,extnID), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
                            { 6, 0x4c, 0x4a, 0, 0, CLASS_UNIVERSAL, TAG_BOOLEAN, TAGGING_BASE, sizeof(asn__boolean), OFFSET(x509__Extension,critical), 0, 0, &default__asn__boolean__FALSE, 0, VTBL_BOOLEAN, FLAG_DEFAULT | FLAG_DEFAULT, -1 },
                            { 6, 0x4c, 0x4b, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(asn__octet_string), OFFSET(x509__Extension,extnValue), 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
                        { 5, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
                    { 4, 0x5f, 0x5e, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
                { 3, 0x5b, 0x5a, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
            { 2, 0xaf, 0xad, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
            { 2, 0xaf, 0xae, 0, 0, CLASS_CONTEXT, 0, TAGGING_EXPLICIT, 0, OFFSET(x509_useful__UnsignedCertificateRevocationList,crlExtensions), 0, 0, 0, 0, VTBL_EXPLICIT_TAG, FLAG_OPTIONAL, 3 },
                { 3, 0xaf, 0xae, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE_OF, TAGGING_BASE, sizeof(x509__Extensions), 0, 0, 0, 0, 0, VTBL_SEQUENCE_OF, 0, 3 },
                    { 4, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__Extension), AOFFSET(x509__Extensions,extension), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                        { 5, 0x4c, 0x49, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__Extension,extnID), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
                        { 5, 0x4c, 0x4a, 0, 0, CLASS_UNIVERSAL, TAG_BOOLEAN, TAGGING_BASE, sizeof(asn__boolean), OFFSET(x509__Extension,critical), 0, 0, &default__asn__boolean__FALSE, 0, VTBL_BOOLEAN, FLAG_DEFAULT | FLAG_DEFAULT, -1 },
                        { 5, 0x4c, 0x4b, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(asn__octet_string), OFFSET(x509__Extension,extnValue), 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
                    { 4, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
                { 3, 0xaf, 0xae, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
            { 2, 0xaf, 0xae, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
        { 1, 0xa7, 0xa4, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
        { 1, 0xa7, 0xa5, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__AlgorithmIdentifier), OFFSET(x509_useful__CRL,algorithm), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
            { 2, 0x35, 0x33, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__AlgorithmIdentifier,algorithm), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
            { 2, 0x35, 0x34, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(asn__any), OFFSET(x509__AlgorithmIdentifier,parameters), 0, 0, 0, 0, VTBL_ANY, FLAG_OPTIONAL, 0 },
        { 1, 0xa7, 0xa5, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
        { 1, 0xa7, 0xa6, 0, 0, CLASS_UNIVERSAL, TAG_BIT_STRING, TAGGING_BASE, sizeof(asn__bit_string), OFFSET(x509_useful__CRL,signature), 0, 0, 0, 0, VTBL_BIT_STRING, 0, -1 },
    { 0, 0x0, 0xa3, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
};

static struct asn_template_ CRL[] = {
    { 0, 0x0, 0xa7, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509_useful__CRL), 0, 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
        { 1, 0xa7, 0xa4, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509_useful__UnsignedCertificateRevocationList), OFFSET(x509_useful__CRL,toBeSigned), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
            { 2, 0xaf, 0xa8, 0, 0, CLASS_UNIVERSAL, TAG_INTEGER, TAGGING_BASE, sizeof(x509__Version), OFFSET(x509_useful__UnsignedCertificateRevocationList,version), 0, 0, 0, 0, VTBL_INTEGER, FLAG_OPTIONAL, 0 },
            { 2, 0xaf, 0xa9, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__AlgorithmIdentifier), OFFSET(x509_useful__UnsignedCertificateRevocationList,signature), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                { 3, 0x35, 0x33, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__AlgorithmIdentifier,algorithm), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
                { 3, 0x35, 0x34, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(asn__any), OFFSET(x509__AlgorithmIdentifier,parameters), 0, 0, 0, 0, VTBL_ANY, FLAG_OPTIONAL, 0 },
            { 2, 0xaf, 0xa9, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
            { 2, 0xaf, 0xaa, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificateRevocationList,issuer), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
            { 2, 0xaf, 0xaa, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(x509_useful__Name), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
            { 2, 0xaf, 0xab, 0, 0, CLASS_UNIVERSAL, TAG_UTCTime, TAGGING_BASE, sizeof(asn__utc_time), OFFSET(x509_useful__UnsignedCertificateRevocationList,thisUpdate), 0, 0, 0, 0, VTBL_UTCTime, 0, -1 },
            { 2, 0xaf, 0xac, 0, 0, CLASS_UNIVERSAL, TAG_UTCTime, TAGGING_BASE, sizeof(asn__utc_time), OFFSET(x509_useful__UnsignedCertificateRevocationList,nextUpdate), 0, 0, 0, 0, VTBL_UTCTime, FLAG_OPTIONAL, 1 },
            { 2, 0xaf, 0xad, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE_OF, TAGGING_BASE, sizeof(x509__CRLEntries), OFFSET(x509_useful__UnsignedCertificateRevocationList,revokedCertificates), 0, 0, 0, 0, VTBL_SEQUENCE_OF, FLAG_OPTIONAL, 2 },
                { 3, 0x5b, 0x5a, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__CRLEntry), AOFFSET(x509__CRLEntries,cRLEntry), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                    { 4, 0x5f, 0x5c, 0, 0, CLASS_UNIVERSAL, 2, TAGGING_IMPLICIT, 0, OFFSET(x509__CRLEntry,userCertificate), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
                    { 4, 0x5f, 0x5c, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(x509__SerialNumber), 0, 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
                    { 4, 0x5f, 0x5d, 0, 0, CLASS_UNIVERSAL, TAG_UTCTime, TAGGING_BASE, sizeof(asn__utc_time), OFFSET(x509__CRLEntry,revocationDate), 0, 0, 0, 0, VTBL_UTCTime, 0, -1 },
                    { 4, 0x5f, 0x5e, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE_OF, TAGGING_BASE, sizeof(x509__Extensions), OFFSET(x509__CRLEntry,crlEntryExtensions), 0, 0, 0, 0, VTBL_SEQUENCE_OF, FLAG_OPTIONAL, 0 },
                        { 5, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__Extension), AOFFSET(x509__Extensions,extension), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                            { 6, 0x4c, 0x49, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__Extension,extnID), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
                            { 6, 0x4c, 0x4a, 0, 0, CLASS_UNIVERSAL, TAG_BOOLEAN, TAGGING_BASE, sizeof(asn__boolean), OFFSET(x509__Extension,critical), 0, 0, &default__asn__boolean__FALSE, 0, VTBL_BOOLEAN, FLAG_DEFAULT | FLAG_DEFAULT, -1 },
                            { 6, 0x4c, 0x4b, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(asn__octet_string), OFFSET(x509__Extension,extnValue), 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
                        { 5, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
                    { 4, 0x5f, 0x5e, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
                { 3, 0x5b, 0x5a, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
            { 2, 0xaf, 0xad, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
            { 2, 0xaf, 0xae, 0, 0, CLASS_CONTEXT, 0, TAGGING_EXPLICIT, 0, OFFSET(x509_useful__UnsignedCertificateRevocationList,crlExtensions), 0, 0, 0, 0, VTBL_EXPLICIT_TAG, FLAG_OPTIONAL, 3 },
                { 3, 0xaf, 0xae, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE_OF, TAGGING_BASE, sizeof(x509__Extensions), 0, 0, 0, 0, 0, VTBL_SEQUENCE_OF, 0, 3 },
                    { 4, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__Extension), AOFFSET(x509__Extensions,extension), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                        { 5, 0x4c, 0x49, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__Extension,extnID), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
                        { 5, 0x4c, 0x4a, 0, 0, CLASS_UNIVERSAL, TAG_BOOLEAN, TAGGING_BASE, sizeof(asn__boolean), OFFSET(x509__Extension,critical), 0, 0, &default__asn__boolean__FALSE, 0, VTBL_BOOLEAN, FLAG_DEFAULT | FLAG_DEFAULT, -1 },
                        { 5, 0x4c, 0x4b, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(asn__octet_string), OFFSET(x509__Extension,extnValue), 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
                    { 4, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
                { 3, 0xaf, 0xae, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
            { 2, 0xaf, 0xae, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
        { 1, 0xa7, 0xa4, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
        { 1, 0xa7, 0xa5, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__AlgorithmIdentifier), OFFSET(x509_useful__CRL,algorithm), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
            { 2, 0x35, 0x33, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__AlgorithmIdentifier,algorithm), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
            { 2, 0x35, 0x34, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(asn__any), OFFSET(x509__AlgorithmIdentifier,parameters), 0, 0, 0, 0, VTBL_ANY, FLAG_OPTIONAL, 0 },
        { 1, 0xa7, 0xa5, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
        { 1, 0xa7, 0xa6, 0, 0, CLASS_UNIVERSAL, TAG_BIT_STRING, TAGGING_BASE, sizeof(asn__bit_string), OFFSET(x509_useful__CRL,signature), 0, 0, 0, 0, VTBL_BIT_STRING, 0, -1 },
    { 0, 0x0, 0xa7, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
};

static struct asn_template_ UnsignedCertificateRevocationList[] = {
    { 0, 0x0, 0xaf, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509_useful__UnsignedCertificateRevocationList), 0, 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
        { 1, 0xaf, 0xa8, 0, 0, CLASS_UNIVERSAL, TAG_INTEGER, TAGGING_BASE, sizeof(x509__Version), OFFSET(x509_useful__UnsignedCertificateRevocationList,version), 0, 0, 0, 0, VTBL_INTEGER, FLAG_OPTIONAL, 0 },
        { 1, 0xaf, 0xa9, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__AlgorithmIdentifier), OFFSET(x509_useful__UnsignedCertificateRevocationList,signature), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
            { 2, 0x35, 0x33, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__AlgorithmIdentifier,algorithm), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
            { 2, 0x35, 0x34, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(asn__any), OFFSET(x509__AlgorithmIdentifier,parameters), 0, 0, 0, 0, VTBL_ANY, FLAG_OPTIONAL, 0 },
        { 1, 0xaf, 0xa9, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
        { 1, 0xaf, 0xaa, 0, 0, CLASS_UNIVERSAL, 16, TAGGING_IMPLICIT, 0, OFFSET(x509_useful__UnsignedCertificateRevocationList,issuer), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
        { 1, 0xaf, 0xaa, 0, 0, CLASS_SPECIAL, TAG_ANY, TAGGING_BASE, sizeof(x509_useful__Name), 0, 0, 0, 0, 0, VTBL_ANY, 0, -1 },
        { 1, 0xaf, 0xab, 0, 0, CLASS_UNIVERSAL, TAG_UTCTime, TAGGING_BASE, sizeof(asn__utc_time), OFFSET(x509_useful__UnsignedCertificateRevocationList,thisUpdate), 0, 0, 0, 0, VTBL_UTCTime, 0, -1 },
        { 1, 0xaf, 0xac, 0, 0, CLASS_UNIVERSAL, TAG_UTCTime, TAGGING_BASE, sizeof(asn__utc_time), OFFSET(x509_useful__UnsignedCertificateRevocationList,nextUpdate), 0, 0, 0, 0, VTBL_UTCTime, FLAG_OPTIONAL, 1 },
        { 1, 0xaf, 0xad, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE_OF, TAGGING_BASE, sizeof(x509__CRLEntries), OFFSET(x509_useful__UnsignedCertificateRevocationList,revokedCertificates), 0, 0, 0, 0, VTBL_SEQUENCE_OF, FLAG_OPTIONAL, 2 },
            { 2, 0x5b, 0x5a, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__CRLEntry), AOFFSET(x509__CRLEntries,cRLEntry), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                { 3, 0x5f, 0x5c, 0, 0, CLASS_UNIVERSAL, 2, TAGGING_IMPLICIT, 0, OFFSET(x509__CRLEntry,userCertificate), 0, 0, 0, 0, VTBL_IMPLICIT_TAG, 0, -1 },
                { 3, 0x5f, 0x5c, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(x509__SerialNumber), 0, 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
                { 3, 0x5f, 0x5d, 0, 0, CLASS_UNIVERSAL, TAG_UTCTime, TAGGING_BASE, sizeof(asn__utc_time), OFFSET(x509__CRLEntry,revocationDate), 0, 0, 0, 0, VTBL_UTCTime, 0, -1 },
                { 3, 0x5f, 0x5e, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE_OF, TAGGING_BASE, sizeof(x509__Extensions), OFFSET(x509__CRLEntry,crlEntryExtensions), 0, 0, 0, 0, VTBL_SEQUENCE_OF, FLAG_OPTIONAL, 0 },
                    { 4, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__Extension), AOFFSET(x509__Extensions,extension), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                        { 5, 0x4c, 0x49, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__Extension,extnID), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
                        { 5, 0x4c, 0x4a, 0, 0, CLASS_UNIVERSAL, TAG_BOOLEAN, TAGGING_BASE, sizeof(asn__boolean), OFFSET(x509__Extension,critical), 0, 0, &default__asn__boolean__FALSE, 0, VTBL_BOOLEAN, FLAG_DEFAULT | FLAG_DEFAULT, -1 },
                        { 5, 0x4c, 0x4b, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(asn__octet_string), OFFSET(x509__Extension,extnValue), 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
                    { 4, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
                { 3, 0x5f, 0x5e, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
            { 2, 0x5b, 0x5a, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
        { 1, 0xaf, 0xad, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
        { 1, 0xaf, 0xae, 0, 0, CLASS_CONTEXT, 0, TAGGING_EXPLICIT, 0, OFFSET(x509_useful__UnsignedCertificateRevocationList,crlExtensions), 0, 0, 0, 0, VTBL_EXPLICIT_TAG, FLAG_OPTIONAL, 3 },
            { 2, 0xaf, 0xae, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE_OF, TAGGING_BASE, sizeof(x509__Extensions), 0, 0, 0, 0, 0, VTBL_SEQUENCE_OF, 0, 3 },
                { 3, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, TAG_SEQUENCE, TAGGING_BASE, sizeof(x509__Extension), AOFFSET(x509__Extensions,extension), 0, 0, 0, 0, VTBL_SEQUENCE, 0, -1 },
                    { 4, 0x4c, 0x49, 0, 0, CLASS_UNIVERSAL, TAG_OBJECT_IDENTIFIER, TAGGING_BASE, sizeof(asn__object_identifier), OFFSET(x509__Extension,extnID), 0, 0, 0, 0, VTBL_OBJECT_IDENTIFIER, 0, -1 },
                    { 4, 0x4c, 0x4a, 0, 0, CLASS_UNIVERSAL, TAG_BOOLEAN, TAGGING_BASE, sizeof(asn__boolean), OFFSET(x509__Extension,critical), 0, 0, &default__asn__boolean__FALSE, 0, VTBL_BOOLEAN, FLAG_DEFAULT | FLAG_DEFAULT, -1 },
                    { 4, 0x4c, 0x4b, 0, 0, CLASS_UNIVERSAL, TAG_OCTET_STRING, TAGGING_BASE, sizeof(asn__octet_string), OFFSET(x509__Extension,extnValue), 0, 0, 0, 0, VTBL_OCTET_STRING, 0, -1 },
                { 3, 0x48, 0x47, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
            { 2, 0xaf, 0xae, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
        { 1, 0xaf, 0xae, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, FLAG_END_OF_ARRAY, -1 },
    { 0, 0x0, 0xaf, 0, 0, CLASS_UNIVERSAL, 0, TAGGING_BASE, 0, 0, 0, 0, 0, 0, VTBL_EOC, 0, -1 },
};



static struct asn_type_info_ x509_useful_types[] = {
    { Name, 0, TEMPLATE_SIZE(Name) },
    { SubjectPublicKeyInfo, 0, TEMPLATE_SIZE(SubjectPublicKeyInfo) },
    { SIGNED, 0, TEMPLATE_SIZE(SIGNED) },
    { Certificate, 0, TEMPLATE_SIZE(Certificate) },
    { UnsignedCertificate, 0, TEMPLATE_SIZE(UnsignedCertificate) },
    { DirectoryString, 0, TEMPLATE_SIZE(DirectoryString) },
    { CertificateRevocationList, 0, TEMPLATE_SIZE(CertificateRevocationList) },
    { CRL, 0, TEMPLATE_SIZE(CRL) },
    { UnsignedCertificateRevocationList, 0, TEMPLATE_SIZE(UnsignedCertificateRevocationList) },
};

static struct a2c_module_ x509_useful__module__ = { 9, x509_useful_types, "x509_useful" };

PRIVATE_DEF a2c_module x509_useful = (a2c_module)&x509_useful__module__;

