/*
 *
 *    x509_useful.h
 *
 *    Note, this file consists of machine-generated data structures.
 *    Do not edit these contents.
 *
 *
 *    $Source: /usr/local/CVS/SETREF_1_0_Release/asn1/src/x509_useful.h,v 
 *    $Revision: 1.6 
 *    $Date: 1997/07/01 01:08:59 
 *    $Name: SETREF_1_0_Release 
 *    $Disclaimer: 
 *    ----------------------------------------------------------------------
 *    SET Draft Reference Implementation Disclaimer/License
 *    June 30, 1997
 *    
 *    This is a beta version of the SET Draft Reference Implementation
 *    ("DRI").  It is a work in progress and is being provided at this
 *    stage and in this form to help developers and other interested
 *    parties to understand the SET protocol.  This version of the DRI
 *    provides the core functionality required to process a simple
 *    transaction.  This release does not support certificate authority
 *    messages. Nor does it support the SET option to perform
 *    transactions without cardholder certificates.  For more details
 *    on the functionality in this beta version, please refer to the
 *    attached documentation.  
 *    
 *    Later versions of the DRI will include additional functionality
 *    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
 *    DEVELOPMENT.  If you discover a bug, please let us know by posting
 *    a message to the SET-DEV mailing list.  Our lawyers made us include
 *    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
 *    describes what you can do with the DRI.
 *     
 *    Copyright (C) 1996, 1997, Visa International Service Association and
 *    MasterCard International Incorporated.  All rights reserved.  
 *    Permission to copy and implement the material contained herein is
 *    granted subject to the conditions that (i) any copy or re-publication
 *    must bear this legend in full; (ii) any derivative work must bear
 *    a notice that it is not the Draft Reference Implementation ("DRI")
 *    for SET and (iii) that none of the copyright holders shall have any
 *    responsibility or liability whatsoever to any other party arising
 *    from the use or publication of the material contained herein.
 *    
 *    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
 *    limited license to (i) make, use, copy and modify the DRI for the
 *    purpose of developing software that complies with the SET
 *    Specification ("SET Products") and for the purpose of achieving a
 *    better understanding of the SET Protocol; and (ii) distribute SET
 *    Products that incorporate all or a portion of the DRI and other
 *    software, which together are provided under a defined interface
 *    different from that provided by the DRI's API.  Licensee shall not
 *    redistribute or sell a license to the DRI nor shall Licensee
 *    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
 *    means a product that provides comprehensive facilities to enable
 *    other parties to create software products for distribution. 
 *    Bolt-on applications and payment modules shall not be considered
 *    Toolkits for the purpose of this license.  The DRI is not intended
 *    to be used as a Toolkit.
 *    
 *    Licensors make no representation or warranty of any kind, express
 *    or implied, relating to the DRI.  Licensors are making the DRI
 *    publicly available as an aid to understanding, creating, and
 *    testing SET Products.  Licensees are solely responsible for any
 *    use of the DRI and agree to hold Licensors harmless for any claim
 *    that may arise out of any product created with the DRI.  
 *    
 *    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
 *    Corporation with offices at 4984 El Camino Real, Los Altos,
 *    California, as a third party beneficiary of this license.
 *    
 *    This software is controlled material under U.S. law and the laws
 *    of other jurisdictions and you hereby acknowledge and agree that
 *    you must fully comply with all the current laws of the United States
 *    including, without limitation, rules and regulations of the United
 *    States Office of Export Administration and other applicable U.S.
 *    governmental agencies.  
 *    ----------------------------------------------------------------------
 *     $
 *
 *    Copyright (C) 1996, 1997, Visa International Service Association and MasterCard International Incorporated
 *    All Rights Reserved.
 *
 *    briank@terisa.com
 *
 */

#ifndef __x509_useful__h__
#define __x509_useful__h__

#include <define.h>

#include <asn_types.h>

#ifdef __cplusplus
extern "C" {
#endif


#include "x509.h"

typedef
    asn__any                       x509_useful__Name                ; 

typedef
    asn__any                       x509_useful__SubjectPublicKeyInfo   ; 

typedef
    struct                         x509_useful__SIGNED_               
    {                                                                 
        asn__any                       toBeSigned                       ; 
        asn__any                       algorithm                        ; 
        asn__octet_string              signature                        ; 
    }                              x509_useful__SIGNED              ; 

typedef
    struct                         x509_useful__UnsignedCertificate_     
    {                                                                 
# define                               x509_useful__UnsignedCertificate__issuerUniqueIdentifier   0 
# define                               x509_useful__UnsignedCertificate__subjectUniqueIdentifier   1 
# define                               x509_useful__UnsignedCertificate__extensions   2 
        UCHAR                          _present[1]                      ; 
        x509__Version                  version                          ; 
        x509__CertificateSerialNumber  serialNumber                     ; 
        x509__AlgorithmIdentifier      signature                        ; 
        x509_useful__Name              issuer                           ; 
        x509__Validity                 validity                         ; 
        x509_useful__Name              subject                          ; 
        x509_useful__SubjectPublicKeyInfo subjectPublicKeyInfo             ; 
        x509__UniqueIdentifier         issuerUniqueIdentifier           ; 
        x509__UniqueIdentifier         subjectUniqueIdentifier          ; 
        x509__Extensions               *extensions                      ; 
    }                              x509_useful__UnsignedCertificate   ; 

typedef
    struct                         x509_useful__Certificate_          
    {                                                                 
        x509_useful__UnsignedCertificate toBeSigned                       ; 
        x509__AlgorithmIdentifier      algorithm                        ; 
        struct                                                            
        {                                                                 
            UINT4                          length                           ; /* number of bits */
            UCHAR                          *value                           ; 
        }                              signature                        ; 
    }                              x509_useful__Certificate         ; 

typedef
    struct                         x509_useful__DirectoryString_      
    {                                                                 
# define                               x509_useful__DirectoryString__printable 0x9e 
# define                               x509_useful__DirectoryString__t61 0x9f 
# define                               x509_useful__DirectoryString__ia5 0xa0 
# define                               x509_useful__DirectoryString__bmp 0xa1 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__printable_string          printable                        ; 
            asn__ia5_string                t61                              ; 
            asn__ia5_string                ia5                              ; 
            asn__bmp_string                bmp                              ; 
        } u                                                             ; 
    }                              x509_useful__DirectoryString     ; 

typedef
    struct                         x509_useful__UnsignedCertificateRevocationList_     
    {                                                                 
# define                               x509_useful__UnsignedCertificateRevocationList__version   0 
# define                               x509_useful__UnsignedCertificateRevocationList__nextUpdate   1 
# define                               x509_useful__UnsignedCertificateRevocationList__revokedCertificates   2 
# define                               x509_useful__UnsignedCertificateRevocationList__crlExtensions   3 
        UCHAR                          _present[1]                      ; 
        x509__Version                  version                          ; 
        x509__AlgorithmIdentifier      signature                        ; 
        x509_useful__Name              issuer                           ; 
        asn__utc_time                  thisUpdate                       ; 
        asn__utc_time                  nextUpdate                       ; 
        x509__CRLEntries               *revokedCertificates             ; 
        x509__Extensions               *crlExtensions                   ; 
    }                              x509_useful__UnsignedCertificateRevocationList   ; 

typedef
    struct                         x509_useful__CRL_                  
    {                                                                 
        x509_useful__UnsignedCertificateRevocationList toBeSigned                       ; 
        x509__AlgorithmIdentifier      algorithm                        ; 
        struct                                                            
        {                                                                 
            UINT4                          length                           ; /* number of bits */
            UCHAR                          *value                           ; 
        }                              signature                        ; 
    }                              x509_useful__CRL                 ; 

typedef
    x509_useful__CRL               x509_useful__CertificateRevocationList   ; 








# define                           X509_USEFUL__NAME                0 /* x509_useful__Name */
# define                           X509_USEFUL__SUBJECTPUBLICKEYINFO   1 /* x509_useful__SubjectPublicKeyInfo */
# define                           X509_USEFUL__SIGNED              2 /* x509_useful__SIGNED */
# define                           X509_USEFUL__CERTIFICATE         3 /* x509_useful__Certificate */
# define                           X509_USEFUL__UNSIGNEDCERTIFICATE   4 /* x509_useful__UnsignedCertificate */
# define                           X509_USEFUL__DIRECTORYSTRING     5 /* x509_useful__DirectoryString */
# define                           X509_USEFUL__CERTIFICATEREVOCATIONLIST   6 /* x509_useful__CertificateRevocationList */
# define                           X509_USEFUL__CRL                 7 /* x509_useful__CRL */
# define                           X509_USEFUL__UNSIGNEDCERTIFICATEREVOCATIONLIST   8 /* x509_useful__UnsignedCertificateRevocationList */



PRIVATE      a2c_module                     x509_useful                      ; 


#ifdef __cplusplus
}
#endif
#endif

