/*
 *
 *    bsupport.c
 *
 *    $Source: /usr/local/CVS/SETREF_1_0_Release/bsupport/src/bsupport.c,v 
 *    $Revision: 1.6 
 *    $Date: 1997/07/01 00:34:09 
 *    $Name: SETREF_1_0_Release 
 *    $Disclaimer: 
 *    ----------------------------------------------------------------------
 *    SET Draft Reference Implementation Disclaimer/License
 *    June 30, 1997
 *    
 *    This is a beta version of the SET Draft Reference Implementation
 *    ("DRI").  It is a work in progress and is being provided at this
 *    stage and in this form to help developers and other interested
 *    parties to understand the SET protocol.  This version of the DRI
 *    provides the core functionality required to process a simple
 *    transaction.  This release does not support certificate authority
 *    messages. Nor does it support the SET option to perform
 *    transactions without cardholder certificates.  For more details
 *    on the functionality in this beta version, please refer to the
 *    attached documentation.  
 *    
 *    Later versions of the DRI will include additional functionality
 *    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
 *    DEVELOPMENT.  If you discover a bug, please let us know by posting
 *    a message to the SET-DEV mailing list.  Our lawyers made us include
 *    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
 *    describes what you can do with the DRI.
 *     
 *    Copyright (C) 1996, 1997, Visa International Service Association and
 *    MasterCard International Incorporated.  All rights reserved.  
 *    Permission to copy and implement the material contained herein is
 *    granted subject to the conditions that (i) any copy or re-publication
 *    must bear this legend in full; (ii) any derivative work must bear
 *    a notice that it is not the Draft Reference Implementation ("DRI")
 *    for SET and (iii) that none of the copyright holders shall have any
 *    responsibility or liability whatsoever to any other party arising
 *    from the use or publication of the material contained herein.
 *    
 *    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
 *    limited license to (i) make, use, copy and modify the DRI for the
 *    purpose of developing software that complies with the SET
 *    Specification ("SET Products") and for the purpose of achieving a
 *    better understanding of the SET Protocol; and (ii) distribute SET
 *    Products that incorporate all or a portion of the DRI and other
 *    software, which together are provided under a defined interface
 *    different from that provided by the DRI's API.  Licensee shall not
 *    redistribute or sell a license to the DRI nor shall Licensee
 *    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
 *    means a product that provides comprehensive facilities to enable
 *    other parties to create software products for distribution. 
 *    Bolt-on applications and payment modules shall not be considered
 *    Toolkits for the purpose of this license.  The DRI is not intended
 *    to be used as a Toolkit.
 *    
 *    Licensors make no representation or warranty of any kind, express
 *    or implied, relating to the DRI.  Licensors are making the DRI
 *    publicly available as an aid to understanding, creating, and
 *    testing SET Products.  Licensees are solely responsible for any
 *    use of the DRI and agree to hold Licensors harmless for any claim
 *    that may arise out of any product created with the DRI.  
 *    
 *    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
 *    Corporation with offices at 4984 El Camino Real, Los Altos,
 *    California, as a third party beneficiary of this license.
 *    
 *    This software is controlled material under U.S. law and the laws
 *    of other jurisdictions and you hereby acknowledge and agree that
 *    you must fully comply with all the current laws of the United States
 *    including, without limitation, rules and regulations of the United
 *    States Office of Export Administration and other applicable U.S.
 *    governmental agencies.  
 *    ----------------------------------------------------------------------
 *     $
 *
 *    Copyright (C) 1996, 1997, Visa International Service Association and MasterCard International Incorporated
 *    All Rights Reserved.
 *
 *    briank@terisa.com
 *
 */


#include <define.h>

#ifdef WIN32
#include <string.h>
#include <malloc.h>
#endif

int T_memcmp
  PROTO_LIST((
    VOID          *s1,
    VOID          *s2,
    unsigned int   n
  ));

VOID T_memcpy
  PROTO_LIST((
    VOID          *s1,
    VOID          *s2,
    unsigned int   n
  ));

VOID T_memmove
  PROTO_LIST((
    VOID          *s1,
    VOID          *s2,
    unsigned int   n
  ));

VOID T_memset
  PROTO_LIST((
    VOID          *ptr,
    int            c,
    unsigned int   n
  ));

VOID T_free
  PROTO_LIST((
    VOID          *ptr
  ));

VOID* T_malloc
  PROTO_LIST((
    unsigned int   size
  ));

VOID* T_realloc
  PROTO_LIST((
    VOID          *ptr,
    unsigned int   size
  ));

int T_strcmp
  PROTO_LIST((
    char    *s1,
    char    *s2
  ));

VOID T_strcpy
  PROTO_LIST((
    char    *s1,
    char    *s2
  ));

unsigned int T_strlen
  PROTO_LIST((
    char    *s 
  ));




int
T_memcmp(s1, s2, n)
    VOID          *s1;
    VOID          *s2;
    unsigned int   n;
{
    return ((n) ? memcmp(s1, s2, n) : 0);
}

VOID
T_memcpy(s1, s2, n)
    VOID          *s1;
    VOID          *s2;
    unsigned int   n;
{
    if (n) memcpy(s1, s2, n);
}

VOID
T_memmove(s1, s2, n)
    VOID          *s1;
    VOID          *s2;
    unsigned int   n;
{
#ifdef NEED_MEMMOVE 
    if (n) bcopy(s2, s1, n);
#else
    if (n) memmove(s1, s2, n);
#endif
}

VOID
T_memset(ptr, c, n)
    VOID          *ptr;
    int            c;
    unsigned int   n;
{
    if (n) memset(ptr, c, n);
}



VOID
T_free(ptr)
    VOID          *ptr;
{
    if (ptr != 0) free(ptr);
}

VOID*
T_malloc(size)
    unsigned int   size;
{
    return (VOID*)malloc(size);
}

VOID*
T_realloc(ptr, size)
    VOID          *ptr;
    unsigned int   size;
{
    if (ptr == 0) return T_malloc(size);
    return (VOID*)realloc(ptr, size);
}


int
T_strcmp(s1, s2)
    char    *s1;
    char    *s2;
{
    return strcmp(s1, s2);
}

VOID
T_strcpy(s1, s2)
    char    *s1;
    char    *s2;
{
    strcpy(s1, s2);
}

unsigned int
T_strlen(s)
    char    *s;
{
    return strlen(s);
}


