/*
 *
 *    define.h
 *
 *    $Source: /usr/local/CVS/common/include/define.h,v 
 *    $Revision: 1.7 
 *    $Date: 1997/07/01 00:36:10 
 *    $Name: SETREF_1_0_Release 
 *    $Disclaimer: 
 *    ----------------------------------------------------------------------
 *    SET Draft Reference Implementation Disclaimer/License
 *    June 30, 1997
 *    
 *    This is a beta version of the SET Draft Reference Implementation
 *    ("DRI").  It is a work in progress and is being provided at this
 *    stage and in this form to help developers and other interested
 *    parties to understand the SET protocol.  This version of the DRI
 *    provides the core functionality required to process a simple
 *    transaction.  This release does not support certificate authority
 *    messages. Nor does it support the SET option to perform
 *    transactions without cardholder certificates.  For more details
 *    on the functionality in this beta version, please refer to the
 *    attached documentation.  
 *    
 *    Later versions of the DRI will include additional functionality
 *    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
 *    DEVELOPMENT.  If you discover a bug, please let us know by posting
 *    a message to the SET-DEV mailing list.  Our lawyers made us include
 *    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
 *    describes what you can do with the DRI.
 *     
 *    Copyright (C) 1996, 1997, Visa International Service Association and
 *    MasterCard International Incorporated.  All rights reserved.  
 *    Permission to copy and implement the material contained herein is
 *    granted subject to the conditions that (i) any copy or re-publication
 *    must bear this legend in full; (ii) any derivative work must bear
 *    a notice that it is not the Draft Reference Implementation ("DRI")
 *    for SET and (iii) that none of the copyright holders shall have any
 *    responsibility or liability whatsoever to any other party arising
 *    from the use or publication of the material contained herein.
 *    
 *    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
 *    limited license to (i) make, use, copy and modify the DRI for the
 *    purpose of developing software that complies with the SET
 *    Specification ("SET Products") and for the purpose of achieving a
 *    better understanding of the SET Protocol; and (ii) distribute SET
 *    Products that incorporate all or a portion of the DRI and other
 *    software, which together are provided under a defined interface
 *    different from that provided by the DRI's API.  Licensee shall not
 *    redistribute or sell a license to the DRI nor shall Licensee
 *    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
 *    means a product that provides comprehensive facilities to enable
 *    other parties to create software products for distribution. 
 *    Bolt-on applications and payment modules shall not be considered
 *    Toolkits for the purpose of this license.  The DRI is not intended
 *    to be used as a Toolkit.
 *    
 *    Licensors make no representation or warranty of any kind, express
 *    or implied, relating to the DRI.  Licensors are making the DRI
 *    publicly available as an aid to understanding, creating, and
 *    testing SET Products.  Licensees are solely responsible for any
 *    use of the DRI and agree to hold Licensors harmless for any claim
 *    that may arise out of any product created with the DRI.  
 *    
 *    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
 *    Corporation with offices at 4984 El Camino Real, Los Altos,
 *    California, as a third party beneficiary of this license.
 *    
 *    This software is controlled material under U.S. law and the laws
 *    of other jurisdictions and you hereby acknowledge and agree that
 *    you must fully comply with all the current laws of the United States
 *    including, without limitation, rules and regulations of the United
 *    States Office of Export Administration and other applicable U.S.
 *    governmental agencies.  
 *    ----------------------------------------------------------------------
 *     $
 *
 *    Copyright (C) 1996, 1997, Visa International Service Association and MasterCard International Incorporated
 *    All Rights Reserved.
 *
 *    briank@terisa.com
 *
 */

#ifndef __DEFINE_H__
#define __DEFINE_H__



#include <assert.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h> 
#include <stdio.h> 


#if defined(__STDC__) || defined(__cplusplus)
#   ifndef USE_ANSI_PROTOTYPES
#       define  USE_ANSI_PROTOTYPES
#   endif
#   ifndef USE_ANSI_STDARG
#       define  USE_ANSI_STDARG
#   endif
#endif

#ifndef PROTO_LIST
#   ifdef USE_ANSI_PROTOTYPES
#       define  PROTO_LIST(list)    list
#   else
#       define  PROTO_LIST(list)    ()
#   endif
#endif

#ifndef TSW_UCHAR_DEFINED
    typedef unsigned char UCHAR;
#    define TSW_UCHAR_DEFINED
#endif

#ifndef TSW_INT2_DEFINED
    typedef short INT2;
#    define TSW_INT2_DEFINED
#endif

#ifndef TSW_INT4_DEFINED
    typedef int INT4;
#    define TSW_INT4_DEFINED
#endif

#if !defined(_VOID) && !defined(VOID)
    typedef void VOID;
#    define _VOID
#endif

#ifndef CONST
#    if defined(__STDC__) || defined(__cplusplus)
#        define CONST const
#    else
#        define CONST
#    endif
#endif

/* if aglobal.h is included, these are there */
#ifndef _AGLOBAL_H_ 

#ifndef TSW_UINT2_DEFINED
    typedef unsigned short UINT2;
#    define TSW_UINT2_DEFINED
#endif

#ifndef TSW_UINT4_DEFINED
    typedef unsigned int UINT4;
#    define TSW_UINT4_DEFINED
#endif

#endif

#ifndef INLINE
#    if defined(__GNUC__) || defined(__cplusplus)
#        define INLINE inline
#    else 
#        define INLINE
#    endif
#endif




#ifdef NEED_MEMORY_H
#include <memory.h>
#endif

#ifdef NEED_STDIO_DEFS 
#include <stdio.h>
int fread PROTO_LIST((char *ptr,int size,int nitems, FILE *stream));
int fwrite PROTO_LIST((char *ptr,int size,int nitems, FILE *stream));
int fseek PROTO_LIST((FILE *stream,long offset, int ptrname));
int _flsbuf PROTO_LIST((unsigned char, ...));
int fflush PROTO_LIST((FILE *stream));
int vfprintf PROTO_LIST((FILE*, char*, ...));
int vsprintf PROTO_LIST((char*, char*, ...));
int fprintf PROTO_LIST((FILE*, char*, ...));
int printf PROTO_LIST((char*,...));
int fclose PROTO_LIST((FILE *stream));
int fputc PROTO_LIST((char c, FILE *stream));
int fgetc PROTO_LIST((FILE *stream));
int ungetc PROTO_LIST((char c, FILE *stream));  
int sscanf PROTO_LIST((char *s, char *format, ...));
int fscanf PROTO_LIST((FILE *s, char *format, ...));
#endif

#ifdef NEED_STRCASECMP_DEFS
int strcasecmp PROTO_LIST((char *,char *));
int strncasecmp PROTO_LIST((char *,char *,int ));
#endif

#ifdef NEED_STRICMP
#define strcasecmp stricmp
#define strncasecmp strnicmp
#endif

#ifdef NEED_CTYPE_DEFS
int tolower PROTO_LIST((int c));
int toupper PROTO_LIST((int c));
#endif

#ifdef NEED_TIME_DEFS
#include <time.h>
time_t time PROTO_LIST((time_t *));
#endif

#ifdef NEED_TIMEGM_DEFS
#include <time.h>
time_t timegm PROTO_LIST((struct tm *tmp));
#endif

#ifdef NEED_RENAME_DEFS
int rename PROTO_LIST((char *oldname, char *newname));
#endif

#ifdef NEED_TELL_DEFS
long tell PROTO_LIST((int));
#endif
  


#ifndef ERROR_MESSAGE_LENGTH
#    define  ERROR_MESSAGE_LENGTH         512
#endif

#ifndef LENGTH_OF_ARRAY
#    define LENGTH_OF_ARRAY(array)        (sizeof((array))/sizeof(*((array))))
#endif

#ifndef ASSERT
#    define ASSERT          assert
#endif

#ifndef PUBLIC
#    define PUBLIC          extern
#endif

#ifndef PRIVATE
#    define PRIVATE         extern
#endif

#ifndef PUBLIC_DEF
#    define PUBLIC_DEF 
#endif

#ifndef PRIVATE_DEF
#    define PRIVATE_DEF
#endif

#ifndef MEMZERO
#    define MEMZERO(obj)         (VOID)memset((VOID*)&(obj),0,sizeof((obj)))
#endif

#ifndef SAFE_FREE
#    define SAFE_FREE(ptr)       ((ptr)?(free((ptr)),0):0)
#endif

#ifndef SAFE_DELETE_VCALL__
#    define SAFE_DELETE_VCALL__(ctxp,call)  \
           ((ctxp)?((*(ctxp))?(call):(NO_ERROR)):(SE_ERR_ILLEGAL_NULL_ARG))
#endif


#define ERROR_MODULE(err)        ((unsigned)((err)&E_MODULE_MASK__)>>E_NUMBER_BITS__)
#define ERROR_NUMBER(err)        ((err)&E_NUMBER_MASK__)                   
#define ERROR_MAKE(mod,num)      (E_N2MODULE__(mod)|ERROR_NUMBER(num))     

#define E_MODULE_BITS__          (6)
#define E_NUMBER_BITS__          (10)
#define E_MAX_MODULE             (64+1)   /* (2^E_MODULE_BITS__)+1 */
#define E_MODULE_MASK__          ((~((~0)<<E_MODULE_BITS__))<<E_NUMBER_BITS__)
#define E_NUMBER_MASK__          (~((~0)<<E_NUMBER_BITS__))                   
#define E_N2MODULE__(mod)        (((mod)<<E_NUMBER_BITS__)&E_MODULE_MASK__)


/*
 *   GLOBAL GENERIC ERROR CODES
 */
#ifdef NO_ERROR
#    if NO_ERROR
         /* this false include forces a compile-time error message */
#        include "error: NO_ERROR defined as something other than 0"
#    endif
#        else
#    define  NO_ERROR                  0
#endif

#define SE_ERR_NO_MEMORY               ERROR_MAKE(0,0x8)
#define SE_ERR_FATAL_IO                ERROR_MAKE(0,0x02)
#define SE_ERR_INTERNAL                ERROR_MAKE(0,0x0c)
#define SE_ERR_ILLEGAL_NULL_ARG        ERROR_MAKE(0,0x0a)
#define SE_ERR_ILLEGAL_ARG             ERROR_MAKE(0,0x13)
#define SE_ERR_BAD_BER_DER_ENCODING    ERROR_MAKE(0,0x07)

#define SE_WARN_OPERATION_CANCELLED    ERROR_MAKE(0,0x03)


#ifndef MIN
#    define MIN(a,b)    ((a)>(b)?(b):(a))
#endif

#ifndef MAX
#    define MAX(a,b)    ((a)>(b)?(a):(b))
#endif


#define FREE free
#define MALLOC malloc
#define REALLOC realloc
#define CALLOC calloc


#ifndef SAFE_MEMCPY
#   include <string.h> /* memcpy, etc. */
#   define SAFE_MEMCPY(dst,src)       {ASSERT(sizeof(*(dst))==sizeof(*(src)));\
                                       memcpy((dst),(src),sizeof(*(dst)));}
#endif

#ifndef UNUSED_ARG
#   define UNUSED_ARG(x)    x=(*(&(x)));
#endif


#ifdef USE_ANSI_STDARG
#   include <stdarg.h>
#   define  VA_START(a,b) va_start(a,b)
#else
#   include <varargs.h>
#   define  VA_START(a,b) va_start(a) 
#endif

#ifndef OFFSETOF
#   define  OFFSETOF  offsetof
#endif



#endif

