#
#    tests.mk
#
#    $Source: /usr/local/CVS/SETREF_1_0_Release/demo/src/tests.mk,v 
#    $Revision: 1.4 
#    $Date: 1997/06/25 02:28:51 
#    $Name: SETREF_1_0_Release 
#    $Disclaimer: 
#    ----------------------------------------------------------------------
#    SET Draft Reference Implementation Disclaimer/License
#    June 30, 1997
#    
#    This is a beta version of the SET Draft Reference Implementation
#    ("DRI").  It is a work in progress and is being provided at this
#    stage and in this form to help developers and other interested
#    parties to understand the SET protocol.  This version of the DRI
#    provides the core functionality required to process a simple
#    transaction.  This release does not support certificate authority
#    messages. Nor does it support the SET option to perform
#    transactions without cardholder certificates.  For more details
#    on the functionality in this beta version, please refer to the
#    attached documentation.  
#    
#    Later versions of the DRI will include additional functionality
#    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
#    DEVELOPMENT.  If you discover a bug, please let us know by posting
#    a message to the SET-DEV mailing list.  Our lawyers made us include
#    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
#    describes what you can do with the DRI.
#     
#    Copyright (C) 1996, 1997, Visa International Service Association and
#    MasterCard International Incorporated.  All rights reserved.  
#    Permission to copy and implement the material contained herein is
#    granted subject to the conditions that (i) any copy or re-publication
#    must bear this legend in full; (ii) any derivative work must bear
#    a notice that it is not the Draft Reference Implementation ("DRI")
#    for SET and (iii) that none of the copyright holders shall have any
#    responsibility or liability whatsoever to any other party arising
#    from the use or publication of the material contained herein.
#    
#    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
#    limited license to (i) make, use, copy and modify the DRI for the
#    purpose of developing software that complies with the SET
#    Specification ("SET Products") and for the purpose of achieving a
#    better understanding of the SET Protocol; and (ii) distribute SET
#    Products that incorporate all or a portion of the DRI and other
#    software, which together are provided under a defined interface
#    different from that provided by the DRI's API.  Licensee shall not
#    redistribute or sell a license to the DRI nor shall Licensee
#    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
#    means a product that provides comprehensive facilities to enable
#    other parties to create software products for distribution. 
#    Bolt-on applications and payment modules shall not be considered
#    Toolkits for the purpose of this license.  The DRI is not intended
#    to be used as a Toolkit.
#    
#    Licensors make no representation or warranty of any kind, express
#    or implied, relating to the DRI.  Licensors are making the DRI
#    publicly available as an aid to understanding, creating, and
#    testing SET Products.  Licensees are solely responsible for any
#    use of the DRI and agree to hold Licensors harmless for any claim
#    that may arise out of any product created with the DRI.  
#    
#    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
#    Corporation with offices at 4984 El Camino Real, Los Altos,
#    California, as a third party beneficiary of this license.
#    
#    This software is controlled material under U.S. law and the laws
#    of other jurisdictions and you hereby acknowledge and agree that
#    you must fully comply with all the current laws of the United States
#    including, without limitation, rules and regulations of the United
#    States Office of Export Administration and other applicable U.S.
#    governmental agencies.  
#    ----------------------------------------------------------------------
#     $
#
#    Copyright (C) 1996, 1997, Visa International Service Association and MasterCard International Incorporated
#    All Rights Reserved.
#
#    briank@terisa.com
#

	

#
# utility targets
#

CLEAN_TESTS       = $(RM) $(RMFLAGS) *.out *.car *.mer *.pay *.set *.cca *.mca *.pca *.gca *.bca *.rca
RESTORE_DATABASE  = $(CP) $(CPFLAGS) ../my*keys* .

clean: cleand

cleand:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	

#
# testing targets
#

test: test.pay test.cert test.cert.inq

test.pay: pay.output pay.simple pay.recurring pay.message \
          pay.latecapture pay.error pay.lidm pay.pantoken \
          pay.authtoken pay.captoken pay.lots pay.pcert pay.inq \
          pay.authrev pay.caprev pay.cred pay.credrev pay.batchadmin

test.cert: cert.caris cert.carrs \
           cert.meris cert.merie cert.merib \
           cert.merrs cert.merre cert.merrb \
           cert.payis cert.payie cert.payib \
           cert.payrs cert.payre cert.payrb

test.cert.inq: cert.inq.caris cert.inq.carrs \
               cert.inq.meris cert.inq.merie cert.inq.merib \
               cert.inq.merrs cert.inq.merre cert.inq.merrb \
               cert.inq.payis cert.inq.payie cert.inq.payib \
               cert.inq.payrs cert.inq.payre cert.inq.payrb

pay.output:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	(./demo              -wpinitreq                    > pinitreq.out) &&\
	(./demo -rpinitreq   -wpinitres   < pinitreq.out   > pinitres.out) &&\
	(./demo -rpinitres   -wpreq       < pinitres.out   > preq.out) &&\
	(./demo -rpreq       -wauthreq    < preq.out       > authreq.out) &&\
	(./demo -rauthreq    -wauthres    < authreq.out    > authres.out) &&\
	(./demo -rauthres    -wcapreq     < authres.out    > capreq.out) &&\
	(./demo -rcapreq     -wcapres     < capreq.out     > capres.out) &&\
	(./demo -rcapres     -wpres       < capres.out     > pres.out) &&\
	(./demo -rpres                    < pres.out)

pay.simple:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo        -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
	 -rpreq       -wauthreq  \
	 -rauthreq    -wauthres \
	 -rauthres    -wcapreq \
	 -rcapreq     -wcapres\
	 -rcapres     -wpres \
	 -rpres
	
pay.latecapture:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo     -Dacqmsg='This is the tunnelled message' \
         -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
	 -rpreq       -wauthreq  \
	 -rauthreq    -wauthres \
	 -rauthres \
	 -wpres -rpres \
	 -wcapreq \
	 -rcapreq     -wcapres\
	 -rcapres
	
pay.recurring:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -Drecurring -DtotalRecur=2 \
	              -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
	 -rpreq       -wauthreq  \
	 -rauthreq    -wauthres \
	\
	 -rauthres    -wauthreq \
	 -rauthreq    -wauthres \
	\
	 -rauthres    -wcapreq \
	 -rcapreq     -wcapres\
	 -rcapres     -wpres \
	 -rpres

pay.message:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -Dacqmsg='This is the tunnelled message' \
	              -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
	 -rpreq       -wauthreq  \
	 -rauthreq    -wauthres \
	 -rauthres    -wcapreq \
	 -rcapreq     -wcapres\
	 -rcapres     -wpres \
	 -rpres

pay.error:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo \
	              -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
         -rpreq       -werror -rerror

pay.lidm:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -Dlidm \
	              -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
	 -rpreq       -wauthreq  \
	 -rauthreq    -wauthres \
	 -rauthres    -wcapreq \
	 -rcapreq     -wcapres\
	 -rcapres     -wpres \
	 -rpres

pay.pantoken:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -Dpantoken \
	              -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
	 -rpreq       -wauthreq  \
	 -rauthreq    -wauthres \
	 -rauthres    -wcapreq \
	 -rcapreq     -wcapres\
	 -rcapres     -wpres \
	 -rpres

pay.authtoken:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -Dauthtoken \
	              -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
	 -rpreq       -wauthreq  \
	 -rauthreq    -wauthres \
	 -rauthres    -wcapreq \
	 -rcapreq     -wcapres\
	 -rcapres     -wpres \
	 -rpres

pay.captoken:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -Dcaptoken \
	              -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
	 -rpreq       -wauthreq  \
	 -rauthreq    -wauthres \
	 -rauthres    -wcapreq \
	 -rcapreq     -wcapres\
	 -rcapres     -wpres \
	 -rpres

pay.lots:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -Drecurring -DtotalRecur=2 \
               -Dcaptoken -Dpantoken -Dlidm \
               -Dacqmsg='This is the tunnelled message' \
	              -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
	 -rpreq       -wauthreq  \
	 -rauthreq    -wauthres \
	\
	 -rauthres    -wauthreq \
	 -rauthreq    -wauthres \
	\
	 -rauthres    -wcapreq \
	 -rcapreq     -wcapres\
	 -rcapres     -wpres \
	 -rpres

pay.pcert:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo        -wpcertreq    \
	 -rpcertreq   -wpcertres   \
 	 -rpcertres
	
pay.inq:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo        -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
	 -rpreq       -wauthreq  \
	 -rauthreq    -wauthres \
	 -rauthres    -wcapreq \
	 -rcapreq     -wcapres\
	 -rcapres     -wpres \
	 -rpres       -winqreq \
	 -rinqreq     -winqres \
	 -rinqres

pay.authrev:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo        -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
	 -rpreq       -wauthreq  \
	 -rauthreq    -wauthres \
	 -rauthres    -wauthrevreq \
	 -rauthrevreq -wauthrevres\
	 -rauthrevres 

pay.caprev:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo   -Dcaptoken \
                      -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
	 -rpreq       -wauthreq  \
	 -rauthreq    -wauthres \
	 -rauthres    -wcapreq \
	 -rcapreq     -wcapres \
	 -rcapres     -wcaprevreq \
	 -rcaprevreq  -wcaprevres \
	 -rcaprevres

pay.cred:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo   -Dcaptoken \
                      -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
	 -rpreq       -wauthreq  \
	 -rauthreq    -wauthres \
	 -rauthres    -wcapreq \
	 -rcapreq     -wcapres \
	 -rcapres     -wcredreq \
	 -rcredreq    -wcredres \
	 -rcredres

pay.credrev:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo   -Dcaptoken \
                      -wpinitreq    \
	 -rpinitreq   -wpinitres   \
	 -rpinitres   -wpreq      \
	 -rpreq       -wauthreq  \
	 -rauthreq    -wauthres \
	 -rauthres    -wcapreq \
	 -rcapreq     -wcapres \
	 -rcapres     -wcredreq \
	 -rcredreq    -wcredres \
	 -rcredres \
	                 -wcredrevreq \
	 -rcredrevreq    -wcredrevres \
	 -rcredrevres

	
pay.batchadmin:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo        -wpinitreq    \
         -rpinitreq   -wpinitres   \
         -rpinitres   -wpreq      \
         -rpreq       -wauthreq  \
         -rauthreq    -wauthres \
         -rauthres    -wcapreq \
         -rcapreq     -wcapres\
         -rcapres \
	                  -wbatchadminreq    \
	 -rbatchadminreq  -wbatchadminres   \
	 -rbatchadminres 


cert.caris:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=cardInitialSig \
	-wcardCInitReq -rcardCInitReq -wcardCInitRes -rcardCInitRes \
	-wregFormReq -rregFormReq -wregFormRes -rregFormRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.carrs:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=cardRenewalSig \
	-wcardCInitReq -rcardCInitReq -wcardCInitRes -rcardCInitRes \
	-wregFormReq -rregFormReq -wregFormRes -rregFormRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.meris:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=merInitialSig \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.merie:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=merInitialEnc \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.merib:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=merInitialBoth \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.merrs:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=merRenewalSig \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.merre:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=merRenewalEnc \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.merrb:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=merRenewalBoth \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.payis:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=pgwyInitialSig \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.payie:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=pgwyInitialEnc \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.payib:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=pgwyInitialBoth \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.payrs:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=pgwyRenewalSig \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.payre:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=pgwyRenewalEnc \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.payrb:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=pgwyRenewalBoth \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.inq.caris:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=cardInitialSig \
	-wcardCInitReq -rcardCInitReq -wcardCInitRes -rcardCInitRes \
	-wregFormReq -rregFormReq -wregFormRes -rregFormRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.inq.carrs:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=cardRenewalSig \
	-wcardCInitReq -rcardCInitReq -wcardCInitRes -rcardCInitRes \
	-wregFormReq -rregFormReq -wregFormRes -rregFormRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.inq.meris:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=merInitialSig \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.inq.merie:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=merInitialEnc \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.inq.merib:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=merInitialBoth \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.inq.merrs:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=merRenewalSig \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.inq.merre:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=merRenewalEnc \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.inq.merrb:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=merRenewalBoth \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.inq.payis:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=pgwyInitialSig \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.inq.payie:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=pgwyInitialEnc \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.inq.payib:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=pgwyInitialBoth \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.inq.payrs:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=pgwyRenewalSig \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.inq.payre:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=pgwyRenewalEnc \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

cert.inq.payrb:
	$(CLEAN_TESTS)
	$(RESTORE_DATABASE)
	./demo -DcertReqType=pgwyRenewalBoth \
	-wMe_AqCInitReq -rMe_AqCInitReq \
	-wMe_AqCInitRes -rMe_AqCInitRes \
	-wCertReq -rCertReq -wCertRes -rCertRes \
	-wCertInqReq -rCertInqReq -wCertInqRes -rCertInqRes

