#
#    targets.mk
#
#    $Source: /usr/local/CVS/io_ctx/src/targets.mk,v 
#    $Revision: 1.12 
#    $Date: 1997/06/25 04:07:01 
#    $Name: SETREF_1_0_Release 
#    $Disclaimer: 
#    ----------------------------------------------------------------------
#    SET Draft Reference Implementation Disclaimer/License
#    June 30, 1997
#    
#    This is a beta version of the SET Draft Reference Implementation
#    ("DRI").  It is a work in progress and is being provided at this
#    stage and in this form to help developers and other interested
#    parties to understand the SET protocol.  This version of the DRI
#    provides the core functionality required to process a simple
#    transaction.  This release does not support certificate authority
#    messages. Nor does it support the SET option to perform
#    transactions without cardholder certificates.  For more details
#    on the functionality in this beta version, please refer to the
#    attached documentation.  
#    
#    Later versions of the DRI will include additional functionality
#    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
#    DEVELOPMENT.  If you discover a bug, please let us know by posting
#    a message to the SET-DEV mailing list.  Our lawyers made us include
#    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
#    describes what you can do with the DRI.
#     
#    Copyright (C) 1996, 1997, Visa International Service Association and
#    MasterCard International Incorporated.  All rights reserved.  
#    Permission to copy and implement the material contained herein is
#    granted subject to the conditions that (i) any copy or re-publication
#    must bear this legend in full; (ii) any derivative work must bear
#    a notice that it is not the Draft Reference Implementation ("DRI")
#    for SET and (iii) that none of the copyright holders shall have any
#    responsibility or liability whatsoever to any other party arising
#    from the use or publication of the material contained herein.
#    
#    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
#    limited license to (i) make, use, copy and modify the DRI for the
#    purpose of developing software that complies with the SET
#    Specification ("SET Products") and for the purpose of achieving a
#    better understanding of the SET Protocol; and (ii) distribute SET
#    Products that incorporate all or a portion of the DRI and other
#    software, which together are provided under a defined interface
#    different from that provided by the DRI's API.  Licensee shall not
#    redistribute or sell a license to the DRI nor shall Licensee
#    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
#    means a product that provides comprehensive facilities to enable
#    other parties to create software products for distribution. 
#    Bolt-on applications and payment modules shall not be considered
#    Toolkits for the purpose of this license.  The DRI is not intended
#    to be used as a Toolkit.
#    
#    Licensors make no representation or warranty of any kind, express
#    or implied, relating to the DRI.  Licensors are making the DRI
#    publicly available as an aid to understanding, creating, and
#    testing SET Products.  Licensees are solely responsible for any
#    use of the DRI and agree to hold Licensors harmless for any claim
#    that may arise out of any product created with the DRI.  
#    
#    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
#    Corporation with offices at 4984 El Camino Real, Los Altos,
#    California, as a third party beneficiary of this license.
#    
#    This software is controlled material under U.S. law and the laws
#    of other jurisdictions and you hereby acknowledge and agree that
#    you must fully comply with all the current laws of the United States
#    including, without limitation, rules and regulations of the United
#    States Office of Export Administration and other applicable U.S.
#    governmental agencies.  
#    ----------------------------------------------------------------------
#     $
#
#    Copyright (C) 1997, Visa International Service Association and MasterCard International Incorporated
#    All Rights Reserved.
#
#    briank@terisa.com
#



#
#    CONFIGURE USER-DEFINED LOCAL ENVIRONMENT
#
#    These fields are specified by the user.  The remainder of
#    this file is generated from this user-specified information.
#
# IO_CTX_DEFINES:
#    cpp defines, with the -D flag preceeding each
#
# IO_CTX_INCLUDES:
#    cpp include directories, with the -I flag preceeding each
#
# IO_CTX_INTERNAL:
#    headers files which are local to a specific module directory,
#    and should not be used by other parts of the toolkit or by
#    the user
#
# IO_CTX_LIBNAME:
#    the library associated with this module directory, used in
#    most cases for debugging purposes
#
# IO_CTX_MAKEFILES:
#    the makefiles
#
# IO_CTX_PREFIX:
#    defines the module name, which also serves as the
#    prefix for all the variable names defined in this file
#
# IO_CTX_PRIVATE:
#    the private, for-toolkit-use-only API header files
#
# IO_CTX_PROGRAMS:
#    programs to build
#
# IO_CTX_PUBLIC:
#    the header files that define the public API for the toolkit
#
# IO_CTX_SOURCES:
#    the source files to compile to object
#
IO_CTX_DEFINES            =
IO_CTX_INCLUDES           = -I$(INCLUDE_SRCDIR) -I$(ERROR_CTX_SRCDIR)
IO_CTX_INTERNAL           = internal_memory.h io_ctx_error.h
IO_CTX_LIBNAME            = libioctx.$(LIBSUFFIX)
IO_CTX_MAKEFILES          = Makefile global.mk override.mk targets.mk
IO_CTX_PREFIX             = IO_CTX
IO_CTX_PRIVATE            =
IO_CTX_PROGRAMS           =
IO_CTX_PUBLIC             = io_ctx.h io_ctx_memio.h \
                            io_ctx_stdio.h
IO_CTX_SOURCES            = io_ctx_error.c io_ctx_memio.c \
                            io_ctx_stdio.c



#
#    CONFIGURE AUTOMATICALLY-GENERATED LOCAL ENVIRONMENT
#
# IO_CTX_OBJECTS:
#    object files to build
#
# IO_CTX_UNUSED:
#    obsolete files in the module directory that are not
#    used during the build process
#
# IO_CTX_USED:
#    all files in the module directory that are used
#    during the build process
#
IO_CTX_OBJECTS            = io_ctx_error.$(OBJSUFFIX) \
                            io_ctx_memio.$(OBJSUFFIX) \
                            io_ctx_stdio.$(OBJSUFFIX)
IO_CTX_UNUSED             = 
IO_CTX_USED               = $(IO_CTX_INTERNAL:%=$(IO_CTX_SRCDIR)%) \
                            $(IO_CTX_MAKEFILES:%=$(IO_CTX_SRCDIR)%) \
                            $(IO_CTX_PRIVATE:%=$(IO_CTX_SRCDIR)%) \
                            $(IO_CTX_PUBLIC:%=$(IO_CTX_SRCDIR)%) \
                            $(IO_CTX_SOURCES:%=$(IO_CTX_SRCDIR)%)



#
#    NOTES
#
#    The following variables may be used during the build process,
#    but are not defined in this file.  If they are to be set
#    to something other than the default blank, then they must
#    be set by the calling make system.
#
# IO_CTX_SRCDIR:
#    if the build target directory is different from the
#    module directory (the source directory), then this
#    variable contains the relative or full path of
#    the module directory
#
# LIBARS:
#    the library archive files (with fully-specified paths) that
#    executables built from this module directory depend upon
#
# LIBPATHS:
#    the paths to search for library archives (specified with
#    the -L)
#
# LIBS:
#    the libraries to use while building executables from
#    this module directory (specified with the -l)
#



#
#    GENERIC ENVIRONMENT
#
DEFINES                  += $(IO_CTX_DEFINES)
OBJECTS                  += $(IO_CTX_OBJECTS)
PUBLIC                   += $(IO_CTX_PUBLIC)



#
#    GENERIC DEPENDENCIES
#
# default:
#    default dependency, must be the first dependency in this makefile
#
# all:
#    build everything in this module directory
#
# build:
#    make only the toolkit build files of this module directory
#
# ci:
#    perform an RCS check-in of this module directory
#
# clean:
#    remove the compiled files
#
# clean_public:
#    remove the public header files that have been copied
#    to a public build directory
#
# objects:
#    build the object files (this dependency is used for
#    building the toolkit library)
#
# private:
#    build only the private API header files
#
# public:
#    build only the public API header files
#
default:                    $(IO_CTX_LIBNAME)
default:                    $(IO_CTX_PROGRAMS)

all:                        $(IO_CTX_PUBLIC)
all:                        $(IO_CTX_OBJECTS)
all:                        $(IO_CTX_LIBNAME)
all:                        $(IO_CTX_PROGRAMS)
build:                      $(IO_CTX_PUBLIC)
build:                      $(IO_CTX_OBJECTS)
ci:                         io_ctx_ci
clean:                      io_ctx_clean
clean_public:               io_ctx_clean_public
objects:                    $(IO_CTX_OBJECTS)
private:                    $(IO_CTX_PRIVATE)
public:                     $(IO_CTX_PUBLIC)



#
#    LOCAL UTILITY DEPENDENCIES
#
#    utility dependencies are necessary because of some
#    make-isms having to do with dependencies
#

io_ctx_ci:
	$(CI) $(CIFLAGS) $(IO_CTX_USED)

io_ctx_clean:
	$(RM) $(RMFLAGS) $(IO_CTX_OBJECTS) $(IO_CTX_LIBNAME) $(IO_CTX_PROGRAMS)

io_ctx_clean_public:
	$(RM) $(RMFLAGS) $(IO_CTX_PUBLIC)

io_ctx_objects: $(IO_CTX_OBJECTS)

io_ctx_programs: $(IO_CTX_PROGRAMS)

io_ctx_public: $(IO_CTX_PUBLIC)



#
#    BUILD DEPENDENCIES
#
#    build dependencies invoke the rule used to build each
#    class of file
#

$(IO_CTX_LIBNAME):
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@

$(IO_CTX_OBJECTS):
	$(COMPILE.c) $(IO_CTX_SRCDIR)$(@:%.$(OBJSUFFIX)=%.c) $(DEFINES) $(INCLUDES)
 
$(IO_CTX_PUBLIC):
	$(CP) $(CPFLAGS) $(IO_CTX_SRCDIR)$@ $@

$(IO_CTX_PROGRAMS):
	$(LINK.c) $@.$(OBJSUFFIX) $(LDLIBS) $(LIBS) $(LIBPATHS)



#
#    FILE DEPENDENCIES
#
#    file dependencies state, for each file that is built,
#    which file(s) it depends upon
#

io_ctx.h: $(IO_CTX_SRCDIR)io_ctx.h

io_ctx_memio.h: $(IO_CTX_SRCDIR)io_ctx_memio.h

io_ctx_stdio.h: $(IO_CTX_SRCDIR)io_ctx_stdio.h

io_ctx_error.$(OBJSUFFIX): $(IO_CTX_SRCDIR)io_ctx_error.h
io_ctx_error.$(OBJSUFFIX): $(IO_CTX_SRCDIR)io_ctx_error.c

io_ctx_memio.$(OBJSUFFIX): $(IO_CTX_SRCDIR)io_ctx_memio.h
io_ctx_memio.$(OBJSUFFIX): $(IO_CTX_SRCDIR)io_ctx_memio.c

io_ctx_stdio.$(OBJSUFFIX): $(IO_CTX_SRCDIR)io_ctx_stdio.h
io_ctx_stdio.$(OBJSUFFIX): $(IO_CTX_SRCDIR)io_ctx_stdio.c

$(IO_CTX_LIBNAME): $(IO_CTX_OBJECTS)
