/*
 *
 *    kdb.h
 *
 *    $Source: /usr/local/CVS/SETREF_1_0_Release/kdb/src/kdb.h,v 
 *    $Revision: 1.6 
 *    $Date: 1997/06/06 00:40:33 
 *    $Name: SETREF_1_0_Release 
 *    $Disclaimer: 
 *    ----------------------------------------------------------------------
 *    SET Draft Reference Implementation Disclaimer/License
 *    June 30, 1997
 *    
 *    This is a beta version of the SET Draft Reference Implementation
 *    ("DRI").  It is a work in progress and is being provided at this
 *    stage and in this form to help developers and other interested
 *    parties to understand the SET protocol.  This version of the DRI
 *    provides the core functionality required to process a simple
 *    transaction.  This release does not support certificate authority
 *    messages. Nor does it support the SET option to perform
 *    transactions without cardholder certificates.  For more details
 *    on the functionality in this beta version, please refer to the
 *    attached documentation.  
 *    
 *    Later versions of the DRI will include additional functionality
 *    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
 *    DEVELOPMENT.  If you discover a bug, please let us know by posting
 *    a message to the SET-DEV mailing list.  Our lawyers made us include
 *    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
 *    describes what you can do with the DRI.
 *     
 *    Copyright (C) 1996, 1997, Visa International Service Association and
 *    MasterCard International Incorporated.  All rights reserved.  
 *    Permission to copy and implement the material contained herein is
 *    granted subject to the conditions that (i) any copy or re-publication
 *    must bear this legend in full; (ii) any derivative work must bear
 *    a notice that it is not the Draft Reference Implementation ("DRI")
 *    for SET and (iii) that none of the copyright holders shall have any
 *    responsibility or liability whatsoever to any other party arising
 *    from the use or publication of the material contained herein.
 *    
 *    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
 *    limited license to (i) make, use, copy and modify the DRI for the
 *    purpose of developing software that complies with the SET
 *    Specification ("SET Products") and for the purpose of achieving a
 *    better understanding of the SET Protocol; and (ii) distribute SET
 *    Products that incorporate all or a portion of the DRI and other
 *    software, which together are provided under a defined interface
 *    different from that provided by the DRI's API.  Licensee shall not
 *    redistribute or sell a license to the DRI nor shall Licensee
 *    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
 *    means a product that provides comprehensive facilities to enable
 *    other parties to create software products for distribution. 
 *    Bolt-on applications and payment modules shall not be considered
 *    Toolkits for the purpose of this license.  The DRI is not intended
 *    to be used as a Toolkit.
 *    
 *    Licensors make no representation or warranty of any kind, express
 *    or implied, relating to the DRI.  Licensors are making the DRI
 *    publicly available as an aid to understanding, creating, and
 *    testing SET Products.  Licensees are solely responsible for any
 *    use of the DRI and agree to hold Licensors harmless for any claim
 *    that may arise out of any product created with the DRI.  
 *    
 *    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
 *    Corporation with offices at 4984 El Camino Real, Los Altos,
 *    California, as a third party beneficiary of this license.
 *    
 *    This software is controlled material under U.S. law and the laws
 *    of other jurisdictions and you hereby acknowledge and agree that
 *    you must fully comply with all the current laws of the United States
 *    including, without limitation, rules and regulations of the United
 *    States Office of Export Administration and other applicable U.S.
 *    governmental agencies.  
 *    ----------------------------------------------------------------------
 *     $
 *
 *    Copyright (C) 1997, Visa International Service Association and MasterCard International Incorporated
 *    All Rights Reserved.
 *
 *    ekr@terisa.com  Mon Feb  3 16:20:16 1997
 *
 */

#ifndef _kdb_h
#define _kdb_h

#include "a2c.h"

#ifdef __cplusplus
extern "C" {
#endif


typedef struct DBASE_CTX {
    VOID                         *handle;
    VOID                         *reserved;
} DBASE_CTX;

int NDBM_InitDB PROTO_LIST((DBASE_CTX *, char *));
int NDBM_CloseDB PROTO_LIST((VOID *));
int NDBM_set_access_mode PROTO_LIST((VOID *, int));
int NDBM_get_access_mode PROTO_LIST((VOID *));

#define DB_W_SHADOW   0x1
#define DB_W_ORIG     0x2
#define DB_R_SHADOW   0x04
#define DB_R_ORIG     0x08

#define KDB_MODULE_NO_                  4
#define KDB_ERR_NOT_FOUND               ERROR_MAKE(KDB_MODULE_NO_, 1)
#define KDB_ERR_INTERNAL                SE_ERR_INTERNAL
#define KDB_ERR_NO_MEMORY               SE_ERR_NO_MEMORY

typedef asn__any              kdb_obj;
typedef
struct kdb_objs_ {
    struct kdb_objs_             *next;
    kdb_obj                       data;
} kdb_objs;

int NDBM_InsertCert PROTO_LIST((unsigned char *, unsigned int,
                                unsigned char *, unsigned int,
                                unsigned char *, unsigned int,
                                kdb_objs *, VOID *));
int NDBM_InsertCertData PROTO_LIST((unsigned char *, unsigned int,
                                    unsigned char *, unsigned int,
                                    unsigned char *, unsigned int,
                                    unsigned char *, unsigned int,
                                    VOID *));
int NDBM_SelectCertByIssuerSerial PROTO_LIST((kdb_objs **, unsigned char *,
                                              unsigned int, unsigned char *,
                                              unsigned int, VOID *));
int NDBM_DeleteCertData PROTO_LIST((unsigned char *,
                                              unsigned int, unsigned char *,
                                              unsigned int, VOID *));
int NDBM_SelectCertsBySubject PROTO_LIST((kdb_objs **, unsigned char *,
                                          unsigned int, VOID *));
int NDBM_InsertPrivateKey PROTO_LIST((unsigned char *, unsigned int,
                                      unsigned char *, unsigned int,
                                      VOID *));
int NDBM_SelectPrivateKey PROTO_LIST((unsigned char *, unsigned int *,
                                      unsigned char *, unsigned int,
                                      VOID *));
int NDBM_InsertCRL PROTO_LIST((unsigned char *, unsigned int,
                               UINT4, kdb_objs *, VOID *));
int NDBM_InsertCRLData PROTO_LIST((unsigned char *, unsigned int,
                                   UINT4, unsigned char *,
                                   unsigned int, VOID *));
int NDBM_SelectCRLByIssuerTime PROTO_LIST((kdb_objs **, unsigned char *,
                                           unsigned int, UINT4, VOID *));
int free_kdb_objs PROTO_LIST((kdb_objs ** listp));


#ifdef __cplusplus
}
#endif
#endif

