/*
 *
 *    keydata.h
 *
 *    $Source: /usr/local/CVS/SETREF_1_0_Release/keydata/src/keydata.h,v 
 *    $Revision: 1.7 
 *    $Date: 1997/06/25 02:33:15 
 *    $Name: SETREF_1_0_Release 
 *    $Disclaimer: 
 *    ----------------------------------------------------------------------
 *    SET Draft Reference Implementation Disclaimer/License
 *    June 30, 1997
 *    
 *    This is a beta version of the SET Draft Reference Implementation
 *    ("DRI").  It is a work in progress and is being provided at this
 *    stage and in this form to help developers and other interested
 *    parties to understand the SET protocol.  This version of the DRI
 *    provides the core functionality required to process a simple
 *    transaction.  This release does not support certificate authority
 *    messages. Nor does it support the SET option to perform
 *    transactions without cardholder certificates.  For more details
 *    on the functionality in this beta version, please refer to the
 *    attached documentation.  
 *    
 *    Later versions of the DRI will include additional functionality
 *    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
 *    DEVELOPMENT.  If you discover a bug, please let us know by posting
 *    a message to the SET-DEV mailing list.  Our lawyers made us include
 *    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
 *    describes what you can do with the DRI.
 *     
 *    Copyright (C) 1996, 1997, Visa International Service Association and
 *    MasterCard International Incorporated.  All rights reserved.  
 *    Permission to copy and implement the material contained herein is
 *    granted subject to the conditions that (i) any copy or re-publication
 *    must bear this legend in full; (ii) any derivative work must bear
 *    a notice that it is not the Draft Reference Implementation ("DRI")
 *    for SET and (iii) that none of the copyright holders shall have any
 *    responsibility or liability whatsoever to any other party arising
 *    from the use or publication of the material contained herein.
 *    
 *    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
 *    limited license to (i) make, use, copy and modify the DRI for the
 *    purpose of developing software that complies with the SET
 *    Specification ("SET Products") and for the purpose of achieving a
 *    better understanding of the SET Protocol; and (ii) distribute SET
 *    Products that incorporate all or a portion of the DRI and other
 *    software, which together are provided under a defined interface
 *    different from that provided by the DRI's API.  Licensee shall not
 *    redistribute or sell a license to the DRI nor shall Licensee
 *    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
 *    means a product that provides comprehensive facilities to enable
 *    other parties to create software products for distribution. 
 *    Bolt-on applications and payment modules shall not be considered
 *    Toolkits for the purpose of this license.  The DRI is not intended
 *    to be used as a Toolkit.
 *    
 *    Licensors make no representation or warranty of any kind, express
 *    or implied, relating to the DRI.  Licensors are making the DRI
 *    publicly available as an aid to understanding, creating, and
 *    testing SET Products.  Licensees are solely responsible for any
 *    use of the DRI and agree to hold Licensors harmless for any claim
 *    that may arise out of any product created with the DRI.  
 *    
 *    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
 *    Corporation with offices at 4984 El Camino Real, Los Altos,
 *    California, as a third party beneficiary of this license.
 *    
 *    This software is controlled material under U.S. law and the laws
 *    of other jurisdictions and you hereby acknowledge and agree that
 *    you must fully comply with all the current laws of the United States
 *    including, without limitation, rules and regulations of the United
 *    States Office of Export Administration and other applicable U.S.
 *    governmental agencies.  
 *    ----------------------------------------------------------------------
 *     $
 *
 *
 *    this file is machine generated
 *
 *
 *    Copyright (C) 1996, 1997, Visa International Service Association and MasterCard International Incorporated
 *    All Rights Reserved.
 *
 *    briank@terisa.com
 *
 */


#ifndef __KEY_DATA_H__
#define __KEY_DATA_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <asn_types.h>

extern unsigned char bca_ca_cert_der[];
extern int len_bca_ca_cert_der;
extern asn__any obj_bca_ca_cert_der;
extern unsigned char bca_ca_dn_der[];
extern int len_bca_ca_dn_der;
extern asn__any obj_bca_ca_dn_der;
extern unsigned char bca_ca_priv_der[];
extern int len_bca_ca_priv_der;
extern asn__any obj_bca_ca_priv_der;
extern unsigned char bca_ca_pub_der[];
extern int len_bca_ca_pub_der;
extern asn__any obj_bca_ca_pub_der;
extern unsigned char card_s_cert_der[];
extern int len_card_s_cert_der;
extern asn__any obj_card_s_cert_der;
extern unsigned char card_s_dn_der[];
extern int len_card_s_dn_der;
extern asn__any obj_card_s_dn_der;
extern unsigned char card_s_priv_der[];
extern int len_card_s_priv_der;
extern asn__any obj_card_s_priv_der;
extern unsigned char card_s_pub_der[];
extern int len_card_s_pub_der;
extern asn__any obj_card_s_pub_der;
extern unsigned char cca_ca_cert_der[];
extern int len_cca_ca_cert_der;
extern asn__any obj_cca_ca_cert_der;
extern unsigned char cca_ca_dn_der[];
extern int len_cca_ca_dn_der;
extern asn__any obj_cca_ca_dn_der;
extern unsigned char cca_ca_priv_der[];
extern int len_cca_ca_priv_der;
extern asn__any obj_cca_ca_priv_der;
extern unsigned char cca_ca_pub_der[];
extern int len_cca_ca_pub_der;
extern asn__any obj_cca_ca_pub_der;
extern unsigned char cca_k_cert_der[];
extern int len_cca_k_cert_der;
extern asn__any obj_cca_k_cert_der;
extern unsigned char cca_k_dn_der[];
extern int len_cca_k_dn_der;
extern asn__any obj_cca_k_dn_der;
extern unsigned char cca_k_priv_der[];
extern int len_cca_k_priv_der;
extern asn__any obj_cca_k_priv_der;
extern unsigned char cca_k_pub_der[];
extern int len_cca_k_pub_der;
extern asn__any obj_cca_k_pub_der;
extern unsigned char cca_s_cert_der[];
extern int len_cca_s_cert_der;
extern asn__any obj_cca_s_cert_der;
extern unsigned char cca_s_dn_der[];
extern int len_cca_s_dn_der;
extern asn__any obj_cca_s_dn_der;
extern unsigned char cca_s_priv_der[];
extern int len_cca_s_priv_der;
extern asn__any obj_cca_s_priv_der;
extern unsigned char cca_s_pub_der[];
extern int len_cca_s_pub_der;
extern asn__any obj_cca_s_pub_der;
extern unsigned char gca_ca_cert_der[];
extern int len_gca_ca_cert_der;
extern asn__any obj_gca_ca_cert_der;
extern unsigned char gca_ca_dn_der[];
extern int len_gca_ca_dn_der;
extern asn__any obj_gca_ca_dn_der;
extern unsigned char gca_ca_priv_der[];
extern int len_gca_ca_priv_der;
extern asn__any obj_gca_ca_priv_der;
extern unsigned char gca_ca_pub_der[];
extern int len_gca_ca_pub_der;
extern asn__any obj_gca_ca_pub_der;
extern unsigned char gca_s_cert_der[];
extern int len_gca_s_cert_der;
extern asn__any obj_gca_s_cert_der;
extern unsigned char gca_s_dn_der[];
extern int len_gca_s_dn_der;
extern asn__any obj_gca_s_dn_der;
extern unsigned char gca_s_priv_der[];
extern int len_gca_s_priv_der;
extern asn__any obj_gca_s_priv_der;
extern unsigned char gca_s_pub_der[];
extern int len_gca_s_pub_der;
extern asn__any obj_gca_s_pub_der;
extern unsigned char mca_ca_cert_der[];
extern int len_mca_ca_cert_der;
extern asn__any obj_mca_ca_cert_der;
extern unsigned char mca_ca_dn_der[];
extern int len_mca_ca_dn_der;
extern asn__any obj_mca_ca_dn_der;
extern unsigned char mca_ca_priv_der[];
extern int len_mca_ca_priv_der;
extern asn__any obj_mca_ca_priv_der;
extern unsigned char mca_ca_pub_der[];
extern int len_mca_ca_pub_der;
extern asn__any obj_mca_ca_pub_der;
extern unsigned char mca_k_cert_der[];
extern int len_mca_k_cert_der;
extern asn__any obj_mca_k_cert_der;
extern unsigned char mca_k_dn_der[];
extern int len_mca_k_dn_der;
extern asn__any obj_mca_k_dn_der;
extern unsigned char mca_k_priv_der[];
extern int len_mca_k_priv_der;
extern asn__any obj_mca_k_priv_der;
extern unsigned char mca_k_pub_der[];
extern int len_mca_k_pub_der;
extern asn__any obj_mca_k_pub_der;
extern unsigned char mca_s_cert_der[];
extern int len_mca_s_cert_der;
extern asn__any obj_mca_s_cert_der;
extern unsigned char mca_s_dn_der[];
extern int len_mca_s_dn_der;
extern asn__any obj_mca_s_dn_der;
extern unsigned char mca_s_priv_der[];
extern int len_mca_s_priv_der;
extern asn__any obj_mca_s_priv_der;
extern unsigned char mca_s_pub_der[];
extern int len_mca_s_pub_der;
extern asn__any obj_mca_s_pub_der;
extern unsigned char mer_k_cert_der[];
extern int len_mer_k_cert_der;
extern asn__any obj_mer_k_cert_der;
extern unsigned char mer_k_dn_der[];
extern int len_mer_k_dn_der;
extern asn__any obj_mer_k_dn_der;
extern unsigned char mer_k_priv_der[];
extern int len_mer_k_priv_der;
extern asn__any obj_mer_k_priv_der;
extern unsigned char mer_k_pub_der[];
extern int len_mer_k_pub_der;
extern asn__any obj_mer_k_pub_der;
extern unsigned char mer_s_cert_der[];
extern int len_mer_s_cert_der;
extern asn__any obj_mer_s_cert_der;
extern unsigned char mer_s_dn_der[];
extern int len_mer_s_dn_der;
extern asn__any obj_mer_s_dn_der;
extern unsigned char mer_s_priv_der[];
extern int len_mer_s_priv_der;
extern asn__any obj_mer_s_priv_der;
extern unsigned char mer_s_pub_der[];
extern int len_mer_s_pub_der;
extern asn__any obj_mer_s_pub_der;
extern unsigned char pca_ca_cert_der[];
extern int len_pca_ca_cert_der;
extern asn__any obj_pca_ca_cert_der;
extern unsigned char pca_ca_dn_der[];
extern int len_pca_ca_dn_der;
extern asn__any obj_pca_ca_dn_der;
extern unsigned char pca_ca_priv_der[];
extern int len_pca_ca_priv_der;
extern asn__any obj_pca_ca_priv_der;
extern unsigned char pca_ca_pub_der[];
extern int len_pca_ca_pub_der;
extern asn__any obj_pca_ca_pub_der;
extern unsigned char pca_k_cert_der[];
extern int len_pca_k_cert_der;
extern asn__any obj_pca_k_cert_der;
extern unsigned char pca_k_dn_der[];
extern int len_pca_k_dn_der;
extern asn__any obj_pca_k_dn_der;
extern unsigned char pca_k_priv_der[];
extern int len_pca_k_priv_der;
extern asn__any obj_pca_k_priv_der;
extern unsigned char pca_k_pub_der[];
extern int len_pca_k_pub_der;
extern asn__any obj_pca_k_pub_der;
extern unsigned char pca_s_cert_der[];
extern int len_pca_s_cert_der;
extern asn__any obj_pca_s_cert_der;
extern unsigned char pca_s_dn_der[];
extern int len_pca_s_dn_der;
extern asn__any obj_pca_s_dn_der;
extern unsigned char pca_s_priv_der[];
extern int len_pca_s_priv_der;
extern asn__any obj_pca_s_priv_der;
extern unsigned char pca_s_pub_der[];
extern int len_pca_s_pub_der;
extern asn__any obj_pca_s_pub_der;
extern unsigned char pgwy_k_cert_der[];
extern int len_pgwy_k_cert_der;
extern asn__any obj_pgwy_k_cert_der;
extern unsigned char pgwy_k_dn_der[];
extern int len_pgwy_k_dn_der;
extern asn__any obj_pgwy_k_dn_der;
extern unsigned char pgwy_k_priv_der[];
extern int len_pgwy_k_priv_der;
extern asn__any obj_pgwy_k_priv_der;
extern unsigned char pgwy_k_pub_der[];
extern int len_pgwy_k_pub_der;
extern asn__any obj_pgwy_k_pub_der;
extern unsigned char pgwy_s_cert_der[];
extern int len_pgwy_s_cert_der;
extern asn__any obj_pgwy_s_cert_der;
extern unsigned char pgwy_s_dn_der[];
extern int len_pgwy_s_dn_der;
extern asn__any obj_pgwy_s_dn_der;
extern unsigned char pgwy_s_priv_der[];
extern int len_pgwy_s_priv_der;
extern asn__any obj_pgwy_s_priv_der;
extern unsigned char pgwy_s_pub_der[];
extern int len_pgwy_s_pub_der;
extern asn__any obj_pgwy_s_pub_der;
extern unsigned char rca_ca_cert_der[];
extern int len_rca_ca_cert_der;
extern asn__any obj_rca_ca_cert_der;
extern unsigned char rca_ca_dn_der[];
extern int len_rca_ca_dn_der;
extern asn__any obj_rca_ca_dn_der;
extern unsigned char rca_ca_priv_der[];
extern int len_rca_ca_priv_der;
extern asn__any obj_rca_ca_priv_der;
extern unsigned char rca_ca_pub_der[];
extern int len_rca_ca_pub_der;
extern asn__any obj_rca_ca_pub_der;

#ifdef __cplusplus
}
#endif
#endif

