/*
 *
 *    asn1set.h
 *
 *    Note, this file consists of machine-generated data structures.
 *    Do not edit these contents.
 *
 *
 *    $Source: /usr/local/CVS/SETREF_1_0_Release/asn1/src/asn1set.h,v 
 *    $Revision: 1.8 
 *    $Date: 1997/07/01 01:08:39 
 *    $Name: SETREF_1_0_Release 
 *    $Disclaimer: 
 *    ----------------------------------------------------------------------
 *    SET Draft Reference Implementation Disclaimer/License
 *    June 30, 1997
 *    
 *    This is a beta version of the SET Draft Reference Implementation
 *    ("DRI").  It is a work in progress and is being provided at this
 *    stage and in this form to help developers and other interested
 *    parties to understand the SET protocol.  This version of the DRI
 *    provides the core functionality required to process a simple
 *    transaction.  This release does not support certificate authority
 *    messages. Nor does it support the SET option to perform
 *    transactions without cardholder certificates.  For more details
 *    on the functionality in this beta version, please refer to the
 *    attached documentation.  
 *    
 *    Later versions of the DRI will include additional functionality
 *    and may include other changes.  DO NOT RELY UPON THIS CODE IN YOUR
 *    DEVELOPMENT.  If you discover a bug, please let us know by posting
 *    a message to the SET-DEV mailing list.  Our lawyers made us include
 *    the next four paragraphs, so PLEASE READ THE TEXT BELOW because it
 *    describes what you can do with the DRI.
 *     
 *    Copyright (C) 1996, 1997, Visa International Service Association and
 *    MasterCard International Incorporated.  All rights reserved.  
 *    Permission to copy and implement the material contained herein is
 *    granted subject to the conditions that (i) any copy or re-publication
 *    must bear this legend in full; (ii) any derivative work must bear
 *    a notice that it is not the Draft Reference Implementation ("DRI")
 *    for SET and (iii) that none of the copyright holders shall have any
 *    responsibility or liability whatsoever to any other party arising
 *    from the use or publication of the material contained herein.
 *    
 *    Visa and MasterCard ("Licensors") hereby grant you ("Licensee") a
 *    limited license to (i) make, use, copy and modify the DRI for the
 *    purpose of developing software that complies with the SET
 *    Specification ("SET Products") and for the purpose of achieving a
 *    better understanding of the SET Protocol; and (ii) distribute SET
 *    Products that incorporate all or a portion of the DRI and other
 *    software, which together are provided under a defined interface
 *    different from that provided by the DRI's API.  Licensee shall not
 *    redistribute or sell a license to the DRI nor shall Licensee
 *    incorporate any part of the DRI into a SET Toolkit.  A "Toolkit"
 *    means a product that provides comprehensive facilities to enable
 *    other parties to create software products for distribution. 
 *    Bolt-on applications and payment modules shall not be considered
 *    Toolkits for the purpose of this license.  The DRI is not intended
 *    to be used as a Toolkit.
 *    
 *    Licensors make no representation or warranty of any kind, express
 *    or implied, relating to the DRI.  Licensors are making the DRI
 *    publicly available as an aid to understanding, creating, and
 *    testing SET Products.  Licensees are solely responsible for any
 *    use of the DRI and agree to hold Licensors harmless for any claim
 *    that may arise out of any product created with the DRI.  
 *    
 *    Licensee expressly acknowledges Terisa Systems, Inc., a Delaware
 *    Corporation with offices at 4984 El Camino Real, Los Altos,
 *    California, as a third party beneficiary of this license.
 *    
 *    This software is controlled material under U.S. law and the laws
 *    of other jurisdictions and you hereby acknowledge and agree that
 *    you must fully comply with all the current laws of the United States
 *    including, without limitation, rules and regulations of the United
 *    States Office of Export Administration and other applicable U.S.
 *    governmental agencies.  
 *    ----------------------------------------------------------------------
 *     $
 *
 *    Copyright (C) 1996, 1997, Visa International Service Association and MasterCard International Incorporated
 *    All Rights Reserved.
 *
 *    briank@terisa.com
 *
 */

#ifndef __asn1set__h__
#define __asn1set__h__

#include <define.h>

#include <asn_types.h>

#include "setpkcs7.h"

#ifdef __cplusplus
extern "C" {
#endif



typedef
    asn__numeric_string            asn1set__PAN                     ; 

typedef
    asn__numeric_string            asn1set__CardExpiry              ; 

typedef
    asn__octet_string              asn1set__Secret                  ; 

typedef
    asn__octet_string              asn1set__Nonce                   ; 

typedef
    struct                         asn1set__PANData0_                 
    {                                                                 
        asn1set__PAN                   pan                              ; 
        asn1set__CardExpiry            cardExpiry                       ; 
        asn1set__Secret                cardSecret                       ; 
        asn1set__Nonce                 exNonce                          ; 
    }                              asn1set__PANData0                ; 

typedef
    asn__visible_string            asn1set__AcctIdentification      ; 

typedef
    struct                         asn1set__AcctData_                 
    {                                                                 
        asn1set__AcctIdentification    acctIdentification               ; 
        asn1set__Nonce                 exNonce                          ; 
    }                              asn1set__AcctData                ; 

typedef
    struct                         asn1set__AcctInfo_                 
    {                                                                 
# define                               asn1set__AcctInfo__panData0    0x143 
# define                               asn1set__AcctInfo__acctData    0x144 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__PANData0              panData0                         ; 
            asn1set__AcctData              acctData                         ; 
        } u                                                             ; 
    }                              asn1set__AcctInfo                ; 

typedef
    asn__numeric_string            asn1set__BIN                     ; 

typedef
    struct                         asn1set__MerchantID_               
    {                                                                 
# define                               asn1set__MerchantID__visibleString 0x40f 
# define                               asn1set__MerchantID__bmpString 0x410 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__MerchantID              ; 

typedef
    struct                         asn1set__MerchantAcquirerID_       
    {                                                                 
        asn1set__BIN                   merchantBIN                      ; 
        asn1set__MerchantID            merchantID                       ; 
    }                              asn1set__MerchantAcquirerID      ; 

typedef
    asn__numeric_string            asn1set__AcquirerBusinessID      ; 

typedef
    struct                         asn1set__AcquirerID_               
    {                                                                 
# define                               asn1set__AcquirerID__acquirerBusinessID   0 
        UCHAR                          _present[1]                      ; 
        asn1set__BIN                   acquirerBIN                      ; 
        asn1set__AcquirerBusinessID    acquirerBusinessID               ; 
    }                              asn1set__AcquirerID              ; 

typedef
    struct                         asn1set__IDData_                   
    {                                                                 
# define                               asn1set__IDData__merchantAcquirerID 0x14a 
# define                               asn1set__IDData__acquirerID    0x14b 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__MerchantAcquirerID    merchantAcquirerID               ; 
            asn1set__AcquirerID            acquirerID                       ; 
        } u                                                             ; 
    }                              asn1set__IDData                  ; 

typedef
    asn__enumerated                asn1set__RequestType             ; 
# define                           asn1set__RequestType__cardInitialSig     1 
# define                           asn1set__RequestType__merInitialSig     4 
# define                           asn1set__RequestType__merInitialEnc     5 
# define                           asn1set__RequestType__merInitialBoth     6 
# define                           asn1set__RequestType__pgwyInitialSig     7 
# define                           asn1set__RequestType__pgwyInitialEnc     8 
# define                           asn1set__RequestType__pgwyInitialBoth     9 
# define                           asn1set__RequestType__cardRenewalSig    10 
# define                           asn1set__RequestType__merRenewalSig    13 
# define                           asn1set__RequestType__merRenewalEnc    14 
# define                           asn1set__RequestType__merRenewalBoth    15 
# define                           asn1set__RequestType__pgwyRenewalSig    16 
# define                           asn1set__RequestType__pgwyRenewalEnc    17 
# define                           asn1set__RequestType__pgwyRenewalBoth    18 

typedef
    asn__visible_string            asn1set__URL                     ; 

typedef
    struct                         asn1set__FieldName_                
    {                                                                 
# define                               asn1set__FieldName__visibleString 0x1d1 
# define                               asn1set__FieldName__bmpString  0x1d2 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__FieldName               ; 

typedef
    struct                         asn1set__SETStringub_FieldDesc_     
    {                                                                 
# define                               asn1set__SETStringub_FieldDesc__visibleString 0x713 
# define                               asn1set__SETStringub_FieldDesc__bmpString 0x714 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_FieldDesc   ; 

typedef
    struct                         asn1set__RegField_                 
    {                                                                 
# define                               asn1set__RegField__fieldId       0 
# define                               asn1set__RegField__fieldDesc     1 
        UCHAR                          _present[1]                      ; 
        asn__object_identifier         fieldId                          ; 
        asn1set__FieldName             fieldName                        ; 
        asn1set__SETStringub_FieldDesc fieldDesc                        ; 
        asn__integer                   fieldLen                         ; 
        asn__boolean                   fieldRequired                    ; 
        asn__boolean                   fieldInvisible                   ; 
    }                              asn1set__RegField                ; 

typedef
    struct                         asn1set__RegFieldSeq_              
    {                                                                 
        struct asn1set__RegFieldSeq_   *next                            ; 
        asn1set__RegField              regField                         ; 
    }                              asn1set__RegFieldSeq             ; 

typedef
    struct                         asn1set__RegTemplate_              
    {                                                                 
# define                               asn1set__RegTemplate__brandLogoURL   0 
# define                               asn1set__RegTemplate__cardLogoURL   1 
# define                               asn1set__RegTemplate__regFieldSeq   2 
        UCHAR                          _present[1]                      ; 
        asn__integer                   regFormID                        ; 
        asn1set__URL                   brandLogoURL                     ; 
        asn1set__URL                   cardLogoURL                      ; 
        asn1set__RegFieldSeq           *regFieldSeq                     ; 
    }                              asn1set__RegTemplate             ; 

typedef
    struct                         asn1set__PolicyText_               
    {                                                                 
# define                               asn1set__PolicyText__visibleString 0x172 
# define                               asn1set__PolicyText__bmpString 0x173 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__PolicyText              ; 

typedef
    struct                         asn1set__RegFormData_              
    {                                                                 
# define                               asn1set__RegFormData__regTemplate   0 
        UCHAR                          _present[1]                      ; 
        asn1set__RegTemplate           regTemplate                      ; 
        asn1set__PolicyText            policy                           ; 
    }                              asn1set__RegFormData             ; 

typedef
    struct                         asn1set__Reason_                   
    {                                                                 
# define                               asn1set__Reason__visibleString 0x16c 
# define                               asn1set__Reason__bmpString     0x16d 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__Reason                  ; 

typedef
    asn1set__URL                   asn1set__ReferralURL             ; 

typedef
    struct                         asn1set__ReferralURLSeq_           
    {                                                                 
        struct asn1set__ReferralURLSeq_ *next                            ; 
        asn1set__ReferralURL           referralURL                      ; 
    }                              asn1set__ReferralURLSeq          ; 

typedef
    struct                         asn1set__ReferralData_             
    {                                                                 
# define                               asn1set__ReferralData__reason    0 
# define                               asn1set__ReferralData__referralURLSeq   1 
        UCHAR                          _present[1]                      ; 
        asn1set__Reason                reason                           ; 
        asn1set__ReferralURLSeq        *referralURLSeq                  ; 
    }                              asn1set__ReferralData            ; 

typedef
    struct                         asn1set__RegFormOrReferral_        
    {                                                                 
# define                               asn1set__RegFormOrReferral__regFormData 0x155 
# define                               asn1set__RegFormOrReferral__referralData 0x156 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__RegFormData           regFormData                      ; 
            asn1set__ReferralData          referralData                     ; 
        } u                                                             ; 
    }                              asn1set__RegFormOrReferral       ; 

typedef
    asn__octet_string              asn1set__RRPID                   ; 

typedef
    asn__octet_string              asn1set__LocalID                 ; 

typedef
    asn__octet_string              asn1set__Challenge               ; 

typedef
    struct                         asn1set__BrandID_                  
    {                                                                 
# define                               asn1set__BrandID__visibleString 0x3eb 
# define                               asn1set__BrandID__bmpString    0x3ec 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__BrandID                 ; 

typedef
    struct                         asn1set__Digests_                  
    {                                                                 
        struct asn1set__Digests_       *next                            ; 
        setpkcs7__Digest               digest                           ; 
    }                              asn1set__Digests                 ; 

typedef
    struct                         asn1set__Thumbs_                   
    {                                                                 
# define                               asn1set__Thumbs__certThumbs      0 
# define                               asn1set__Thumbs__crlThumbs       1 
# define                               asn1set__Thumbs__brandCRLIdThumbs   2 
        UCHAR                          _present[1]                      ; 
        x509__AlgorithmIdentifier      digestAlgorithm                  ; 
        asn1set__Digests               *certThumbs                      ; 
        asn1set__Digests               *crlThumbs                       ; 
        asn1set__Digests               *brandCRLIdThumbs                ; 
    }                              asn1set__Thumbs                  ; 

typedef
    struct                         asn1set__CardCInitReq_             
    {                                                                 
# define                               asn1set__CardCInitReq__thumbs    0 
        UCHAR                          _present[1]                      ; 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__LocalID               lid_EE                           ; 
        asn1set__Challenge             chall_EE                         ; 
        asn1set__BrandID               brandID                          ; 
        asn1set__Thumbs                thumbs                           ; 
    }                              asn1set__CardCInitReq            ; 

typedef
    asn__any                       asn1set__SignedData              ; 

typedef
    asn1set__SignedData            asn1set__S                       ; 

typedef
    asn1set__S                     asn1set__CardCInitRes            ; 

typedef
    struct                         asn1set__CertThumb_                
    {                                                                 
        x509__AlgorithmIdentifier      digestAlgorithm                  ; 
        setpkcs7__Digest               thumbprint                       ; 
    }                              asn1set__CertThumb               ; 

typedef
    asn__any                       asn1set__SIGNED                  ; 

typedef
    asn1set__SIGNED                asn1set__BrandCRLIdentifier      ; 

typedef
    struct                         asn1set__CardCInitResTBS_          
    {                                                                 
# define                               asn1set__CardCInitResTBS__lid_CA   0 
# define                               asn1set__CardCInitResTBS__brandCRLIdentifier   1 
# define                               asn1set__CardCInitResTBS__thumbs   2 
        UCHAR                          _present[1]                      ; 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__LocalID               lid_EE                           ; 
        asn1set__Challenge             chall_EE                         ; 
        asn1set__LocalID               lid_CA                           ; 
        asn1set__CertThumb             caeThumb                         ; 
        asn1set__BrandCRLIdentifier    brandCRLIdentifier               ; 
        asn1set__Thumbs                thumbs                           ; 
    }                              asn1set__CardCInitResTBS         ; 

typedef
    asn__visible_string            asn1set__Language                ; 

typedef
    struct                         asn1set__Me_AqCInitReq_            
    {                                                                 
# define                               asn1set__Me_AqCInitReq__thumbs   0 
        UCHAR                          _present[1]                      ; 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__LocalID               lid_EE                           ; 
        asn1set__Challenge             chall_EE                         ; 
        asn1set__RequestType           requestType                      ; 
        asn1set__IDData                idData                           ; 
        asn1set__BrandID               brandID                          ; 
        asn1set__Language              language                         ; 
        asn1set__Thumbs                thumbs                           ; 
    }                              asn1set__Me_AqCInitReq           ; 

typedef
    asn1set__S                     asn1set__Me_AqCInitRes           ; 

typedef
    struct                         asn1set__Me_AqCInitResTBS_         
    {                                                                 
# define                               asn1set__Me_AqCInitResTBS__lid_CA   0 
# define                               asn1set__Me_AqCInitResTBS__acctDataField   1 
# define                               asn1set__Me_AqCInitResTBS__brandCRLIdentifier   2 
# define                               asn1set__Me_AqCInitResTBS__thumbs   3 
        UCHAR                          _present[1]                      ; 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__LocalID               lid_EE                           ; 
        asn1set__Challenge             chall_EE                         ; 
        asn1set__LocalID               lid_CA                           ; 
        asn1set__Challenge             chall_CA                         ; 
        asn1set__RequestType           requestType                      ; 
        asn1set__RegFormOrReferral     regFormOrReferral                ; 
        asn1set__RegField              acctDataField                    ; 
        asn1set__CertThumb             caeThumb                         ; 
        asn1set__BrandCRLIdentifier    brandCRLIdentifier               ; 
        asn1set__Thumbs                thumbs                           ; 
    }                              asn1set__Me_AqCInitResTBS        ; 

typedef
    asn__any                       asn1set__EnvelopedData           ; 

typedef
    asn1set__EnvelopedData         asn1set__E                       ; 

typedef
    asn1set__E                     asn1set__EX                      ; 

typedef
    asn1set__EX                    asn1set__EXH                     ; 

typedef
    asn1set__EXH                   asn1set__RegFormReq              ; 

typedef
    asn__any                       asn1set__L                       ; 

typedef
    asn1set__L                     asn1set__RegFormReqTBE           ; 

typedef
    struct                         asn1set__RegFormReqData_           
    {                                                                 
# define                               asn1set__RegFormReqData__lid_CA   0 
# define                               asn1set__RegFormReqData__thumbs   1 
        UCHAR                          _present[1]                      ; 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__LocalID               lid_EE                           ; 
        asn1set__Challenge             chall_EE2                        ; 
        asn1set__LocalID               lid_CA                           ; 
        asn1set__RequestType           requestType                      ; 
        asn1set__Language              language                         ; 
        asn1set__Thumbs                thumbs                           ; 
    }                              asn1set__RegFormReqData          ; 

typedef
    struct                         asn1set__PANOnly_                  
    {                                                                 
        asn1set__PAN                   pan                              ; 
        asn1set__Nonce                 exNonce                          ; 
    }                              asn1set__PANOnly                 ; 

typedef
    asn1set__S                     asn1set__RegFormRes              ; 

typedef
    struct                         asn1set__RegFormResTBS_            
    {                                                                 
# define                               asn1set__RegFormResTBS__lid_CA   0 
# define                               asn1set__RegFormResTBS__caeThumb   1 
# define                               asn1set__RegFormResTBS__brandCRLIdentifier   2 
# define                               asn1set__RegFormResTBS__thumbs   3 
        UCHAR                          _present[1]                      ; 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__LocalID               lid_EE                           ; 
        asn1set__Challenge             chall_EE2                        ; 
        asn1set__LocalID               lid_CA                           ; 
        asn1set__Challenge             chall_CA                         ; 
        asn1set__CertThumb             caeThumb                         ; 
        asn1set__RequestType           requestType                      ; 
        asn1set__RegFormOrReferral     formOrReferal                    ; 
        asn1set__BrandCRLIdentifier    brandCRLIdentifier               ; 
        asn1set__Thumbs                thumbs                           ; 
    }                              asn1set__RegFormResTBS           ; 

typedef
    asn1set__E                     asn1set__EncX                    ; 

typedef
    asn1set__E                     asn1set__Enc                     ; 

typedef
    struct                         asn1set__CertReq_                  
    {                                                                 
# define                               asn1set__CertReq__encx         0x1b3 
# define                               asn1set__CertReq__enc          0x1b4 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__EncX                  encx                             ; 
            asn1set__Enc                   enc                              ; 
        } u                                                             ; 
    }                              asn1set__CertReq                 ; 

typedef
    asn1set__S                     asn1set__CertReqTBE              ; 

typedef
    asn__generalized_time          asn1set__Date                    ; 

typedef
    struct                         asn1set__SETStringub_FieldValue_     
    {                                                                 
# define                               asn1set__SETStringub_FieldValue__visibleString 0x719 
# define                               asn1set__SETStringub_FieldValue__bmpString 0x71a 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_FieldValue   ; 

typedef
    struct                         asn1set__FieldValue_               
    {                                                                 
# define                               asn1set__FieldValue__setString 0x1d4 
# define                               asn1set__FieldValue__octetString 0x1d5 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__SETStringub_FieldValue setString                        ; 
            asn__octet_string              octetString                      ; 
        } u                                                             ; 
    }                              asn1set__FieldValue              ; 

typedef
    struct                         asn1set__RegFormItems_             
    {                                                                 
        asn1set__FieldName             fieldName                        ; 
        asn1set__FieldValue            fieldValue                       ; 
    }                              asn1set__RegFormItems            ; 

typedef
    struct                         asn1set__RegForm_                  
    {                                                                 
        struct asn1set__RegForm_       *next                            ; 
        asn1set__RegFormItems          regFormItems                     ; 
    }                              asn1set__RegForm                 ; 

typedef
    asn__octet_string              asn1set__BackKey                 ; 

typedef
    struct                         asn1set__BackKeyData_              
    {                                                                 
        asn__object_identifier         backAlgID                        ; 
        asn1set__BackKey               backKey                          ; 
    }                              asn1set__BackKeyData             ; 

typedef
    asn__any                       asn1set__SubjectPublicKeyInfo    ; 

typedef
    struct                         asn1set__PublicKeySorE_            
    {                                                                 
# define                               asn1set__PublicKeySorE__publicKeyS   0 
# define                               asn1set__PublicKeySorE__publicKeyE   1 
        UCHAR                          _present[1]                      ; 
        asn1set__SubjectPublicKeyInfo  publicKeyS                       ; 
        asn1set__SubjectPublicKeyInfo  publicKeyE                       ; 
    }                              asn1set__PublicKeySorE           ; 

typedef
    struct                         asn1set__CertReqData_              
    {                                                                 
# define                               asn1set__CertReqData__lid_CA     0 
# define                               asn1set__CertReqData__chall_CA   1 
# define                               asn1set__CertReqData__idData     2 
# define                               asn1set__CertReqData__regForm    3 
# define                               asn1set__CertReqData__caBackKeyData   4 
# define                               asn1set__CertReqData__eeThumb    5 
# define                               asn1set__CertReqData__thumbs     6 
        UCHAR                          _present[1]                      ; 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__LocalID               lid_EE                           ; 
        asn1set__Challenge             chall_EE3                        ; 
        asn1set__LocalID               lid_CA                           ; 
        asn1set__Challenge             chall_CA                         ; 
        asn1set__RequestType           requestType                      ; 
        asn1set__Date                  requestDate                      ; 
        asn1set__IDData                idData                           ; 
        asn__integer                   regFormID                        ; 
        asn1set__RegForm               *regForm                         ; 
        asn1set__BackKeyData           caBackKeyData                    ; 
        asn1set__PublicKeySorE         publicKeySorE                    ; 
        asn1set__CertThumb             eeThumb                          ; 
        asn1set__Thumbs                thumbs                           ; 
    }                              asn1set__CertReqData             ; 

typedef
    asn1set__SignedData            asn1set__SO                      ; 

typedef
    struct                         asn1set__CertReqTBEX_              
    {                                                                 
        asn1set__CertReqData           certReqData                      ; 
        asn1set__SO                    s                                ; 
    }                              asn1set__CertReqTBEX             ; 

typedef
    struct                         asn1set__CertReqTBS_               
    {                                                                 
        asn1set__CertReqData           certReqData                      ; 
        asn1set__AcctInfo              acctInfo                         ; 
    }                              asn1set__CertReqTBS              ; 

typedef
    asn1set__EnvelopedData         asn1set__EK                      ; 

typedef
    asn1set__EK                    asn1set__EncK                    ; 

typedef
    struct                         asn1set__CertRes_                  
    {                                                                 
# define                               asn1set__CertRes__certResTBS   0x1da 
# define                               asn1set__CertRes__certResTBSK  0x1db 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__S                     certResTBS                       ; 
            asn1set__EncK                  certResTBSK                      ; 
        } u                                                             ; 
    }                              asn1set__CertRes                 ; 

typedef
    asn1set__S                     asn1set__CertResTBE              ; 

typedef
    asn__enumerated                asn1set__CertStatusCode          ; 
# define                           asn1set__CertStatusCode__requestComplete     1 
# define                           asn1set__CertStatusCode__invalidLanguage     2 
# define                           asn1set__CertStatusCode__invalidBIN     3 
# define                           asn1set__CertStatusCode__sigValidationFail     4 
# define                           asn1set__CertStatusCode__decryptionError     5 
# define                           asn1set__CertStatusCode__requestInProgress     6 
# define                           asn1set__CertStatusCode__rejectedByIssuer     7 
# define                           asn1set__CertStatusCode__requestPended     8 
# define                           asn1set__CertStatusCode__rejectedByAquirer     9 
# define                           asn1set__CertStatusCode__regFormAnswerMalformed    10 
# define                           asn1set__CertStatusCode__rejectedByCA    11 
# define                           asn1set__CertStatusCode__unableToEncryptResponse    12 

typedef
    struct                         asn1set__SETStringub_eeMessage_     
    {                                                                 
# define                               asn1set__SETStringub_eeMessage__visibleString 0x70d 
# define                               asn1set__SETStringub_eeMessage__bmpString 0x70e 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_eeMessage   ; 

typedef
    asn__integer                   asn1set__Currency                ; 

typedef
    struct                         asn1set__SETStringub_cardholderMsg_     
    {                                                                 
# define                               asn1set__SETStringub_cardholderMsg__visibleString 0x6f8 
# define                               asn1set__SETStringub_cardholderMsg__bmpString 0x6f9 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_cardholderMsg   ; 

typedef
    struct                         asn1set__CAMsg_                    
    {                                                                 
# define                               asn1set__CAMsg__cardLogoURL      0 
# define                               asn1set__CAMsg__brandLogoURL     1 
# define                               asn1set__CAMsg__cardCurrency     2 
# define                               asn1set__CAMsg__cardholderMsg    3 
        UCHAR                          _present[1]                      ; 
        asn1set__URL                   cardLogoURL                      ; 
        asn1set__URL                   brandLogoURL                     ; 
        asn1set__Currency              cardCurrency                     ; 
        asn1set__SETStringub_cardholderMsg cardholderMsg                    ; 
    }                              asn1set__CAMsg                   ; 

typedef
    struct                         asn1set__SETStringub_Reason_       
    {                                                                 
# define                               asn1set__SETStringub_Reason__visibleString 0x737 
# define                               asn1set__SETStringub_Reason__bmpString 0x738 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_Reason      ; 

typedef
    struct                         asn1set__FailedItem_               
    {                                                                 
        asn__integer                   itemNumber                       ; 
        asn1set__SETStringub_Reason    itemReason                       ; 
    }                              asn1set__FailedItem              ; 

typedef
    struct                         asn1set__FailedItemSeq_            
    {                                                                 
        struct asn1set__FailedItemSeq_ *next                            ; 
        asn1set__FailedItem            failedItem                       ; 
    }                              asn1set__FailedItemSeq           ; 

typedef
    struct                         asn1set__CertStatus_               
    {                                                                 
# define                               asn1set__CertStatus__nonceCCA    0 
# define                               asn1set__CertStatus__eeMessage   1 
# define                               asn1set__CertStatus__caMsg       2 
# define                               asn1set__CertStatus__failedItemSeq   3 
        UCHAR                          _present[1]                      ; 
        asn1set__CertStatusCode        certStatusCode                   ; 
        asn1set__Nonce                 nonceCCA                         ; 
        asn1set__SETStringub_eeMessage eeMessage                        ; 
        asn1set__CAMsg                 caMsg                            ; 
        asn1set__FailedItemSeq         *failedItemSeq                   ; 
    }                              asn1set__CertStatus              ; 

typedef
    struct                         asn1set__CertResData_              
    {                                                                 
# define                               asn1set__CertResData__certThumbs   0 
# define                               asn1set__CertResData__brandCRLIdentifier   1 
# define                               asn1set__CertResData__thumbs     2 
        UCHAR                          _present[1]                      ; 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__LocalID               lid_EE                           ; 
        asn1set__Challenge             chall_EE3                        ; 
        asn1set__LocalID               lid_CA                           ; 
        asn1set__CertStatus            certStatus                       ; 
        asn1set__Thumbs                certThumbs                       ; 
        asn1set__BrandCRLIdentifier    brandCRLIdentifier               ; 
        asn1set__Thumbs                thumbs                           ; 
    }                              asn1set__CertResData             ; 

typedef
    asn1set__BackKeyData           asn1set__CAKey                   ; 

typedef
    asn1set__S                     asn1set__CertInqReq              ; 

typedef
    struct                         asn1set__CertInqReqTBS_            
    {                                                                 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__LocalID               lid_EE                           ; 
        asn1set__Challenge             chall_EE3                        ; 
        asn1set__LocalID               lid_CA                           ; 
    }                              asn1set__CertInqReqTBS           ; 

typedef
    asn1set__CertRes               asn1set__CertInqRes              ; 

typedef
    asn__any                       asn1set__DigestedData            ; 

typedef
    asn1set__DigestedData          asn1set__DetachedDigest          ; 

typedef
    struct                         asn1set__SETStringub_terseStatement_     
    {                                                                 
# define                               asn1set__SETStringub_terseStatement__visibleString 0x75e 
# define                               asn1set__SETStringub_terseStatement__bmpString 0x75f 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_terseStatement   ; 

typedef
    struct                         asn1set__SETQualifier_             
    {                                                                 
# define                               asn1set__SETQualifier__policyDigest   0 
# define                               asn1set__SETQualifier__terseStatement   1 
# define                               asn1set__SETQualifier__policyURL   2 
# define                               asn1set__SETQualifier__policyEmail   3 
        UCHAR                          _present[1]                      ; 
        asn1set__DetachedDigest        policyDigest                     ; 
        asn1set__SETStringub_terseStatement terseStatement                   ; 
        asn1set__URL                   policyURL                        ; 
        asn1set__URL                   policyEmail                      ; 
    }                              asn1set__SETQualifier            ; 

typedef
# define                           asn1set__CertificateTypeSyntax__card   0 
# define                           asn1set__CertificateTypeSyntax__mer   1 
# define                           asn1set__CertificateTypeSyntax__pgwy   2 
# define                           asn1set__CertificateTypeSyntax__cca   3 
# define                           asn1set__CertificateTypeSyntax__mca   4 
# define                           asn1set__CertificateTypeSyntax__pca   5 
# define                           asn1set__CertificateTypeSyntax__gca   6 
# define                           asn1set__CertificateTypeSyntax__bca   7 
# define                           asn1set__CertificateTypeSyntax__rca   8 
# define                           asn1set__CertificateTypeSyntax__acq   9 
    UCHAR                          asn1set__CertificateTypeSyntax[2]   ; 

typedef
    struct                         asn1set__AdditionalPolicy_         
    {                                                                 
# define                               asn1set__AdditionalPolicy__policyOID   0 
# define                               asn1set__AdditionalPolicy__policyQualifier   1 
        UCHAR                          _present[1]                      ; 
        x509__CertPolicyId             policyOID                        ; 
        asn1set__SETQualifier          policyQualifier                  ; 
        asn1set__CertificateTypeSyntax policyAddedBy                    ; 
    }                              asn1set__AdditionalPolicy        ; 

typedef
    struct                         asn1set__AdditionalPolicies_       
    {                                                                 
        struct asn1set__AdditionalPolicies_ *next                            ; 
        asn1set__AdditionalPolicy      additionalPolicy                 ; 
    }                              asn1set__AdditionalPolicies      ; 

typedef
    struct                         asn1set__SetPolicyQualifier_       
    {                                                                 
# define                               asn1set__SetPolicyQualifier__additionalPolicies   0 
        UCHAR                          _present[1]                      ; 
        asn1set__SETQualifier          rootQualifier                    ; 
        asn1set__AdditionalPolicies    *additionalPolicies              ; 
    }                              asn1set__SetPolicyQualifier      ; 

typedef
    struct                         asn1set__PolicyQualifierInfo_      
    {                                                                 
# define                               asn1set__PolicyQualifierInfo__qualifier   0 
        UCHAR                          _present[1]                      ; 
        asn__object_identifier         policyQualifierId                ; 
        asn1set__SetPolicyQualifier    qualifier                        ; 
    }                              asn1set__PolicyQualifierInfo     ; 

typedef
    struct                         asn1set__PolicyQualifierInfos_     
    {                                                                 
        struct asn1set__PolicyQualifierInfos_ *next                            ; 
        asn1set__PolicyQualifierInfo   policyQualifierInfo              ; 
    }                              asn1set__PolicyQualifierInfos    ; 

typedef
    struct                         asn1set__PolicyInformation_        
    {                                                                 
# define                               asn1set__PolicyInformation__policyQualifiers   0 
        UCHAR                          _present[1]                      ; 
        x509__CertPolicyId             policyIdentifier                 ; 
        asn1set__PolicyQualifierInfos  *policyQualifiers                ; 
    }                              asn1set__PolicyInformation       ; 

typedef
    struct                         asn1set__CertificatePoliciesSyntax_     
    {                                                                 
        struct asn1set__CertificatePoliciesSyntax_ *next                            ; 
        asn1set__PolicyInformation     policyInformation                ; 
    }                              asn1set__CertificatePoliciesSyntax   ; 

typedef
    asn1set__DetachedDigest        asn1set__DD                      ; 

typedef
    struct                         asn1set__RootKeyThumb_             
    {                                                                 
        asn1set__DD                    rootKeyThumbprint                ; 
    }                              asn1set__RootKeyThumb            ; 

typedef
    asn1set__RootKeyThumb          asn1set__HashedRootKeySyntax     ; 

typedef
    struct                         asn1set__SETStringub_merName_      
    {                                                                 
# define                               asn1set__SETStringub_merName__visibleString 0x725 
# define                               asn1set__SETStringub_merName__bmpString 0x726 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_merName     ; 

typedef
    struct                         asn1set__SETStringub_cityName_     
    {                                                                 
# define                               asn1set__SETStringub_cityName__visibleString 0x6fe 
# define                               asn1set__SETStringub_cityName__bmpString 0x6ff 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_cityName    ; 

typedef
    struct                         asn1set__SETStringub_stateProvince_     
    {                                                                 
# define                               asn1set__SETStringub_stateProvince__visibleString 0x74c 
# define                               asn1set__SETStringub_stateProvince__bmpString 0x74d 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_stateProvince   ; 

typedef
    struct                         asn1set__SETStringub_postalCode_     
    {                                                                 
# define                               asn1set__SETStringub_postalCode__visibleString 0x72e 
# define                               asn1set__SETStringub_postalCode__bmpString 0x72f 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_postalCode   ; 

typedef
    struct                         asn1set__SETStringub_countryName_     
    {                                                                 
# define                               asn1set__SETStringub_countryName__visibleString 0x707 
# define                               asn1set__SETStringub_countryName__bmpString 0x708 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_countryName   ; 

typedef
    struct                         asn1set__MerNames_                 
    {                                                                 
# define                               asn1set__MerNames__language      0 
# define                               asn1set__MerNames__stateProvince   1 
# define                               asn1set__MerNames__postalCode    2 
        UCHAR                          _present[1]                      ; 
        asn1set__Language              language                         ; 
        asn1set__SETStringub_merName   name                             ; 
        asn1set__SETStringub_cityName  city                             ; 
        asn1set__SETStringub_stateProvince stateProvince                    ; 
        asn1set__SETStringub_postalCode postalCode                       ; 
        asn1set__SETStringub_countryName countryName                      ; 
    }                              asn1set__MerNames                ; 

typedef
    struct                         asn1set__MerNameSeq_               
    {                                                                 
        struct asn1set__MerNameSeq_    *next                            ; 
        asn1set__MerNames              merNames                         ; 
    }                              asn1set__MerNameSeq              ; 

typedef
    asn__integer                   asn1set__CountryCode             ; 

typedef
    struct                         asn1set__MerchantDataSyntax_       
    {                                                                 
        asn1set__MerchantID            merID                            ; 
        asn1set__BIN                   merAcquirerBIN                   ; 
        asn1set__MerNameSeq            *merNameSeq                      ; 
        asn1set__CountryCode           merCountry                       ; 
        asn__boolean                   merAuthFlag                      ; 
    }                              asn1set__MerchantDataSyntax      ; 

typedef
    asn__boolean                   asn1set__CardCertRequiredSyntax   ; 

typedef
    struct                         asn1set__TunnelAlg_                
    {                                                                 
        struct asn1set__TunnelAlg_     *next                            ; 
        asn__object_identifier         object_identifier                ; 
    }                              asn1set__TunnelAlg               ; 

typedef
    struct                         asn1set__TunnelingSyntax_          
    {                                                                 
        asn__boolean                   tunneling                        ; 
        asn1set__TunnelAlg             *tunnelAlgIDs                    ; 
    }                              asn1set__TunnelingSyntax         ; 

typedef
    struct                         asn1set__SETExtensionsSyntax_      
    {                                                                 
        struct asn1set__SETExtensionsSyntax_ *next                            ; 
        asn__object_identifier         object_identifier                ; 
    }                              asn1set__SETExtensionsSyntax     ; 

typedef
    asn__object_identifier         asn1set__OID                     ; 

typedef
    struct                         asn1set__CurrencyAmount_           
    {                                                                 
        asn1set__Currency              currency                         ; 
        asn__integer                   amount                           ; 
        asn__integer                   amtExp10                         ; 
    }                              asn1set__CurrencyAmount          ; 

typedef
    struct                         asn1set__SETStringub_reference_     
    {                                                                 
# define                               asn1set__SETStringub_reference__visibleString 0x73a 
# define                               asn1set__SETStringub_reference__bmpString 0x73b 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_reference   ; 

typedef
    struct                         asn1set__SETStringub_taxID_        
    {                                                                 
# define                               asn1set__SETStringub_taxID__visibleString 0x758 
# define                               asn1set__SETStringub_taxID__bmpString 0x759 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_taxID       ; 

typedef
    struct                         asn1set__SETStringub_commCode_     
    {                                                                 
# define                               asn1set__SETStringub_commCode__visibleString 0x701 
# define                               asn1set__SETStringub_commCode__bmpString 0x702 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_commCode    ; 

typedef
    struct                         asn1set__SETStringub_merType_      
    {                                                                 
# define                               asn1set__SETStringub_merType__visibleString 0x728 
# define                               asn1set__SETStringub_merType__bmpString 0x729 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_merType     ; 

typedef
    struct                         asn1set__ChargeInfo_               
    {                                                                 
# define                               asn1set__ChargeInfo__totalFreightShippingAmount   0 
# define                               asn1set__ChargeInfo__totalDutyTariffAmount   1 
# define                               asn1set__ChargeInfo__dutyTariffReference   2 
# define                               asn1set__ChargeInfo__totalNationalTaxAmount   3 
# define                               asn1set__ChargeInfo__totalLocalTaxAmount   4 
# define                               asn1set__ChargeInfo__totalOtherTaxAmount   5 
# define                               asn1set__ChargeInfo__totalTaxAmount   6 
# define                               asn1set__ChargeInfo__merchantTaxID   7 
# define                               asn1set__ChargeInfo__merchantDutyTariffRef   8 
# define                               asn1set__ChargeInfo__customerDutyTariffRef   9 
# define                               asn1set__ChargeInfo__summaryCommodityCode  10 
# define                               asn1set__ChargeInfo__merchantType  11 
        UCHAR                          _present[2]                      ; 
        asn1set__CurrencyAmount        totalFreightShippingAmount       ; 
        asn1set__CurrencyAmount        totalDutyTariffAmount            ; 
        asn1set__SETStringub_reference dutyTariffReference              ; 
        asn1set__CurrencyAmount        totalNationalTaxAmount           ; 
        asn1set__CurrencyAmount        totalLocalTaxAmount              ; 
        asn1set__CurrencyAmount        totalOtherTaxAmount              ; 
        asn1set__CurrencyAmount        totalTaxAmount                   ; 
        asn1set__SETStringub_taxID     merchantTaxID                    ; 
        asn1set__SETStringub_reference merchantDutyTariffRef            ; 
        asn1set__SETStringub_reference customerDutyTariffRef            ; 
        asn1set__SETStringub_commCode  summaryCommodityCode             ; 
        asn1set__SETStringub_merType   merchantType                     ; 
    }                              asn1set__ChargeInfo              ; 

typedef
    struct                         asn1set__SETStringub_locationID_     
    {                                                                 
# define                               asn1set__SETStringub_locationID__visibleString 0x722 
# define                               asn1set__SETStringub_locationID__bmpString 0x723 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_locationID   ; 

typedef
    struct                         asn1set__Location_                 
    {                                                                 
# define                               asn1set__Location__city          0 
# define                               asn1set__Location__stateProvince   1 
# define                               asn1set__Location__postalCode    2 
# define                               asn1set__Location__locationID    3 
        UCHAR                          _present[1]                      ; 
        asn1set__CountryCode           countryCode                      ; 
        asn1set__SETStringub_cityName  city                             ; 
        asn1set__SETStringub_stateProvince stateProvince                    ; 
        asn1set__SETStringub_postalCode postalCode                       ; 
        asn1set__SETStringub_locationID locationID                       ; 
    }                              asn1set__Location                ; 

typedef
    struct                         asn1set__SETStringub_unitMeasure_     
    {                                                                 
# define                               asn1set__SETStringub_unitMeasure__visibleString 0x764 
# define                               asn1set__SETStringub_unitMeasure__bmpString 0x765 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_unitMeasure   ; 

typedef
    struct                         asn1set__SETStringub_description_     
    {                                                                 
# define                               asn1set__SETStringub_description__visibleString 0x70a 
# define                               asn1set__SETStringub_description__bmpString 0x70b 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_description   ; 

typedef
    struct                         asn1set__SETStringub_productCode_     
    {                                                                 
# define                               asn1set__SETStringub_productCode__visibleString 0x731 
# define                               asn1set__SETStringub_productCode__bmpString 0x732 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_productCode   ; 

typedef
    asn__real                      asn1set__FloatingPoint           ; 

typedef
    struct                         asn1set__SETStringub_taxType_      
    {                                                                 
# define                               asn1set__SETStringub_taxType__visibleString 0x75b 
# define                               asn1set__SETStringub_taxType__bmpString 0x75c 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_taxType     ; 

typedef
    struct                         asn1set__Item_                     
    {                                                                 
# define                               asn1set__Item__unitOfMeasureCode   0 
# define                               asn1set__Item__commodityCode     1 
# define                               asn1set__Item__productCode       2 
# define                               asn1set__Item__unitCost          3 
# define                               asn1set__Item__netCost           4 
# define                               asn1set__Item__discountAmount    5 
# define                               asn1set__Item__nationalTaxAmount   6 
# define                               asn1set__Item__nationalTaxRate   7 
# define                               asn1set__Item__nationalTaxType   8 
# define                               asn1set__Item__localTaxAmount    9 
# define                               asn1set__Item__otherTaxAmount   10 
        UCHAR                          _present[2]                      ; 
        asn__integer                   quantity                         ; 
        asn1set__SETStringub_unitMeasure unitOfMeasureCode                ; 
        asn1set__SETStringub_description descriptor                       ; 
        asn1set__SETStringub_commCode  commodityCode                    ; 
        asn1set__SETStringub_productCode productCode                      ; 
        asn1set__CurrencyAmount        unitCost                         ; 
        asn1set__CurrencyAmount        netCost                          ; 
        asn__boolean                   discountInd                      ; 
        asn1set__CurrencyAmount        discountAmount                   ; 
        asn1set__CurrencyAmount        nationalTaxAmount                ; 
        asn1set__FloatingPoint         nationalTaxRate                  ; 
        asn1set__SETStringub_taxType   nationalTaxType                  ; 
        asn1set__CurrencyAmount        localTaxAmount                   ; 
        asn1set__CurrencyAmount        otherTaxAmount                   ; 
        asn1set__CurrencyAmount        itemTotalCost                    ; 
    }                              asn1set__Item                    ; 

typedef
    struct                         asn1set__ItemSeq_                  
    {                                                                 
        struct asn1set__ItemSeq_       *next                            ; 
        asn1set__Item                  item                             ; 
    }                              asn1set__ItemSeq                 ; 

typedef
    struct                         asn1set__CommercialCardData_       
    {                                                                 
# define                               asn1set__CommercialCardData__chargeInfo   0 
# define                               asn1set__CommercialCardData__merchantLocation   1 
# define                               asn1set__CommercialCardData__shipFrom   2 
# define                               asn1set__CommercialCardData__shipTo   3 
# define                               asn1set__CommercialCardData__itemSeq   4 
        UCHAR                          _present[1]                      ; 
        asn1set__ChargeInfo            chargeInfo                       ; 
        asn1set__Location              merchantLocation                 ; 
        asn1set__Location              shipFrom                         ; 
        asn1set__Location              shipTo                           ; 
        asn1set__ItemSeq               *itemSeq                         ; 
    }                              asn1set__CommercialCardData      ; 

typedef
    struct                         asn1set__SETStringub_renterName_     
    {                                                                 
# define                               asn1set__SETStringub_renterName__visibleString 0x743 
# define                               asn1set__SETStringub_renterName__bmpString 0x744 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_renterName   ; 

typedef
    struct                         asn1set__DateTime_                 
    {                                                                 
        asn1set__Date                  date                             ; 
        asn__boolean                   timeInd                          ; 
    }                              asn1set__DateTime                ; 

typedef
    asn__enumerated                asn1set__AutoNoShow              ; 
# define                           asn1set__AutoNoShow__normalVehicle     0 
# define                           asn1set__AutoNoShow__specialVehicle     1 

typedef
    struct                         asn1set__SETStringub_rentalNum_     
    {                                                                 
# define                               asn1set__SETStringub_rentalNum__visibleString 0x73d 
# define                               asn1set__SETStringub_rentalNum__bmpString 0x73e 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_rentalNum   ; 

typedef
    struct                         asn1set__SETStringub_rentalRefNum_     
    {                                                                 
# define                               asn1set__SETStringub_rentalRefNum__visibleString 0x740 
# define                               asn1set__SETStringub_rentalRefNum__bmpString 0x741 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_rentalRefNum   ; 

typedef
    struct                         asn1set__SETStringub_insuranceType_     
    {                                                                 
# define                               asn1set__SETStringub_insuranceType__visibleString 0x71f 
# define                               asn1set__SETStringub_insuranceType__bmpString 0x720 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_insuranceType   ; 

typedef
    struct                         asn1set__AutoApplicableRate_       
    {                                                                 
# define                               asn1set__AutoApplicableRate__dailyRentalRate 0x32e 
# define                               asn1set__AutoApplicableRate__weeklyRentalRate 0x32f 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__CurrencyAmount        dailyRentalRate                  ; 
            asn1set__CurrencyAmount        weeklyRentalRate                 ; 
        } u                                                             ; 
    }                              asn1set__AutoApplicableRate      ; 

typedef
    asn__enumerated                asn1set__DistanceScale           ; 
# define                           asn1set__DistanceScale__miles      0 
# define                           asn1set__DistanceScale__kilometers     1 

typedef
    struct                         asn1set__Distance_                 
    {                                                                 
        asn1set__DistanceScale         scale                            ; 
        asn__integer                   dist                             ; 
    }                              asn1set__Distance                ; 

typedef
    struct                         asn1set__SETStringub_vehicleClass_     
    {                                                                 
# define                               asn1set__SETStringub_vehicleClass__visibleString 0x767 
# define                               asn1set__SETStringub_vehicleClass__bmpString 0x768 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_vehicleClass   ; 

typedef
    struct                         asn1set__SETStringub_corpID_       
    {                                                                 
# define                               asn1set__SETStringub_corpID__visibleString 0x704 
# define                               asn1set__SETStringub_corpID__bmpString 0x705 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_corpID      ; 

typedef
    struct                         asn1set__AutoRateInfo_             
    {                                                                 
# define                               asn1set__AutoRateInfo__lateReturnHourlyRate   0 
# define                               asn1set__AutoRateInfo__distanceRate   1 
# define                               asn1set__AutoRateInfo__freeDistance   2 
# define                               asn1set__AutoRateInfo__vehicleClassCode   3 
# define                               asn1set__AutoRateInfo__corporateID   4 
        UCHAR                          _present[1]                      ; 
        asn1set__AutoApplicableRate    autoApplicableRate               ; 
        asn1set__CurrencyAmount        lateReturnHourlyRate             ; 
        asn1set__CurrencyAmount        distanceRate                     ; 
        asn1set__Distance              freeDistance                     ; 
        asn1set__SETStringub_vehicleClass vehicleClassCode                 ; 
        asn1set__SETStringub_corpID    corporateID                      ; 
    }                              asn1set__AutoRateInfo            ; 

typedef
    struct                         asn1set__AutoCharges_              
    {                                                                 
# define                               asn1set__AutoCharges__lateReturnCharges   0 
# define                               asn1set__AutoCharges__totalDistance   1 
# define                               asn1set__AutoCharges__extraDistanceCharges   2 
# define                               asn1set__AutoCharges__insuranceCharges   3 
# define                               asn1set__AutoCharges__fuelCharges   4 
# define                               asn1set__AutoCharges__autoTowingCharges   5 
# define                               asn1set__AutoCharges__oneWayDropOffCharges   6 
# define                               asn1set__AutoCharges__telephoneCharges   7 
# define                               asn1set__AutoCharges__violationsCharges   8 
# define                               asn1set__AutoCharges__deliveryCharges   9 
# define                               asn1set__AutoCharges__parkingCharges  10 
# define                               asn1set__AutoCharges__otherCharges  11 
# define                               asn1set__AutoCharges__totalTaxAmount  12 
# define                               asn1set__AutoCharges__auditAdjustment  13 
        UCHAR                          _present[2]                      ; 
        asn1set__CurrencyAmount        regularDistanceCharges           ; 
        asn1set__CurrencyAmount        lateReturnCharges                ; 
        asn1set__Distance              totalDistance                    ; 
        asn1set__CurrencyAmount        extraDistanceCharges             ; 
        asn1set__CurrencyAmount        insuranceCharges                 ; 
        asn1set__CurrencyAmount        fuelCharges                      ; 
        asn1set__CurrencyAmount        autoTowingCharges                ; 
        asn1set__CurrencyAmount        oneWayDropOffCharges             ; 
        asn1set__CurrencyAmount        telephoneCharges                 ; 
        asn1set__CurrencyAmount        violationsCharges                ; 
        asn1set__CurrencyAmount        deliveryCharges                  ; 
        asn1set__CurrencyAmount        parkingCharges                   ; 
        asn1set__CurrencyAmount        otherCharges                     ; 
        asn1set__CurrencyAmount        totalTaxAmount                   ; 
        asn1set__CurrencyAmount        auditAdjustment                  ; 
    }                              asn1set__AutoCharges             ; 

typedef
    struct                         asn1set__MarketAutoCap_            
    {                                                                 
# define                               asn1set__MarketAutoCap__renterName   0 
# define                               asn1set__MarketAutoCap__rentalLocation   1 
# define                               asn1set__MarketAutoCap__autoNoShow   2 
# define                               asn1set__MarketAutoCap__rentalAgreementNumber   3 
# define                               asn1set__MarketAutoCap__referenceNumber   4 
# define                               asn1set__MarketAutoCap__insuranceType   5 
# define                               asn1set__MarketAutoCap__autoRateInfo   6 
# define                               asn1set__MarketAutoCap__returnLocation   7 
        UCHAR                          _present[2]                      ; 
        asn1set__SETStringub_renterName renterName                       ; 
        asn1set__Location              rentalLocation                   ; 
        asn1set__DateTime              rentalDateTime                   ; 
        asn1set__AutoNoShow            autoNoShow                       ; 
        asn1set__SETStringub_rentalNum rentalAgreementNumber            ; 
        asn1set__SETStringub_rentalRefNum referenceNumber                  ; 
        asn1set__SETStringub_insuranceType insuranceType                    ; 
        asn1set__AutoRateInfo          autoRateInfo                     ; 
        asn1set__Location              returnLocation                   ; 
        asn1set__DateTime              returnDateTime                   ; 
        asn1set__AutoCharges           autoCharges                      ; 
    }                              asn1set__MarketAutoCap           ; 

typedef
    asn__enumerated                asn1set__HotelNoShow             ; 
# define                           asn1set__HotelNoShow__guaranteedLateArrival     0 

typedef
    struct                         asn1set__SETStringub_hotelFolio_     
    {                                                                 
# define                               asn1set__SETStringub_hotelFolio__visibleString 0x71c 
# define                               asn1set__SETStringub_hotelFolio__bmpString 0x71d 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_hotelFolio   ; 

typedef
    struct                         asn1set__Phone_                    
    {                                                                 
# define                               asn1set__Phone__visibleString  0x423 
# define                               asn1set__Phone__bmpString      0x424 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__Phone                   ; 

typedef
    struct                         asn1set__SETStringub_programCode_     
    {                                                                 
# define                               asn1set__SETStringub_programCode__visibleString 0x734 
# define                               asn1set__SETStringub_programCode__bmpString 0x735 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_programCode   ; 

typedef
    struct                         asn1set__HotelRateInfo_            
    {                                                                 
# define                               asn1set__HotelRateInfo__dailyTaxRate   0 
        UCHAR                          _present[1]                      ; 
        asn1set__CurrencyAmount        dailyRoomRate                    ; 
        asn1set__CurrencyAmount        dailyTaxRate                     ; 
    }                              asn1set__HotelRateInfo           ; 

typedef
    struct                         asn1set__HotelCharges_             
    {                                                                 
# define                               asn1set__HotelCharges__roomTax   0 
# define                               asn1set__HotelCharges__prepaidExpenses   1 
# define                               asn1set__HotelCharges__foodBeverageCharges   2 
# define                               asn1set__HotelCharges__roomServiceCharges   3 
# define                               asn1set__HotelCharges__miniBarCharges   4 
# define                               asn1set__HotelCharges__laundryCharges   5 
# define                               asn1set__HotelCharges__telephoneCharges   6 
# define                               asn1set__HotelCharges__businessCenterCharges   7 
# define                               asn1set__HotelCharges__parkingCharges   8 
# define                               asn1set__HotelCharges__movieCharges   9 
# define                               asn1set__HotelCharges__healthClubCharges  10 
# define                               asn1set__HotelCharges__giftShopPurchases  11 
# define                               asn1set__HotelCharges__folioCashAdvances  12 
# define                               asn1set__HotelCharges__otherCharges  13 
# define                               asn1set__HotelCharges__totalTaxAmount  14 
# define                               asn1set__HotelCharges__auditAdjustment  15 
        UCHAR                          _present[3]                      ; 
        asn1set__CurrencyAmount        roomCharges                      ; 
        asn1set__CurrencyAmount        roomTax                          ; 
        asn1set__CurrencyAmount        prepaidExpenses                  ; 
        asn1set__CurrencyAmount        foodBeverageCharges              ; 
        asn1set__CurrencyAmount        roomServiceCharges               ; 
        asn1set__CurrencyAmount        miniBarCharges                   ; 
        asn1set__CurrencyAmount        laundryCharges                   ; 
        asn1set__CurrencyAmount        telephoneCharges                 ; 
        asn1set__CurrencyAmount        businessCenterCharges            ; 
        asn1set__CurrencyAmount        parkingCharges                   ; 
        asn1set__CurrencyAmount        movieCharges                     ; 
        asn1set__CurrencyAmount        healthClubCharges                ; 
        asn1set__CurrencyAmount        giftShopPurchases                ; 
        asn1set__CurrencyAmount        folioCashAdvances                ; 
        asn1set__CurrencyAmount        otherCharges                     ; 
        asn1set__CurrencyAmount        totalTaxAmount                   ; 
        asn1set__CurrencyAmount        auditAdjustment                  ; 
    }                              asn1set__HotelCharges            ; 

typedef
    struct                         asn1set__MarketHotelCap_           
    {                                                                 
# define                               asn1set__MarketHotelCap__hotelNoShow   0 
# define                               asn1set__MarketHotelCap__durationOfStay   1 
# define                               asn1set__MarketHotelCap__folioNumber   2 
# define                               asn1set__MarketHotelCap__propertyPhone   3 
# define                               asn1set__MarketHotelCap__customerServicePhone   4 
# define                               asn1set__MarketHotelCap__programCode   5 
# define                               asn1set__MarketHotelCap__hotelRateInfo   6 
        UCHAR                          _present[1]                      ; 
        asn1set__Date                  arrivalDate                      ; 
        asn1set__HotelNoShow           hotelNoShow                      ; 
        asn1set__Date                  departureDate                    ; 
        asn__integer                   durationOfStay                   ; 
        asn1set__SETStringub_hotelFolio folioNumber                      ; 
        asn1set__Phone                 propertyPhone                    ; 
        asn1set__Phone                 customerServicePhone             ; 
        asn1set__SETStringub_programCode programCode                      ; 
        asn1set__HotelRateInfo         hotelRateInfo                    ; 
        asn1set__HotelCharges          hotelCharges                     ; 
    }                              asn1set__MarketHotelCap          ; 

typedef
    struct                         asn1set__SETStringub_passName_     
    {                                                                 
# define                               asn1set__SETStringub_passName__visibleString 0x72b 
# define                               asn1set__SETStringub_passName__bmpString 0x72c 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_passName    ; 

typedef
    struct                         asn1set__SETStringub_airportCode_     
    {                                                                 
# define                               asn1set__SETStringub_airportCode__visibleString 0x6f5 
# define                               asn1set__SETStringub_airportCode__bmpString 0x6f6 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_airportCode   ; 

typedef
    struct                         asn1set__SETStringub_carrierCode_     
    {                                                                 
# define                               asn1set__SETStringub_carrierCode__visibleString 0x6fb 
# define                               asn1set__SETStringub_carrierCode__bmpString 0x6fc 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_carrierCode   ; 

typedef
    struct                         asn1set__SETStringub_serviceClass_     
    {                                                                 
# define                               asn1set__SETStringub_serviceClass__visibleString 0x746 
# define                               asn1set__SETStringub_serviceClass__bmpString 0x747 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_serviceClass   ; 

typedef
    asn__enumerated                asn1set__StopOverCode            ; 
# define                           asn1set__StopOverCode__noStopOverPermitted     0 
# define                           asn1set__StopOverCode__stopOverPermitted     1 

typedef
    struct                         asn1set__SETStringub_fareBasis_     
    {                                                                 
# define                               asn1set__SETStringub_fareBasis__visibleString 0x710 
# define                               asn1set__SETStringub_fareBasis__bmpString 0x711 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_fareBasis   ; 

typedef
    struct                         asn1set__TripLeg_                  
    {                                                                 
# define                               asn1set__TripLeg__fareBasisCode   0 
# define                               asn1set__TripLeg__departureTax   1 
        UCHAR                          _present[1]                      ; 
        asn1set__Date                  dateOfTravel                     ; 
        asn1set__SETStringub_carrierCode carrierCode                      ; 
        asn1set__SETStringub_serviceClass serviceClass                     ; 
        asn1set__StopOverCode          stopOverCode                     ; 
        asn1set__SETStringub_airportCode destCityAirport                  ; 
        asn1set__SETStringub_fareBasis fareBasisCode                    ; 
        asn1set__CurrencyAmount        departureTax                     ; 
    }                              asn1set__TripLeg                 ; 

typedef
    struct                         asn1set__TripLegSeq_               
    {                                                                 
        struct asn1set__TripLegSeq_    *next                            ; 
        asn1set__TripLeg               tripLeg                          ; 
    }                              asn1set__TripLegSeq              ; 

typedef
    struct                         asn1set__SETStringub_ticketNum_     
    {                                                                 
# define                               asn1set__SETStringub_ticketNum__visibleString 0x761 
# define                               asn1set__SETStringub_ticketNum__bmpString 0x762 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_ticketNum   ; 

typedef
    struct                         asn1set__SETStringub_taCode_       
    {                                                                 
# define                               asn1set__SETStringub_taCode__visibleString 0x752 
# define                               asn1set__SETStringub_taCode__bmpString 0x753 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_taCode      ; 

typedef
    struct                         asn1set__SETStringub_taName_       
    {                                                                 
# define                               asn1set__SETStringub_taName__visibleString 0x755 
# define                               asn1set__SETStringub_taName__bmpString 0x756 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_taName      ; 

typedef
    asn__enumerated                asn1set__Restrictions            ; 
# define                           asn1set__Restrictions__unspecifiedRestriction     0 

typedef
    struct                         asn1set__MarketTransportCap_       
    {                                                                 
# define                               asn1set__MarketTransportCap__tripLegSeq   0 
# define                               asn1set__MarketTransportCap__ticketNumber   1 
# define                               asn1set__MarketTransportCap__travelAgencyCode   2 
# define                               asn1set__MarketTransportCap__travelAgencyName   3 
# define                               asn1set__MarketTransportCap__restrictions   4 
        UCHAR                          _present[1]                      ; 
        asn1set__SETStringub_passName  passengerName                    ; 
        asn1set__Date                  departureDate                    ; 
        asn1set__SETStringub_airportCode origCityAirport                  ; 
        asn1set__TripLegSeq            *tripLegSeq                      ; 
        asn1set__SETStringub_ticketNum ticketNumber                     ; 
        asn1set__SETStringub_taCode    travelAgencyCode                 ; 
        asn1set__SETStringub_taName    travelAgencyName                 ; 
        asn1set__Restrictions          restrictions                     ; 
    }                              asn1set__MarketTransportCap      ; 

typedef
    asn__octet_string              asn1set__XID                     ; 

typedef
    struct                         asn1set__MessageIDs_               
    {                                                                 
# define                               asn1set__MessageIDs__lid_C       0 
# define                               asn1set__MessageIDs__lid_M       1 
# define                               asn1set__MessageIDs__xID         2 
        UCHAR                          _present[1]                      ; 
        asn1set__LocalID               lid_C                            ; 
        asn1set__LocalID               lid_M                            ; 
        asn1set__XID                   xID                              ; 
    }                              asn1set__MessageIDs              ; 

typedef
    asn__visible_string            asn1set__SWIdent                 ; 

typedef
    struct                         asn1set__MessageHeader_            
    {                                                                 
# define                               asn1set__MessageHeader__messageIDs   0 
# define                               asn1set__MessageHeader__rrpid    1 
        UCHAR                          _present[1]                      ; 
        asn__integer                   version                          ; 
        asn__integer                   revision                         ; 
        asn1set__Date                  date                             ; 
        asn1set__MessageIDs            messageIDs                       ; 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__SWIdent               swIdent                          ; 
    }                              asn1set__MessageHeader           ; 

typedef
    struct                         asn1set__MsgExtension_             
    {                                                                 
        asn__object_identifier         extnID                           ; 
        asn__boolean                   critical                         ; 
        asn__any                       extnValue                        ; 
    }                              asn1set__MsgExtension            ; 

typedef
    struct                         asn1set__MsgExtensions_            
    {                                                                 
        struct asn1set__MsgExtensions_ *next                            ; 
        asn1set__MsgExtension          msgExtension                     ; 
    }                              asn1set__MsgExtensions           ; 

typedef
    struct                         asn1set__PInitReq_                 
    {                                                                 
# define                               asn1set__PInitReq__localID_M     0 
# define                               asn1set__PInitReq__thumbs        1 
# define                               asn1set__PInitReq__piRqExtensions   2 
        UCHAR                          _present[1]                      ; 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__Language              language                         ; 
        asn1set__LocalID               localID_C                        ; 
        asn1set__LocalID               localID_M                        ; 
        asn1set__Challenge             chall_C                          ; 
        asn1set__BrandID               brandID                          ; 
        asn1set__BIN                   bin                              ; 
        asn1set__Thumbs                thumbs                           ; 
        asn1set__MsgExtensions         *piRqExtensions                  ; 
    }                              asn1set__PInitReq                ; 

typedef
    asn1set__S                     asn1set__PInitRes                ; 

typedef
    asn1set__SO                    asn1set__PISignature             ; 

typedef
    struct                         asn1set__PIDualSigned_             
    {                                                                 
        asn1set__PISignature           piSignature                      ; 
        asn1set__EX                    exPIData                         ; 
    }                              asn1set__PIDualSigned            ; 

typedef
    asn1set__L                     asn1set__OIDualSigned            ; 

typedef
    struct                         asn1set__PReqDualSigned_           
    {                                                                 
        asn1set__PIDualSigned          piDualSigned                     ; 
        asn1set__OIDualSigned          oiDualSigned                     ; 
    }                              asn1set__PReqDualSigned          ; 

typedef
    asn1set__EXH                   asn1set__PIUnsigned              ; 

typedef
    asn1set__L                     asn1set__OIUnsigned              ; 

typedef
    struct                         asn1set__PReqUnsigned_             
    {                                                                 
        asn1set__PIUnsigned            piUnsigned                       ; 
        asn1set__OIUnsigned            oiUnsigned                       ; 
    }                              asn1set__PReqUnsigned            ; 

typedef
    struct                         asn1set__PReq_                     
    {                                                                 
# define                               asn1set__PReq__pReqDualSigned  0x46c 
# define                               asn1set__PReq__pReqUnsigned    0x46d 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__PReqDualSigned        pReqDualSigned                   ; 
            asn1set__PReqUnsigned          pReqUnsigned                     ; 
        } u                                                             ; 
    }                              asn1set__PReq                    ; 

typedef
    asn1set__S                     asn1set__PRes                    ; 

typedef
    asn1set__S                     asn1set__InqReqSigned            ; 

typedef
    asn__visible_string            asn1set__PaySysID                ; 

typedef
    struct                         asn1set__TransIDs_                 
    {                                                                 
# define                               asn1set__TransIDs__lid_M         0 
# define                               asn1set__TransIDs__paySysID      1 
        UCHAR                          _present[1]                      ; 
        asn1set__LocalID               lid_C                            ; 
        asn1set__LocalID               lid_M                            ; 
        asn1set__XID                   xid                              ; 
        asn1set__Date                  pReqDate                         ; 
        asn1set__PaySysID              paySysID                         ; 
        asn1set__Language              language                         ; 
    }                              asn1set__TransIDs                ; 

typedef
    struct                         asn1set__InqReqData_               
    {                                                                 
# define                               asn1set__InqReqData__inqRqExtensions   0 
        UCHAR                          _present[1]                      ; 
        asn1set__TransIDs              transIDs                         ; 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__Challenge             chall_C2                         ; 
        asn1set__MsgExtensions         *inqRqExtensions                 ; 
    }                              asn1set__InqReqData              ; 

typedef
    struct                         asn1set__InqReq_                   
    {                                                                 
# define                               asn1set__InqReq__inqReqSigned  0x4d2 
# define                               asn1set__InqReq__inqReqUnsigned 0x4d3 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__InqReqSigned          inqReqSigned                     ; 
            asn1set__InqReqData            inqReqUnsigned                   ; 
        } u                                                             ; 
    }                              asn1set__InqReq                  ; 

typedef
    asn1set__PRes                  asn1set__InqRes                  ; 

typedef
    struct                         asn1set__EncB_                     
    {                                                                 
        asn1set__Enc                   enc                              ; 
        asn__any                       baggage                          ; 
    }                              asn1set__EncB                    ; 

typedef
    asn1set__EncB                  asn1set__AuthReq                 ; 

typedef
    struct                         asn1set__EncBX_                    
    {                                                                 
        asn1set__EncX                  encX                             ; 
        asn__any                       baggage                          ; 
    }                              asn1set__EncBX                   ; 

typedef
    struct                         asn1set__AuthRes_                  
    {                                                                 
# define                               asn1set__AuthRes__encB         0x504 
# define                               asn1set__AuthRes__encBX        0x505 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__EncB                  encB                             ; 
            asn1set__EncBX                 encBX                            ; 
        } u                                                             ; 
    }                              asn1set__AuthRes                 ; 

typedef
    asn1set__EncB                  asn1set__AuthRevReq              ; 

typedef
    struct                         asn1set__AuthRevRes_               
    {                                                                 
# define                               asn1set__AuthRevRes__encB      0x552 
# define                               asn1set__AuthRevRes__enc       0x553 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__EncB                  encB                             ; 
            asn1set__Enc                   enc                              ; 
        } u                                                             ; 
    }                              asn1set__AuthRevRes              ; 

typedef
    struct                         asn1set__CapReq_                   
    {                                                                 
# define                               asn1set__CapReq__encB          0x567 
# define                               asn1set__CapReq__encBX         0x568 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__EncB                  encB                             ; 
            asn1set__EncBX                 encBX                            ; 
        } u                                                             ; 
    }                              asn1set__CapReq                  ; 

typedef
    asn1set__Enc                   asn1set__CapRes                  ; 

typedef
    struct                         asn1set__CapRevReq_                
    {                                                                 
# define                               asn1set__CapRevReq__encB       0x5bf 
# define                               asn1set__CapRevReq__encBX      0x5c0 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__EncB                  encB                             ; 
            asn1set__EncBX                 encBX                            ; 
        } u                                                             ; 
    }                              asn1set__CapRevReq               ; 

typedef
    asn1set__Enc                   asn1set__CapRevRes               ; 

typedef
    struct                         asn1set__CredReq_                  
    {                                                                 
# define                               asn1set__CredReq__encB         0x5ce 
# define                               asn1set__CredReq__encBX        0x5cf 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__EncB                  encB                             ; 
            asn1set__EncBX                 encBX                            ; 
        } u                                                             ; 
    }                              asn1set__CredReq                 ; 

typedef
    asn1set__Enc                   asn1set__CredRes                 ; 

typedef
    struct                         asn1set__CredRevReq_               
    {                                                                 
# define                               asn1set__CredRevReq__encB      0x5dd 
# define                               asn1set__CredRevReq__encBX     0x5de 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__EncB                  encB                             ; 
            asn1set__EncBX                 encBX                            ; 
        } u                                                             ; 
    }                              asn1set__CredRevReq              ; 

typedef
    asn1set__Enc                   asn1set__CredRevRes              ; 

typedef
    asn1set__S                     asn1set__PCertReq                ; 

typedef
    asn1set__S                     asn1set__PCertRes                ; 

typedef
    asn1set__Enc                   asn1set__BatchAdminReq           ; 

typedef
    asn1set__Enc                   asn1set__BatchAdminRes           ; 

typedef
    asn1set__S                     asn1set__SignedError             ; 

typedef
    asn__enumerated                asn1set__ErrorCode               ; 
# define                           asn1set__ErrorCode__unspecifiedFailure     1 
# define                           asn1set__ErrorCode__messageNotSupported     2 
# define                           asn1set__ErrorCode__decodingFailure     3 
# define                           asn1set__ErrorCode__invalidCertificate     4 
# define                           asn1set__ErrorCode__expiredCertificate     5 
# define                           asn1set__ErrorCode__revokedCertificate     6 
# define                           asn1set__ErrorCode__missingCertificate     7 
# define                           asn1set__ErrorCode__signatureFailure     8 
# define                           asn1set__ErrorCode__badMessageHeader     9 
# define                           asn1set__ErrorCode__wrapperMsgMismatch    10 
# define                           asn1set__ErrorCode__versionTooOld    11 
# define                           asn1set__ErrorCode__versionTooNew    12 
# define                           asn1set__ErrorCode__unrecognizedExtension    13 
# define                           asn1set__ErrorCode__messageTooBig    14 
# define                           asn1set__ErrorCode__signatureRequired    15 
# define                           asn1set__ErrorCode__messageTooOld    16 
# define                           asn1set__ErrorCode__messageTooNew    17 
# define                           asn1set__ErrorCode__thumbsMismatch    18 
# define                           asn1set__ErrorCode__unknownRRPID    19 
# define                           asn1set__ErrorCode__unknownXID    20 
# define                           asn1set__ErrorCode__unknownLID    21 
# define                           asn1set__ErrorCode__challengeMismatch    22 

typedef
    struct                         asn1set__ErrorMsg_                 
    {                                                                 
# define                               asn1set__ErrorMsg__messageHeader 0x3d1 
# define                               asn1set__ErrorMsg__badWrapper  0x3d2 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__MessageHeader         messageHeader                    ; 
            asn__octet_string              badWrapper                       ; 
        } u                                                             ; 
    }                              asn1set__ErrorMsg                ; 

typedef
    struct                         asn1set__ErrorTBS_                 
    {                                                                 
# define                               asn1set__ErrorTBS__errorOID      0 
# define                               asn1set__ErrorTBS__errorThumb    1 
        UCHAR                          _present[1]                      ; 
        asn1set__ErrorCode             errorCode                        ; 
        asn1set__Nonce                 errorNonce                       ; 
        asn__object_identifier         errorOID                         ; 
        asn1set__CertThumb             errorThumb                       ; 
        asn1set__ErrorMsg              errorMsg                         ; 
    }                              asn1set__ErrorTBS                ; 

typedef
    struct                         asn1set__Error_                    
    {                                                                 
# define                               asn1set__Error__signedError    0x3c7 
# define                               asn1set__Error__unsignedError  0x3c8 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__SignedError           signedError                      ; 
            asn1set__ErrorTBS              unsignedError                    ; 
        } u                                                             ; 
    }                              asn1set__Error                   ; 

typedef
    struct                         asn1set__Message_                  
    {                                                                 
# define                               asn1set__Message__pInitReq     0x39f 
# define                               asn1set__Message__pInitRes     0x3a0 
# define                               asn1set__Message__pReq         0x3a1 
# define                               asn1set__Message__pRes         0x3a2 
# define                               asn1set__Message__inqReq       0x3a3 
# define                               asn1set__Message__inqRes       0x3a4 
# define                               asn1set__Message__authReq      0x3a5 
# define                               asn1set__Message__authRes      0x3a6 
# define                               asn1set__Message__authRevReq   0x3a7 
# define                               asn1set__Message__authRevRes   0x3a8 
# define                               asn1set__Message__capReq       0x3a9 
# define                               asn1set__Message__capRes       0x3aa 
# define                               asn1set__Message__capRevReq    0x3ab 
# define                               asn1set__Message__capRevRes    0x3ac 
# define                               asn1set__Message__credReq      0x3ad 
# define                               asn1set__Message__credRes      0x3ae 
# define                               asn1set__Message__credRevReq   0x3af 
# define                               asn1set__Message__credRevRes   0x3b0 
# define                               asn1set__Message__pCertReq     0x3b1 
# define                               asn1set__Message__pCertRes     0x3b2 
# define                               asn1set__Message__batchAdminReq 0x3b3 
# define                               asn1set__Message__batchAdminRes 0x3b4 
# define                               asn1set__Message__cardCInitReq 0x3b5 
# define                               asn1set__Message__cardCInitRes 0x3b6 
# define                               asn1set__Message__me_AqCInitReq 0x3b7 
# define                               asn1set__Message__me_AqCInitRes 0x3b8 
# define                               asn1set__Message__regFormReq   0x3b9 
# define                               asn1set__Message__regFormRes   0x3ba 
# define                               asn1set__Message__certReq      0x3bb 
# define                               asn1set__Message__certRes      0x3bc 
# define                               asn1set__Message__certInqReq   0x3bd 
# define                               asn1set__Message__certInqRes   0x3be 
# define                               asn1set__Message__error        0x3bf 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__PInitReq              pInitReq                         ; 
            asn1set__PInitRes              pInitRes                         ; 
            asn1set__PReq                  pReq                             ; 
            asn1set__PRes                  pRes                             ; 
            asn1set__InqReq                inqReq                           ; 
            asn1set__InqRes                inqRes                           ; 
            asn1set__AuthReq               authReq                          ; 
            asn1set__AuthRes               authRes                          ; 
            asn1set__AuthRevReq            authRevReq                       ; 
            asn1set__AuthRevRes            authRevRes                       ; 
            asn1set__CapReq                capReq                           ; 
            asn1set__CapRes                capRes                           ; 
            asn1set__CapRevReq             capRevReq                        ; 
            asn1set__CapRevRes             capRevRes                        ; 
            asn1set__CredReq               credReq                          ; 
            asn1set__CredRes               credRes                          ; 
            asn1set__CredRevReq            credRevReq                       ; 
            asn1set__CredRevRes            credRevRes                       ; 
            asn1set__PCertReq              pCertReq                         ; 
            asn1set__PCertRes              pCertRes                         ; 
            asn1set__BatchAdminReq         batchAdminReq                    ; 
            asn1set__BatchAdminRes         batchAdminRes                    ; 
            asn1set__CardCInitReq          cardCInitReq                     ; 
            asn1set__CardCInitRes          cardCInitRes                     ; 
            asn1set__Me_AqCInitReq         me_AqCInitReq                    ; 
            asn1set__Me_AqCInitRes         me_AqCInitRes                    ; 
            asn1set__RegFormReq            regFormReq                       ; 
            asn1set__RegFormRes            regFormRes                       ; 
            asn1set__CertReq               certReq                          ; 
            asn1set__CertRes               certRes                          ; 
            asn1set__CertInqReq            certInqReq                       ; 
            asn1set__CertInqRes            certInqRes                       ; 
            asn1set__Error                 error                            ; 
        } u                                                             ; 
    }                              asn1set__Message                 ; 

typedef
    struct                         asn1set__MessageWrapper_           
    {                                                                 
# define                               asn1set__MessageWrapper__mwExtensions   0 
        UCHAR                          _present[1]                      ; 
        asn1set__MessageHeader         messageHeader                    ; 
        asn1set__Message               message                          ; 
        asn1set__MsgExtensions         *mwExtensions                    ; 
    }                              asn1set__MessageWrapper          ; 

typedef
    asn__any                       asn1set__EncodedBrandCRLID       ; 

typedef
    asn__any                       asn1set__Name                    ; 

typedef
    struct                         asn1set__CRLIdentifier_            
    {                                                                 
        asn1set__Name                  issuerName                       ; 
        asn__integer                   crlNumber                        ; 
    }                              asn1set__CRLIdentifier           ; 

typedef
    struct                         asn1set__CRLIdentifierSeq_         
    {                                                                 
        struct asn1set__CRLIdentifierSeq_ *next                            ; 
        asn1set__CRLIdentifier         cRLIdentifier                    ; 
    }                              asn1set__CRLIdentifierSeq        ; 

typedef
    struct                         asn1set__UnsignedBrandCRLIdentifier_     
    {                                                                 
# define                               asn1set__UnsignedBrandCRLIdentifier__crlIdentifierSeq   0 
# define                               asn1set__UnsignedBrandCRLIdentifier__bCRLExtensions   1 
        UCHAR                          _present[1]                      ; 
        asn__integer                   version                          ; 
        asn__integer                   sequenceNum                      ; 
        asn1set__BrandID               brandID                          ; 
        asn__generalized_time          notBefore                        ; 
        asn__generalized_time          notAfter                         ; 
        asn1set__CRLIdentifierSeq      *crlIdentifierSeq                ; 
        x509__Extensions               *bCRLExtensions                  ; 
    }                              asn1set__UnsignedBrandCRLIdentifier   ; 

typedef
    asn1set__S                     asn1set__CRLNotification         ; 

typedef
    struct                         asn1set__CRLNotificationTBS_       
    {                                                                 
        asn1set__Date                  date                             ; 
        setpkcs7__Digest               crlThumbprint                    ; 
    }                              asn1set__CRLNotificationTBS      ; 

typedef
    asn1set__S                     asn1set__CRLNotificationRes      ; 

typedef
    struct                         asn1set__CRLNotificationResTBS_     
    {                                                                 
        asn1set__Date                  date                             ; 
        setpkcs7__Digest               crlThumbprint                    ; 
    }                              asn1set__CRLNotificationResTBS   ; 

typedef
    asn1set__S                     asn1set__BCIDistribution         ; 

typedef
    struct                         asn1set__BCIDistributionTBS_       
    {                                                                 
        asn1set__Date                  date                             ; 
        asn1set__BrandCRLIdentifier    bci                              ; 
    }                              asn1set__BCIDistributionTBS      ; 

typedef
    struct                         asn1set__PANData_                  
    {                                                                 
        asn1set__PAN                   pan                              ; 
        asn1set__CardExpiry            cardExpiry                       ; 
        asn1set__Secret                panSecret                        ; 
        asn1set__Nonce                 exNonce                          ; 
    }                              asn1set__PANData                 ; 

typedef
    struct                         asn1set__PANToken_                 
    {                                                                 
        asn1set__PAN                   pan                              ; 
        asn1set__CardExpiry            cardExpiry                       ; 
        asn1set__Nonce                 exNonce                          ; 
    }                              asn1set__PANToken                ; 

typedef
    struct                         asn1set__AttributeSet_             
    {                                                                 
        struct asn1set__AttributeSet_  *next                            ; 
        x509__Attribute                attribute                        ; 
    }                              asn1set__AttributeSet            ; 

typedef
    asn__any                       asn1set__EncodedCertificationRequestInfo   ; 

typedef
    asn1set__SIGNED                asn1set__CertificationRequest    ; 

typedef
    struct                         asn1set__CertificationRequestInfo_     
    {                                                                 
        asn__integer                   version                          ; 
        x509__Name                     subject                          ; 
        x509__SubjectPublicKeyInfo     subjectPublicKeyInfo             ; 
        asn1set__AttributeSet          *attributes                      ; 
    }                              asn1set__CertificationRequestInfo   ; 

typedef
    struct                         asn1set__PInitResData_             
    {                                                                 
# define                               asn1set__PInitResData__brandCRLIdentifier   0 
# define                               asn1set__PInitResData__thumbs    1 
# define                               asn1set__PInitResData__piRsExtensions   2 
        UCHAR                          _present[1]                      ; 
        asn1set__TransIDs              transIDs                         ; 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__Challenge             chall_C                          ; 
        asn1set__Challenge             chall_M                          ; 
        asn1set__BrandCRLIdentifier    brandCRLIdentifier               ; 
        asn1set__CertThumb             peThumb                          ; 
        asn1set__Thumbs                thumbs                           ; 
        asn1set__MsgExtensions         *piRsExtensions                  ; 
    }                              asn1set__PInitResData            ; 

typedef
    asn1set__L                     asn1set__PIDualSignedTBE         ; 

typedef
    asn1set__L                     asn1set__PI_OILink               ; 

typedef
    asn1set__DD                    asn1set__HPIData                 ; 

typedef
    asn1set__DD                    asn1set__HOIData                 ; 

typedef
    struct                         asn1set__PI_TBS_                   
    {                                                                 
        asn1set__HPIData               hPIData                          ; 
        asn1set__HOIData               hOIData                          ; 
    }                              asn1set__PI_TBS                  ; 

typedef
    asn1set__EncX                  asn1set__AuthToken               ; 

typedef
    struct                         asn1set__PI_                       
    {                                                                 
# define                               asn1set__PI__piUnsigned        0x47e 
# define                               asn1set__PI__piDualSigned      0x47f 
# define                               asn1set__PI__authToken         0x480 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__PIUnsigned            piUnsigned                       ; 
            asn1set__PIDualSigned          piDualSigned                     ; 
            asn1set__AuthToken             authToken                        ; 
        } u                                                             ; 
    }                              asn1set__PI                      ; 

typedef
    asn1set__DD                    asn1set__HOD                     ; 

typedef
    struct                         asn1set__Inputs_                   
    {                                                                 
        asn1set__HOD                   hod                              ; 
        asn1set__CurrencyAmount        purchAmt                         ; 
    }                              asn1set__Inputs                  ; 

typedef
    struct                         asn1set__Recurring_                
    {                                                                 
        asn__integer                   recurringFrequency               ; 
        asn1set__Date                  recurringExpiry                  ; 
    }                              asn1set__Recurring               ; 

typedef
    struct                         asn1set__InstallRecurInd_          
    {                                                                 
# define                               asn1set__InstallRecurInd__installTotalTrans 0x6b0 
# define                               asn1set__InstallRecurInd__recurring 0x6b1 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__integer                   installTotalTrans                ; 
            asn1set__Recurring             recurring                        ; 
        } u                                                             ; 
    }                              asn1set__InstallRecurInd         ; 

typedef
    struct                         asn1set__InstallRecurData_         
    {                                                                 
# define                               asn1set__InstallRecurData__irExtensions   0 
        UCHAR                          _present[1]                      ; 
        asn1set__InstallRecurInd       installRecurInd                  ; 
        asn1set__MsgExtensions         *irExtensions                    ; 
    }                              asn1set__InstallRecurData        ; 

typedef
    setpkcs7__Digest               asn1set__HMAC                    ; 

typedef
    asn1set__HMAC                  asn1set__TransStain              ; 

typedef
    struct                         asn1set__PIHead_                   
    {                                                                 
# define                               asn1set__PIHead__installRecurData   0 
# define                               asn1set__PIHead__acqBackKeyData   1 
# define                               asn1set__PIHead__piExtensions    2 
        UCHAR                          _present[1]                      ; 
        asn1set__TransIDs              transIDs                         ; 
        asn1set__Inputs                inputs                           ; 
        asn1set__MerchantID            merchantID                       ; 
        asn1set__InstallRecurData      installRecurData                 ; 
        asn1set__TransStain            transStain                       ; 
        asn1set__SWIdent               swIdent                          ; 
        asn1set__BackKeyData           acqBackKeyData                   ; 
        asn1set__MsgExtensions         *piExtensions                    ; 
    }                              asn1set__PIHead                  ; 

typedef
    struct                         asn1set__PIData_                   
    {                                                                 
        asn1set__PIHead                piHead                           ; 
        asn1set__PANData               panData                          ; 
    }                              asn1set__PIData                  ; 

typedef
    struct                         asn1set__OIDList_                  
    {                                                                 
        struct asn1set__OIDList_       *next                            ; 
        asn__object_identifier         object_identifier                ; 
    }                              asn1set__OIDList                 ; 

typedef
    struct                         asn1set__OIData_                   
    {                                                                 
# define                               asn1set__OIData__chall_M         0 
# define                               asn1set__OIData__odExtOIDs       1 
# define                               asn1set__OIData__oiExtensions    2 
        UCHAR                          _present[1]                      ; 
        asn1set__TransIDs              transIDs                         ; 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__Challenge             chall_C                          ; 
        asn1set__HOD                   hod                              ; 
        asn1set__Nonce                 odSalt                           ; 
        asn1set__Challenge             chall_M                          ; 
        asn1set__BrandID               brandID                          ; 
        asn1set__BIN                   bin                              ; 
        asn1set__OIDList               *odExtOIDs                       ; 
        asn1set__MsgExtensions         *oiExtensions                    ; 
    }                              asn1set__OIData                  ; 

typedef
    asn__octet_string              asn1set__OD                      ; 

typedef
    struct                         asn1set__HODInput_                 
    {                                                                 
# define                               asn1set__HODInput__installRecurData   0 
# define                               asn1set__HODInput__odExtensions   1 
        UCHAR                          _present[1]                      ; 
        asn1set__OD                    od                               ; 
        asn1set__CurrencyAmount        purchAmt                         ; 
        asn1set__Nonce                 odSalt                           ; 
        asn1set__InstallRecurData      installRecurData                 ; 
        asn1set__MsgExtensions         *odExtensions                    ; 
    }                              asn1set__HODInput                ; 

typedef
    struct                         asn1set__PIDataUnsigned_           
    {                                                                 
        asn1set__PIHead                piHead                           ; 
        asn1set__PANToken              panToken                         ; 
    }                              asn1set__PIDataUnsigned          ; 

typedef
    asn1set__L                     asn1set__PIUnsignedTBE           ; 

typedef
    asn__enumerated                asn1set__CompletionCode          ; 
# define                           asn1set__CompletionCode__meaninglessRatio     0 
# define                           asn1set__CompletionCode__orderRejected     1 
# define                           asn1set__CompletionCode__orderReceived     2 
# define                           asn1set__CompletionCode__orderNotReceived     3 
# define                           asn1set__CompletionCode__authorizationPerformed     4 
# define                           asn1set__CompletionCode__capturePerformed     5 
# define                           asn1set__CompletionCode__creditPerformed     6 

typedef
    asn1set__EncK                  asn1set__AcqCardMsg              ; 

typedef
    asn__enumerated                asn1set__AuthCode                ; 
# define                           asn1set__AuthCode__approved        0 
# define                           asn1set__AuthCode__unspecifiedFailure     1 
# define                           asn1set__AuthCode__declined        2 
# define                           asn1set__AuthCode__noReply         3 
# define                           asn1set__AuthCode__callIssuer      4 
# define                           asn1set__AuthCode__amountError     5 
# define                           asn1set__AuthCode__expiredCard     6 
# define                           asn1set__AuthCode__invalidTransaction     7 
# define                           asn1set__AuthCode__systemError     8 
# define                           asn1set__AuthCode__piPreviouslyUsed     9 
# define                           asn1set__AuthCode__recurringTooSoon    10 
# define                           asn1set__AuthCode__recurringExpired    11 
# define                           asn1set__AuthCode__piAuthMismatch    12 
# define                           asn1set__AuthCode__installRecurMismatch    13 
# define                           asn1set__AuthCode__captureNotSupported    14 
# define                           asn1set__AuthCode__signatureRequired    15 
# define                           asn1set__AuthCode__cardMerchBrandMismatch    16 

typedef
    struct                         asn1set__CurrConv_                 
    {                                                                 
        asn1set__FloatingPoint         currConvRate                     ; 
        asn1set__Currency              cardCurr                         ; 
    }                              asn1set__CurrConv                ; 

typedef
    struct                         asn1set__AuthStatus_               
    {                                                                 
# define                               asn1set__AuthStatus__currConv    0 
        UCHAR                          _present[1]                      ; 
        asn1set__Date                  authDate                         ; 
        asn1set__AuthCode              authCode                         ; 
        asn1set__FloatingPoint         authRatio                        ; 
        asn1set__CurrConv              currConv                         ; 
    }                              asn1set__AuthStatus              ; 

typedef
    asn__enumerated                asn1set__CapCode                 ; 
# define                           asn1set__CapCode__success          0 
# define                           asn1set__CapCode__unspecifiedFailure     1 
# define                           asn1set__CapCode__duplicateRequest     2 
# define                           asn1set__CapCode__authExpired      3 
# define                           asn1set__CapCode__authDataMissing     4 
# define                           asn1set__CapCode__invalidAuthData     5 
# define                           asn1set__CapCode__capTokenMissing     6 
# define                           asn1set__CapCode__invalidCapToken     7 
# define                           asn1set__CapCode__batchUnknown     8 
# define                           asn1set__CapCode__batchClosed      9 
# define                           asn1set__CapCode__unknownXID      10 
# define                           asn1set__CapCode__unknownLID      11 

typedef
    struct                         asn1set__CapStatus_                
    {                                                                 
        asn1set__Date                  capDate                          ; 
        asn1set__CapCode               capCode                          ; 
        asn1set__FloatingPoint         capRatio                         ; 
    }                              asn1set__CapStatus               ; 

typedef
    asn__enumerated                asn1set__CapRevOrCredCode        ; 
# define                           asn1set__CapRevOrCredCode__success     0 
# define                           asn1set__CapRevOrCredCode__unspecifiedFailure     1 
# define                           asn1set__CapRevOrCredCode__duplicateRequest     2 
# define                           asn1set__CapRevOrCredCode__originalProcessed     3 
# define                           asn1set__CapRevOrCredCode__originalNotFound     4 
# define                           asn1set__CapRevOrCredCode__capPurged     5 
# define                           asn1set__CapRevOrCredCode__capDataMismatch     6 
# define                           asn1set__CapRevOrCredCode__missingCapData     7 
# define                           asn1set__CapRevOrCredCode__missingCapToken     8 
# define                           asn1set__CapRevOrCredCode__invalidCapToken     9 
# define                           asn1set__CapRevOrCredCode__batchUnknown    10 
# define                           asn1set__CapRevOrCredCode__batchClosed    11 

typedef
    struct                         asn1set__CreditStatus_             
    {                                                                 
        asn1set__Date                  creditDate                       ; 
        asn1set__CapRevOrCredCode      creditCode                       ; 
        asn1set__FloatingPoint         creditRatio                      ; 
    }                              asn1set__CreditStatus            ; 

typedef
    struct                         asn1set__CreditStatusSeq_          
    {                                                                 
        struct asn1set__CreditStatusSeq_ *next                            ; 
        asn1set__CreditStatus          creditStatus                     ; 
    }                              asn1set__CreditStatusSeq         ; 

typedef
    struct                         asn1set__Results_                  
    {                                                                 
# define                               asn1set__Results__acqCardMsg     0 
# define                               asn1set__Results__authStatus     1 
# define                               asn1set__Results__capStatus      2 
# define                               asn1set__Results__credStatusSeq   3 
        UCHAR                          _present[1]                      ; 
        asn1set__AcqCardMsg            acqCardMsg                       ; 
        asn1set__AuthStatus            authStatus                       ; 
        asn1set__CapStatus             capStatus                        ; 
        asn1set__CreditStatusSeq       *credStatusSeq                   ; 
    }                              asn1set__Results                 ; 

typedef
    struct                         asn1set__PResPayload_              
    {                                                                 
# define                               asn1set__PResPayload__results    0 
# define                               asn1set__PResPayload__pRsExtensions   1 
        UCHAR                          _present[1]                      ; 
        asn1set__CompletionCode        completionCode                   ; 
        asn1set__Results               results                          ; 
        asn1set__MsgExtensions         *pRsExtensions                   ; 
    }                              asn1set__PResPayload             ; 

typedef
    struct                         asn1set__PResPayloadSeq_           
    {                                                                 
        struct asn1set__PResPayloadSeq_ *next                            ; 
        asn1set__PResPayload           pResPayload                      ; 
    }                              asn1set__PResPayloadSeq          ; 

typedef
    struct                         asn1set__PResData_                 
    {                                                                 
# define                               asn1set__PResData__brandCRLIdentifier   0 
        UCHAR                          _present[1]                      ; 
        asn1set__TransIDs              transIDs                         ; 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__Challenge             chall_C                          ; 
        asn1set__BrandCRLIdentifier    brandCRLIdentifier               ; 
        asn1set__PResPayloadSeq        *pResPayloadSeq                  ; 
    }                              asn1set__PResData                ; 

typedef
    asn1set__S                     asn1set__AuthReqTBE              ; 

typedef
    asn1set__L                     asn1set__AuthReqTBS              ; 

typedef
    struct                         asn1set__MerTermIDs_               
    {                                                                 
# define                               asn1set__MerTermIDs__terminalID   0 
# define                               asn1set__MerTermIDs__agentNum    1 
# define                               asn1set__MerTermIDs__chainNum    2 
# define                               asn1set__MerTermIDs__storeNum    3 
        UCHAR                          _present[1]                      ; 
        asn1set__MerchantID            merchantID                       ; 
        asn__visible_string            terminalID                       ; 
        asn__integer                   agentNum                         ; 
        asn__integer                   chainNum                         ; 
        asn__integer                   storeNum                         ; 
    }                              asn1set__MerTermIDs              ; 

typedef
    struct                         asn1set__RRTags_                   
    {                                                                 
        asn1set__RRPID                 rrpid                            ; 
        asn1set__MerTermIDs            merTermIDs                       ; 
        asn1set__Date                  currentDate                      ; 
    }                              asn1set__RRTags                  ; 

typedef
    asn__integer                   asn1set__AuthRetNum              ; 

typedef
    struct                         asn1set__AuthTags_                 
    {                                                                 
# define                               asn1set__AuthTags__authRetNum    0 
        UCHAR                          _present[1]                      ; 
        asn1set__RRTags                authRRTags                       ; 
        asn1set__TransIDs              transIDs                         ; 
        asn1set__AuthRetNum            authRetNum                       ; 
    }                              asn1set__AuthTags                ; 

typedef
    struct                         asn1set__CheckDigests_             
    {                                                                 
        asn1set__HOIData               hOIData                          ; 
        asn1set__HOD                   hod2                             ; 
    }                              asn1set__CheckDigests            ; 

typedef
    struct                         asn1set__SETStringub_AVSData_      
    {                                                                 
# define                               asn1set__SETStringub_AVSData__visibleString 0x6ec 
# define                               asn1set__SETStringub_AVSData__bmpString 0x6ed 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_AVSData     ; 

typedef
    struct                         asn1set__AVSData_                  
    {                                                                 
# define                               asn1set__AVSData__streetAddress   0 
        UCHAR                          _present[1]                      ; 
        asn1set__SETStringub_AVSData   streetAddress                    ; 
        asn1set__Location              location                         ; 
    }                              asn1set__AVSData                 ; 

typedef
    asn__enumerated                asn1set__SpecialProcessing       ; 
# define                           asn1set__SpecialProcessing__directMarketing     0 
# define                           asn1set__SpecialProcessing__preferredCustomer     1 

typedef
    asn__enumerated                asn1set__CardSuspect             ; 
# define                           asn1set__CardSuspect__unspecifiedReason     0 

typedef
    asn__integer                   asn1set__Duration                ; 

typedef
    struct                         asn1set__MarketAutoAuth_           
    {                                                                 
        asn1set__Duration              duration                         ; 
    }                              asn1set__MarketAutoAuth          ; 

typedef
    asn__enumerated                asn1set__Prestige                ; 
# define                           asn1set__Prestige__unknown         0 
# define                           asn1set__Prestige__level_1         1 
# define                           asn1set__Prestige__level_2         2 
# define                           asn1set__Prestige__level_3         3 

typedef
    struct                         asn1set__MarketHotelAuth_          
    {                                                                 
# define                               asn1set__MarketHotelAuth__prestige   0 
        UCHAR                          _present[1]                      ; 
        asn1set__Duration              duration                         ; 
        asn1set__Prestige              prestige                         ; 
    }                              asn1set__MarketHotelAuth         ; 

typedef
    struct                         asn1set__MarketSpecAuthData_       
    {                                                                 
# define                               asn1set__MarketSpecAuthData__auto_rental 0x687 
# define                               asn1set__MarketSpecAuthData__hotel 0x688 
# define                               asn1set__MarketSpecAuthData__transport 0x689 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__MarketAutoAuth        auto_rental                      ; 
            asn1set__MarketHotelAuth       hotel                            ; 
        } u                                                             ; 
    }                              asn1set__MarketSpecAuthData      ; 

typedef
    asn__numeric_string            asn1set__MerchCatCode            ; 

typedef
    asn__enumerated                asn1set__MerchGroup              ; 
# define                           asn1set__MerchGroup__commercialTravel     1 
# define                           asn1set__MerchGroup__lodging       2 
# define                           asn1set__MerchGroup__automobileRental     3 
# define                           asn1set__MerchGroup__restaurant     4 
# define                           asn1set__MerchGroup__medical       5 
# define                           asn1set__MerchGroup__mailOrPhoneOrder     6 
# define                           asn1set__MerchGroup__riskyPurchase     7 
# define                           asn1set__MerchGroup__other         8 

typedef
    struct                         asn1set__MerchData_                
    {                                                                 
# define                               asn1set__MerchData__merchCatCode   0 
# define                               asn1set__MerchData__merchGroup   1 
        UCHAR                          _present[1]                      ; 
        asn1set__MerchCatCode          merchCatCode                     ; 
        asn1set__MerchGroup            merchGroup                       ; 
    }                              asn1set__MerchData               ; 

typedef
    struct                         asn1set__AuthReqPayload_           
    {                                                                 
# define                               asn1set__AuthReqPayload__avsData   0 
# define                               asn1set__AuthReqPayload__specialProcessing   1 
# define                               asn1set__AuthReqPayload__cardSuspect   2 
# define                               asn1set__AuthReqPayload__installRecurData   3 
# define                               asn1set__AuthReqPayload__marketSpecAuthData   4 
# define                               asn1set__AuthReqPayload__aRqExtensions   5 
        UCHAR                          _present[1]                      ; 
        asn__boolean                   subsequentAuthInd                ; 
        asn1set__CurrencyAmount        authReqAmt                       ; 
        asn1set__AVSData               avsData                          ; 
        asn1set__SpecialProcessing     specialProcessing                ; 
        asn1set__CardSuspect           cardSuspect                      ; 
        asn__boolean                   requestCardTypeInd               ; 
        asn1set__InstallRecurData      installRecurData                 ; 
        asn1set__MarketSpecAuthData    marketSpecAuthData               ; 
        asn1set__MerchData             merchData                        ; 
        asn1set__MsgExtensions         *aRqExtensions                   ; 
    }                              asn1set__AuthReqPayload          ; 

typedef
    struct                         asn1set__AuthReqItem_              
    {                                                                 
# define                               asn1set__AuthReqItem__checkDigests   0 
        UCHAR                          _present[1]                      ; 
        asn1set__AuthTags              authTags                         ; 
        asn1set__CheckDigests          checkDigests                     ; 
        asn1set__AuthReqPayload        authReqPayload                   ; 
    }                              asn1set__AuthReqItem             ; 

typedef
    asn__integer                   asn1set__BatchID                 ; 

typedef
    asn__integer                   asn1set__BatchSequenceNum        ; 

typedef
    asn__enumerated                asn1set__PayRecurInd             ; 
# define                           asn1set__PayRecurInd__unknown      0 
# define                           asn1set__PayRecurInd__singleTransaction     1 
# define                           asn1set__PayRecurInd__recurringTransaction     2 
# define                           asn1set__PayRecurInd__installmentPayment     3 
# define                           asn1set__PayRecurInd__otherMailOrder     4 

typedef
    asn__visible_string            asn1set__MerOrderNum             ; 

typedef
    asn__enumerated                asn1set__AuthCharInd             ; 
# define                           asn1set__AuthCharInd__directMarketing     0 
# define                           asn1set__AuthCharInd__recurringPayment     1 
# define                           asn1set__AuthCharInd__addressVerification     2 
# define                           asn1set__AuthCharInd__preferredCustomer     3 
# define                           asn1set__AuthCharInd__incrementalAuth     4 

typedef
    asn__enumerated                asn1set__MarketSpecDataID        ; 
# define                           asn1set__MarketSpecDataID__failedEdit     0 
# define                           asn1set__MarketSpecDataID__auto     1 
# define                           asn1set__MarketSpecDataID__hotel     2 
# define                           asn1set__MarketSpecDataID__transport     3 

typedef
    struct                         asn1set__MarketSpecCapData_        
    {                                                                 
# define                               asn1set__MarketSpecCapData__auto_rental 0x68b 
# define                               asn1set__MarketSpecCapData__hotel 0x68c 
# define                               asn1set__MarketSpecCapData__transport 0x68d 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__MarketAutoCap         auto_rental                      ; 
            asn1set__MarketHotelCap        hotel                            ; 
            asn1set__MarketTransportCap    transport                        ; 
        } u                                                             ; 
    }                              asn1set__MarketSpecCapData       ; 

typedef
    struct                         asn1set__MarketSpecSaleData_       
    {                                                                 
# define                               asn1set__MarketSpecSaleData__marketSpecDataID   0 
# define                               asn1set__MarketSpecSaleData__marketSpecCapData   1 
        UCHAR                          _present[1]                      ; 
        asn1set__MarketSpecDataID      marketSpecDataID                 ; 
        asn1set__MarketSpecCapData     marketSpecCapData                ; 
    }                              asn1set__MarketSpecSaleData      ; 

typedef
    struct                         asn1set__SETStringub_summary_      
    {                                                                 
# define                               asn1set__SETStringub_summary__visibleString 0x74f 
# define                               asn1set__SETStringub_summary__bmpString 0x750 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_summary     ; 

typedef
    struct                         asn1set__SaleDetail_               
    {                                                                 
# define                               asn1set__SaleDetail__batchID     0 
# define                               asn1set__SaleDetail__batchSequenceNum   1 
# define                               asn1set__SaleDetail__payRecurInd   2 
# define                               asn1set__SaleDetail__merOrderNum   3 
# define                               asn1set__SaleDetail__authCharInd   4 
# define                               asn1set__SaleDetail__marketSpecSaleData   5 
# define                               asn1set__SaleDetail__commercialCardData   6 
# define                               asn1set__SaleDetail__orderSummary   7 
# define                               asn1set__SaleDetail__customerReferenceNumber   8 
# define                               asn1set__SaleDetail__customerServicePhone   9 
# define                               asn1set__SaleDetail__saleExtensions  10 
        UCHAR                          _present[2]                      ; 
        asn1set__BatchID               batchID                          ; 
        asn1set__BatchSequenceNum      batchSequenceNum                 ; 
        asn1set__PayRecurInd           payRecurInd                      ; 
        asn1set__MerOrderNum           merOrderNum                      ; 
        asn1set__AuthCharInd           authCharInd                      ; 
        asn1set__MarketSpecSaleData    marketSpecSaleData               ; 
        asn1set__CommercialCardData    commercialCardData               ; 
        asn1set__SETStringub_summary   orderSummary                     ; 
        asn1set__SETStringub_reference customerReferenceNumber          ; 
        asn1set__Phone                 customerServicePhone             ; 
        asn__boolean                   okToPrintPhoneInd                ; 
        asn1set__MsgExtensions         *saleExtensions                  ; 
    }                              asn1set__SaleDetail              ; 

typedef
    struct                         asn1set__AuthReqData_              
    {                                                                 
# define                               asn1set__AuthReqData__mThumbs    0 
# define                               asn1set__AuthReqData__saleDetail   1 
        UCHAR                          _present[1]                      ; 
        asn1set__AuthReqItem           authReqItem                      ; 
        asn1set__Thumbs                mThumbs                          ; 
        asn__boolean                   captureNow                       ; 
        asn1set__SaleDetail            saleDetail                       ; 
    }                              asn1set__AuthReqData             ; 

typedef
    asn1set__S                     asn1set__AuthResTBE              ; 

typedef
    asn1set__L                     asn1set__AuthResTBS              ; 

typedef
    struct                         asn1set__AuthResTBEX_              
    {                                                                 
        asn1set__AuthResTBS            authResTBS                       ; 
        asn1set__SO                    s                                ; 
    }                              asn1set__AuthResTBEX             ; 

typedef
    struct                         asn1set__AuthResTBSX_              
    {                                                                 
        asn1set__AuthResTBS            authResTBS                       ; 
        asn1set__PANToken              panToken                         ; 
    }                              asn1set__AuthResTBSX             ; 

typedef
    asn__visible_string            asn1set__ApprovalCode            ; 

typedef
    asn__visible_string            asn1set__ValidationCode          ; 

typedef
    struct                         asn1set__AuthValCodes_             
    {                                                                 
# define                               asn1set__AuthValCodes__approvalCode   0 
# define                               asn1set__AuthValCodes__authCharInd   1 
# define                               asn1set__AuthValCodes__validationCode   2 
# define                               asn1set__AuthValCodes__marketSpec   3 
        UCHAR                          _present[1]                      ; 
        asn1set__ApprovalCode          approvalCode                     ; 
        asn1set__AuthCharInd           authCharInd                      ; 
        asn1set__ValidationCode        validationCode                   ; 
        asn1set__MarketSpecDataID      marketSpec                       ; 
    }                              asn1set__AuthValCodes            ; 

typedef
    asn__enumerated                asn1set__RespReason              ; 
# define                           asn1set__RespReason__issuer        0 
# define                           asn1set__RespReason__standInTimeOut     1 
# define                           asn1set__RespReason__standInFloorLimit     2 
# define                           asn1set__RespReason__standInSuppressInquiries     3 
# define                           asn1set__RespReason__standInIssuerUnavailable     4 
# define                           asn1set__RespReason__standInIssuerRequest     5 

typedef
    asn__enumerated                asn1set__CardType                ; 
# define                           asn1set__CardType__unavailable     0 
# define                           asn1set__CardType__classic         1 
# define                           asn1set__CardType__gold            2 
# define                           asn1set__CardType__platinum        3 
# define                           asn1set__CardType__premier         4 
# define                           asn1set__CardType__debit           5 
# define                           asn1set__CardType__pinBasedDebit     6 
# define                           asn1set__CardType__atm             7 
# define                           asn1set__CardType__electronicOnly     8 
# define                           asn1set__CardType__unspecifiedConsumer     9 
# define                           asn1set__CardType__corporateTravel    10 
# define                           asn1set__CardType__purchasing     11 
# define                           asn1set__CardType__business       12 
# define                           asn1set__CardType__unspecifiedCommercial    13 
# define                           asn1set__CardType__privateLabel    14 
# define                           asn1set__CardType__proprietary    15 

typedef
    asn__enumerated                asn1set__AVSResult               ; 
# define                           asn1set__AVSResult__resultUnavailable     0 
# define                           asn1set__AVSResult__noMatch        1 
# define                           asn1set__AVSResult__addressMatchOnly     2 
# define                           asn1set__AVSResult__postalCodeMatchOnly     3 
# define                           asn1set__AVSResult__fullMatch      4 

typedef
    asn__numeric_string            asn1set__LogRefID                ; 

typedef
    struct                         asn1set__ResponseData_             
    {                                                                 
# define                               asn1set__ResponseData__authValCodes   0 
# define                               asn1set__ResponseData__respReason   1 
# define                               asn1set__ResponseData__cardType   2 
# define                               asn1set__ResponseData__avsResult   3 
# define                               asn1set__ResponseData__logRefID   4 
        UCHAR                          _present[1]                      ; 
        asn1set__AuthValCodes          authValCodes                     ; 
        asn1set__RespReason            respReason                       ; 
        asn1set__CardType              cardType                         ; 
        asn1set__AVSResult             avsResult                        ; 
        asn1set__LogRefID              logRefID                         ; 
    }                              asn1set__ResponseData            ; 

typedef
    asn__enumerated                asn1set__CloseStatus             ; 
# define                           asn1set__CloseStatus__closedbyMerchant     0 
# define                           asn1set__CloseStatus__closedbyAcquirer     1 

typedef
    struct                         asn1set__ClosedWhen_               
    {                                                                 
        asn1set__CloseStatus           closeStatus                      ; 
        asn1set__Date                  closeDateTime                    ; 
    }                              asn1set__ClosedWhen              ; 

typedef
    struct                         asn1set__BatchTotals_              
    {                                                                 
# define                               asn1set__BatchTotals__batchTotalExtensions   0 
        UCHAR                          _present[1]                      ; 
        asn__integer                   transactionCountCredit           ; 
        asn1set__CurrencyAmount        transactionTotalAmtCredit        ; 
        asn__integer                   transactionCountDebit            ; 
        asn1set__CurrencyAmount        transactionTotalAmtDebit         ; 
        asn1set__MsgExtensions         *batchTotalExtensions            ; 
    }                              asn1set__BatchTotals             ; 

typedef
    struct                         asn1set__BrandBatchDetails_        
    {                                                                 
        asn1set__BrandID               brandID                          ; 
        asn1set__BatchTotals           batchTotals                      ; 
    }                              asn1set__BrandBatchDetails       ; 

typedef
    struct                         asn1set__BrandBatchDetailsSeq_     
    {                                                                 
        struct asn1set__BrandBatchDetailsSeq_ *next                            ; 
        asn1set__BrandBatchDetails     brandBatchDetails                ; 
    }                              asn1set__BrandBatchDetailsSeq    ; 

typedef
    struct                         asn1set__BatchDetails_             
    {                                                                 
# define                               asn1set__BatchDetails__brandBatchDetailsSeq   0 
        UCHAR                          _present[1]                      ; 
        asn1set__BatchTotals           batchTotals                      ; 
        asn1set__BrandBatchDetailsSeq  *brandBatchDetailsSeq            ; 
    }                              asn1set__BatchDetails            ; 

typedef
    struct                         asn1set__BatchStatus_              
    {                                                                 
# define                               asn1set__BatchStatus__closedWhen   0 
# define                               asn1set__BatchStatus__batchExtensions   1 
        UCHAR                          _present[1]                      ; 
        asn1set__Date                  openDateTime                     ; 
        asn1set__ClosedWhen            closedWhen                       ; 
        asn1set__BatchDetails          batchDetails                     ; 
        asn1set__MsgExtensions         *batchExtensions                 ; 
    }                              asn1set__BatchStatus             ; 

typedef
    struct                         asn1set__AuthHeader_               
    {                                                                 
# define                               asn1set__AuthHeader__batchStatus   0 
# define                               asn1set__AuthHeader__currConv    1 
        UCHAR                          _present[1]                      ; 
        asn1set__CurrencyAmount        authAmt                          ; 
        asn1set__AuthCode              authCode                         ; 
        asn1set__ResponseData          responseData                     ; 
        asn1set__BatchStatus           batchStatus                      ; 
        asn1set__CurrConv              currConv                         ; 
    }                              asn1set__AuthHeader              ; 

typedef
    struct                         asn1set__CapResPayload_            
    {                                                                 
# define                               asn1set__CapResPayload__batchID   0 
# define                               asn1set__CapResPayload__batchSequenceNum   1 
# define                               asn1set__CapResPayload__cRsPayExtensions   2 
        UCHAR                          _present[1]                      ; 
        asn1set__CapCode               capCode                          ; 
        asn1set__CurrencyAmount        capAmt                           ; 
        asn1set__BatchID               batchID                          ; 
        asn1set__BatchSequenceNum      batchSequenceNum                 ; 
        asn1set__MsgExtensions         *cRsPayExtensions                ; 
    }                              asn1set__CapResPayload           ; 

typedef
    struct                         asn1set__AuthResPayload_           
    {                                                                 
# define                               asn1set__AuthResPayload__capResPayload   0 
# define                               asn1set__AuthResPayload__aRsExtensions   1 
        UCHAR                          _present[1]                      ; 
        asn1set__AuthHeader            authHeader                       ; 
        asn1set__CapResPayload         capResPayload                    ; 
        asn1set__MsgExtensions         *aRsExtensions                   ; 
    }                              asn1set__AuthResPayload          ; 

typedef
    struct                         asn1set__AuthResData_              
    {                                                                 
# define                               asn1set__AuthResData__brandCRLIdentifier   0 
# define                               asn1set__AuthResData__peThumb    1 
        UCHAR                          _present[1]                      ; 
        asn1set__AuthTags              authTags                         ; 
        asn1set__BrandCRLIdentifier    brandCRLIdentifier               ; 
        asn1set__CertThumb             peThumb                          ; 
        asn1set__AuthResPayload        authResPayload                   ; 
    }                              asn1set__AuthResData             ; 

typedef
    struct                         asn1set__CapToken_                 
    {                                                                 
# define                               asn1set__CapToken__encX        0x667 
# define                               asn1set__CapToken__enc         0x668 
# define                               asn1set__CapToken__null        0x669 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn1set__EncX                  encX                             ; 
            asn1set__Enc                   enc                              ; 
        } u                                                             ; 
    }                              asn1set__CapToken                ; 

typedef
    struct                         asn1set__AuthResBaggage_           
    {                                                                 
# define                               asn1set__AuthResBaggage__capToken   0 
# define                               asn1set__AuthResBaggage__acqCardMsg   1 
# define                               asn1set__AuthResBaggage__authToken   2 
        UCHAR                          _present[1]                      ; 
        asn1set__CapToken              capToken                         ; 
        asn1set__AcqCardMsg            acqCardMsg                       ; 
        asn1set__AuthToken             authToken                        ; 
    }                              asn1set__AuthResBaggage          ; 

typedef
    asn1set__BackKeyData           asn1set__AcqBackKey              ; 

typedef
    asn1set__S                     asn1set__AcqCardCodeMsgTBE       ; 

typedef
    asn__enumerated                asn1set__AcqCardCode             ; 
# define                           asn1set__AcqCardCode__messageOfDay     0 
# define                           asn1set__AcqCardCode__accountInfo     1 
# define                           asn1set__AcqCardCode__callCustomerService     2 

typedef
    struct                         asn1set__SETStringub_acqCardText_     
    {                                                                 
# define                               asn1set__SETStringub_acqCardText__visibleString 0x6f2 
# define                               asn1set__SETStringub_acqCardText__bmpString 0x6f3 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_acqCardText   ; 

typedef
    struct                         asn1set__SETStringub_acqCardPhone_     
    {                                                                 
# define                               asn1set__SETStringub_acqCardPhone__visibleString 0x6ef 
# define                               asn1set__SETStringub_acqCardPhone__bmpString 0x6f0 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_acqCardPhone   ; 

typedef
    struct                         asn1set__AcqCardMsgData_           
    {                                                                 
# define                               asn1set__AcqCardMsgData__acqCardText   0 
# define                               asn1set__AcqCardMsgData__acqCardURL   1 
# define                               asn1set__AcqCardMsgData__acqCardPhone   2 
        UCHAR                          _present[1]                      ; 
        asn1set__SETStringub_acqCardText acqCardText                      ; 
        asn1set__URL                   acqCardURL                       ; 
        asn1set__SETStringub_acqCardPhone acqCardPhone                     ; 
    }                              asn1set__AcqCardMsgData          ; 

typedef
    struct                         asn1set__AcqCardCodeMsg_           
    {                                                                 
        asn1set__AcqCardCode           acqCardCode                      ; 
        asn1set__AcqCardMsgData        acqCardMsgData                   ; 
    }                              asn1set__AcqCardCodeMsg          ; 

typedef
    asn1set__S                     asn1set__AuthRevReqTBE           ; 

typedef
    asn1set__L                     asn1set__AuthRevReqTBS           ; 

typedef
    asn1set__RRTags                asn1set__AuthRevRRTags           ; 

typedef
    struct                         asn1set__AuthRevTags_              
    {                                                                 
# define                               asn1set__AuthRevTags__authRetNum   0 
        UCHAR                          _present[1]                      ; 
        asn1set__AuthRevRRTags         authRevRRTags                    ; 
        asn1set__AuthRetNum            authRetNum                       ; 
    }                              asn1set__AuthRevTags             ; 

typedef
    struct                         asn1set__AuthRevReqData_           
    {                                                                 
# define                               asn1set__AuthRevReqData__mThumbs   0 
# define                               asn1set__AuthRevReqData__authReqData   1 
# define                               asn1set__AuthRevReqData__authResPayload   2 
# define                               asn1set__AuthRevReqData__aRvRqExtensions   3 
        UCHAR                          _present[1]                      ; 
        asn1set__AuthRevTags           authRevTags                      ; 
        asn1set__Thumbs                mThumbs                          ; 
        asn1set__AuthReqData           authReqData                      ; 
        asn1set__AuthResPayload        authResPayload                   ; 
        asn1set__CurrencyAmount        authNewAmt                       ; 
        asn1set__MsgExtensions         *aRvRqExtensions                 ; 
    }                              asn1set__AuthRevReqData          ; 

typedef
    struct                         asn1set__AuthRevReqBaggage_        
    {                                                                 
# define                               asn1set__AuthRevReqBaggage__capToken   0 
        UCHAR                          _present[1]                      ; 
        asn1set__PI                    pi                               ; 
        asn1set__CapToken              capToken                         ; 
    }                              asn1set__AuthRevReqBaggage       ; 

typedef
    asn1set__S                     asn1set__AuthRevResTBE           ; 

typedef
    asn1set__S                     asn1set__AuthRevResTBEB          ; 

typedef
    asn1set__L                     asn1set__AuthRevResTBS           ; 

typedef
    struct                         asn1set__AuthRevResBaggage_        
    {                                                                 
# define                               asn1set__AuthRevResBaggage__capTokenNew   0 
# define                               asn1set__AuthRevResBaggage__authTokenNew   1 
        UCHAR                          _present[1]                      ; 
        asn1set__CapToken              capTokenNew                      ; 
        asn1set__AuthToken             authTokenNew                     ; 
    }                              asn1set__AuthRevResBaggage       ; 

typedef
    asn__enumerated                asn1set__AuthRevCode             ; 
# define                           asn1set__AuthRevCode__approved     0 
# define                           asn1set__AuthRevCode__unspecifiedFailure     1 
# define                           asn1set__AuthRevCode__noReply      2 
# define                           asn1set__AuthRevCode__amountError     3 
# define                           asn1set__AuthRevCode__expiredCard     4 
# define                           asn1set__AuthRevCode__invalidTransaction     5 
# define                           asn1set__AuthRevCode__systemError     6 
# define                           asn1set__AuthRevCode__missingCapToken     7 
# define                           asn1set__AuthRevCode__invalidCapToken     8 
# define                           asn1set__AuthRevCode__invalidAmount     9 

typedef
    struct                         asn1set__AuthResDataNew_           
    {                                                                 
# define                               asn1set__AuthResDataNew__authResPayloadNew   0 
        UCHAR                          _present[1]                      ; 
        asn1set__TransIDs              transIDs                         ; 
        asn1set__AuthResPayload        authResPayloadNew                ; 
    }                              asn1set__AuthResDataNew          ; 

typedef
    struct                         asn1set__AuthRevResData_           
    {                                                                 
# define                               asn1set__AuthRevResData__brandCRLIdentifier   0 
# define                               asn1set__AuthRevResData__peThumb   1 
# define                               asn1set__AuthRevResData__aRvRsExtensions   2 
        UCHAR                          _present[1]                      ; 
        asn1set__AuthRevCode           authRevCode                      ; 
        asn1set__AuthRevTags           authRevTags                      ; 
        asn1set__BrandCRLIdentifier    brandCRLIdentifier               ; 
        asn1set__CertThumb             peThumb                          ; 
        asn1set__CurrencyAmount        authNewAmt                       ; 
        asn1set__AuthResDataNew        authResDataNew                   ; 
        asn1set__MsgExtensions         *aRvRsExtensions                 ; 
    }                              asn1set__AuthRevResData          ; 

typedef
    asn1set__S                     asn1set__CapReqTBE               ; 

typedef
    asn1set__L                     asn1set__CapReqTBS               ; 

typedef
    struct                         asn1set__CapReqTBEX_               
    {                                                                 
        asn1set__CapReqTBS             capReqTBS                        ; 
        asn1set__SO                    s                                ; 
    }                              asn1set__CapReqTBEX              ; 

typedef
    struct                         asn1set__CapReqTBSX_               
    {                                                                 
        asn1set__CapReqTBS             capReqTBS                        ; 
        asn1set__PANToken              panToken                         ; 
    }                              asn1set__CapReqTBSX              ; 

typedef
    asn1set__RRTags                asn1set__CapRRTags               ; 

typedef
    struct                         asn1set__CapPayload_               
    {                                                                 
# define                               asn1set__CapPayload__authReqItem   0 
# define                               asn1set__CapPayload__authResPayload   1 
# define                               asn1set__CapPayload__saleDetail   2 
# define                               asn1set__CapPayload__cPayExtensions   3 
        UCHAR                          _present[1]                      ; 
        asn1set__Date                  capDate                          ; 
        asn1set__CurrencyAmount        capReqAmt                        ; 
        asn1set__AuthReqItem           authReqItem                      ; 
        asn1set__AuthResPayload        authResPayload                   ; 
        asn1set__SaleDetail            saleDetail                       ; 
        asn1set__MsgExtensions         *cPayExtensions                  ; 
    }                              asn1set__CapPayload              ; 

typedef
    struct                         asn1set__CapItem_                  
    {                                                                 
        asn1set__TransIDs              transIDs                         ; 
        asn1set__RRPID                 authRRPID                        ; 
        asn1set__CapPayload            capPayload                       ; 
    }                              asn1set__CapItem                 ; 

typedef
    struct                         asn1set__CapItemSeq_               
    {                                                                 
        struct asn1set__CapItemSeq_    *next                            ; 
        asn1set__CapItem               capItem                          ; 
    }                              asn1set__CapItemSeq              ; 

typedef
    struct                         asn1set__CapReqData_               
    {                                                                 
# define                               asn1set__CapReqData__mThumbs     0 
# define                               asn1set__CapReqData__cRqExtensions   1 
        UCHAR                          _present[1]                      ; 
        asn1set__CapRRTags             capRRTags                        ; 
        asn1set__Thumbs                mThumbs                          ; 
        asn1set__CapItemSeq            *capItemSeq                      ; 
        asn1set__MsgExtensions         *cRqExtensions                   ; 
    }                              asn1set__CapReqData              ; 

typedef
    asn1set__S                     asn1set__CapResTBE               ; 

typedef
    struct                         asn1set__BatchStatusSeq_           
    {                                                                 
        struct asn1set__BatchStatusSeq_ *next                            ; 
        asn1set__BatchStatus           batchStatus                      ; 
    }                              asn1set__BatchStatusSeq          ; 

typedef
    struct                         asn1set__CapResItem_               
    {                                                                 
        asn1set__TransIDs              transIDs                         ; 
        asn1set__RRPID                 authRRPID                        ; 
        asn1set__CapResPayload         capResPayload                    ; 
    }                              asn1set__CapResItem              ; 

typedef
    struct                         asn1set__CapResItemSeq_            
    {                                                                 
        struct asn1set__CapResItemSeq_ *next                            ; 
        asn1set__CapResItem            capResItem                       ; 
    }                              asn1set__CapResItemSeq           ; 

typedef
    struct                         asn1set__CapResData_               
    {                                                                 
# define                               asn1set__CapResData__brandCRLIdentifier   0 
# define                               asn1set__CapResData__peThumb     1 
# define                               asn1set__CapResData__batchStatusSeq   2 
# define                               asn1set__CapResData__cRsExtensions   3 
        UCHAR                          _present[1]                      ; 
        asn1set__CapRRTags             capRRTags                        ; 
        asn1set__BrandCRLIdentifier    brandCRLIdentifier               ; 
        asn1set__CertThumb             peThumb                          ; 
        asn1set__BatchStatusSeq        *batchStatusSeq                  ; 
        asn1set__CapResItemSeq         *capResItemSeq                   ; 
        asn1set__MsgExtensions         *cRsExtensions                   ; 
    }                              asn1set__CapResData              ; 

typedef
    struct                         asn1set__CapRevOrCredReqItem_      
    {                                                                 
# define                               asn1set__CapRevOrCredReqItem__newBatchID   0 
# define                               asn1set__CapRevOrCredReqItem__capRevOrCredReqAmt   1 
# define                               asn1set__CapRevOrCredReqItem__cRvRqItemExtensions   2 
        UCHAR                          _present[1]                      ; 
        asn1set__TransIDs              transIDs                         ; 
        asn1set__RRPID                 authRRPID                        ; 
        asn1set__CapPayload            capPayload                       ; 
        asn1set__BatchID               newBatchID                       ; 
        asn1set__Date                  capRevOrCredReqDate              ; 
        asn1set__CurrencyAmount        capRevOrCredReqAmt               ; 
        asn__boolean                   newAccountInd                    ; 
        asn1set__MsgExtensions         *cRvRqItemExtensions             ; 
    }                              asn1set__CapRevOrCredReqItem     ; 

typedef
    struct                         asn1set__CapRevOrCredReqItemSeq_     
    {                                                                 
        struct asn1set__CapRevOrCredReqItemSeq_ *next                            ; 
        asn1set__CapRevOrCredReqItem   capRevOrCredReqItem              ; 
    }                              asn1set__CapRevOrCredReqItemSeq   ; 

typedef
    struct                         asn1set__CapRevOrCredReqData_      
    {                                                                 
# define                               asn1set__CapRevOrCredReqData__mThumbs   0 
# define                               asn1set__CapRevOrCredReqData__cRvRqExtensions   1 
        UCHAR                          _present[1]                      ; 
        asn1set__RRTags                capRevOrCredRRTags               ; 
        asn1set__Thumbs                mThumbs                          ; 
        asn1set__CapRevOrCredReqItemSeq *capRevOrCredReqItemSeq          ; 
        asn1set__MsgExtensions         *cRvRqExtensions                 ; 
    }                              asn1set__CapRevOrCredReqData     ; 

typedef
    struct                         asn1set__CapRevOrCredResPayload_     
    {                                                                 
# define                               asn1set__CapRevOrCredResPayload__batchID   0 
# define                               asn1set__CapRevOrCredResPayload__batchSequenceNum   1 
# define                               asn1set__CapRevOrCredResPayload__cRvRsPayExtensions   2 
        UCHAR                          _present[1]                      ; 
        asn1set__CapRevOrCredCode      capRevOrCredCode                 ; 
        asn1set__CurrencyAmount        capRevOrCredActualAmt            ; 
        asn1set__BatchID               batchID                          ; 
        asn1set__BatchSequenceNum      batchSequenceNum                 ; 
        asn1set__MsgExtensions         *cRvRsPayExtensions              ; 
    }                              asn1set__CapRevOrCredResPayload   ; 

typedef
    struct                         asn1set__CapRevOrCredResItem_      
    {                                                                 
        asn1set__TransIDs              transIDs                         ; 
        asn1set__RRPID                 authRRPID                        ; 
        asn1set__CapRevOrCredResPayload capRevOrCredResPayload           ; 
    }                              asn1set__CapRevOrCredResItem     ; 

typedef
    struct                         asn1set__CapRevOrCredResItemSeq_     
    {                                                                 
        struct asn1set__CapRevOrCredResItemSeq_ *next                            ; 
        asn1set__CapRevOrCredResItem   capRevOrCredResItem              ; 
    }                              asn1set__CapRevOrCredResItemSeq   ; 

typedef
    struct                         asn1set__CapRevOrCredResData_      
    {                                                                 
# define                               asn1set__CapRevOrCredResData__brandCRLIdentifier   0 
# define                               asn1set__CapRevOrCredResData__peThumb   1 
# define                               asn1set__CapRevOrCredResData__batchStatusSeq   2 
# define                               asn1set__CapRevOrCredResData__cRvRsExtensions   3 
        UCHAR                          _present[1]                      ; 
        asn1set__RRTags                capRevOrCredRRTags               ; 
        asn1set__BrandCRLIdentifier    brandCRLIdentifier               ; 
        asn1set__CertThumb             peThumb                          ; 
        asn1set__BatchStatusSeq        *batchStatusSeq                  ; 
        asn1set__CapRevOrCredResItemSeq *capRevOrCredResItemSeq          ; 
        asn1set__MsgExtensions         *cRvRsExtensions                 ; 
    }                              asn1set__CapRevOrCredResData     ; 

typedef
    asn1set__S                     asn1set__CapRevReqTBE            ; 

typedef
    asn1set__L                     asn1set__CapRevReqTBS            ; 

typedef
    struct                         asn1set__CapRevReqTBEX_            
    {                                                                 
        asn1set__CapRevReqTBS          capRevReqTBS                     ; 
        asn1set__SO                    s                                ; 
    }                              asn1set__CapRevReqTBEX           ; 

typedef
    struct                         asn1set__CapRevReqTBSX_            
    {                                                                 
        asn1set__CapRevReqTBS          capRevReqTBS                     ; 
        asn1set__PANToken              panToken                         ; 
    }                              asn1set__CapRevReqTBSX           ; 

typedef
    asn1set__CapRevOrCredReqData   asn1set__CapRevData              ; 

typedef
    asn1set__S                     asn1set__CapRevResTBE            ; 

typedef
    asn1set__CapRevOrCredResData   asn1set__CapRevResData           ; 

typedef
    asn1set__S                     asn1set__CredReqTBE              ; 

typedef
    asn1set__L                     asn1set__CredReqTBS              ; 

typedef
    struct                         asn1set__CredReqTBEX_              
    {                                                                 
        asn1set__CredReqTBS            credReqTBS                       ; 
        asn1set__SO                    s                                ; 
    }                              asn1set__CredReqTBEX             ; 

typedef
    struct                         asn1set__CredReqTBSX_              
    {                                                                 
        asn1set__CredReqTBS            credReqTBS                       ; 
        asn1set__PANToken              panToken                         ; 
    }                              asn1set__CredReqTBSX             ; 

typedef
    asn1set__CapRevOrCredReqData   asn1set__CredReqData             ; 

typedef
    asn1set__S                     asn1set__CredResTBE              ; 

typedef
    asn1set__CapRevOrCredResData   asn1set__CredResData             ; 

typedef
    asn1set__S                     asn1set__CredRevReqTBE           ; 

typedef
    asn1set__L                     asn1set__CredRevReqTBS           ; 

typedef
    struct                         asn1set__CredRevReqTBEX_           
    {                                                                 
        asn1set__CredRevReqTBS         credRevReqTBS                    ; 
        asn1set__SO                    s                                ; 
    }                              asn1set__CredRevReqTBEX          ; 

typedef
    struct                         asn1set__CredRevReqTBSX_           
    {                                                                 
        asn1set__CredRevReqTBS         credRevReqTBS                    ; 
        asn1set__PANToken              panToken                         ; 
    }                              asn1set__CredRevReqTBSX          ; 

typedef
    asn1set__CapRevOrCredReqData   asn1set__CredRevReqData          ; 

typedef
    asn1set__S                     asn1set__CredRevResTBE           ; 

typedef
    asn1set__CapRevOrCredResData   asn1set__CredRevResData          ; 

typedef
    struct                         asn1set__BrandAndBIN_              
    {                                                                 
# define                               asn1set__BrandAndBIN__bin        0 
        UCHAR                          _present[1]                      ; 
        asn1set__BrandID               brandID                          ; 
        asn1set__BIN                   bin                              ; 
    }                              asn1set__BrandAndBIN             ; 

typedef
    struct                         asn1set__BrandAndBINSeq_           
    {                                                                 
        struct asn1set__BrandAndBINSeq_ *next                            ; 
        asn1set__BrandAndBIN           brandAndBIN                      ; 
    }                              asn1set__BrandAndBINSeq          ; 

typedef
    struct                         asn1set__PCertReqData_             
    {                                                                 
# define                               asn1set__PCertReqData__mThumbs   0 
# define                               asn1set__PCertReqData__pcRqExtensions   1 
        UCHAR                          _present[1]                      ; 
        asn1set__RRTags                pCertRRTags                      ; 
        asn1set__Thumbs                mThumbs                          ; 
        asn1set__BrandAndBINSeq        *brandAndBINSeq                  ; 
        asn1set__MsgExtensions         *pcRqExtensions                  ; 
    }                              asn1set__PCertReqData            ; 

typedef
    asn__enumerated                asn1set__PCertCode               ; 
# define                           asn1set__PCertCode__success        0 
# define                           asn1set__PCertCode__unspecifiedFailure     1 
# define                           asn1set__PCertCode__brandNotSupported     2 
# define                           asn1set__PCertCode__unknownBIN     3 

typedef
    struct                         asn1set__PCertResItem_             
    {                                                                 
# define                               asn1set__PCertResItem__certThumb   0 
        UCHAR                          _present[1]                      ; 
        asn1set__PCertCode             pCertCode                        ; 
        asn1set__CertThumb             certThumb                        ; 
    }                              asn1set__PCertResItem            ; 

typedef
    struct                         asn1set__PCertResItemSeq_          
    {                                                                 
        struct asn1set__PCertResItemSeq_ *next                            ; 
        asn1set__PCertResItem          pCertResItem                     ; 
    }                              asn1set__PCertResItemSeq         ; 

typedef
    struct                         asn1set__BrandCRLIdentifierSeq_     
    {                                                                 
        struct asn1set__BrandCRLIdentifierSeq_ *next                            ; 
        asn1set__BrandCRLIdentifier    brandCRLIdentifier               ; 
    }                              asn1set__BrandCRLIdentifierSeq   ; 

typedef
    struct                         asn1set__PCertResTBS_              
    {                                                                 
# define                               asn1set__PCertResTBS__brandCRLIdentifierSeq   0 
# define                               asn1set__PCertResTBS__pcRsExtensions   1 
        UCHAR                          _present[1]                      ; 
        asn1set__RRTags                pCertRRTags                      ; 
        asn1set__PCertResItemSeq       *pCertResItemSeq                 ; 
        asn1set__BrandCRLIdentifierSeq *brandCRLIdentifierSeq           ; 
        asn1set__MsgExtensions         *pcRsExtensions                  ; 
    }                              asn1set__PCertResTBS             ; 

typedef
    asn1set__S                     asn1set__BatchAdminReqTBE        ; 

typedef
    asn__enumerated                asn1set__BatchOperation          ; 
# define                           asn1set__BatchOperation__open      0 
# define                           asn1set__BatchOperation__purge     1 
# define                           asn1set__BatchOperation__close     2 

typedef
    struct                         asn1set__ReturnTransactionDetail_     
    {                                                                 
# define                               asn1set__ReturnTransactionDetail__brandID   0 
        UCHAR                          _present[1]                      ; 
        asn__integer                   startingPoint                    ; 
        asn__integer                   maximumItems                     ; 
        asn__boolean                   errorsOnlyInd                    ; 
        asn1set__BrandID               brandID                          ; 
    }                              asn1set__ReturnTransactionDetail   ; 

typedef
    asn__enumerated                asn1set__ReimbursementID         ; 
# define                           asn1set__ReimbursementID__unspecified     0 
# define                           asn1set__ReimbursementID__standard     1 
# define                           asn1set__ReimbursementID__keyEntered     2 
# define                           asn1set__ReimbursementID__electronic     3 
# define                           asn1set__ReimbursementID__additionalData     4 
# define                           asn1set__ReimbursementID__enhancedData     5 
# define                           asn1set__ReimbursementID__marketSpecific     6 

typedef
    asn__enumerated                asn1set__AmountType              ; 
# define                           asn1set__AmountType__credit        0 
# define                           asn1set__AmountType__debit         1 

typedef
    asn__enumerated                asn1set__TransactionStatus       ; 
# define                           asn1set__TransactionStatus__success     0 
# define                           asn1set__TransactionStatus__unspecifiedFailure     1 

typedef
    struct                         asn1set__TransactionDetail_        
    {                                                                 
# define                               asn1set__TransactionDetail__reimbursementID   0 
# define                               asn1set__TransactionDetail__transactionStatus   1 
# define                               asn1set__TransactionDetail__transExtensions   2 
        UCHAR                          _present[1]                      ; 
        asn1set__TransIDs              transIDs                         ; 
        asn1set__RRPID                 authRRPID                        ; 
        asn1set__BrandID               brandID                          ; 
        asn1set__BatchSequenceNum      batchSequenceNum                 ; 
        asn1set__ReimbursementID       reimbursementID                  ; 
        asn1set__CurrencyAmount        transactionAmt                   ; 
        asn1set__AmountType            transactionAmtType               ; 
        asn1set__TransactionStatus     transactionStatus                ; 
        asn1set__MsgExtensions         *transExtensions                 ; 
    }                              asn1set__TransactionDetail       ; 

typedef
    struct                         asn1set__TransactionDetailSeq_     
    {                                                                 
        struct asn1set__TransactionDetailSeq_ *next                            ; 
        asn1set__TransactionDetail     transactionDetail                ; 
    }                              asn1set__TransactionDetailSeq    ; 

typedef
    struct                         asn1set__TransDetails_             
    {                                                                 
        asn__integer                   nextStartingPoint                ; 
        asn1set__TransactionDetailSeq  *transactionDetailSeq            ; 
    }                              asn1set__TransDetails            ; 

typedef
    struct                         asn1set__BatchAdminReqData_        
    {                                                                 
# define                               asn1set__BatchAdminReqData__batchID   0 
# define                               asn1set__BatchAdminReqData__brandAndBINSeq   1 
# define                               asn1set__BatchAdminReqData__batchOperation   2 
# define                               asn1set__BatchAdminReqData__returnTransactionDetail   3 
# define                               asn1set__BatchAdminReqData__batchStatus   4 
# define                               asn1set__BatchAdminReqData__transDetails   5 
# define                               asn1set__BatchAdminReqData__baRqExtensions   6 
        UCHAR                          _present[1]                      ; 
        asn1set__RRTags                batchAdminRRTags                 ; 
        asn1set__BatchID               batchID                          ; 
        asn1set__BrandAndBINSeq        *brandAndBINSeq                  ; 
        asn1set__BatchOperation        batchOperation                   ; 
        asn__boolean                   returnBatchSummaryInd            ; 
        asn1set__ReturnTransactionDetail returnTransactionDetail          ; 
        asn1set__BatchStatus           batchStatus                      ; 
        asn1set__TransDetails          transDetails                     ; 
        asn1set__MsgExtensions         *baRqExtensions                  ; 
    }                              asn1set__BatchAdminReqData       ; 

typedef
    asn1set__S                     asn1set__BatchAdminResTBE        ; 

typedef
    asn__enumerated                asn1set__BAStatus                ; 
# define                           asn1set__BAStatus__success         0 
# define                           asn1set__BAStatus__unspecifiedFailure     1 
# define                           asn1set__BAStatus__brandNotSupported     2 
# define                           asn1set__BAStatus__unknownBIN      3 
# define                           asn1set__BAStatus__batchIDunavailable     4 
# define                           asn1set__BAStatus__batchAlreadyOpen     5 
# define                           asn1set__BAStatus__unknownBatchID     6 
# define                           asn1set__BAStatus__brandBatchMismatch     7 
# define                           asn1set__BAStatus__totalsOutOfBalance     8 
# define                           asn1set__BAStatus__unknownStartingPoint     9 
# define                           asn1set__BAStatus__stopItemDetail    10 
# define                           asn1set__BAStatus__unknownBatchOperation    11 

typedef
    asn__enumerated                asn1set__TransmissionStatus      ; 
# define                           asn1set__TransmissionStatus__pending     0 
# define                           asn1set__TransmissionStatus__inProgress     1 
# define                           asn1set__TransmissionStatus__batchRejectedByAcquirer     2 
# define                           asn1set__TransmissionStatus__completedSuccessfully     3 
# define                           asn1set__TransmissionStatus__completedWithItemErrors     4 

typedef
    struct                         asn1set__SETStringub_SettlementAccount_     
    {                                                                 
# define                               asn1set__SETStringub_SettlementAccount__visibleString 0x749 
# define                               asn1set__SETStringub_SettlementAccount__bmpString 0x74a 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_SettlementAccount   ; 

typedef
    struct                         asn1set__SettlementInfo_           
    {                                                                 
        asn1set__CurrencyAmount        settlementAmount                 ; 
        asn1set__AmountType            settlementType                   ; 
        asn1set__SETStringub_SettlementAccount settlementAccount                ; 
        asn1set__Date                  settlementDepositDate            ; 
    }                              asn1set__SettlementInfo          ; 

typedef
    struct                         asn1set__BatchAdminResData_        
    {                                                                 
# define                               asn1set__BatchAdminResData__baStatus   0 
# define                               asn1set__BatchAdminResData__batchStatus   1 
# define                               asn1set__BatchAdminResData__transmissionStatus   2 
# define                               asn1set__BatchAdminResData__settlementInfo   3 
# define                               asn1set__BatchAdminResData__transDetails   4 
# define                               asn1set__BatchAdminResData__baRsExtensions   5 
        UCHAR                          _present[1]                      ; 
        asn1set__RRTags                batchAdminTags                   ; 
        asn1set__BatchID               batchID                          ; 
        asn1set__BAStatus              baStatus                         ; 
        asn1set__BatchStatus           batchStatus                      ; 
        asn1set__TransmissionStatus    transmissionStatus               ; 
        asn1set__SettlementInfo        settlementInfo                   ; 
        asn1set__TransDetails          transDetails                     ; 
        asn1set__MsgExtensions         *baRsExtensions                  ; 
    }                              asn1set__BatchAdminResData       ; 

typedef
    asn__any                       asn1set__TokenOpaque             ; 

typedef
    struct                         asn1set__AuthTokenData_            
    {                                                                 
# define                               asn1set__AuthTokenData__acqBackKeyData   0 
# define                               asn1set__AuthTokenData__installRecurData   1 
# define                               asn1set__AuthTokenData__recurringCount   2 
# define                               asn1set__AuthTokenData__totalAuthAmount   3 
# define                               asn1set__AuthTokenData__authTokenOpaque   4 
        UCHAR                          _present[1]                      ; 
        asn1set__TransIDs              transIDs                         ; 
        asn1set__CurrencyAmount        purchAmt                         ; 
        asn1set__MerchantID            merchantID                       ; 
        asn1set__BackKeyData           acqBackKeyData                   ; 
        asn1set__InstallRecurData      installRecurData                 ; 
        asn__integer                   recurringCount                   ; 
        asn1set__Date                  prevAuthDateTime                 ; 
        asn1set__CurrencyAmount        totalAuthAmount                  ; 
        asn1set__TokenOpaque           authTokenOpaque                  ; 
    }                              asn1set__AuthTokenData           ; 

typedef
    struct                         asn1set__AuthTokenTBE_             
    {                                                                 
        asn1set__AuthTokenData         authTokenData                    ; 
        asn1set__SO                    s                                ; 
    }                              asn1set__AuthTokenTBE            ; 

typedef
    struct                         asn1set__AuthTokenTBS_             
    {                                                                 
        asn1set__AuthTokenData         authTokenData                    ; 
        asn1set__PANToken              panToken                         ; 
    }                              asn1set__AuthTokenTBS            ; 

typedef
    asn1set__S                     asn1set__CapTokenTBE             ; 

typedef
    struct                         asn1set__CapTokenData_             
    {                                                                 
        asn1set__RRPID                 authRRPID                        ; 
        asn1set__CurrencyAmount        authAmt                          ; 
        asn1set__TokenOpaque           tokenOpaque                      ; 
    }                              asn1set__CapTokenData            ; 

typedef
    struct                         asn1set__CapTokenTBEX_             
    {                                                                 
        asn1set__CapTokenData          capTokenData                     ; 
        asn1set__SO                    s                                ; 
    }                              asn1set__CapTokenTBEX            ; 

typedef
    struct                         asn1set__CapTokenTBS_              
    {                                                                 
        asn1set__CapTokenData          capTokenData                     ; 
        asn1set__PANToken              panToken                         ; 
    }                              asn1set__CapTokenTBS             ; 

typedef
    struct                         asn1set__CapTokenSeq_              
    {                                                                 
        struct asn1set__CapTokenSeq_   *next                            ; 
        asn1set__CapToken              capToken                         ; 
    }                              asn1set__CapTokenSeq             ; 

typedef
    struct                         asn1set__AnyAny_                   
    {                                                                 
        asn__any                       any1                             ; 
        asn__any                       any2                             ; 
    }                              asn1set__AnyAny                  ; 

typedef
    asn__boolean                   asn1set__Boolean                 ; 

typedef
    asn__integer                   asn1set__Integer                 ; 

typedef
    asn__visible_string            asn1set__Visiblestring           ; 

typedef
    asn__printable_string          asn1set__Printablestring         ; 

typedef
    x509__AlgorithmIdentifier      asn1set__CEAlgorithmIdentifier   ; 

typedef
    x509__AlgorithmIdentifier      asn1set__DAlgorithmIdentifier    ; 

typedef
    asn__octet_string              asn1set__H                       ; 

typedef
    struct                         asn1set__HMACPanData_              
    {                                                                 
        asn1set__PAN                   pan                              ; 
        asn1set__CardExpiry            cardExpiry                       ; 
    }                              asn1set__HMACPanData             ; 

typedef
    asn1set__E                     asn1set__EH                      ; 

typedef
    struct                         asn1set__SETStringub_FieldName_     
    {                                                                 
# define                               asn1set__SETStringub_FieldName__visibleString 0x716 
# define                               asn1set__SETStringub_FieldName__bmpString 0x717 
        UINT4                          _choice                          ; 
        union                                                             
        {                                                                 
            asn__visible_string            visibleString                    ; 
            asn__bmp_string                bmpString                        ; 
        } u                                                             ; 
    }                              asn1set__SETStringub_FieldName   ; 



extern      asn__integer                   asn1set__ub_acctIdentification   ; 
extern      asn__integer                   asn1set__ub_cardholderMsg        ; 
extern      asn__integer                   asn1set__ub_eeMessage            ; 
extern      asn__integer                   asn1set__ub_FieldDesc            ; 
extern      asn__integer                   asn1set__ub_FieldList            ; 
extern      asn__integer                   asn1set__ub_FieldName            ; 
extern      asn__integer                   asn1set__ub_FieldValue           ; 
extern      asn__integer                   asn1set__ub_PolicyText           ; 
extern      asn__integer                   asn1set__ub_Reason               ; 
extern      asn__integer                   asn1set__ub_countryName          ; 
extern      asn__integer                   asn1set__ub_cityName             ; 
extern      asn__integer                   asn1set__ub_merName              ; 
extern      asn__integer                   asn1set__ub_postalCode           ; 
extern      asn__integer                   asn1set__ub_stateProvince        ; 
extern      asn__integer                   asn1set__ub_terseStatement       ; 
extern      asn__object_identifier         asn1set__id_ce                   ; 
extern      asn__object_identifier         asn1set__id_ce_keyUsage          ; 
extern      asn__object_identifier         asn1set__id_ce_privateKeyUsagePeriod   ; 
extern      asn__object_identifier         asn1set__id_ce_subjectAltName    ; 
extern      asn__object_identifier         asn1set__id_ce_issuerAltName     ; 
extern      asn__object_identifier         asn1set__id_ce_basicConstraints   ; 
extern      asn__object_identifier         asn1set__id_ce_cRLNumber         ; 
extern      asn__object_identifier         asn1set__id_ce_certificatePolicies   ; 
extern      asn__object_identifier         asn1set__id_ce_authorityKeyIdentifier   ; 
extern      asn__object_identifier         asn1set__id_set                  ; 
extern      asn1set__OID                   asn1set__id_set_contentType      ; 
extern      asn1set__OID                   asn1set__id_set_msgExt           ; 
extern      asn1set__OID                   asn1set__id_set_field            ; 
extern      asn1set__OID                   asn1set__id_set_attribute        ; 
extern      asn1set__OID                   asn1set__id_set_algorithm        ; 
extern      asn1set__OID                   asn1set__id_set_policy           ; 
extern      asn1set__OID                   asn1set__id_set_module           ; 
extern      asn1set__OID                   asn1set__id_set_certExt          ; 
extern      asn1set__OID                   asn1set__id_set_brand            ; 
extern      asn1set__OID                   asn1set__id_set_vendor           ; 
extern      asn1set__OID                   asn1set__id_set_national         ; 
extern      asn1set__OID                   asn1set__id_set_content_PANData   ; 
extern      asn1set__OID                   asn1set__id_set_content_PANToken   ; 
extern      asn1set__OID                   asn1set__id_set_content_PANOnly   ; 
extern      asn1set__OID                   asn1set__id_set_content_OIData   ; 
extern      asn1set__OID                   asn1set__id_set_content_PI       ; 
extern      asn1set__OID                   asn1set__id_set_content_PIData   ; 
extern      asn1set__OID                   asn1set__id_set_content_PIDataUnsigned   ; 
extern      asn1set__OID                   asn1set__id_set_content_HODInput   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthResBaggage   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthRevReqBaggage   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthRevResBaggage   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapTokenSeq   ; 
extern      asn1set__OID                   asn1set__id_set_content_PInitResData   ; 
extern      asn1set__OID                   asn1set__id_set_content_PI_TBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_PResData   ; 
extern      asn1set__OID                   asn1set__id_set_content_InqReqData   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthReqTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthResTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthResTBSX   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthTokenTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapTokenData   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapTokenTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_AcqCardCodeMsg   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthRevReqTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthRevResData   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthRevResTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapReqTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapReqTBSX   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapResData   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapRevReqTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapRevReqTBSX   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapRevResData   ; 
extern      asn1set__OID                   asn1set__id_set_content_CredReqTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_CredReqTBSX   ; 
extern      asn1set__OID                   asn1set__id_set_content_CredResData   ; 
extern      asn1set__OID                   asn1set__id_set_content_CredRevReqTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_CredRevReqTBSX   ; 
extern      asn1set__OID                   asn1set__id_set_content_CredRevResData   ; 
extern      asn1set__OID                   asn1set__id_set_content_PCertReqData   ; 
extern      asn1set__OID                   asn1set__id_set_content_PCertResTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_BatchAdminReqData   ; 
extern      asn1set__OID                   asn1set__id_set_content_BatchAdminResData   ; 
extern      asn1set__OID                   asn1set__id_set_content_CardCInitResTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_Me_AqCInitResTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_RegFormResTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_CertReqData   ; 
extern      asn1set__OID                   asn1set__id_set_content_CertReqTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_CertResData   ; 
extern      asn1set__OID                   asn1set__id_set_content_CertInqReqTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_ErrorTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_PIDualSignedTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_PIUnsignedTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthReqTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthResTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthResTBEX   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthTokenTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapTokenTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapTokenTBEX   ; 
extern      asn1set__OID                   asn1set__id_set_content_AcqCardCodeMsgTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthRevReqTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthRevResTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_AuthRevResTBEB   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapReqTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapReqTBEX   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapResTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapRevReqTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapRevReqTBEX   ; 
extern      asn1set__OID                   asn1set__id_set_content_CapRevResTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_CredReqTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_CredReqTBEX   ; 
extern      asn1set__OID                   asn1set__id_set_content_CredResTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_CredRevReqTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_CredRevReqTBEX   ; 
extern      asn1set__OID                   asn1set__id_set_content_CredRevResTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_BatchAdminReqTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_BatchAdminResTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_RegFormReqTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_CertReqTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_CertReqTBEX   ; 
extern      asn1set__OID                   asn1set__id_set_content_CertResTBE   ; 
extern      asn1set__OID                   asn1set__id_set_content_CRLNotificationTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_CRLNotificationResTBS   ; 
extern      asn1set__OID                   asn1set__id_set_content_BCIDistributionTBS   ; 
extern      asn1set__OID                   asn1set__id_set_fullName         ; 
extern      asn1set__OID                   asn1set__id_set_givenName        ; 
extern      asn1set__OID                   asn1set__id_set_familyName       ; 
extern      asn1set__OID                   asn1set__id_set_birthFamilyName   ; 
extern      asn1set__OID                   asn1set__id_set_placeName        ; 
extern      asn1set__OID                   asn1set__id_set_identificationNumber   ; 
extern      asn1set__OID                   asn1set__id_set_month            ; 
extern      asn1set__OID                   asn1set__id_set_date             ; 
extern      asn1set__OID                   asn1set__id_set_address          ; 
extern      asn1set__OID                   asn1set__id_set_telephone        ; 
extern      asn1set__OID                   asn1set__id_set_amount           ; 
extern      asn1set__OID                   asn1set__id_set_accountNumber    ; 
extern      asn1set__OID                   asn1set__id_set_passPhrase       ; 
extern      asn1set__OID                   asn1set__id_set_attribute_cert   ; 
extern      asn1set__OID                   asn1set__id_set_rootKeyThumb     ; 
extern      asn1set__OID                   asn1set__id_set_additionalPolicy   ; 
extern      asn1set__OID                   asn1set__id_set_policy_root      ; 
extern      asn1set__OID                   asn1set__id_set_hashedRootKey    ; 
extern      asn1set__OID                   asn1set__id_set_certificateType   ; 
extern      asn1set__OID                   asn1set__id_set_merchantData     ; 
extern      asn1set__OID                   asn1set__id_set_cardCertRequired   ; 
extern      asn1set__OID                   asn1set__id_set_tunneling        ; 
extern      asn1set__OID                   asn1set__id_set_setExtensions    ; 
extern      asn1set__OID                   asn1set__id_set_setQualifier     ; 
extern      asn1set__OID                   asn1set__id_set_IATA_ATA         ; 
extern      asn1set__OID                   asn1set__id_set_Diners           ; 
extern      asn1set__OID                   asn1set__id_set_AmericanExpress   ; 
extern      asn1set__OID                   asn1set__id_set_JCB              ; 
extern      asn1set__OID                   asn1set__id_set_Visa             ; 
extern      asn1set__OID                   asn1set__id_set_MasterCard       ; 
extern      asn1set__OID                   asn1set__id_set_Novus            ; 
extern      asn1set__OID                   asn1set__id_set_GlobeSet         ; 
extern      asn1set__OID                   asn1set__id_set_IBM              ; 
extern      asn1set__OID                   asn1set__id_set_Cybercash        ; 
extern      asn1set__OID                   asn1set__id_set_Terisa           ; 
extern      asn1set__OID                   asn1set__id_set_RSADSI           ; 
extern      asn1set__OID                   asn1set__id_set_VeriFone         ; 
extern      asn1set__OID                   asn1set__id_set_Trintech         ; 
extern      asn1set__OID                   asn1set__id_set_BankGate         ; 
extern      asn1set__OID                   asn1set__id_set_GTE              ; 
extern      asn1set__OID                   asn1set__id_set_CompuSource      ; 
extern      asn1set__OID                   asn1set__id_set_Griffin          ; 
extern      asn1set__OID                   asn1set__id_set_Certicom         ; 
extern      asn1set__OID                   asn1set__id_set_OSS              ; 
extern      asn1set__OID                   asn1set__id_set_TenthMountain    ; 
extern      asn1set__OID                   asn1set__id_set_Antares          ; 
extern      asn1set__OID                   asn1set__id_set_ECC              ; 
extern      asn1set__OID                   asn1set__id_set_Maithean         ; 
extern      asn1set__OID                   asn1set__id_set_Netscape         ; 
extern      asn1set__OID                   asn1set__id_set_VeriSign         ; 
extern      asn1set__OID                   asn1set__id_set_BlueMoney        ; 
extern      asn1set__OID                   asn1set__id_set_Lacerte          ; 
extern      asn1set__OID                   asn1set__id_set_Fujitsu          ; 
extern      asn1set__OID                   asn1set__id_set_eLab             ; 
extern      asn1set__OID                   asn1set__id_set_Entrust          ; 
extern      asn1set__OID                   asn1set__id_set_VIAnet           ; 
extern      asn1set__OID                   asn1set__id_set_III              ; 
extern      asn1set__OID                   asn1set__id_set_OpenMarket       ; 
extern      asn1set__OID                   asn1set__id_set_Lexem            ; 
extern      asn1set__OID                   asn1set__id_set_Intertrader      ; 
extern      asn1set__OID                   asn1set__id_set_Persimmon        ; 
extern      asn1set__OID                   asn1set__id_set_NABLE            ; 
extern      asn1set__OID                   asn1set__id_set_espace_net       ; 
extern      asn1set__OID                   asn1set__id_set_Hitachi          ; 
extern      asn1set__OID                   asn1set__id_set_Microsoft        ; 
extern      asn1set__OID                   asn1set__id_set_NEC              ; 
extern      asn1set__OID                   asn1set__id_set_Mitsubishi       ; 
extern      asn1set__OID                   asn1set__id_set_NCR              ; 
extern      asn1set__OID                   asn1set__id_set_e_COMM           ; 
extern      asn1set__OID                   asn1set__id_set_Gemplus          ; 
extern      asn1set__OID                   asn1set__id_set_Japan            ; 
extern      asn__integer                   asn1set__joint_iso_itu_t         ; 
extern      asn__integer                   asn1set__internationalRA         ; 
extern      asn__integer                   asn1set__set                     ; 
extern      asn__integer                   asn1set__ub_airportCode          ; 
extern      asn__integer                   asn1set__ub_carrierCode          ; 
extern      asn__integer                   asn1set__ub_commCode             ; 
extern      asn__integer                   asn1set__ub_corpID               ; 
extern      asn__integer                   asn1set__ub_description          ; 
extern      asn__integer                   asn1set__ub_fareBasis            ; 
extern      asn__integer                   asn1set__ub_hotelFolio           ; 
extern      asn__integer                   asn1set__ub_insuranceType        ; 
extern      asn__integer                   asn1set__ub_items                ; 
extern      asn__integer                   asn1set__ub_passName             ; 
extern      asn__integer                   asn1set__ub_phone                ; 
extern      asn__integer                   asn1set__ub_productCode          ; 
extern      asn__integer                   asn1set__ub_programCode          ; 
extern      asn__integer                   asn1set__ub_reference            ; 
extern      asn__integer                   asn1set__ub_rentalNum            ; 
extern      asn__integer                   asn1set__ub_rentalRefNum         ; 
extern      asn__integer                   asn1set__ub_renterName           ; 
extern      asn__integer                   asn1set__ub_serviceClass         ; 
extern      asn__integer                   asn1set__ub_taCode               ; 
extern      asn__integer                   asn1set__ub_taName               ; 
extern      asn__integer                   asn1set__ub_taxID                ; 
extern      asn__integer                   asn1set__ub_taxType              ; 
extern      asn__integer                   asn1set__ub_ticketNum            ; 
extern      asn__integer                   asn1set__ub_vehicleClass         ; 
extern      asn__integer                   asn1set__ub_unitMeasure          ; 
extern      asn__integer                   asn1set__ub_BrandID              ; 
extern      asn__integer                   asn1set__ub_MerchantID           ; 
extern      asn__integer                   asn1set__ub_SWIdent              ; 
extern      asn__integer                   asn1set__ub_acqBusinessID        ; 
extern      asn__integer                   asn1set__ub_locationID           ; 
extern      asn__integer                   asn1set__ub_paySysID             ; 
extern      asn__integer                   asn1set__ub_RFC1766_language     ; 
extern      asn__integer                   asn1set__ub_URL                  ; 
extern      asn__object_identifier         asn1set__secsig                  ; 
extern      asn__object_identifier         asn1set__pkcs_1                  ; 
extern      asn__object_identifier         asn1set__rsaOAEPEncryptionSET    ; 
extern      asn__object_identifier         asn1set__id_rsaEncryption        ; 
extern      asn__object_identifier         asn1set__id_sha1_with_rsa_signature   ; 
extern      asn__object_identifier         asn1set__id_sha1                 ; 
extern      asn__object_identifier         asn1set__id_desCBC               ; 
extern      asn__object_identifier         asn1set__id_desCDMF              ; 
extern      asn__object_identifier         asn1set__pkcs_7                  ; 
extern      asn__object_identifier         asn1set__data                    ; 
extern      asn__object_identifier         asn1set__signedData              ; 
extern      asn__object_identifier         asn1set__envelopedData           ; 
extern      asn__object_identifier         asn1set__digestedData            ; 
extern      asn__object_identifier         asn1set__pkcs_9                  ; 
extern      asn__object_identifier         asn1set__contentType             ; 
extern      asn__object_identifier         asn1set__messageDigest           ; 
extern      asn__integer                   asn1set__ub_acqCardText          ; 
extern      asn__integer                   asn1set__ub_acqCardPhone         ; 
extern      asn__integer                   asn1set__ub_approvalCode         ; 
extern      asn__integer                   asn1set__ub_AVSData              ; 
extern      asn__integer                   asn1set__ub_logRefID             ; 
extern      asn__integer                   asn1set__ub_merOrderNum          ; 
extern      asn__integer                   asn1set__ub_merType              ; 
extern      asn__integer                   asn1set__ub_recurringFrequency   ; 
extern      asn__integer                   asn1set__ub_SettlementAccount    ; 
extern      asn__integer                   asn1set__ub_summary              ; 
extern      asn__integer                   asn1set__ub_terminalID           ; 
extern      asn__integer                   asn1set__ub_validationCode       ; 





# define                           ASN1SET__ACCTINFO                0 /* asn1set__AcctInfo */
# define                           ASN1SET__ACCTDATA                1 /* asn1set__AcctData */
# define                           ASN1SET__ACCTIDENTIFICATION      2 /* asn1set__AcctIdentification */
# define                           ASN1SET__IDDATA                  3 /* asn1set__IDData */
# define                           ASN1SET__MERCHANTACQUIRERID      4 /* asn1set__MerchantAcquirerID */
# define                           ASN1SET__ACQUIRERID              5 /* asn1set__AcquirerID */
# define                           ASN1SET__ACQUIRERBUSINESSID      6 /* asn1set__AcquirerBusinessID */
# define                           ASN1SET__REQUESTTYPE             7 /* asn1set__RequestType */
# define                           ASN1SET__REGFORMORREFERRAL       8 /* asn1set__RegFormOrReferral */
# define                           ASN1SET__REGFORMDATA             9 /* asn1set__RegFormData */
# define                           ASN1SET__REGTEMPLATE            10 /* asn1set__RegTemplate */
# define                           ASN1SET__REGFIELDSEQ            11 /* asn1set__RegFieldSeq */
# define                           ASN1SET__REGFIELD               12 /* asn1set__RegField */
# define                           ASN1SET__REFERRALDATA           13 /* asn1set__ReferralData */
# define                           ASN1SET__REASON                 14 /* asn1set__Reason */
# define                           ASN1SET__REFERRALURLSEQ         15 /* asn1set__ReferralURLSeq */
# define                           ASN1SET__REFERRALURL            16 /* asn1set__ReferralURL */
# define                           ASN1SET__POLICYTEXT             17 /* asn1set__PolicyText */
# define                           ASN1SET__CARDCINITREQ           18 /* asn1set__CardCInitReq */
# define                           ASN1SET__CARDCINITRES           19 /* asn1set__CardCInitRes */
# define                           ASN1SET__CARDCINITRESTBS        20 /* asn1set__CardCInitResTBS */
# define                           ASN1SET__ME_AQCINITREQ          21 /* asn1set__Me_AqCInitReq */
# define                           ASN1SET__ME_AQCINITRES          22 /* asn1set__Me_AqCInitRes */
# define                           ASN1SET__ME_AQCINITRESTBS       23 /* asn1set__Me_AqCInitResTBS */
# define                           ASN1SET__REGFORMREQ             24 /* asn1set__RegFormReq */
# define                           ASN1SET__REGFORMREQTBE          25 /* asn1set__RegFormReqTBE */
# define                           ASN1SET__REGFORMREQDATA         26 /* asn1set__RegFormReqData */
# define                           ASN1SET__PANONLY                27 /* asn1set__PANOnly */
# define                           ASN1SET__REGFORMRES             28 /* asn1set__RegFormRes */
# define                           ASN1SET__REGFORMRESTBS          29 /* asn1set__RegFormResTBS */
# define                           ASN1SET__CERTREQ                30 /* asn1set__CertReq */
# define                           ASN1SET__CERTREQTBE             31 /* asn1set__CertReqTBE */
# define                           ASN1SET__CERTREQTBEX            32 /* asn1set__CertReqTBEX */
# define                           ASN1SET__CERTREQTBS             33 /* asn1set__CertReqTBS */
# define                           ASN1SET__CERTREQDATA            34 /* asn1set__CertReqData */
# define                           ASN1SET__REGFORM                35 /* asn1set__RegForm */
# define                           ASN1SET__REGFORMITEMS           36 /* asn1set__RegFormItems */
# define                           ASN1SET__FIELDNAME              37 /* asn1set__FieldName */
# define                           ASN1SET__FIELDVALUE             38 /* asn1set__FieldValue */
# define                           ASN1SET__PUBLICKEYSORE          39 /* asn1set__PublicKeySorE */
# define                           ASN1SET__CERTRES                40 /* asn1set__CertRes */
# define                           ASN1SET__CERTRESTBE             41 /* asn1set__CertResTBE */
# define                           ASN1SET__CERTRESDATA            42 /* asn1set__CertResData */
# define                           ASN1SET__CERTSTATUS             43 /* asn1set__CertStatus */
# define                           ASN1SET__FAILEDITEMSEQ          44 /* asn1set__FailedItemSeq */
# define                           ASN1SET__FAILEDITEM             45 /* asn1set__FailedItem */
# define                           ASN1SET__CERTSTATUSCODE         46 /* asn1set__CertStatusCode */
# define                           ASN1SET__CAMSG                  47 /* asn1set__CAMsg */
# define                           ASN1SET__CAKEY                  48 /* asn1set__CAKey */
# define                           ASN1SET__CERTINQREQ             49 /* asn1set__CertInqReq */
# define                           ASN1SET__CERTINQREQTBS          50 /* asn1set__CertInqReqTBS */
# define                           ASN1SET__CERTINQRES             51 /* asn1set__CertInqRes */
# define                           ASN1SET__CERTIFICATEPOLICIESSYNTAX  52 /* asn1set__CertificatePoliciesSyntax */
# define                           ASN1SET__POLICYINFORMATION      53 /* asn1set__PolicyInformation */
# define                           ASN1SET__POLICYQUALIFIERINFOS   54 /* asn1set__PolicyQualifierInfos */
# define                           ASN1SET__POLICYQUALIFIERINFO    55 /* asn1set__PolicyQualifierInfo */
# define                           ASN1SET__SETPOLICYQUALIFIER     56 /* asn1set__SetPolicyQualifier */
# define                           ASN1SET__ADDITIONALPOLICIES     57 /* asn1set__AdditionalPolicies */
# define                           ASN1SET__ADDITIONALPOLICY       58 /* asn1set__AdditionalPolicy */
# define                           ASN1SET__SETQUALIFIER           59 /* asn1set__SETQualifier */
# define                           ASN1SET__HASHEDROOTKEYSYNTAX    60 /* asn1set__HashedRootKeySyntax */
# define                           ASN1SET__ROOTKEYTHUMB           61 /* asn1set__RootKeyThumb */
# define                           ASN1SET__CERTIFICATETYPESYNTAX  62 /* asn1set__CertificateTypeSyntax */
# define                           ASN1SET__MERCHANTDATASYNTAX     63 /* asn1set__MerchantDataSyntax */
# define                           ASN1SET__MERNAMESEQ             64 /* asn1set__MerNameSeq */
# define                           ASN1SET__MERNAMES               65 /* asn1set__MerNames */
# define                           ASN1SET__CARDCERTREQUIREDSYNTAX  66 /* asn1set__CardCertRequiredSyntax */
# define                           ASN1SET__TUNNELINGSYNTAX        67 /* asn1set__TunnelingSyntax */
# define                           ASN1SET__TUNNELALG              68 /* asn1set__TunnelAlg */
# define                           ASN1SET__SETEXTENSIONSSYNTAX    69 /* asn1set__SETExtensionsSyntax */
# define                           ASN1SET__OID                    70 /* asn1set__OID */
# define                           ASN1SET__COMMERCIALCARDDATA     71 /* asn1set__CommercialCardData */
# define                           ASN1SET__CHARGEINFO             72 /* asn1set__ChargeInfo */
# define                           ASN1SET__ITEMSEQ                73 /* asn1set__ItemSeq */
# define                           ASN1SET__ITEM                   74 /* asn1set__Item */
# define                           ASN1SET__MARKETAUTOCAP          75 /* asn1set__MarketAutoCap */
# define                           ASN1SET__AUTONOSHOW             76 /* asn1set__AutoNoShow */
# define                           ASN1SET__AUTORATEINFO           77 /* asn1set__AutoRateInfo */
# define                           ASN1SET__AUTOAPPLICABLERATE     78 /* asn1set__AutoApplicableRate */
# define                           ASN1SET__AUTOCHARGES            79 /* asn1set__AutoCharges */
# define                           ASN1SET__MARKETHOTELCAP         80 /* asn1set__MarketHotelCap */
# define                           ASN1SET__HOTELNOSHOW            81 /* asn1set__HotelNoShow */
# define                           ASN1SET__HOTELRATEINFO          82 /* asn1set__HotelRateInfo */
# define                           ASN1SET__HOTELCHARGES           83 /* asn1set__HotelCharges */
# define                           ASN1SET__MARKETTRANSPORTCAP     84 /* asn1set__MarketTransportCap */
# define                           ASN1SET__TRIPLEGSEQ             85 /* asn1set__TripLegSeq */
# define                           ASN1SET__TRIPLEG                86 /* asn1set__TripLeg */
# define                           ASN1SET__STOPOVERCODE           87 /* asn1set__StopOverCode */
# define                           ASN1SET__RESTRICTIONS           88 /* asn1set__Restrictions */
# define                           ASN1SET__MESSAGEWRAPPER         89 /* asn1set__MessageWrapper */
# define                           ASN1SET__MESSAGEHEADER          90 /* asn1set__MessageHeader */
# define                           ASN1SET__MESSAGEIDS             91 /* asn1set__MessageIDs */
# define                           ASN1SET__MESSAGE                92 /* asn1set__Message */
# define                           ASN1SET__MSGEXTENSIONS          93 /* asn1set__MsgExtensions */
# define                           ASN1SET__MSGEXTENSION           94 /* asn1set__MsgExtension */
# define                           ASN1SET__ERROR                  95 /* asn1set__Error */
# define                           ASN1SET__SIGNEDERROR            96 /* asn1set__SignedError */
# define                           ASN1SET__ERRORTBS               97 /* asn1set__ErrorTBS */
# define                           ASN1SET__ERRORMSG               98 /* asn1set__ErrorMsg */
# define                           ASN1SET__ERRORCODE              99 /* asn1set__ErrorCode */
# define                           ASN1SET__BRANDCRLIDENTIFIER    100 /* asn1set__BrandCRLIdentifier */
# define                           ASN1SET__ENCODEDBRANDCRLID     101 /* asn1set__EncodedBrandCRLID */
# define                           ASN1SET__UNSIGNEDBRANDCRLIDENTIFIER 102 /* asn1set__UnsignedBrandCRLIdentifier */
# define                           ASN1SET__CRLNOTIFICATION       103 /* asn1set__CRLNotification */
# define                           ASN1SET__CRLNOTIFICATIONTBS    104 /* asn1set__CRLNotificationTBS */
# define                           ASN1SET__CRLNOTIFICATIONRES    105 /* asn1set__CRLNotificationRes */
# define                           ASN1SET__CRLNOTIFICATIONRESTBS 106 /* asn1set__CRLNotificationResTBS */
# define                           ASN1SET__BCIDISTRIBUTION       107 /* asn1set__BCIDistribution */
# define                           ASN1SET__BCIDISTRIBUTIONTBS    108 /* asn1set__BCIDistributionTBS */
# define                           ASN1SET__BRANDID               109 /* asn1set__BrandID */
# define                           ASN1SET__CRLIDENTIFIERSEQ      110 /* asn1set__CRLIdentifierSeq */
# define                           ASN1SET__CRLIDENTIFIER         111 /* asn1set__CRLIdentifier */
# define                           ASN1SET__BACKKEYDATA           112 /* asn1set__BackKeyData */
# define                           ASN1SET__BACKKEY               113 /* asn1set__BackKey */
# define                           ASN1SET__BIN                   114 /* asn1set__BIN */
# define                           ASN1SET__CARDEXPIRY            115 /* asn1set__CardExpiry */
# define                           ASN1SET__CERTTHUMB             116 /* asn1set__CertThumb */
# define                           ASN1SET__CHALLENGE             117 /* asn1set__Challenge */
# define                           ASN1SET__COUNTRYCODE           118 /* asn1set__CountryCode */
# define                           ASN1SET__CURRENCY              119 /* asn1set__Currency */
# define                           ASN1SET__DATE                  120 /* asn1set__Date */
# define                           ASN1SET__DATETIME              121 /* asn1set__DateTime */
# define                           ASN1SET__DISTANCE              122 /* asn1set__Distance */
# define                           ASN1SET__DISTANCESCALE         123 /* asn1set__DistanceScale */
# define                           ASN1SET__LANGUAGE              124 /* asn1set__Language */
# define                           ASN1SET__LOCALID               125 /* asn1set__LocalID */
# define                           ASN1SET__LOCATION              126 /* asn1set__Location */
# define                           ASN1SET__MERCHANTID            127 /* asn1set__MerchantID */
# define                           ASN1SET__NONCE                 128 /* asn1set__Nonce */
# define                           ASN1SET__PAN                   129 /* asn1set__PAN */
# define                           ASN1SET__PANDATA               130 /* asn1set__PANData */
# define                           ASN1SET__PANDATA0              131 /* asn1set__PANData0 */
# define                           ASN1SET__PANTOKEN              132 /* asn1set__PANToken */
# define                           ASN1SET__PAYSYSID              133 /* asn1set__PaySysID */
# define                           ASN1SET__PHONE                 134 /* asn1set__Phone */
# define                           ASN1SET__RRPID                 135 /* asn1set__RRPID */
# define                           ASN1SET__SECRET                136 /* asn1set__Secret */
# define                           ASN1SET__SWIDENT               137 /* asn1set__SWIdent */
# define                           ASN1SET__THUMBS                138 /* asn1set__Thumbs */
# define                           ASN1SET__TRANSIDS              139 /* asn1set__TransIDs */
# define                           ASN1SET__URL                   140 /* asn1set__URL */
# define                           ASN1SET__XID                   141 /* asn1set__XID */
# define                           ASN1SET__ATTRIBUTESET          142 /* asn1set__AttributeSet */
# define                           ASN1SET__ENCODEDCERTIFICATIONREQUESTINFO 143 /* asn1set__EncodedCertificationRequestInfo */
# define                           ASN1SET__CERTIFICATIONREQUEST  144 /* asn1set__CertificationRequest */
# define                           ASN1SET__CERTIFICATIONREQUESTINFO 145 /* asn1set__CertificationRequestInfo */
# define                           ASN1SET__PINITREQ              146 /* asn1set__PInitReq */
# define                           ASN1SET__PINITRES              147 /* asn1set__PInitRes */
# define                           ASN1SET__PINITRESDATA          148 /* asn1set__PInitResData */
# define                           ASN1SET__PREQ                  149 /* asn1set__PReq */
# define                           ASN1SET__PREQDUALSIGNED        150 /* asn1set__PReqDualSigned */
# define                           ASN1SET__PIDUALSIGNED          151 /* asn1set__PIDualSigned */
# define                           ASN1SET__PIDUALSIGNEDTBE       152 /* asn1set__PIDualSignedTBE */
# define                           ASN1SET__PI_OILINK             153 /* asn1set__PI_OILink */
# define                           ASN1SET__OIDUALSIGNED          154 /* asn1set__OIDualSigned */
# define                           ASN1SET__PISIGNATURE           155 /* asn1set__PISignature */
# define                           ASN1SET__PI_TBS                156 /* asn1set__PI_TBS */
# define                           ASN1SET__HPIDATA               157 /* asn1set__HPIData */
# define                           ASN1SET__HOIDATA               158 /* asn1set__HOIData */
# define                           ASN1SET__PI                    159 /* asn1set__PI */
# define                           ASN1SET__PIDATA                160 /* asn1set__PIData */
# define                           ASN1SET__PIHEAD                161 /* asn1set__PIHead */
# define                           ASN1SET__INPUTS                162 /* asn1set__Inputs */
# define                           ASN1SET__TRANSSTAIN            163 /* asn1set__TransStain */
# define                           ASN1SET__OIDATA                164 /* asn1set__OIData */
# define                           ASN1SET__OIDLIST               165 /* asn1set__OIDList */
# define                           ASN1SET__HOD                   166 /* asn1set__HOD */
# define                           ASN1SET__HODINPUT              167 /* asn1set__HODInput */
# define                           ASN1SET__OD                    168 /* asn1set__OD */
# define                           ASN1SET__PREQUNSIGNED          169 /* asn1set__PReqUnsigned */
# define                           ASN1SET__OIUNSIGNED            170 /* asn1set__OIUnsigned */
# define                           ASN1SET__PIDATAUNSIGNED        171 /* asn1set__PIDataUnsigned */
# define                           ASN1SET__PIUNSIGNED            172 /* asn1set__PIUnsigned */
# define                           ASN1SET__PIUNSIGNEDTBE         173 /* asn1set__PIUnsignedTBE */
# define                           ASN1SET__PRES                  174 /* asn1set__PRes */
# define                           ASN1SET__PRESDATA              175 /* asn1set__PResData */
# define                           ASN1SET__PRESPAYLOADSEQ        176 /* asn1set__PResPayloadSeq */
# define                           ASN1SET__PRESPAYLOAD           177 /* asn1set__PResPayload */
# define                           ASN1SET__COMPLETIONCODE        178 /* asn1set__CompletionCode */
# define                           ASN1SET__RESULTS               179 /* asn1set__Results */
# define                           ASN1SET__AUTHSTATUS            180 /* asn1set__AuthStatus */
# define                           ASN1SET__CAPSTATUS             181 /* asn1set__CapStatus */
# define                           ASN1SET__CREDITSTATUSSEQ       182 /* asn1set__CreditStatusSeq */
# define                           ASN1SET__CREDITSTATUS          183 /* asn1set__CreditStatus */
# define                           ASN1SET__INQREQ                184 /* asn1set__InqReq */
# define                           ASN1SET__INQREQSIGNED          185 /* asn1set__InqReqSigned */
# define                           ASN1SET__INQREQDATA            186 /* asn1set__InqReqData */
# define                           ASN1SET__INQRES                187 /* asn1set__InqRes */
# define                           ASN1SET__AUTHREQ               188 /* asn1set__AuthReq */
# define                           ASN1SET__AUTHREQTBE            189 /* asn1set__AuthReqTBE */
# define                           ASN1SET__AUTHREQTBS            190 /* asn1set__AuthReqTBS */
# define                           ASN1SET__AUTHREQDATA           191 /* asn1set__AuthReqData */
# define                           ASN1SET__AUTHREQITEM           192 /* asn1set__AuthReqItem */
# define                           ASN1SET__AUTHTAGS              193 /* asn1set__AuthTags */
# define                           ASN1SET__CHECKDIGESTS          194 /* asn1set__CheckDigests */
# define                           ASN1SET__AUTHREQPAYLOAD        195 /* asn1set__AuthReqPayload */
# define                           ASN1SET__AVSDATA               196 /* asn1set__AVSData */
# define                           ASN1SET__SPECIALPROCESSING     197 /* asn1set__SpecialProcessing */
# define                           ASN1SET__CARDSUSPECT           198 /* asn1set__CardSuspect */
# define                           ASN1SET__MERCHDATA             199 /* asn1set__MerchData */
# define                           ASN1SET__MERCHCATCODE          200 /* asn1set__MerchCatCode */
# define                           ASN1SET__MERCHGROUP            201 /* asn1set__MerchGroup */
# define                           ASN1SET__AUTHRES               202 /* asn1set__AuthRes */
# define                           ASN1SET__AUTHRESTBE            203 /* asn1set__AuthResTBE */
# define                           ASN1SET__AUTHRESTBEX           204 /* asn1set__AuthResTBEX */
# define                           ASN1SET__AUTHRESTBS            205 /* asn1set__AuthResTBS */
# define                           ASN1SET__AUTHRESTBSX           206 /* asn1set__AuthResTBSX */
# define                           ASN1SET__AUTHRESDATA           207 /* asn1set__AuthResData */
# define                           ASN1SET__AUTHRESBAGGAGE        208 /* asn1set__AuthResBaggage */
# define                           ASN1SET__ACQBACKKEY            209 /* asn1set__AcqBackKey */
# define                           ASN1SET__ACQCARDMSG            210 /* asn1set__AcqCardMsg */
# define                           ASN1SET__ACQCARDCODEMSGTBE     211 /* asn1set__AcqCardCodeMsgTBE */
# define                           ASN1SET__ACQCARDCODEMSG        212 /* asn1set__AcqCardCodeMsg */
# define                           ASN1SET__ACQCARDCODE           213 /* asn1set__AcqCardCode */
# define                           ASN1SET__ACQCARDMSGDATA        214 /* asn1set__AcqCardMsgData */
# define                           ASN1SET__AUTHRESPAYLOAD        215 /* asn1set__AuthResPayload */
# define                           ASN1SET__AUTHHEADER            216 /* asn1set__AuthHeader */
# define                           ASN1SET__AUTHCODE              217 /* asn1set__AuthCode */
# define                           ASN1SET__RESPONSEDATA          218 /* asn1set__ResponseData */
# define                           ASN1SET__AUTHVALCODES          219 /* asn1set__AuthValCodes */
# define                           ASN1SET__RESPREASON            220 /* asn1set__RespReason */
# define                           ASN1SET__CARDTYPE              221 /* asn1set__CardType */
# define                           ASN1SET__AVSRESULT             222 /* asn1set__AVSResult */
# define                           ASN1SET__LOGREFID              223 /* asn1set__LogRefID */
# define                           ASN1SET__APPROVALCODE          224 /* asn1set__ApprovalCode */
# define                           ASN1SET__AUTHCHARIND           225 /* asn1set__AuthCharInd */
# define                           ASN1SET__VALIDATIONCODE        226 /* asn1set__ValidationCode */
# define                           ASN1SET__AUTHREVREQ            227 /* asn1set__AuthRevReq */
# define                           ASN1SET__AUTHREVREQTBE         228 /* asn1set__AuthRevReqTBE */
# define                           ASN1SET__AUTHREVREQTBS         229 /* asn1set__AuthRevReqTBS */
# define                           ASN1SET__AUTHREVREQDATA        230 /* asn1set__AuthRevReqData */
# define                           ASN1SET__AUTHREVREQBAGGAGE     231 /* asn1set__AuthRevReqBaggage */
# define                           ASN1SET__AUTHREVTAGS           232 /* asn1set__AuthRevTags */
# define                           ASN1SET__AUTHREVRRTAGS         233 /* asn1set__AuthRevRRTags */
# define                           ASN1SET__AUTHRETNUM            234 /* asn1set__AuthRetNum */
# define                           ASN1SET__AUTHREVRES            235 /* asn1set__AuthRevRes */
# define                           ASN1SET__AUTHREVRESTBE         236 /* asn1set__AuthRevResTBE */
# define                           ASN1SET__AUTHREVRESTBEB        237 /* asn1set__AuthRevResTBEB */
# define                           ASN1SET__AUTHREVRESTBS         238 /* asn1set__AuthRevResTBS */
# define                           ASN1SET__AUTHREVRESBAGGAGE     239 /* asn1set__AuthRevResBaggage */
# define                           ASN1SET__AUTHREVRESDATA        240 /* asn1set__AuthRevResData */
# define                           ASN1SET__AUTHREVCODE           241 /* asn1set__AuthRevCode */
# define                           ASN1SET__AUTHRESDATANEW        242 /* asn1set__AuthResDataNew */
# define                           ASN1SET__CAPREQ                243 /* asn1set__CapReq */
# define                           ASN1SET__CAPREQTBE             244 /* asn1set__CapReqTBE */
# define                           ASN1SET__CAPREQTBEX            245 /* asn1set__CapReqTBEX */
# define                           ASN1SET__CAPREQTBS             246 /* asn1set__CapReqTBS */
# define                           ASN1SET__CAPREQTBSX            247 /* asn1set__CapReqTBSX */
# define                           ASN1SET__CAPREQDATA            248 /* asn1set__CapReqData */
# define                           ASN1SET__CAPRRTAGS             249 /* asn1set__CapRRTags */
# define                           ASN1SET__CAPITEMSEQ            250 /* asn1set__CapItemSeq */
# define                           ASN1SET__CAPITEM               251 /* asn1set__CapItem */
# define                           ASN1SET__CAPPAYLOAD            252 /* asn1set__CapPayload */
# define                           ASN1SET__CAPRES                253 /* asn1set__CapRes */
# define                           ASN1SET__CAPRESTBE             254 /* asn1set__CapResTBE */
# define                           ASN1SET__CAPRESDATA            255 /* asn1set__CapResData */
# define                           ASN1SET__CAPRESITEMSEQ         256 /* asn1set__CapResItemSeq */
# define                           ASN1SET__CAPRESITEM            257 /* asn1set__CapResItem */
# define                           ASN1SET__CAPRESPAYLOAD         258 /* asn1set__CapResPayload */
# define                           ASN1SET__CAPCODE               259 /* asn1set__CapCode */
# define                           ASN1SET__CAPREVORCREDREQDATA   260 /* asn1set__CapRevOrCredReqData */
# define                           ASN1SET__CAPREVORCREDREQITEMSEQ 261 /* asn1set__CapRevOrCredReqItemSeq */
# define                           ASN1SET__CAPREVORCREDREQITEM   262 /* asn1set__CapRevOrCredReqItem */
# define                           ASN1SET__CAPREVORCREDRESDATA   263 /* asn1set__CapRevOrCredResData */
# define                           ASN1SET__CAPREVORCREDRESITEMSEQ 264 /* asn1set__CapRevOrCredResItemSeq */
# define                           ASN1SET__CAPREVORCREDRESITEM   265 /* asn1set__CapRevOrCredResItem */
# define                           ASN1SET__CAPREVORCREDRESPAYLOAD 266 /* asn1set__CapRevOrCredResPayload */
# define                           ASN1SET__CAPREVORCREDCODE      267 /* asn1set__CapRevOrCredCode */
# define                           ASN1SET__CAPREVREQ             268 /* asn1set__CapRevReq */
# define                           ASN1SET__CAPREVREQTBE          269 /* asn1set__CapRevReqTBE */
# define                           ASN1SET__CAPREVREQTBEX         270 /* asn1set__CapRevReqTBEX */
# define                           ASN1SET__CAPREVREQTBS          271 /* asn1set__CapRevReqTBS */
# define                           ASN1SET__CAPREVREQTBSX         272 /* asn1set__CapRevReqTBSX */
# define                           ASN1SET__CAPREVDATA            273 /* asn1set__CapRevData */
# define                           ASN1SET__CAPREVRES             274 /* asn1set__CapRevRes */
# define                           ASN1SET__CAPREVRESTBE          275 /* asn1set__CapRevResTBE */
# define                           ASN1SET__CAPREVRESDATA         276 /* asn1set__CapRevResData */
# define                           ASN1SET__CREDREQ               277 /* asn1set__CredReq */
# define                           ASN1SET__CREDREQTBE            278 /* asn1set__CredReqTBE */
# define                           ASN1SET__CREDREQTBEX           279 /* asn1set__CredReqTBEX */
# define                           ASN1SET__CREDREQTBS            280 /* asn1set__CredReqTBS */
# define                           ASN1SET__CREDREQTBSX           281 /* asn1set__CredReqTBSX */
# define                           ASN1SET__CREDREQDATA           282 /* asn1set__CredReqData */
# define                           ASN1SET__CREDRES               283 /* asn1set__CredRes */
# define                           ASN1SET__CREDRESTBE            284 /* asn1set__CredResTBE */
# define                           ASN1SET__CREDRESDATA           285 /* asn1set__CredResData */
# define                           ASN1SET__CREDREVREQ            286 /* asn1set__CredRevReq */
# define                           ASN1SET__CREDREVREQTBE         287 /* asn1set__CredRevReqTBE */
# define                           ASN1SET__CREDREVREQTBEX        288 /* asn1set__CredRevReqTBEX */
# define                           ASN1SET__CREDREVREQTBS         289 /* asn1set__CredRevReqTBS */
# define                           ASN1SET__CREDREVREQTBSX        290 /* asn1set__CredRevReqTBSX */
# define                           ASN1SET__CREDREVREQDATA        291 /* asn1set__CredRevReqData */
# define                           ASN1SET__CREDREVRES            292 /* asn1set__CredRevRes */
# define                           ASN1SET__CREDREVRESTBE         293 /* asn1set__CredRevResTBE */
# define                           ASN1SET__CREDREVRESDATA        294 /* asn1set__CredRevResData */
# define                           ASN1SET__PCERTREQ              295 /* asn1set__PCertReq */
# define                           ASN1SET__PCERTREQDATA          296 /* asn1set__PCertReqData */
# define                           ASN1SET__BRANDANDBINSEQ        297 /* asn1set__BrandAndBINSeq */
# define                           ASN1SET__BRANDANDBIN           298 /* asn1set__BrandAndBIN */
# define                           ASN1SET__PCERTRES              299 /* asn1set__PCertRes */
# define                           ASN1SET__PCERTRESTBS           300 /* asn1set__PCertResTBS */
# define                           ASN1SET__PCERTRESITEMSEQ       301 /* asn1set__PCertResItemSeq */
# define                           ASN1SET__PCERTRESITEM          302 /* asn1set__PCertResItem */
# define                           ASN1SET__PCERTCODE             303 /* asn1set__PCertCode */
# define                           ASN1SET__BRANDCRLIDENTIFIERSEQ 304 /* asn1set__BrandCRLIdentifierSeq */
# define                           ASN1SET__BATCHADMINREQ         305 /* asn1set__BatchAdminReq */
# define                           ASN1SET__BATCHADMINREQTBE      306 /* asn1set__BatchAdminReqTBE */
# define                           ASN1SET__BATCHADMINREQDATA     307 /* asn1set__BatchAdminReqData */
# define                           ASN1SET__BATCHOPERATION        308 /* asn1set__BatchOperation */
# define                           ASN1SET__RETURNTRANSACTIONDETAIL 309 /* asn1set__ReturnTransactionDetail */
# define                           ASN1SET__TRANSDETAILS          310 /* asn1set__TransDetails */
# define                           ASN1SET__BATCHADMINRES         311 /* asn1set__BatchAdminRes */
# define                           ASN1SET__BATCHADMINRESTBE      312 /* asn1set__BatchAdminResTBE */
# define                           ASN1SET__BATCHADMINRESDATA     313 /* asn1set__BatchAdminResData */
# define                           ASN1SET__TRANSMISSIONSTATUS    314 /* asn1set__TransmissionStatus */
# define                           ASN1SET__SETTLEMENTINFO        315 /* asn1set__SettlementInfo */
# define                           ASN1SET__BASTATUS              316 /* asn1set__BAStatus */
# define                           ASN1SET__CLOSEDWHEN            317 /* asn1set__ClosedWhen */
# define                           ASN1SET__CLOSESTATUS           318 /* asn1set__CloseStatus */
# define                           ASN1SET__BATCHSTATUSSEQ        319 /* asn1set__BatchStatusSeq */
# define                           ASN1SET__BATCHSTATUS           320 /* asn1set__BatchStatus */
# define                           ASN1SET__BATCHDETAILS          321 /* asn1set__BatchDetails */
# define                           ASN1SET__BRANDBATCHDETAILSSEQ  322 /* asn1set__BrandBatchDetailsSeq */
# define                           ASN1SET__BRANDBATCHDETAILS     323 /* asn1set__BrandBatchDetails */
# define                           ASN1SET__BATCHTOTALS           324 /* asn1set__BatchTotals */
# define                           ASN1SET__TRANSACTIONDETAILSEQ  325 /* asn1set__TransactionDetailSeq */
# define                           ASN1SET__TRANSACTIONDETAIL     326 /* asn1set__TransactionDetail */
# define                           ASN1SET__AMOUNTTYPE            327 /* asn1set__AmountType */
# define                           ASN1SET__TRANSACTIONSTATUS     328 /* asn1set__TransactionStatus */
# define                           ASN1SET__REIMBURSEMENTID       329 /* asn1set__ReimbursementID */
# define                           ASN1SET__AUTHTOKEN             330 /* asn1set__AuthToken */
# define                           ASN1SET__AUTHTOKENTBE          331 /* asn1set__AuthTokenTBE */
# define                           ASN1SET__AUTHTOKENTBS          332 /* asn1set__AuthTokenTBS */
# define                           ASN1SET__AUTHTOKENDATA         333 /* asn1set__AuthTokenData */
# define                           ASN1SET__BATCHID               334 /* asn1set__BatchID */
# define                           ASN1SET__BATCHSEQUENCENUM      335 /* asn1set__BatchSequenceNum */
# define                           ASN1SET__CAPTOKEN              336 /* asn1set__CapToken */
# define                           ASN1SET__CAPTOKENTBE           337 /* asn1set__CapTokenTBE */
# define                           ASN1SET__CAPTOKENTBEX          338 /* asn1set__CapTokenTBEX */
# define                           ASN1SET__CAPTOKENTBS           339 /* asn1set__CapTokenTBS */
# define                           ASN1SET__CAPTOKENDATA          340 /* asn1set__CapTokenData */
# define                           ASN1SET__CAPTOKENSEQ           341 /* asn1set__CapTokenSeq */
# define                           ASN1SET__CURRENCYAMOUNT        342 /* asn1set__CurrencyAmount */
# define                           ASN1SET__CURRCONV              343 /* asn1set__CurrConv */
# define                           ASN1SET__FLOATINGPOINT         344 /* asn1set__FloatingPoint */
# define                           ASN1SET__MARKETAUTOAUTH        345 /* asn1set__MarketAutoAuth */
# define                           ASN1SET__MARKETHOTELAUTH       346 /* asn1set__MarketHotelAuth */
# define                           ASN1SET__DURATION              347 /* asn1set__Duration */
# define                           ASN1SET__PRESTIGE              348 /* asn1set__Prestige */
# define                           ASN1SET__MARKETSPECAUTHDATA    349 /* asn1set__MarketSpecAuthData */
# define                           ASN1SET__MARKETSPECCAPDATA     350 /* asn1set__MarketSpecCapData */
# define                           ASN1SET__MARKETSPECSALEDATA    351 /* asn1set__MarketSpecSaleData */
# define                           ASN1SET__MARKETTRANSPORTAUTH   352 /* asn1set__MarketTransportAuth */
# define                           ASN1SET__MARKETSPECDATAID      353 /* asn1set__MarketSpecDataID */
# define                           ASN1SET__MERORDERNUM           354 /* asn1set__MerOrderNum */
# define                           ASN1SET__MERTERMIDS            355 /* asn1set__MerTermIDs */
# define                           ASN1SET__RRTAGS                356 /* asn1set__RRTags */
# define                           ASN1SET__SALEDETAIL            357 /* asn1set__SaleDetail */
# define                           ASN1SET__PAYRECURIND           358 /* asn1set__PayRecurInd */
# define                           ASN1SET__INSTALLRECURDATA      359 /* asn1set__InstallRecurData */
# define                           ASN1SET__INSTALLRECURIND       360 /* asn1set__InstallRecurInd */
# define                           ASN1SET__RECURRING             361 /* asn1set__Recurring */
# define                           ASN1SET__TOKENOPAQUE           362 /* asn1set__TokenOpaque */
# define                           ASN1SET__ANYANY                363 /* asn1set__AnyAny */
# define                           ASN1SET__BOOLEAN               364 /* asn1set__Boolean */
# define                           ASN1SET__INTEGER               365 /* asn1set__Integer */
# define                           ASN1SET__VISIBLESTRING         366 /* asn1set__Visiblestring */
# define                           ASN1SET__PRINTABLESTRING       367 /* asn1set__Printablestring */
# define                           ASN1SET__CEALGORITHMIDENTIFIER 368 /* asn1set__CEAlgorithmIdentifier */
# define                           ASN1SET__DALGORITHMIDENTIFIER  369 /* asn1set__DAlgorithmIdentifier */
# define                           ASN1SET__DIGESTS               370 /* asn1set__Digests */
# define                           ASN1SET__SIGNEDDATA            371 /* asn1set__SignedData */
# define                           ASN1SET__ENVELOPEDDATA         372 /* asn1set__EnvelopedData */
# define                           ASN1SET__DIGESTEDDATA          373 /* asn1set__DigestedData */
# define                           ASN1SET__SIGNED                374 /* asn1set__SIGNED */
# define                           ASN1SET__L                     375 /* asn1set__L */
# define                           ASN1SET__DD                    376 /* asn1set__DD */
# define                           ASN1SET__DETACHEDDIGEST        377 /* asn1set__DetachedDigest */
# define                           ASN1SET__H                     378 /* asn1set__H */
# define                           ASN1SET__HMAC                  379 /* asn1set__HMAC */
# define                           ASN1SET__HMACPANDATA           380 /* asn1set__HMACPanData */
# define                           ASN1SET__S                     381 /* asn1set__S */
# define                           ASN1SET__SO                    382 /* asn1set__SO */
# define                           ASN1SET__ENC                   383 /* asn1set__Enc */
# define                           ASN1SET__ENCK                  384 /* asn1set__EncK */
# define                           ASN1SET__ENCX                  385 /* asn1set__EncX */
# define                           ASN1SET__ENCB                  386 /* asn1set__EncB */
# define                           ASN1SET__ENCBX                 387 /* asn1set__EncBX */
# define                           ASN1SET__E                     388 /* asn1set__E */
# define                           ASN1SET__EH                    389 /* asn1set__EH */
# define                           ASN1SET__EX                    390 /* asn1set__EX */
# define                           ASN1SET__EXH                   391 /* asn1set__EXH */
# define                           ASN1SET__EK                    392 /* asn1set__EK */
# define                           ASN1SET__NAME                  393 /* asn1set__Name */
# define                           ASN1SET__SUBJECTPUBLICKEYINFO  394 /* asn1set__SubjectPublicKeyInfo */
# define                           ASN1SET__SETSTRINGUB_AVSDATA   395 /* asn1set__SETStringub_AVSData */
# define                           ASN1SET__SETSTRINGUB_ACQCARDPHONE 396 /* asn1set__SETStringub_acqCardPhone */
# define                           ASN1SET__SETSTRINGUB_ACQCARDTEXT 397 /* asn1set__SETStringub_acqCardText */
# define                           ASN1SET__SETSTRINGUB_AIRPORTCODE 398 /* asn1set__SETStringub_airportCode */
# define                           ASN1SET__SETSTRINGUB_CARDHOLDERMSG 399 /* asn1set__SETStringub_cardholderMsg */
# define                           ASN1SET__SETSTRINGUB_CARRIERCODE 400 /* asn1set__SETStringub_carrierCode */
# define                           ASN1SET__SETSTRINGUB_CITYNAME  401 /* asn1set__SETStringub_cityName */
# define                           ASN1SET__SETSTRINGUB_COMMCODE  402 /* asn1set__SETStringub_commCode */
# define                           ASN1SET__SETSTRINGUB_CORPID    403 /* asn1set__SETStringub_corpID */
# define                           ASN1SET__SETSTRINGUB_COUNTRYNAME 404 /* asn1set__SETStringub_countryName */
# define                           ASN1SET__SETSTRINGUB_DESCRIPTION 405 /* asn1set__SETStringub_description */
# define                           ASN1SET__SETSTRINGUB_EEMESSAGE 406 /* asn1set__SETStringub_eeMessage */
# define                           ASN1SET__SETSTRINGUB_FAREBASIS 407 /* asn1set__SETStringub_fareBasis */
# define                           ASN1SET__SETSTRINGUB_FIELDDESC 408 /* asn1set__SETStringub_FieldDesc */
# define                           ASN1SET__SETSTRINGUB_FIELDNAME 409 /* asn1set__SETStringub_FieldName */
# define                           ASN1SET__SETSTRINGUB_FIELDVALUE 410 /* asn1set__SETStringub_FieldValue */
# define                           ASN1SET__SETSTRINGUB_HOTELFOLIO 411 /* asn1set__SETStringub_hotelFolio */
# define                           ASN1SET__SETSTRINGUB_INSURANCETYPE 412 /* asn1set__SETStringub_insuranceType */
# define                           ASN1SET__SETSTRINGUB_LOCATIONID 413 /* asn1set__SETStringub_locationID */
# define                           ASN1SET__SETSTRINGUB_MERNAME   414 /* asn1set__SETStringub_merName */
# define                           ASN1SET__SETSTRINGUB_MERTYPE   415 /* asn1set__SETStringub_merType */
# define                           ASN1SET__SETSTRINGUB_PASSNAME  416 /* asn1set__SETStringub_passName */
# define                           ASN1SET__SETSTRINGUB_POSTALCODE 417 /* asn1set__SETStringub_postalCode */
# define                           ASN1SET__SETSTRINGUB_PRODUCTCODE 418 /* asn1set__SETStringub_productCode */
# define                           ASN1SET__SETSTRINGUB_PROGRAMCODE 419 /* asn1set__SETStringub_programCode */
# define                           ASN1SET__SETSTRINGUB_REASON    420 /* asn1set__SETStringub_Reason */
# define                           ASN1SET__SETSTRINGUB_REFERENCE 421 /* asn1set__SETStringub_reference */
# define                           ASN1SET__SETSTRINGUB_RENTALNUM 422 /* asn1set__SETStringub_rentalNum */
# define                           ASN1SET__SETSTRINGUB_RENTALREFNUM 423 /* asn1set__SETStringub_rentalRefNum */
# define                           ASN1SET__SETSTRINGUB_RENTERNAME 424 /* asn1set__SETStringub_renterName */
# define                           ASN1SET__SETSTRINGUB_SERVICECLASS 425 /* asn1set__SETStringub_serviceClass */
# define                           ASN1SET__SETSTRINGUB_SETTLEMENTACCOUNT 426 /* asn1set__SETStringub_SettlementAccount */
# define                           ASN1SET__SETSTRINGUB_STATEPROVINCE 427 /* asn1set__SETStringub_stateProvince */
# define                           ASN1SET__SETSTRINGUB_SUMMARY   428 /* asn1set__SETStringub_summary */
# define                           ASN1SET__SETSTRINGUB_TACODE    429 /* asn1set__SETStringub_taCode */
# define                           ASN1SET__SETSTRINGUB_TANAME    430 /* asn1set__SETStringub_taName */
# define                           ASN1SET__SETSTRINGUB_TAXID     431 /* asn1set__SETStringub_taxID */
# define                           ASN1SET__SETSTRINGUB_TAXTYPE   432 /* asn1set__SETStringub_taxType */
# define                           ASN1SET__SETSTRINGUB_TERSESTATEMENT 433 /* asn1set__SETStringub_terseStatement */
# define                           ASN1SET__SETSTRINGUB_TICKETNUM 434 /* asn1set__SETStringub_ticketNum */
# define                           ASN1SET__SETSTRINGUB_UNITMEASURE 435 /* asn1set__SETStringub_unitMeasure */
# define                           ASN1SET__SETSTRINGUB_VEHICLECLASS 436 /* asn1set__SETStringub_vehicleClass */



PRIVATE      a2c_module                     asn1set                          ; 


#ifdef __cplusplus
}
#endif
#endif

